/*===- TableGen'erated file -------------------------------------*- C++ -*-===*\
|*                                                                            *|
|* DAG Instruction Selector for the WebAssembly target                        *|
|*                                                                            *|
|* Automatically generated file, do not edit!                                 *|
|*                                                                            *|
\*===----------------------------------------------------------------------===*/

// *** NOTE: This file is #included into the middle of the target
// *** instruction selector class.  These functions are really methods.

// If GET_DAGISEL_DECL is #defined with any value, only function
// declarations will be included when this file is included.
// If GET_DAGISEL_BODY is #defined, its value should be the name of
// the instruction selector class. Function bodies will be emitted
// and each function's name will be qualified with the name of the
// class.
//
// When neither of the GET_DAGISEL* macros is defined, the functions
// are emitted inline.

#if defined(GET_DAGISEL_DECL) && defined(GET_DAGISEL_BODY)
#error GET_DAGISEL_DECL and GET_DAGISEL_BODY cannot be both defined, undef both for inline definitions
#endif

#ifdef GET_DAGISEL_BODY
#define LOCAL_DAGISEL_STRINGIZE(X) LOCAL_DAGISEL_STRINGIZE_(X)
#define LOCAL_DAGISEL_STRINGIZE_(X) #X
static_assert(sizeof(LOCAL_DAGISEL_STRINGIZE(GET_DAGISEL_BODY)) > 1,
   "GET_DAGISEL_BODY is empty: it should be defined with the class name");
#undef LOCAL_DAGISEL_STRINGIZE_
#undef LOCAL_DAGISEL_STRINGIZE
#endif

#if !defined(GET_DAGISEL_DECL) && !defined(GET_DAGISEL_BODY)
#define DAGISEL_INLINE 1
#else
#define DAGISEL_INLINE 0
#endif

#if !DAGISEL_INLINE
#define DAGISEL_CLASS_COLONCOLON GET_DAGISEL_BODY ::
#else
#define DAGISEL_CLASS_COLONCOLON
#endif

#ifdef GET_DAGISEL_DECL
void SelectCode(SDNode *N);
#endif
#if defined(GET_DAGISEL_BODY) || DAGISEL_INLINE
void DAGISEL_CLASS_COLONCOLON SelectCode(SDNode *N)
{
  // Some target values are emitted as 2 bytes, TARGET_VAL handles
  // this.
  #define TARGET_VAL(X) X & 255, unsigned(X) >> 8
  static const unsigned char MatcherTable[] = {
/*     0*/ OPC_SwitchOpcode /*122 cases */, 44|128,9/*1196*/, TARGET_VAL(ISD::ZERO_EXTEND),// ->1201
/*     5*/  OPC_Scope, 32|128,9/*1184*/, /*->1192*/ // 2 children in Scope
/*     8*/   OPC_MoveChild0,
/*     9*/   OPC_SwitchOpcode /*9 cases */, 124, TARGET_VAL(ISD::AssertZext),// ->137
/*    13*/    OPC_MoveChild0,
/*    14*/    OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),
/*    17*/    OPC_RecordMemRef,
/*    18*/    OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/*    19*/    OPC_CheckFoldableChainNode,
/*    20*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*    21*/    OPC_Scope, 56, /*->79*/ // 2 children in Scope
/*    23*/     OPC_CheckChild1TypeI32,
/*    24*/     OPC_MoveChild2,
/*    25*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*    28*/     OPC_RecordChild0, // #2 = $exp
/*    29*/     OPC_MoveSibling3,
/*    30*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*    33*/     OPC_RecordChild0, // #3 = $new
/*    34*/     OPC_MoveParent,
/*    35*/     OPC_Scope, 20, /*->57*/ // 2 children in Scope
/*    37*/      OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_i8
/*    38*/      OPC_MoveParent,
/*    39*/      OPC_MoveParent,
/*    40*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*    41*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*    43*/      OPC_EmitMergeInputChains1_0,
/*    44*/      OPC_EmitInteger32, 0, 
/*    46*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i8>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*    57*/     /*Scope*/ 20, /*->78*/
/*    58*/      OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_i16
/*    59*/      OPC_MoveParent,
/*    60*/      OPC_MoveParent,
/*    61*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*    62*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*    64*/      OPC_EmitMergeInputChains1_0,
/*    65*/      OPC_EmitInteger32, 0, 
/*    67*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i16>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*    78*/     0, /*End of Scope*/
/*    79*/    /*Scope*/ 56, /*->136*/
/*    80*/     OPC_CheckChild1TypeI64,
/*    81*/     OPC_MoveChild2,
/*    82*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*    85*/     OPC_RecordChild0, // #2 = $exp
/*    86*/     OPC_MoveSibling3,
/*    87*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*    90*/     OPC_RecordChild0, // #3 = $new
/*    91*/     OPC_MoveParent,
/*    92*/     OPC_Scope, 20, /*->114*/ // 2 children in Scope
/*    94*/      OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_i8
/*    95*/      OPC_MoveParent,
/*    96*/      OPC_MoveParent,
/*    97*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*    98*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*   100*/      OPC_EmitMergeInputChains1_0,
/*   101*/      OPC_EmitInteger32, 0, 
/*   103*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i8>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*   114*/     /*Scope*/ 20, /*->135*/
/*   115*/      OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_i16
/*   116*/      OPC_MoveParent,
/*   117*/      OPC_MoveParent,
/*   118*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   119*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*   121*/      OPC_EmitMergeInputChains1_0,
/*   122*/      OPC_EmitInteger32, 0, 
/*   124*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (zext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i16>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*   135*/     0, /*End of Scope*/
/*   136*/    0, /*End of Scope*/
/*   137*/   /*SwitchOpcode*/ 69, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),// ->209
/*   140*/    OPC_RecordMemRef,
/*   141*/    OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/*   142*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   143*/    OPC_Scope, 31, /*->176*/ // 2 children in Scope
/*   145*/     OPC_CheckChild1TypeI32,
/*   146*/     OPC_MoveChild2,
/*   147*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   150*/     OPC_RecordChild0, // #2 = $exp
/*   151*/     OPC_MoveSibling3,
/*   152*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   155*/     OPC_RecordChild0, // #3 = $new
/*   156*/     OPC_MoveParent,
/*   157*/     OPC_CheckPredicate3,  // Predicate_atomic_cmp_swap_i32
/*   158*/     OPC_MoveParent,
/*   159*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   160*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*   162*/     OPC_EmitMergeInputChains1_0,
/*   163*/     OPC_EmitInteger32, 0, 
/*   165*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i64*/8, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (zext:{ *:[i64] } (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i32>>) - Complexity = 22
               // Dst: (ATOMIC_RMW32_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*   176*/    /*Scope*/ 31, /*->208*/
/*   177*/     OPC_CheckChild1TypeI64,
/*   178*/     OPC_MoveChild2,
/*   179*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   182*/     OPC_RecordChild0, // #2 = $exp
/*   183*/     OPC_MoveSibling3,
/*   184*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   187*/     OPC_RecordChild0, // #3 = $new
/*   188*/     OPC_MoveParent,
/*   189*/     OPC_CheckPredicate3,  // Predicate_atomic_cmp_swap_i32
/*   190*/     OPC_MoveParent,
/*   191*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   192*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*   194*/     OPC_EmitMergeInputChains1_0,
/*   195*/     OPC_EmitInteger32, 0, 
/*   197*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i64*/8, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (zext:{ *:[i64] } (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i32>>) - Complexity = 22
               // Dst: (ATOMIC_RMW32_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*   208*/    0, /*End of Scope*/
/*   209*/   /*SwitchOpcode*/ 11|128,1/*139*/, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),// ->352
/*   213*/    OPC_RecordMemRef,
/*   214*/    OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*   215*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   216*/    OPC_Scope, 66, /*->284*/ // 2 children in Scope
/*   218*/     OPC_CheckChild1TypeI32,
/*   219*/     OPC_MoveChild2,
/*   220*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   223*/     OPC_RecordChild0, // #2 = $val
/*   224*/     OPC_MoveParent,
/*   225*/     OPC_Scope, 18, /*->245*/ // 3 children in Scope
/*   227*/      OPC_CheckPredicate1,  // Predicate_atomic_load_add_i8
/*   228*/      OPC_MoveParent,
/*   229*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   230*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   232*/      OPC_EmitMergeInputChains1_0,
/*   233*/      OPC_EmitInteger32, 0, 
/*   235*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   245*/     /*Scope*/ 18, /*->264*/
/*   246*/      OPC_CheckPredicate2,  // Predicate_atomic_load_add_i16
/*   247*/      OPC_MoveParent,
/*   248*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   249*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   251*/      OPC_EmitMergeInputChains1_0,
/*   252*/      OPC_EmitInteger32, 0, 
/*   254*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   264*/     /*Scope*/ 18, /*->283*/
/*   265*/      OPC_CheckPredicate3,  // Predicate_atomic_load_add_i32
/*   266*/      OPC_MoveParent,
/*   267*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   268*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   270*/      OPC_EmitMergeInputChains1_0,
/*   271*/      OPC_EmitInteger32, 0, 
/*   273*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   283*/     0, /*End of Scope*/
/*   284*/    /*Scope*/ 66, /*->351*/
/*   285*/     OPC_CheckChild1TypeI64,
/*   286*/     OPC_MoveChild2,
/*   287*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   290*/     OPC_RecordChild0, // #2 = $val
/*   291*/     OPC_MoveParent,
/*   292*/     OPC_Scope, 18, /*->312*/ // 3 children in Scope
/*   294*/      OPC_CheckPredicate1,  // Predicate_atomic_load_add_i8
/*   295*/      OPC_MoveParent,
/*   296*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   297*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   299*/      OPC_EmitMergeInputChains1_0,
/*   300*/      OPC_EmitInteger32, 0, 
/*   302*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   312*/     /*Scope*/ 18, /*->331*/
/*   313*/      OPC_CheckPredicate2,  // Predicate_atomic_load_add_i16
/*   314*/      OPC_MoveParent,
/*   315*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   316*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   318*/      OPC_EmitMergeInputChains1_0,
/*   319*/      OPC_EmitInteger32, 0, 
/*   321*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   331*/     /*Scope*/ 18, /*->350*/
/*   332*/      OPC_CheckPredicate3,  // Predicate_atomic_load_add_i32
/*   333*/      OPC_MoveParent,
/*   334*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   335*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   337*/      OPC_EmitMergeInputChains1_0,
/*   338*/      OPC_EmitInteger32, 0, 
/*   340*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   350*/     0, /*End of Scope*/
/*   351*/    0, /*End of Scope*/
/*   352*/   /*SwitchOpcode*/ 11|128,1/*139*/, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),// ->495
/*   356*/    OPC_RecordMemRef,
/*   357*/    OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*   358*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   359*/    OPC_Scope, 66, /*->427*/ // 2 children in Scope
/*   361*/     OPC_CheckChild1TypeI32,
/*   362*/     OPC_MoveChild2,
/*   363*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   366*/     OPC_RecordChild0, // #2 = $val
/*   367*/     OPC_MoveParent,
/*   368*/     OPC_Scope, 18, /*->388*/ // 3 children in Scope
/*   370*/      OPC_CheckPredicate1,  // Predicate_atomic_load_sub_i8
/*   371*/      OPC_MoveParent,
/*   372*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   373*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   375*/      OPC_EmitMergeInputChains1_0,
/*   376*/      OPC_EmitInteger32, 0, 
/*   378*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   388*/     /*Scope*/ 18, /*->407*/
/*   389*/      OPC_CheckPredicate2,  // Predicate_atomic_load_sub_i16
/*   390*/      OPC_MoveParent,
/*   391*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   392*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   394*/      OPC_EmitMergeInputChains1_0,
/*   395*/      OPC_EmitInteger32, 0, 
/*   397*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   407*/     /*Scope*/ 18, /*->426*/
/*   408*/      OPC_CheckPredicate3,  // Predicate_atomic_load_sub_i32
/*   409*/      OPC_MoveParent,
/*   410*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   411*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   413*/      OPC_EmitMergeInputChains1_0,
/*   414*/      OPC_EmitInteger32, 0, 
/*   416*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   426*/     0, /*End of Scope*/
/*   427*/    /*Scope*/ 66, /*->494*/
/*   428*/     OPC_CheckChild1TypeI64,
/*   429*/     OPC_MoveChild2,
/*   430*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   433*/     OPC_RecordChild0, // #2 = $val
/*   434*/     OPC_MoveParent,
/*   435*/     OPC_Scope, 18, /*->455*/ // 3 children in Scope
/*   437*/      OPC_CheckPredicate1,  // Predicate_atomic_load_sub_i8
/*   438*/      OPC_MoveParent,
/*   439*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   440*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   442*/      OPC_EmitMergeInputChains1_0,
/*   443*/      OPC_EmitInteger32, 0, 
/*   445*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   455*/     /*Scope*/ 18, /*->474*/
/*   456*/      OPC_CheckPredicate2,  // Predicate_atomic_load_sub_i16
/*   457*/      OPC_MoveParent,
/*   458*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   459*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   461*/      OPC_EmitMergeInputChains1_0,
/*   462*/      OPC_EmitInteger32, 0, 
/*   464*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   474*/     /*Scope*/ 18, /*->493*/
/*   475*/      OPC_CheckPredicate3,  // Predicate_atomic_load_sub_i32
/*   476*/      OPC_MoveParent,
/*   477*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   478*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   480*/      OPC_EmitMergeInputChains1_0,
/*   481*/      OPC_EmitInteger32, 0, 
/*   483*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   493*/     0, /*End of Scope*/
/*   494*/    0, /*End of Scope*/
/*   495*/   /*SwitchOpcode*/ 11|128,1/*139*/, TARGET_VAL(ISD::ATOMIC_LOAD_AND),// ->638
/*   499*/    OPC_RecordMemRef,
/*   500*/    OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*   501*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   502*/    OPC_Scope, 66, /*->570*/ // 2 children in Scope
/*   504*/     OPC_CheckChild1TypeI32,
/*   505*/     OPC_MoveChild2,
/*   506*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   509*/     OPC_RecordChild0, // #2 = $val
/*   510*/     OPC_MoveParent,
/*   511*/     OPC_Scope, 18, /*->531*/ // 3 children in Scope
/*   513*/      OPC_CheckPredicate1,  // Predicate_atomic_load_and_i8
/*   514*/      OPC_MoveParent,
/*   515*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   516*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   518*/      OPC_EmitMergeInputChains1_0,
/*   519*/      OPC_EmitInteger32, 0, 
/*   521*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   531*/     /*Scope*/ 18, /*->550*/
/*   532*/      OPC_CheckPredicate2,  // Predicate_atomic_load_and_i16
/*   533*/      OPC_MoveParent,
/*   534*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   535*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   537*/      OPC_EmitMergeInputChains1_0,
/*   538*/      OPC_EmitInteger32, 0, 
/*   540*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   550*/     /*Scope*/ 18, /*->569*/
/*   551*/      OPC_CheckPredicate3,  // Predicate_atomic_load_and_i32
/*   552*/      OPC_MoveParent,
/*   553*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   554*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   556*/      OPC_EmitMergeInputChains1_0,
/*   557*/      OPC_EmitInteger32, 0, 
/*   559*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   569*/     0, /*End of Scope*/
/*   570*/    /*Scope*/ 66, /*->637*/
/*   571*/     OPC_CheckChild1TypeI64,
/*   572*/     OPC_MoveChild2,
/*   573*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   576*/     OPC_RecordChild0, // #2 = $val
/*   577*/     OPC_MoveParent,
/*   578*/     OPC_Scope, 18, /*->598*/ // 3 children in Scope
/*   580*/      OPC_CheckPredicate1,  // Predicate_atomic_load_and_i8
/*   581*/      OPC_MoveParent,
/*   582*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   583*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   585*/      OPC_EmitMergeInputChains1_0,
/*   586*/      OPC_EmitInteger32, 0, 
/*   588*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   598*/     /*Scope*/ 18, /*->617*/
/*   599*/      OPC_CheckPredicate2,  // Predicate_atomic_load_and_i16
/*   600*/      OPC_MoveParent,
/*   601*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   602*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   604*/      OPC_EmitMergeInputChains1_0,
/*   605*/      OPC_EmitInteger32, 0, 
/*   607*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   617*/     /*Scope*/ 18, /*->636*/
/*   618*/      OPC_CheckPredicate3,  // Predicate_atomic_load_and_i32
/*   619*/      OPC_MoveParent,
/*   620*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   621*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   623*/      OPC_EmitMergeInputChains1_0,
/*   624*/      OPC_EmitInteger32, 0, 
/*   626*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   636*/     0, /*End of Scope*/
/*   637*/    0, /*End of Scope*/
/*   638*/   /*SwitchOpcode*/ 11|128,1/*139*/, TARGET_VAL(ISD::ATOMIC_LOAD_OR),// ->781
/*   642*/    OPC_RecordMemRef,
/*   643*/    OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/*   644*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   645*/    OPC_Scope, 66, /*->713*/ // 2 children in Scope
/*   647*/     OPC_CheckChild1TypeI32,
/*   648*/     OPC_MoveChild2,
/*   649*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   652*/     OPC_RecordChild0, // #2 = $val
/*   653*/     OPC_MoveParent,
/*   654*/     OPC_Scope, 18, /*->674*/ // 3 children in Scope
/*   656*/      OPC_CheckPredicate1,  // Predicate_atomic_load_or_i8
/*   657*/      OPC_MoveParent,
/*   658*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   659*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   661*/      OPC_EmitMergeInputChains1_0,
/*   662*/      OPC_EmitInteger32, 0, 
/*   664*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   674*/     /*Scope*/ 18, /*->693*/
/*   675*/      OPC_CheckPredicate2,  // Predicate_atomic_load_or_i16
/*   676*/      OPC_MoveParent,
/*   677*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   678*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   680*/      OPC_EmitMergeInputChains1_0,
/*   681*/      OPC_EmitInteger32, 0, 
/*   683*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   693*/     /*Scope*/ 18, /*->712*/
/*   694*/      OPC_CheckPredicate3,  // Predicate_atomic_load_or_i32
/*   695*/      OPC_MoveParent,
/*   696*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   697*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   699*/      OPC_EmitMergeInputChains1_0,
/*   700*/      OPC_EmitInteger32, 0, 
/*   702*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   712*/     0, /*End of Scope*/
/*   713*/    /*Scope*/ 66, /*->780*/
/*   714*/     OPC_CheckChild1TypeI64,
/*   715*/     OPC_MoveChild2,
/*   716*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   719*/     OPC_RecordChild0, // #2 = $val
/*   720*/     OPC_MoveParent,
/*   721*/     OPC_Scope, 18, /*->741*/ // 3 children in Scope
/*   723*/      OPC_CheckPredicate1,  // Predicate_atomic_load_or_i8
/*   724*/      OPC_MoveParent,
/*   725*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   726*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   728*/      OPC_EmitMergeInputChains1_0,
/*   729*/      OPC_EmitInteger32, 0, 
/*   731*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   741*/     /*Scope*/ 18, /*->760*/
/*   742*/      OPC_CheckPredicate2,  // Predicate_atomic_load_or_i16
/*   743*/      OPC_MoveParent,
/*   744*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   745*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   747*/      OPC_EmitMergeInputChains1_0,
/*   748*/      OPC_EmitInteger32, 0, 
/*   750*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   760*/     /*Scope*/ 18, /*->779*/
/*   761*/      OPC_CheckPredicate3,  // Predicate_atomic_load_or_i32
/*   762*/      OPC_MoveParent,
/*   763*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   764*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   766*/      OPC_EmitMergeInputChains1_0,
/*   767*/      OPC_EmitInteger32, 0, 
/*   769*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   779*/     0, /*End of Scope*/
/*   780*/    0, /*End of Scope*/
/*   781*/   /*SwitchOpcode*/ 11|128,1/*139*/, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),// ->924
/*   785*/    OPC_RecordMemRef,
/*   786*/    OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/*   787*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   788*/    OPC_Scope, 66, /*->856*/ // 2 children in Scope
/*   790*/     OPC_CheckChild1TypeI32,
/*   791*/     OPC_MoveChild2,
/*   792*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   795*/     OPC_RecordChild0, // #2 = $val
/*   796*/     OPC_MoveParent,
/*   797*/     OPC_Scope, 18, /*->817*/ // 3 children in Scope
/*   799*/      OPC_CheckPredicate1,  // Predicate_atomic_load_xor_i8
/*   800*/      OPC_MoveParent,
/*   801*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   802*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   804*/      OPC_EmitMergeInputChains1_0,
/*   805*/      OPC_EmitInteger32, 0, 
/*   807*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   817*/     /*Scope*/ 18, /*->836*/
/*   818*/      OPC_CheckPredicate2,  // Predicate_atomic_load_xor_i16
/*   819*/      OPC_MoveParent,
/*   820*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   821*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   823*/      OPC_EmitMergeInputChains1_0,
/*   824*/      OPC_EmitInteger32, 0, 
/*   826*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   836*/     /*Scope*/ 18, /*->855*/
/*   837*/      OPC_CheckPredicate3,  // Predicate_atomic_load_xor_i32
/*   838*/      OPC_MoveParent,
/*   839*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   840*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   842*/      OPC_EmitMergeInputChains1_0,
/*   843*/      OPC_EmitInteger32, 0, 
/*   845*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   855*/     0, /*End of Scope*/
/*   856*/    /*Scope*/ 66, /*->923*/
/*   857*/     OPC_CheckChild1TypeI64,
/*   858*/     OPC_MoveChild2,
/*   859*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   862*/     OPC_RecordChild0, // #2 = $val
/*   863*/     OPC_MoveParent,
/*   864*/     OPC_Scope, 18, /*->884*/ // 3 children in Scope
/*   866*/      OPC_CheckPredicate1,  // Predicate_atomic_load_xor_i8
/*   867*/      OPC_MoveParent,
/*   868*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   869*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   871*/      OPC_EmitMergeInputChains1_0,
/*   872*/      OPC_EmitInteger32, 0, 
/*   874*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   884*/     /*Scope*/ 18, /*->903*/
/*   885*/      OPC_CheckPredicate2,  // Predicate_atomic_load_xor_i16
/*   886*/      OPC_MoveParent,
/*   887*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   888*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   890*/      OPC_EmitMergeInputChains1_0,
/*   891*/      OPC_EmitInteger32, 0, 
/*   893*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   903*/     /*Scope*/ 18, /*->922*/
/*   904*/      OPC_CheckPredicate3,  // Predicate_atomic_load_xor_i32
/*   905*/      OPC_MoveParent,
/*   906*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   907*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*   909*/      OPC_EmitMergeInputChains1_0,
/*   910*/      OPC_EmitInteger32, 0, 
/*   912*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*   922*/     0, /*End of Scope*/
/*   923*/    0, /*End of Scope*/
/*   924*/   /*SwitchOpcode*/ 11|128,1/*139*/, TARGET_VAL(ISD::ATOMIC_SWAP),// ->1067
/*   928*/    OPC_RecordMemRef,
/*   929*/    OPC_RecordNode, // #0 = 'atomic_swap' chained node
/*   930*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*   931*/    OPC_Scope, 66, /*->999*/ // 2 children in Scope
/*   933*/     OPC_CheckChild1TypeI32,
/*   934*/     OPC_MoveChild2,
/*   935*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*   938*/     OPC_RecordChild0, // #2 = $val
/*   939*/     OPC_MoveParent,
/*   940*/     OPC_Scope, 18, /*->960*/ // 3 children in Scope
/*   942*/      OPC_CheckPredicate1,  // Predicate_atomic_swap_i8
/*   943*/      OPC_MoveParent,
/*   944*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   945*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   947*/      OPC_EmitMergeInputChains1_0,
/*   948*/      OPC_EmitInteger32, 0, 
/*   950*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   960*/     /*Scope*/ 18, /*->979*/
/*   961*/      OPC_CheckPredicate2,  // Predicate_atomic_swap_i16
/*   962*/      OPC_MoveParent,
/*   963*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   964*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   966*/      OPC_EmitMergeInputChains1_0,
/*   967*/      OPC_EmitInteger32, 0, 
/*   969*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   979*/     /*Scope*/ 18, /*->998*/
/*   980*/      OPC_CheckPredicate3,  // Predicate_atomic_swap_i32
/*   981*/      OPC_MoveParent,
/*   982*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*   983*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*   985*/      OPC_EmitMergeInputChains1_0,
/*   986*/      OPC_EmitInteger32, 0, 
/*   988*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*   998*/     0, /*End of Scope*/
/*   999*/    /*Scope*/ 66, /*->1066*/
/*  1000*/     OPC_CheckChild1TypeI64,
/*  1001*/     OPC_MoveChild2,
/*  1002*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1005*/     OPC_RecordChild0, // #2 = $val
/*  1006*/     OPC_MoveParent,
/*  1007*/     OPC_Scope, 18, /*->1027*/ // 3 children in Scope
/*  1009*/      OPC_CheckPredicate1,  // Predicate_atomic_swap_i8
/*  1010*/      OPC_MoveParent,
/*  1011*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1012*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1014*/      OPC_EmitMergeInputChains1_0,
/*  1015*/      OPC_EmitInteger32, 0, 
/*  1017*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1027*/     /*Scope*/ 18, /*->1046*/
/*  1028*/      OPC_CheckPredicate2,  // Predicate_atomic_swap_i16
/*  1029*/      OPC_MoveParent,
/*  1030*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1031*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1033*/      OPC_EmitMergeInputChains1_0,
/*  1034*/      OPC_EmitInteger32, 0, 
/*  1036*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1046*/     /*Scope*/ 18, /*->1065*/
/*  1047*/      OPC_CheckPredicate3,  // Predicate_atomic_swap_i32
/*  1048*/      OPC_MoveParent,
/*  1049*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1050*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1052*/      OPC_EmitMergeInputChains1_0,
/*  1053*/      OPC_EmitInteger32, 0, 
/*  1055*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW32_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (zext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i32>>) - Complexity = 19
                // Dst: (ATOMIC_RMW32_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1065*/     0, /*End of Scope*/
/*  1066*/    0, /*End of Scope*/
/*  1067*/   /*SwitchOpcode*/ 121, TARGET_VAL(ISD::ATOMIC_LOAD),// ->1191
/*  1070*/    OPC_RecordMemRef,
/*  1071*/    OPC_RecordNode, // #0 = 'atomic_load' chained node
/*  1072*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1073*/    OPC_Scope, 57, /*->1132*/ // 2 children in Scope
/*  1075*/     OPC_CheckChild1TypeI32,
/*  1076*/     OPC_Scope, 17, /*->1095*/ // 3 children in Scope
/*  1078*/      OPC_CheckPredicate1,  // Predicate_atomic_load_8
/*  1079*/      OPC_MoveParent,
/*  1080*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  1081*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  1083*/      OPC_EmitMergeInputChains1_0,
/*  1084*/      OPC_EmitInteger32, 0, 
/*  1086*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_8>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  1095*/     /*Scope*/ 17, /*->1113*/
/*  1096*/      OPC_CheckPredicate2,  // Predicate_atomic_load_16
/*  1097*/      OPC_MoveParent,
/*  1098*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  1099*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  1101*/      OPC_EmitMergeInputChains1_0,
/*  1102*/      OPC_EmitInteger32, 0, 
/*  1104*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_16>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  1113*/     /*Scope*/ 17, /*->1131*/
/*  1114*/      OPC_CheckPredicate3,  // Predicate_atomic_load_32
/*  1115*/      OPC_MoveParent,
/*  1116*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  1117*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  1119*/      OPC_EmitMergeInputChains1_0,
/*  1120*/      OPC_EmitInteger32, 0, 
/*  1122*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD32_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_32>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD32_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  1131*/     0, /*End of Scope*/
/*  1132*/    /*Scope*/ 57, /*->1190*/
/*  1133*/     OPC_CheckChild1TypeI64,
/*  1134*/     OPC_Scope, 17, /*->1153*/ // 3 children in Scope
/*  1136*/      OPC_CheckPredicate1,  // Predicate_atomic_load_8
/*  1137*/      OPC_MoveParent,
/*  1138*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  1139*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  1141*/      OPC_EmitMergeInputChains1_0,
/*  1142*/      OPC_EmitInteger32, 0, 
/*  1144*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_8>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  1153*/     /*Scope*/ 17, /*->1171*/
/*  1154*/      OPC_CheckPredicate2,  // Predicate_atomic_load_16
/*  1155*/      OPC_MoveParent,
/*  1156*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  1157*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  1159*/      OPC_EmitMergeInputChains1_0,
/*  1160*/      OPC_EmitInteger32, 0, 
/*  1162*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_16>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  1171*/     /*Scope*/ 17, /*->1189*/
/*  1172*/      OPC_CheckPredicate3,  // Predicate_atomic_load_32
/*  1173*/      OPC_MoveParent,
/*  1174*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  1175*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  1177*/      OPC_EmitMergeInputChains1_0,
/*  1178*/      OPC_EmitInteger32, 0, 
/*  1180*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD32_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (zext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_32>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD32_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  1189*/     0, /*End of Scope*/
/*  1190*/    0, /*End of Scope*/
/*  1191*/   0, // EndSwitchOpcode
/*  1192*/  /*Scope*/ 7, /*->1200*/
/*  1193*/   OPC_RecordChild0, // #0 = $src
/*  1194*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND_U_I32),
                 /*MVT::i64*/8, 1/*#Ops*/, 0, 
             // Src: (zext:{ *:[i64] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (I64_EXTEND_U_I32:{ *:[i64] } I32:{ *:[i32] }:$src)
/*  1200*/  0, /*End of Scope*/
/*  1201*/ /*SwitchOpcode*/ 86|128,6/*854*/, TARGET_VAL(ISD::ANY_EXTEND),// ->2059
/*  1205*/  OPC_Scope, 74|128,6/*842*/, /*->2050*/ // 2 children in Scope
/*  1208*/   OPC_MoveChild0,
/*  1209*/   OPC_SwitchOpcode /*8 cases */, 124, TARGET_VAL(ISD::AssertZext),// ->1337
/*  1213*/    OPC_MoveChild0,
/*  1214*/    OPC_CheckOpcode, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),
/*  1217*/    OPC_RecordMemRef,
/*  1218*/    OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/*  1219*/    OPC_CheckFoldableChainNode,
/*  1220*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1221*/    OPC_Scope, 56, /*->1279*/ // 2 children in Scope
/*  1223*/     OPC_CheckChild1TypeI32,
/*  1224*/     OPC_MoveChild2,
/*  1225*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1228*/     OPC_RecordChild0, // #2 = $exp
/*  1229*/     OPC_MoveSibling3,
/*  1230*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1233*/     OPC_RecordChild0, // #3 = $new
/*  1234*/     OPC_MoveParent,
/*  1235*/     OPC_Scope, 20, /*->1257*/ // 2 children in Scope
/*  1237*/      OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_i8
/*  1238*/      OPC_MoveParent,
/*  1239*/      OPC_MoveParent,
/*  1240*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1241*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  1243*/      OPC_EmitMergeInputChains1_0,
/*  1244*/      OPC_EmitInteger32, 0, 
/*  1246*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i8>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  1257*/     /*Scope*/ 20, /*->1278*/
/*  1258*/      OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_i16
/*  1259*/      OPC_MoveParent,
/*  1260*/      OPC_MoveParent,
/*  1261*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1262*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  1264*/      OPC_EmitMergeInputChains1_0,
/*  1265*/      OPC_EmitInteger32, 0, 
/*  1267*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i16>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  1278*/     0, /*End of Scope*/
/*  1279*/    /*Scope*/ 56, /*->1336*/
/*  1280*/     OPC_CheckChild1TypeI64,
/*  1281*/     OPC_MoveChild2,
/*  1282*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1285*/     OPC_RecordChild0, // #2 = $exp
/*  1286*/     OPC_MoveSibling3,
/*  1287*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1290*/     OPC_RecordChild0, // #3 = $new
/*  1291*/     OPC_MoveParent,
/*  1292*/     OPC_Scope, 20, /*->1314*/ // 2 children in Scope
/*  1294*/      OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_i8
/*  1295*/      OPC_MoveParent,
/*  1296*/      OPC_MoveParent,
/*  1297*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1298*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  1300*/      OPC_EmitMergeInputChains1_0,
/*  1301*/      OPC_EmitInteger32, 0, 
/*  1303*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i8>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW8_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  1314*/     /*Scope*/ 20, /*->1335*/
/*  1315*/      OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_i16
/*  1316*/      OPC_MoveParent,
/*  1317*/      OPC_MoveParent,
/*  1318*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1319*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  1321*/      OPC_EmitMergeInputChains1_0,
/*  1322*/      OPC_EmitInteger32, 0, 
/*  1324*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 5/*#Ops*/, 6, 4, 5, 2, 3, 
                // Src: (anyext:{ *:[i64] } (assertzext:{ *:[i32] } (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$exp), (trunc:{ *:[i32] } i64:{ *:[i64] }:$new))<<P:Predicate_atomic_cmp_swap_i16>>)) - Complexity = 25
                // Dst: (ATOMIC_RMW16_U_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  1335*/     0, /*End of Scope*/
/*  1336*/    0, /*End of Scope*/
/*  1337*/   /*SwitchOpcode*/ 101, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),// ->1441
/*  1340*/    OPC_RecordMemRef,
/*  1341*/    OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*  1342*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1343*/    OPC_Scope, 47, /*->1392*/ // 2 children in Scope
/*  1345*/     OPC_CheckChild1TypeI32,
/*  1346*/     OPC_MoveChild2,
/*  1347*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1350*/     OPC_RecordChild0, // #2 = $val
/*  1351*/     OPC_MoveParent,
/*  1352*/     OPC_Scope, 18, /*->1372*/ // 2 children in Scope
/*  1354*/      OPC_CheckPredicate1,  // Predicate_atomic_load_add_i8
/*  1355*/      OPC_MoveParent,
/*  1356*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1357*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1359*/      OPC_EmitMergeInputChains1_0,
/*  1360*/      OPC_EmitInteger32, 0, 
/*  1362*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1372*/     /*Scope*/ 18, /*->1391*/
/*  1373*/      OPC_CheckPredicate2,  // Predicate_atomic_load_add_i16
/*  1374*/      OPC_MoveParent,
/*  1375*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1376*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1378*/      OPC_EmitMergeInputChains1_0,
/*  1379*/      OPC_EmitInteger32, 0, 
/*  1381*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1391*/     0, /*End of Scope*/
/*  1392*/    /*Scope*/ 47, /*->1440*/
/*  1393*/     OPC_CheckChild1TypeI64,
/*  1394*/     OPC_MoveChild2,
/*  1395*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1398*/     OPC_RecordChild0, // #2 = $val
/*  1399*/     OPC_MoveParent,
/*  1400*/     OPC_Scope, 18, /*->1420*/ // 2 children in Scope
/*  1402*/      OPC_CheckPredicate1,  // Predicate_atomic_load_add_i8
/*  1403*/      OPC_MoveParent,
/*  1404*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1405*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1407*/      OPC_EmitMergeInputChains1_0,
/*  1408*/      OPC_EmitInteger32, 0, 
/*  1410*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1420*/     /*Scope*/ 18, /*->1439*/
/*  1421*/      OPC_CheckPredicate2,  // Predicate_atomic_load_add_i16
/*  1422*/      OPC_MoveParent,
/*  1423*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1424*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1426*/      OPC_EmitMergeInputChains1_0,
/*  1427*/      OPC_EmitInteger32, 0, 
/*  1429*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_add_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1439*/     0, /*End of Scope*/
/*  1440*/    0, /*End of Scope*/
/*  1441*/   /*SwitchOpcode*/ 101, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),// ->1545
/*  1444*/    OPC_RecordMemRef,
/*  1445*/    OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*  1446*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1447*/    OPC_Scope, 47, /*->1496*/ // 2 children in Scope
/*  1449*/     OPC_CheckChild1TypeI32,
/*  1450*/     OPC_MoveChild2,
/*  1451*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1454*/     OPC_RecordChild0, // #2 = $val
/*  1455*/     OPC_MoveParent,
/*  1456*/     OPC_Scope, 18, /*->1476*/ // 2 children in Scope
/*  1458*/      OPC_CheckPredicate1,  // Predicate_atomic_load_sub_i8
/*  1459*/      OPC_MoveParent,
/*  1460*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1461*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1463*/      OPC_EmitMergeInputChains1_0,
/*  1464*/      OPC_EmitInteger32, 0, 
/*  1466*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1476*/     /*Scope*/ 18, /*->1495*/
/*  1477*/      OPC_CheckPredicate2,  // Predicate_atomic_load_sub_i16
/*  1478*/      OPC_MoveParent,
/*  1479*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1480*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1482*/      OPC_EmitMergeInputChains1_0,
/*  1483*/      OPC_EmitInteger32, 0, 
/*  1485*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1495*/     0, /*End of Scope*/
/*  1496*/    /*Scope*/ 47, /*->1544*/
/*  1497*/     OPC_CheckChild1TypeI64,
/*  1498*/     OPC_MoveChild2,
/*  1499*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1502*/     OPC_RecordChild0, // #2 = $val
/*  1503*/     OPC_MoveParent,
/*  1504*/     OPC_Scope, 18, /*->1524*/ // 2 children in Scope
/*  1506*/      OPC_CheckPredicate1,  // Predicate_atomic_load_sub_i8
/*  1507*/      OPC_MoveParent,
/*  1508*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1509*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1511*/      OPC_EmitMergeInputChains1_0,
/*  1512*/      OPC_EmitInteger32, 0, 
/*  1514*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1524*/     /*Scope*/ 18, /*->1543*/
/*  1525*/      OPC_CheckPredicate2,  // Predicate_atomic_load_sub_i16
/*  1526*/      OPC_MoveParent,
/*  1527*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1528*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1530*/      OPC_EmitMergeInputChains1_0,
/*  1531*/      OPC_EmitInteger32, 0, 
/*  1533*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_sub_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1543*/     0, /*End of Scope*/
/*  1544*/    0, /*End of Scope*/
/*  1545*/   /*SwitchOpcode*/ 101, TARGET_VAL(ISD::ATOMIC_LOAD_AND),// ->1649
/*  1548*/    OPC_RecordMemRef,
/*  1549*/    OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*  1550*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1551*/    OPC_Scope, 47, /*->1600*/ // 2 children in Scope
/*  1553*/     OPC_CheckChild1TypeI32,
/*  1554*/     OPC_MoveChild2,
/*  1555*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1558*/     OPC_RecordChild0, // #2 = $val
/*  1559*/     OPC_MoveParent,
/*  1560*/     OPC_Scope, 18, /*->1580*/ // 2 children in Scope
/*  1562*/      OPC_CheckPredicate1,  // Predicate_atomic_load_and_i8
/*  1563*/      OPC_MoveParent,
/*  1564*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1565*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1567*/      OPC_EmitMergeInputChains1_0,
/*  1568*/      OPC_EmitInteger32, 0, 
/*  1570*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1580*/     /*Scope*/ 18, /*->1599*/
/*  1581*/      OPC_CheckPredicate2,  // Predicate_atomic_load_and_i16
/*  1582*/      OPC_MoveParent,
/*  1583*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1584*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1586*/      OPC_EmitMergeInputChains1_0,
/*  1587*/      OPC_EmitInteger32, 0, 
/*  1589*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1599*/     0, /*End of Scope*/
/*  1600*/    /*Scope*/ 47, /*->1648*/
/*  1601*/     OPC_CheckChild1TypeI64,
/*  1602*/     OPC_MoveChild2,
/*  1603*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1606*/     OPC_RecordChild0, // #2 = $val
/*  1607*/     OPC_MoveParent,
/*  1608*/     OPC_Scope, 18, /*->1628*/ // 2 children in Scope
/*  1610*/      OPC_CheckPredicate1,  // Predicate_atomic_load_and_i8
/*  1611*/      OPC_MoveParent,
/*  1612*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1613*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1615*/      OPC_EmitMergeInputChains1_0,
/*  1616*/      OPC_EmitInteger32, 0, 
/*  1618*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1628*/     /*Scope*/ 18, /*->1647*/
/*  1629*/      OPC_CheckPredicate2,  // Predicate_atomic_load_and_i16
/*  1630*/      OPC_MoveParent,
/*  1631*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1632*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1634*/      OPC_EmitMergeInputChains1_0,
/*  1635*/      OPC_EmitInteger32, 0, 
/*  1637*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_and_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1647*/     0, /*End of Scope*/
/*  1648*/    0, /*End of Scope*/
/*  1649*/   /*SwitchOpcode*/ 101, TARGET_VAL(ISD::ATOMIC_LOAD_OR),// ->1753
/*  1652*/    OPC_RecordMemRef,
/*  1653*/    OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/*  1654*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1655*/    OPC_Scope, 47, /*->1704*/ // 2 children in Scope
/*  1657*/     OPC_CheckChild1TypeI32,
/*  1658*/     OPC_MoveChild2,
/*  1659*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1662*/     OPC_RecordChild0, // #2 = $val
/*  1663*/     OPC_MoveParent,
/*  1664*/     OPC_Scope, 18, /*->1684*/ // 2 children in Scope
/*  1666*/      OPC_CheckPredicate1,  // Predicate_atomic_load_or_i8
/*  1667*/      OPC_MoveParent,
/*  1668*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1669*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1671*/      OPC_EmitMergeInputChains1_0,
/*  1672*/      OPC_EmitInteger32, 0, 
/*  1674*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1684*/     /*Scope*/ 18, /*->1703*/
/*  1685*/      OPC_CheckPredicate2,  // Predicate_atomic_load_or_i16
/*  1686*/      OPC_MoveParent,
/*  1687*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1688*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1690*/      OPC_EmitMergeInputChains1_0,
/*  1691*/      OPC_EmitInteger32, 0, 
/*  1693*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1703*/     0, /*End of Scope*/
/*  1704*/    /*Scope*/ 47, /*->1752*/
/*  1705*/     OPC_CheckChild1TypeI64,
/*  1706*/     OPC_MoveChild2,
/*  1707*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1710*/     OPC_RecordChild0, // #2 = $val
/*  1711*/     OPC_MoveParent,
/*  1712*/     OPC_Scope, 18, /*->1732*/ // 2 children in Scope
/*  1714*/      OPC_CheckPredicate1,  // Predicate_atomic_load_or_i8
/*  1715*/      OPC_MoveParent,
/*  1716*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1717*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1719*/      OPC_EmitMergeInputChains1_0,
/*  1720*/      OPC_EmitInteger32, 0, 
/*  1722*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1732*/     /*Scope*/ 18, /*->1751*/
/*  1733*/      OPC_CheckPredicate2,  // Predicate_atomic_load_or_i16
/*  1734*/      OPC_MoveParent,
/*  1735*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1736*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1738*/      OPC_EmitMergeInputChains1_0,
/*  1739*/      OPC_EmitInteger32, 0, 
/*  1741*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_or_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1751*/     0, /*End of Scope*/
/*  1752*/    0, /*End of Scope*/
/*  1753*/   /*SwitchOpcode*/ 101, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),// ->1857
/*  1756*/    OPC_RecordMemRef,
/*  1757*/    OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/*  1758*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1759*/    OPC_Scope, 47, /*->1808*/ // 2 children in Scope
/*  1761*/     OPC_CheckChild1TypeI32,
/*  1762*/     OPC_MoveChild2,
/*  1763*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1766*/     OPC_RecordChild0, // #2 = $val
/*  1767*/     OPC_MoveParent,
/*  1768*/     OPC_Scope, 18, /*->1788*/ // 2 children in Scope
/*  1770*/      OPC_CheckPredicate1,  // Predicate_atomic_load_xor_i8
/*  1771*/      OPC_MoveParent,
/*  1772*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1773*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1775*/      OPC_EmitMergeInputChains1_0,
/*  1776*/      OPC_EmitInteger32, 0, 
/*  1778*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1788*/     /*Scope*/ 18, /*->1807*/
/*  1789*/      OPC_CheckPredicate2,  // Predicate_atomic_load_xor_i16
/*  1790*/      OPC_MoveParent,
/*  1791*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1792*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1794*/      OPC_EmitMergeInputChains1_0,
/*  1795*/      OPC_EmitInteger32, 0, 
/*  1797*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1807*/     0, /*End of Scope*/
/*  1808*/    /*Scope*/ 47, /*->1856*/
/*  1809*/     OPC_CheckChild1TypeI64,
/*  1810*/     OPC_MoveChild2,
/*  1811*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1814*/     OPC_RecordChild0, // #2 = $val
/*  1815*/     OPC_MoveParent,
/*  1816*/     OPC_Scope, 18, /*->1836*/ // 2 children in Scope
/*  1818*/      OPC_CheckPredicate1,  // Predicate_atomic_load_xor_i8
/*  1819*/      OPC_MoveParent,
/*  1820*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1821*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1823*/      OPC_EmitMergeInputChains1_0,
/*  1824*/      OPC_EmitInteger32, 0, 
/*  1826*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1836*/     /*Scope*/ 18, /*->1855*/
/*  1837*/      OPC_CheckPredicate2,  // Predicate_atomic_load_xor_i16
/*  1838*/      OPC_MoveParent,
/*  1839*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1840*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1842*/      OPC_EmitMergeInputChains1_0,
/*  1843*/      OPC_EmitInteger32, 0, 
/*  1845*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_load_xor_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1855*/     0, /*End of Scope*/
/*  1856*/    0, /*End of Scope*/
/*  1857*/   /*SwitchOpcode*/ 101, TARGET_VAL(ISD::ATOMIC_SWAP),// ->1961
/*  1860*/    OPC_RecordMemRef,
/*  1861*/    OPC_RecordNode, // #0 = 'atomic_swap' chained node
/*  1862*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1863*/    OPC_Scope, 47, /*->1912*/ // 2 children in Scope
/*  1865*/     OPC_CheckChild1TypeI32,
/*  1866*/     OPC_MoveChild2,
/*  1867*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1870*/     OPC_RecordChild0, // #2 = $val
/*  1871*/     OPC_MoveParent,
/*  1872*/     OPC_Scope, 18, /*->1892*/ // 2 children in Scope
/*  1874*/      OPC_CheckPredicate1,  // Predicate_atomic_swap_i8
/*  1875*/      OPC_MoveParent,
/*  1876*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1877*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1879*/      OPC_EmitMergeInputChains1_0,
/*  1880*/      OPC_EmitInteger32, 0, 
/*  1882*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1892*/     /*Scope*/ 18, /*->1911*/
/*  1893*/      OPC_CheckPredicate2,  // Predicate_atomic_swap_i16
/*  1894*/      OPC_MoveParent,
/*  1895*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1896*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  1898*/      OPC_EmitMergeInputChains1_0,
/*  1899*/      OPC_EmitInteger32, 0, 
/*  1901*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  1911*/     0, /*End of Scope*/
/*  1912*/    /*Scope*/ 47, /*->1960*/
/*  1913*/     OPC_CheckChild1TypeI64,
/*  1914*/     OPC_MoveChild2,
/*  1915*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  1918*/     OPC_RecordChild0, // #2 = $val
/*  1919*/     OPC_MoveParent,
/*  1920*/     OPC_Scope, 18, /*->1940*/ // 2 children in Scope
/*  1922*/      OPC_CheckPredicate1,  // Predicate_atomic_swap_i8
/*  1923*/      OPC_MoveParent,
/*  1924*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1925*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1927*/      OPC_EmitMergeInputChains1_0,
/*  1928*/      OPC_EmitInteger32, 0, 
/*  1930*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i8>>) - Complexity = 19
                // Dst: (ATOMIC_RMW8_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1940*/     /*Scope*/ 18, /*->1959*/
/*  1941*/      OPC_CheckPredicate2,  // Predicate_atomic_swap_i16
/*  1942*/      OPC_MoveParent,
/*  1943*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  1944*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  1946*/      OPC_EmitMergeInputChains1_0,
/*  1947*/      OPC_EmitInteger32, 0, 
/*  1949*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
                // Src: (anyext:{ *:[i64] } (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), (trunc:{ *:[i32] } i64:{ *:[i64] }:$val))<<P:Predicate_atomic_swap_i16>>) - Complexity = 19
                // Dst: (ATOMIC_RMW16_U_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  1959*/     0, /*End of Scope*/
/*  1960*/    0, /*End of Scope*/
/*  1961*/   /*SwitchOpcode*/ 85, TARGET_VAL(ISD::ATOMIC_LOAD),// ->2049
/*  1964*/    OPC_RecordMemRef,
/*  1965*/    OPC_RecordNode, // #0 = 'atomic_load' chained node
/*  1966*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  1967*/    OPC_Scope, 39, /*->2008*/ // 2 children in Scope
/*  1969*/     OPC_CheckChild1TypeI32,
/*  1970*/     OPC_Scope, 17, /*->1989*/ // 2 children in Scope
/*  1972*/      OPC_CheckPredicate1,  // Predicate_atomic_load_8
/*  1973*/      OPC_MoveParent,
/*  1974*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  1975*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  1977*/      OPC_EmitMergeInputChains1_0,
/*  1978*/      OPC_EmitInteger32, 0, 
/*  1980*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_8>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  1989*/     /*Scope*/ 17, /*->2007*/
/*  1990*/      OPC_CheckPredicate2,  // Predicate_atomic_load_16
/*  1991*/      OPC_MoveParent,
/*  1992*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  1993*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  1995*/      OPC_EmitMergeInputChains1_0,
/*  1996*/      OPC_EmitInteger32, 0, 
/*  1998*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_16>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  2007*/     0, /*End of Scope*/
/*  2008*/    /*Scope*/ 39, /*->2048*/
/*  2009*/     OPC_CheckChild1TypeI64,
/*  2010*/     OPC_Scope, 17, /*->2029*/ // 2 children in Scope
/*  2012*/      OPC_CheckPredicate1,  // Predicate_atomic_load_8
/*  2013*/      OPC_MoveParent,
/*  2014*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2015*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  2017*/      OPC_EmitMergeInputChains1_0,
/*  2018*/      OPC_EmitInteger32, 0, 
/*  2020*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_8>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  2029*/     /*Scope*/ 17, /*->2047*/
/*  2030*/      OPC_CheckPredicate2,  // Predicate_atomic_load_16
/*  2031*/      OPC_MoveParent,
/*  2032*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2033*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  2035*/      OPC_EmitMergeInputChains1_0,
/*  2036*/      OPC_EmitInteger32, 0, 
/*  2038*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (anyext:{ *:[i64] } (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_16>>) - Complexity = 16
                // Dst: (ATOMIC_LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  2047*/     0, /*End of Scope*/
/*  2048*/    0, /*End of Scope*/
/*  2049*/   0, // EndSwitchOpcode
/*  2050*/  /*Scope*/ 7, /*->2058*/
/*  2051*/   OPC_RecordChild0, // #0 = $src
/*  2052*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND_U_I32),
                 /*MVT::i64*/8, 1/*#Ops*/, 0, 
             // Src: (anyext:{ *:[i64] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (I64_EXTEND_U_I32:{ *:[i64] } I32:{ *:[i32] }:$src)
/*  2058*/  0, /*End of Scope*/
/*  2059*/ /*SwitchOpcode*/ 67|128,7/*963*/, TARGET_VAL(ISD::STORE),// ->3026
/*  2063*/  OPC_RecordMemRef,
/*  2064*/  OPC_RecordNode, // #0 = 'st' chained node
/*  2065*/  OPC_Scope, 127|128,1/*255*/, /*->2323*/ // 2 children in Scope
/*  2068*/   OPC_MoveChild1,
/*  2069*/   OPC_CheckOpcode, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
/*  2072*/   OPC_RecordChild0, // #1 = $vec
/*  2073*/   OPC_Scope, 64, /*->2139*/ // 4 children in Scope
/*  2075*/    OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/*  2077*/    OPC_RecordChild1, // #2 = $idx
/*  2078*/    OPC_MoveChild1,
/*  2079*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  2082*/    OPC_CheckPredicate, 18, // Predicate_LaneIdx16
/*  2084*/    OPC_CheckTypeI32,
/*  2085*/    OPC_MoveParent,
/*  2086*/    OPC_CheckTypeI32,
/*  2087*/    OPC_MoveParent,
/*  2088*/    OPC_RecordChild2, // #3 = $AddrOps32:offset:addr
/*  2089*/    OPC_Scope, 23, /*->2114*/ // 2 children in Scope
/*  2091*/     OPC_CheckChild2TypeI32,
/*  2092*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2093*/     OPC_CheckPredicate, 14, // Predicate_truncstore
/*  2095*/     OPC_CheckPredicate, 19, // Predicate_truncstorei8
/*  2097*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2098*/     OPC_CheckComplexPat0, /*#*/3, // SelectAddrOperands32:$ #4 #5
/*  2100*/     OPC_EmitMergeInputChains1_0,
/*  2101*/     OPC_EmitInteger32, 0, 
/*  2103*/     OPC_EmitConvertToTarget2,
/*  2104*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I8x16_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 21
               // Dst: (STORE_LANE_I8x16_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v16i8] }:$vec)
/*  2114*/    /*Scope*/ 23, /*->2138*/
/*  2115*/     OPC_CheckChild2TypeI64,
/*  2116*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2117*/     OPC_CheckPredicate, 14, // Predicate_truncstore
/*  2119*/     OPC_CheckPredicate, 19, // Predicate_truncstorei8
/*  2121*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2122*/     OPC_CheckComplexPat1, /*#*/3, // SelectAddrOperands64:$ #4 #5
/*  2124*/     OPC_EmitMergeInputChains1_0,
/*  2125*/     OPC_EmitInteger32, 0, 
/*  2127*/     OPC_EmitConvertToTarget2,
/*  2128*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I8x16_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 21
               // Dst: (STORE_LANE_I8x16_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v16i8] }:$vec)
/*  2138*/    0, /*End of Scope*/
/*  2139*/   /*Scope*/ 64, /*->2204*/
/*  2140*/    OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/*  2142*/    OPC_RecordChild1, // #2 = $idx
/*  2143*/    OPC_MoveChild1,
/*  2144*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  2147*/    OPC_CheckPredicate, 13, // Predicate_LaneIdx8
/*  2149*/    OPC_CheckTypeI32,
/*  2150*/    OPC_MoveParent,
/*  2151*/    OPC_CheckTypeI32,
/*  2152*/    OPC_MoveParent,
/*  2153*/    OPC_RecordChild2, // #3 = $AddrOps32:offset:addr
/*  2154*/    OPC_Scope, 23, /*->2179*/ // 2 children in Scope
/*  2156*/     OPC_CheckChild2TypeI32,
/*  2157*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2158*/     OPC_CheckPredicate, 14, // Predicate_truncstore
/*  2160*/     OPC_CheckPredicate, 20, // Predicate_truncstorei16
/*  2162*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2163*/     OPC_CheckComplexPat0, /*#*/3, // SelectAddrOperands32:$ #4 #5
/*  2165*/     OPC_EmitMergeInputChains1_0,
/*  2166*/     OPC_EmitInteger32, 0, 
/*  2168*/     OPC_EmitConvertToTarget2,
/*  2169*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 21
               // Dst: (STORE_LANE_I16x8_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v8i16] }:$vec)
/*  2179*/    /*Scope*/ 23, /*->2203*/
/*  2180*/     OPC_CheckChild2TypeI64,
/*  2181*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2182*/     OPC_CheckPredicate, 14, // Predicate_truncstore
/*  2184*/     OPC_CheckPredicate, 20, // Predicate_truncstorei16
/*  2186*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2187*/     OPC_CheckComplexPat1, /*#*/3, // SelectAddrOperands64:$ #4 #5
/*  2189*/     OPC_EmitMergeInputChains1_0,
/*  2190*/     OPC_EmitInteger32, 0, 
/*  2192*/     OPC_EmitConvertToTarget2,
/*  2193*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 21
               // Dst: (STORE_LANE_I16x8_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v8i16] }:$vec)
/*  2203*/    0, /*End of Scope*/
/*  2204*/   /*Scope*/ 58, /*->2263*/
/*  2205*/    OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/*  2207*/    OPC_RecordChild1, // #2 = $idx
/*  2208*/    OPC_MoveChild1,
/*  2209*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  2212*/    OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/*  2214*/    OPC_CheckTypeI32,
/*  2215*/    OPC_MoveParent,
/*  2216*/    OPC_CheckTypeI32,
/*  2217*/    OPC_MoveParent,
/*  2218*/    OPC_RecordChild2, // #3 = $AddrOps32:offset:addr
/*  2219*/    OPC_Scope, 20, /*->2241*/ // 2 children in Scope
/*  2221*/     OPC_CheckChild2TypeI32,
/*  2222*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2223*/     OPC_CheckPredicate5,  // Predicate_store
/*  2224*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2225*/     OPC_CheckComplexPat0, /*#*/3, // SelectAddrOperands32:$ #4 #5
/*  2227*/     OPC_EmitMergeInputChains1_0,
/*  2228*/     OPC_EmitInteger32, 0, 
/*  2230*/     OPC_EmitConvertToTarget2,
/*  2231*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 21
               // Dst: (STORE_LANE_I32x4_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v4i32] }:$vec)
/*  2241*/    /*Scope*/ 20, /*->2262*/
/*  2242*/     OPC_CheckChild2TypeI64,
/*  2243*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2244*/     OPC_CheckPredicate5,  // Predicate_store
/*  2245*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2246*/     OPC_CheckComplexPat1, /*#*/3, // SelectAddrOperands64:$ #4 #5
/*  2248*/     OPC_EmitMergeInputChains1_0,
/*  2249*/     OPC_EmitInteger32, 0, 
/*  2251*/     OPC_EmitConvertToTarget2,
/*  2252*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 21
               // Dst: (STORE_LANE_I32x4_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v4i32] }:$vec)
/*  2262*/    0, /*End of Scope*/
/*  2263*/   /*Scope*/ 58, /*->2322*/
/*  2264*/    OPC_CheckChild0Type, /*MVT::v2i64*/78, 
/*  2266*/    OPC_RecordChild1, // #2 = $idx
/*  2267*/    OPC_MoveChild1,
/*  2268*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  2271*/    OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/*  2273*/    OPC_CheckTypeI32,
/*  2274*/    OPC_MoveParent,
/*  2275*/    OPC_CheckTypeI64,
/*  2276*/    OPC_MoveParent,
/*  2277*/    OPC_RecordChild2, // #3 = $AddrOps32:offset:addr
/*  2278*/    OPC_Scope, 20, /*->2300*/ // 2 children in Scope
/*  2280*/     OPC_CheckChild2TypeI32,
/*  2281*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2282*/     OPC_CheckPredicate5,  // Predicate_store
/*  2283*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2284*/     OPC_CheckComplexPat0, /*#*/3, // SelectAddrOperands32:$ #4 #5
/*  2286*/     OPC_EmitMergeInputChains1_0,
/*  2287*/     OPC_EmitInteger32, 0, 
/*  2289*/     OPC_EmitConvertToTarget2,
/*  2290*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 21
               // Dst: (STORE_LANE_I64x2_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v2i64] }:$vec)
/*  2300*/    /*Scope*/ 20, /*->2321*/
/*  2301*/     OPC_CheckChild2TypeI64,
/*  2302*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2303*/     OPC_CheckPredicate5,  // Predicate_store
/*  2304*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2305*/     OPC_CheckComplexPat1, /*#*/3, // SelectAddrOperands64:$ #4 #5
/*  2307*/     OPC_EmitMergeInputChains1_0,
/*  2308*/     OPC_EmitInteger32, 0, 
/*  2310*/     OPC_EmitConvertToTarget2,
/*  2311*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_LANE_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   5/*#Ops*/, 6, 4, 7, 5, 1, 
               // Src: (st (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 21
               // Dst: (STORE_LANE_I64x2_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v2i64] }:$vec)
/*  2321*/    0, /*End of Scope*/
/*  2322*/   0, /*End of Scope*/
/*  2323*/  /*Scope*/ 60|128,5/*700*/, /*->3025*/
/*  2325*/   OPC_RecordChild1, // #1 = $val
/*  2326*/   OPC_Scope, 2|128,1/*130*/, /*->2459*/ // 11 children in Scope
/*  2329*/    OPC_CheckChild1TypeI32,
/*  2330*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2331*/    OPC_Scope, 62, /*->2395*/ // 2 children in Scope
/*  2333*/     OPC_CheckChild2TypeI32,
/*  2334*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2335*/     OPC_Scope, 16, /*->2353*/ // 2 children in Scope
/*  2337*/      OPC_CheckPredicate5,  // Predicate_store
/*  2338*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2339*/      OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2341*/      OPC_EmitMergeInputChains1_0,
/*  2342*/      OPC_EmitInteger32, 0, 
/*  2344*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (st i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                // Dst: (STORE_I32_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  2353*/     /*Scope*/ 40, /*->2394*/
/*  2354*/      OPC_CheckPredicate, 14, // Predicate_truncstore
/*  2356*/      OPC_Scope, 17, /*->2375*/ // 2 children in Scope
/*  2358*/       OPC_CheckPredicate, 19, // Predicate_truncstorei8
/*  2360*/       OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2361*/       OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2363*/       OPC_EmitMergeInputChains1_0,
/*  2364*/       OPC_EmitInteger32, 0, 
/*  2366*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 13
                 // Dst: (STORE8_I32_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  2375*/      /*Scope*/ 17, /*->2393*/
/*  2376*/       OPC_CheckPredicate, 20, // Predicate_truncstorei16
/*  2378*/       OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2379*/       OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2381*/       OPC_EmitMergeInputChains1_0,
/*  2382*/       OPC_EmitInteger32, 0, 
/*  2384*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 13
                 // Dst: (STORE16_I32_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i32:{ *:[i32] }:$val)
/*  2393*/      0, /*End of Scope*/
/*  2394*/     0, /*End of Scope*/
/*  2395*/    /*Scope*/ 62, /*->2458*/
/*  2396*/     OPC_CheckChild2TypeI64,
/*  2397*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2398*/     OPC_Scope, 16, /*->2416*/ // 2 children in Scope
/*  2400*/      OPC_CheckPredicate5,  // Predicate_store
/*  2401*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2402*/      OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2404*/      OPC_EmitMergeInputChains1_0,
/*  2405*/      OPC_EmitInteger32, 0, 
/*  2407*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (st i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                // Dst: (STORE_I32_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/*  2416*/     /*Scope*/ 40, /*->2457*/
/*  2417*/      OPC_CheckPredicate, 14, // Predicate_truncstore
/*  2419*/      OPC_Scope, 17, /*->2438*/ // 2 children in Scope
/*  2421*/       OPC_CheckPredicate, 19, // Predicate_truncstorei8
/*  2423*/       OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2424*/       OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2426*/       OPC_EmitMergeInputChains1_0,
/*  2427*/       OPC_EmitInteger32, 0, 
/*  2429*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 13
                 // Dst: (STORE8_I32_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/*  2438*/      /*Scope*/ 17, /*->2456*/
/*  2439*/       OPC_CheckPredicate, 20, // Predicate_truncstorei16
/*  2441*/       OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2442*/       OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2444*/       OPC_EmitMergeInputChains1_0,
/*  2445*/       OPC_EmitInteger32, 0, 
/*  2447*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 13
                 // Dst: (STORE16_I32_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i32:{ *:[i32] }:$val)
/*  2456*/      0, /*End of Scope*/
/*  2457*/     0, /*End of Scope*/
/*  2458*/    0, /*End of Scope*/
/*  2459*/   /*Scope*/ 38|128,1/*166*/, /*->2627*/
/*  2461*/    OPC_CheckChild1TypeI64,
/*  2462*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2463*/    OPC_Scope, 80, /*->2545*/ // 2 children in Scope
/*  2465*/     OPC_CheckChild2TypeI32,
/*  2466*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2467*/     OPC_Scope, 16, /*->2485*/ // 2 children in Scope
/*  2469*/      OPC_CheckPredicate5,  // Predicate_store
/*  2470*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2471*/      OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2473*/      OPC_EmitMergeInputChains1_0,
/*  2474*/      OPC_EmitInteger32, 0, 
/*  2476*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (st i64:{ *:[i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                // Dst: (STORE_I64_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2485*/     /*Scope*/ 58, /*->2544*/
/*  2486*/      OPC_CheckPredicate, 14, // Predicate_truncstore
/*  2488*/      OPC_Scope, 17, /*->2507*/ // 3 children in Scope
/*  2490*/       OPC_CheckPredicate, 19, // Predicate_truncstorei8
/*  2492*/       OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2493*/       OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2495*/       OPC_EmitMergeInputChains1_0,
/*  2496*/       OPC_EmitInteger32, 0, 
/*  2498*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 13
                 // Dst: (STORE8_I64_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2507*/      /*Scope*/ 17, /*->2525*/
/*  2508*/       OPC_CheckPredicate, 20, // Predicate_truncstorei16
/*  2510*/       OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2511*/       OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2513*/       OPC_EmitMergeInputChains1_0,
/*  2514*/       OPC_EmitInteger32, 0, 
/*  2516*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 13
                 // Dst: (STORE16_I64_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2525*/      /*Scope*/ 17, /*->2543*/
/*  2526*/       OPC_CheckPredicate, 25, // Predicate_truncstorei32
/*  2528*/       OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2529*/       OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2531*/       OPC_EmitMergeInputChains1_0,
/*  2532*/       OPC_EmitInteger32, 0, 
/*  2534*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE32_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>> - Complexity = 13
                 // Dst: (STORE32_I64_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, i64:{ *:[i64] }:$val)
/*  2543*/      0, /*End of Scope*/
/*  2544*/     0, /*End of Scope*/
/*  2545*/    /*Scope*/ 80, /*->2626*/
/*  2546*/     OPC_CheckChild2TypeI64,
/*  2547*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2548*/     OPC_Scope, 16, /*->2566*/ // 2 children in Scope
/*  2550*/      OPC_CheckPredicate5,  // Predicate_store
/*  2551*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2552*/      OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2554*/      OPC_EmitMergeInputChains1_0,
/*  2555*/      OPC_EmitInteger32, 0, 
/*  2557*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (st i64:{ *:[i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
                // Dst: (STORE_I64_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  2566*/     /*Scope*/ 58, /*->2625*/
/*  2567*/      OPC_CheckPredicate, 14, // Predicate_truncstore
/*  2569*/      OPC_Scope, 17, /*->2588*/ // 3 children in Scope
/*  2571*/       OPC_CheckPredicate, 19, // Predicate_truncstorei8
/*  2573*/       OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2574*/       OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2576*/       OPC_EmitMergeInputChains1_0,
/*  2577*/       OPC_EmitInteger32, 0, 
/*  2579*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE8_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei8>> - Complexity = 13
                 // Dst: (STORE8_I64_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  2588*/      /*Scope*/ 17, /*->2606*/
/*  2589*/       OPC_CheckPredicate, 20, // Predicate_truncstorei16
/*  2591*/       OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2592*/       OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2594*/       OPC_EmitMergeInputChains1_0,
/*  2595*/       OPC_EmitInteger32, 0, 
/*  2597*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE16_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei16>> - Complexity = 13
                 // Dst: (STORE16_I64_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  2606*/      /*Scope*/ 17, /*->2624*/
/*  2607*/       OPC_CheckPredicate, 25, // Predicate_truncstorei32
/*  2609*/       OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2610*/       OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2612*/       OPC_EmitMergeInputChains1_0,
/*  2613*/       OPC_EmitInteger32, 0, 
/*  2615*/       OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE32_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     4/*#Ops*/, 5, 3, 4, 1, 
                 // Src: (st i64:{ *:[i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_truncstore>><<P:Predicate_truncstorei32>> - Complexity = 13
                 // Dst: (STORE32_I64_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, i64:{ *:[i64] }:$val)
/*  2624*/      0, /*End of Scope*/
/*  2625*/     0, /*End of Scope*/
/*  2626*/    0, /*End of Scope*/
/*  2627*/   /*Scope*/ 43, /*->2671*/
/*  2628*/    OPC_CheckChild1Type, /*MVT::f32*/12, 
/*  2630*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2631*/    OPC_Scope, 18, /*->2651*/ // 2 children in Scope
/*  2633*/     OPC_CheckChild2TypeI32,
/*  2634*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2635*/     OPC_CheckPredicate5,  // Predicate_store
/*  2636*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2637*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2639*/     OPC_EmitMergeInputChains1_0,
/*  2640*/     OPC_EmitInteger32, 0, 
/*  2642*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st f32:{ *:[f32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_F32_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, f32:{ *:[f32] }:$val)
/*  2651*/    /*Scope*/ 18, /*->2670*/
/*  2652*/     OPC_CheckChild2TypeI64,
/*  2653*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2654*/     OPC_CheckPredicate5,  // Predicate_store
/*  2655*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2656*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2658*/     OPC_EmitMergeInputChains1_0,
/*  2659*/     OPC_EmitInteger32, 0, 
/*  2661*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st f32:{ *:[f32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_F32_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, f32:{ *:[f32] }:$val)
/*  2670*/    0, /*End of Scope*/
/*  2671*/   /*Scope*/ 43, /*->2715*/
/*  2672*/    OPC_CheckChild1Type, /*MVT::f64*/13, 
/*  2674*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2675*/    OPC_Scope, 18, /*->2695*/ // 2 children in Scope
/*  2677*/     OPC_CheckChild2TypeI32,
/*  2678*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2679*/     OPC_CheckPredicate5,  // Predicate_store
/*  2680*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2681*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2683*/     OPC_EmitMergeInputChains1_0,
/*  2684*/     OPC_EmitInteger32, 0, 
/*  2686*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st f64:{ *:[f64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_F64_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, f64:{ *:[f64] }:$val)
/*  2695*/    /*Scope*/ 18, /*->2714*/
/*  2696*/     OPC_CheckChild2TypeI64,
/*  2697*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2698*/     OPC_CheckPredicate5,  // Predicate_store
/*  2699*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2700*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2702*/     OPC_EmitMergeInputChains1_0,
/*  2703*/     OPC_EmitInteger32, 0, 
/*  2705*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st f64:{ *:[f64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_F64_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, f64:{ *:[f64] }:$val)
/*  2714*/    0, /*End of Scope*/
/*  2715*/   /*Scope*/ 43, /*->2759*/
/*  2716*/    OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/*  2718*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2719*/    OPC_Scope, 18, /*->2739*/ // 2 children in Scope
/*  2721*/     OPC_CheckChild2TypeI32,
/*  2722*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2723*/     OPC_CheckPredicate5,  // Predicate_store
/*  2724*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2725*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2727*/     OPC_EmitMergeInputChains1_0,
/*  2728*/     OPC_EmitInteger32, 0, 
/*  2730*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v16i8:{ *:[v16i8] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v16i8:{ *:[v16i8] }:$val)
/*  2739*/    /*Scope*/ 18, /*->2758*/
/*  2740*/     OPC_CheckChild2TypeI64,
/*  2741*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2742*/     OPC_CheckPredicate5,  // Predicate_store
/*  2743*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2744*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2746*/     OPC_EmitMergeInputChains1_0,
/*  2747*/     OPC_EmitInteger32, 0, 
/*  2749*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v16i8:{ *:[v16i8] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v16i8:{ *:[v16i8] }:$val)
/*  2758*/    0, /*End of Scope*/
/*  2759*/   /*Scope*/ 43, /*->2803*/
/*  2760*/    OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/*  2762*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2763*/    OPC_Scope, 18, /*->2783*/ // 2 children in Scope
/*  2765*/     OPC_CheckChild2TypeI32,
/*  2766*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2767*/     OPC_CheckPredicate5,  // Predicate_store
/*  2768*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2769*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2771*/     OPC_EmitMergeInputChains1_0,
/*  2772*/     OPC_EmitInteger32, 0, 
/*  2774*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v8i16:{ *:[v8i16] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v8i16:{ *:[v8i16] }:$val)
/*  2783*/    /*Scope*/ 18, /*->2802*/
/*  2784*/     OPC_CheckChild2TypeI64,
/*  2785*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2786*/     OPC_CheckPredicate5,  // Predicate_store
/*  2787*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2788*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2790*/     OPC_EmitMergeInputChains1_0,
/*  2791*/     OPC_EmitInteger32, 0, 
/*  2793*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v8i16:{ *:[v8i16] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v8i16:{ *:[v8i16] }:$val)
/*  2802*/    0, /*End of Scope*/
/*  2803*/   /*Scope*/ 43, /*->2847*/
/*  2804*/    OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/*  2806*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2807*/    OPC_Scope, 18, /*->2827*/ // 2 children in Scope
/*  2809*/     OPC_CheckChild2TypeI32,
/*  2810*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2811*/     OPC_CheckPredicate5,  // Predicate_store
/*  2812*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2813*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2815*/     OPC_EmitMergeInputChains1_0,
/*  2816*/     OPC_EmitInteger32, 0, 
/*  2818*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v4i32:{ *:[v4i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v4i32:{ *:[v4i32] }:$val)
/*  2827*/    /*Scope*/ 18, /*->2846*/
/*  2828*/     OPC_CheckChild2TypeI64,
/*  2829*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2830*/     OPC_CheckPredicate5,  // Predicate_store
/*  2831*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2832*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2834*/     OPC_EmitMergeInputChains1_0,
/*  2835*/     OPC_EmitInteger32, 0, 
/*  2837*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v4i32:{ *:[v4i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v4i32:{ *:[v4i32] }:$val)
/*  2846*/    0, /*End of Scope*/
/*  2847*/   /*Scope*/ 43, /*->2891*/
/*  2848*/    OPC_CheckChild1Type, /*MVT::v2i64*/78, 
/*  2850*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2851*/    OPC_Scope, 18, /*->2871*/ // 2 children in Scope
/*  2853*/     OPC_CheckChild2TypeI32,
/*  2854*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2855*/     OPC_CheckPredicate5,  // Predicate_store
/*  2856*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2857*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2859*/     OPC_EmitMergeInputChains1_0,
/*  2860*/     OPC_EmitInteger32, 0, 
/*  2862*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v2i64:{ *:[v2i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v2i64:{ *:[v2i64] }:$val)
/*  2871*/    /*Scope*/ 18, /*->2890*/
/*  2872*/     OPC_CheckChild2TypeI64,
/*  2873*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2874*/     OPC_CheckPredicate5,  // Predicate_store
/*  2875*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2876*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2878*/     OPC_EmitMergeInputChains1_0,
/*  2879*/     OPC_EmitInteger32, 0, 
/*  2881*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v2i64:{ *:[v2i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v2i64:{ *:[v2i64] }:$val)
/*  2890*/    0, /*End of Scope*/
/*  2891*/   /*Scope*/ 43, /*->2935*/
/*  2892*/    OPC_CheckChild1Type, /*MVT::v4f32*/111, 
/*  2894*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2895*/    OPC_Scope, 18, /*->2915*/ // 2 children in Scope
/*  2897*/     OPC_CheckChild2TypeI32,
/*  2898*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2899*/     OPC_CheckPredicate5,  // Predicate_store
/*  2900*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2901*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2903*/     OPC_EmitMergeInputChains1_0,
/*  2904*/     OPC_EmitInteger32, 0, 
/*  2906*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v4f32:{ *:[v4f32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v4f32:{ *:[v4f32] }:$val)
/*  2915*/    /*Scope*/ 18, /*->2934*/
/*  2916*/     OPC_CheckChild2TypeI64,
/*  2917*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2918*/     OPC_CheckPredicate5,  // Predicate_store
/*  2919*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2920*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2922*/     OPC_EmitMergeInputChains1_0,
/*  2923*/     OPC_EmitInteger32, 0, 
/*  2925*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v4f32:{ *:[v4f32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v4f32:{ *:[v4f32] }:$val)
/*  2934*/    0, /*End of Scope*/
/*  2935*/   /*Scope*/ 44, /*->2980*/
/*  2936*/    OPC_CheckChild1Type, /*MVT::v2f64*/1|128,1/*129*/, 
/*  2939*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2940*/    OPC_Scope, 18, /*->2960*/ // 2 children in Scope
/*  2942*/     OPC_CheckChild2TypeI32,
/*  2943*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2944*/     OPC_CheckPredicate5,  // Predicate_store
/*  2945*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2946*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2948*/     OPC_EmitMergeInputChains1_0,
/*  2949*/     OPC_EmitInteger32, 0, 
/*  2951*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v2f64:{ *:[v2f64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v2f64:{ *:[v2f64] }:$val)
/*  2960*/    /*Scope*/ 18, /*->2979*/
/*  2961*/     OPC_CheckChild2TypeI64,
/*  2962*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2963*/     OPC_CheckPredicate5,  // Predicate_store
/*  2964*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  2965*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  2967*/     OPC_EmitMergeInputChains1_0,
/*  2968*/     OPC_EmitInteger32, 0, 
/*  2970*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v2f64:{ *:[v2f64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v2f64:{ *:[v2f64] }:$val)
/*  2979*/    0, /*End of Scope*/
/*  2980*/   /*Scope*/ 43, /*->3024*/
/*  2981*/    OPC_CheckChild1Type, /*MVT::v8f16*/92, 
/*  2983*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  2984*/    OPC_Scope, 18, /*->3004*/ // 2 children in Scope
/*  2986*/     OPC_CheckChild2TypeI32,
/*  2987*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  2988*/     OPC_CheckPredicate5,  // Predicate_store
/*  2989*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  2990*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  2992*/     OPC_EmitMergeInputChains1_0,
/*  2993*/     OPC_EmitInteger32, 0, 
/*  2995*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v8f16:{ *:[v8f16] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, v8f16:{ *:[v8f16] }:$val)
/*  3004*/    /*Scope*/ 18, /*->3023*/
/*  3005*/     OPC_CheckChild2TypeI64,
/*  3006*/     OPC_CheckPredicate4,  // Predicate_unindexedstore
/*  3007*/     OPC_CheckPredicate5,  // Predicate_store
/*  3008*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  3009*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3011*/     OPC_EmitMergeInputChains1_0,
/*  3012*/     OPC_EmitInteger32, 0, 
/*  3014*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (st v8f16:{ *:[v8f16] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedstore>><<P:Predicate_store>> - Complexity = 13
               // Dst: (STORE_V128_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, v8f16:{ *:[v8f16] }:$val)
/*  3023*/    0, /*End of Scope*/
/*  3024*/   0, /*End of Scope*/
/*  3025*/  0, /*End of Scope*/
/*  3026*/ /*SwitchOpcode*/ 22|128,2/*278*/, TARGET_VAL(ISD::INTRINSIC_VOID),// ->3308
/*  3030*/  OPC_Scope, 40, /*->3072*/ // 3 children in Scope
/*  3032*/   OPC_RecordNode, // #0 = 'intrinsic_void' chained node
/*  3033*/   OPC_CheckChild1Integer, 2|128,68|128,1/*25090*/, 
/*  3037*/   OPC_MoveChild2,
/*  3038*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3041*/   OPC_RecordChild0, // #1 = $table1
/*  3042*/   OPC_MoveChild0,
/*  3043*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3046*/   OPC_MoveParent,
/*  3047*/   OPC_MoveSibling3,
/*  3048*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3051*/   OPC_RecordChild0, // #2 = $table2
/*  3052*/   OPC_MoveChild0,
/*  3053*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3056*/   OPC_MoveParent,
/*  3057*/   OPC_MoveParent,
/*  3058*/   OPC_RecordChild4, // #3 = $d
/*  3059*/   OPC_RecordChild5, // #4 = $s
/*  3060*/   OPC_RecordChild6, // #5 = $n
/*  3061*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  3062*/   OPC_EmitMergeInputChains1_0,
/*  3063*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_COPY),
                 5/*#Ops*/, 1, 2, 3, 4, 5, 
             // Src: (intrinsic_void 12545:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table1), (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table2), I32:{ *:[i32] }:$d, I32:{ *:[i32] }:$s, I32:{ *:[i32] }:$n) - Complexity = 20
             // Dst: (TABLE_COPY (tglobaladdr:{ *:[i32] }):$table1, (tglobaladdr:{ *:[i32] }):$table2, I32:{ *:[i32] }:$d, I32:{ *:[i32] }:$s, I32:{ *:[i32] }:$n)
/*  3072*/  /*Scope*/ 44, /*->3117*/
/*  3073*/   OPC_RecordMemRef,
/*  3074*/   OPC_RecordNode, // #0 = 'intrinsic_void' chained node
/*  3075*/   OPC_CheckChild1Integer, 126|128,67|128,1/*25086*/, 
/*  3079*/   OPC_RecordChild2, // #1 = $val
/*  3080*/   OPC_RecordChild3, // #2 = $AddrOps32:offset:addr
/*  3081*/   OPC_Scope, 16, /*->3099*/ // 2 children in Scope
/*  3083*/    OPC_CheckChild3TypeI32,
/*  3084*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  3085*/    OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3087*/    OPC_EmitMergeInputChains1_0,
/*  3088*/    OPC_EmitInteger32, 0, 
/*  3090*/    OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F16_F32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  4/*#Ops*/, 5, 3, 4, 1, 
              // Src: (intrinsic_void 12543:{ *:[iPTR] }, f32:{ *:[f32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)) - Complexity = 17
              // Dst: (STORE_F16_F32_A32 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr, f32:{ *:[f32] }:$val)
/*  3099*/   /*Scope*/ 16, /*->3116*/
/*  3100*/    OPC_CheckChild3TypeI64,
/*  3101*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  3102*/    OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3104*/    OPC_EmitMergeInputChains1_0,
/*  3105*/    OPC_EmitInteger32, 0, 
/*  3107*/    OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::STORE_F16_F32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  4/*#Ops*/, 5, 3, 4, 1, 
              // Src: (intrinsic_void 12543:{ *:[iPTR] }, f32:{ *:[f32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)) - Complexity = 17
              // Dst: (STORE_F16_F32_A64 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr, f32:{ *:[f32] }:$val)
/*  3116*/   0, /*End of Scope*/
/*  3117*/  /*Scope*/ 60|128,1/*188*/, /*->3307*/
/*  3119*/   OPC_RecordNode, // #0 = 'intrinsic_void' chained node
/*  3120*/   OPC_Scope, 26, /*->3148*/ // 7 children in Scope
/*  3122*/    OPC_CheckChild1Integer, 26|128,68|128,1/*25114*/, 
/*  3126*/    OPC_MoveChild2,
/*  3127*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3130*/    OPC_RecordChild0, // #1 = $table
/*  3131*/    OPC_MoveChild0,
/*  3132*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3135*/    OPC_MoveParent,
/*  3136*/    OPC_MoveParent,
/*  3137*/    OPC_RecordChild3, // #2 = $i
/*  3138*/    OPC_RecordChild4, // #3 = $val
/*  3139*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  3140*/    OPC_EmitMergeInputChains1_0,
/*  3141*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_SET_FUNCREF),
                  3/*#Ops*/, 1, 2, 3, 
              // Src: (intrinsic_void 12557:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, FUNCREF:{ *:[funcref] }:$val) - Complexity = 14
              // Dst: (TABLE_SET_FUNCREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, FUNCREF:{ *:[funcref] }:$val)
/*  3148*/   /*Scope*/ 28, /*->3177*/
/*  3149*/    OPC_CheckChild1Integer, 8|128,68|128,1/*25096*/, 
/*  3153*/    OPC_MoveChild2,
/*  3154*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3157*/    OPC_RecordChild0, // #1 = $table
/*  3158*/    OPC_MoveChild0,
/*  3159*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3162*/    OPC_MoveParent,
/*  3163*/    OPC_MoveParent,
/*  3164*/    OPC_RecordChild3, // #2 = $i
/*  3165*/    OPC_RecordChild4, // #3 = $val
/*  3166*/    OPC_RecordChild5, // #4 = $n
/*  3167*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  3168*/    OPC_EmitMergeInputChains1_0,
/*  3169*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_FILL_FUNCREF),
                  4/*#Ops*/, 1, 2, 3, 4, 
              // Src: (intrinsic_void 12548:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, FUNCREF:{ *:[funcref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
              // Dst: (TABLE_FILL_FUNCREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, FUNCREF:{ *:[funcref] }:$val, I32:{ *:[i32] }:$n)
/*  3177*/   /*Scope*/ 26, /*->3204*/
/*  3178*/    OPC_CheckChild1Integer, 24|128,68|128,1/*25112*/, 
/*  3182*/    OPC_MoveChild2,
/*  3183*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3186*/    OPC_RecordChild0, // #1 = $table
/*  3187*/    OPC_MoveChild0,
/*  3188*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3191*/    OPC_MoveParent,
/*  3192*/    OPC_MoveParent,
/*  3193*/    OPC_RecordChild3, // #2 = $i
/*  3194*/    OPC_RecordChild4, // #3 = $val
/*  3195*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  3196*/    OPC_EmitMergeInputChains1_0,
/*  3197*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_SET_EXTERNREF),
                  3/*#Ops*/, 1, 2, 3, 
              // Src: (intrinsic_void 12556:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, EXTERNREF:{ *:[externref] }:$val) - Complexity = 14
              // Dst: (TABLE_SET_EXTERNREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, EXTERNREF:{ *:[externref] }:$val)
/*  3204*/   /*Scope*/ 28, /*->3233*/
/*  3205*/    OPC_CheckChild1Integer, 6|128,68|128,1/*25094*/, 
/*  3209*/    OPC_MoveChild2,
/*  3210*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3213*/    OPC_RecordChild0, // #1 = $table
/*  3214*/    OPC_MoveChild0,
/*  3215*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3218*/    OPC_MoveParent,
/*  3219*/    OPC_MoveParent,
/*  3220*/    OPC_RecordChild3, // #2 = $i
/*  3221*/    OPC_RecordChild4, // #3 = $val
/*  3222*/    OPC_RecordChild5, // #4 = $n
/*  3223*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  3224*/    OPC_EmitMergeInputChains1_0,
/*  3225*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_FILL_EXTERNREF),
                  4/*#Ops*/, 1, 2, 3, 4, 
              // Src: (intrinsic_void 12547:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, EXTERNREF:{ *:[externref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
              // Dst: (TABLE_FILL_EXTERNREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, EXTERNREF:{ *:[externref] }:$val, I32:{ *:[i32] }:$n)
/*  3233*/   /*Scope*/ 27, /*->3261*/
/*  3234*/    OPC_CheckChild1Integer, 22|128,68|128,1/*25110*/, 
/*  3238*/    OPC_MoveChild2,
/*  3239*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3242*/    OPC_RecordChild0, // #1 = $table
/*  3243*/    OPC_MoveChild0,
/*  3244*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3247*/    OPC_MoveParent,
/*  3248*/    OPC_MoveParent,
/*  3249*/    OPC_RecordChild3, // #2 = $i
/*  3250*/    OPC_RecordChild4, // #3 = $val
/*  3251*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/*  3253*/    OPC_EmitMergeInputChains1_0,
/*  3254*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_SET_EXNREF),
                  3/*#Ops*/, 1, 2, 3, 
              // Src: (intrinsic_void 12555:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, EXNREF:{ *:[exnref] }:$val) - Complexity = 14
              // Dst: (TABLE_SET_EXNREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, EXNREF:{ *:[exnref] }:$val)
/*  3261*/   /*Scope*/ 29, /*->3291*/
/*  3262*/    OPC_CheckChild1Integer, 4|128,68|128,1/*25092*/, 
/*  3266*/    OPC_MoveChild2,
/*  3267*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3270*/    OPC_RecordChild0, // #1 = $table
/*  3271*/    OPC_MoveChild0,
/*  3272*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3275*/    OPC_MoveParent,
/*  3276*/    OPC_MoveParent,
/*  3277*/    OPC_RecordChild3, // #2 = $i
/*  3278*/    OPC_RecordChild4, // #3 = $val
/*  3279*/    OPC_RecordChild5, // #4 = $n
/*  3280*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/*  3282*/    OPC_EmitMergeInputChains1_0,
/*  3283*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::TABLE_FILL_EXNREF),
                  4/*#Ops*/, 1, 2, 3, 4, 
              // Src: (intrinsic_void 12546:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i, EXNREF:{ *:[exnref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
              // Dst: (TABLE_FILL_EXNREF (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i, EXNREF:{ *:[exnref] }:$val, I32:{ *:[i32] }:$n)
/*  3291*/   /*Scope*/ 14, /*->3306*/
/*  3292*/    OPC_CheckChild1Integer, 120|128,67|128,1/*25080*/, 
/*  3296*/    OPC_CheckPatternPredicate, 16, // (Subtarget->hasExceptionHandling())
/*  3298*/    OPC_EmitMergeInputChains1_0,
/*  3299*/    OPC_EmitInteger32, 0, 
/*  3301*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::RETHROW),
                  1/*#Ops*/, 1, 
              // Src: (intrinsic_void 12540:{ *:[iPTR] }) - Complexity = 8
              // Dst: (RETHROW 0:{ *:[i32] })
/*  3306*/   0, /*End of Scope*/
/*  3307*/  0, /*End of Scope*/
/*  3308*/ /*SwitchOpcode*/ 81|128,3/*465*/, TARGET_VAL(ISD::INTRINSIC_W_CHAIN),// ->3777
/*  3312*/  OPC_Scope, 22|128,1/*150*/, /*->3465*/ // 3 children in Scope
/*  3315*/   OPC_RecordMemRef,
/*  3316*/   OPC_RecordNode, // #0 = 'intrinsic_w_chain' chained node
/*  3317*/   OPC_Scope, 45, /*->3364*/ // 3 children in Scope
/*  3319*/    OPC_CheckChild1Integer, 58|128,67|128,1/*25018*/, 
/*  3323*/    OPC_RecordChild2, // #1 = $AddrOps32:offset:addr
/*  3324*/    OPC_Scope, 18, /*->3344*/ // 2 children in Scope
/*  3326*/     OPC_CheckChild2TypeI32,
/*  3327*/     OPC_RecordChild3, // #2 = $count
/*  3328*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3329*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  3331*/     OPC_EmitMergeInputChains1_0,
/*  3332*/     OPC_EmitInteger32, 0, 
/*  3334*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_NOTIFY_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 12509:{ *:[iPTR] }, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), I32:{ *:[i32] }:$count) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_NOTIFY_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$count)
/*  3344*/    /*Scope*/ 18, /*->3363*/
/*  3345*/     OPC_CheckChild2TypeI64,
/*  3346*/     OPC_RecordChild3, // #2 = $count
/*  3347*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3348*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  3350*/     OPC_EmitMergeInputChains1_0,
/*  3351*/     OPC_EmitInteger32, 0, 
/*  3353*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_NOTIFY_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 12509:{ *:[iPTR] }, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), I32:{ *:[i32] }:$count) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_NOTIFY_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$count)
/*  3363*/    0, /*End of Scope*/
/*  3364*/   /*Scope*/ 49, /*->3414*/
/*  3365*/    OPC_CheckChild1Integer, 60|128,67|128,1/*25020*/, 
/*  3369*/    OPC_RecordChild2, // #1 = $AddrOps32:offset:addr
/*  3370*/    OPC_Scope, 20, /*->3392*/ // 2 children in Scope
/*  3372*/     OPC_CheckChild2TypeI32,
/*  3373*/     OPC_RecordChild3, // #2 = $exp
/*  3374*/     OPC_RecordChild4, // #3 = $timeout
/*  3375*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3376*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  3378*/     OPC_EmitMergeInputChains1_0,
/*  3379*/     OPC_EmitInteger32, 0, 
/*  3381*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 12510:{ *:[iPTR] }, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_WAIT32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i64] }:$timeout)
/*  3392*/    /*Scope*/ 20, /*->3413*/
/*  3393*/     OPC_CheckChild2TypeI64,
/*  3394*/     OPC_RecordChild3, // #2 = $exp
/*  3395*/     OPC_RecordChild4, // #3 = $timeout
/*  3396*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3397*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  3399*/     OPC_EmitMergeInputChains1_0,
/*  3400*/     OPC_EmitInteger32, 0, 
/*  3402*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 12510:{ *:[iPTR] }, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_WAIT32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i64] }:$timeout)
/*  3413*/    0, /*End of Scope*/
/*  3414*/   /*Scope*/ 49, /*->3464*/
/*  3415*/    OPC_CheckChild1Integer, 62|128,67|128,1/*25022*/, 
/*  3419*/    OPC_RecordChild2, // #1 = $AddrOps32:offset:addr
/*  3420*/    OPC_Scope, 20, /*->3442*/ // 2 children in Scope
/*  3422*/     OPC_CheckChild2TypeI32,
/*  3423*/     OPC_RecordChild3, // #2 = $exp
/*  3424*/     OPC_RecordChild4, // #3 = $timeout
/*  3425*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3426*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  3428*/     OPC_EmitMergeInputChains1_0,
/*  3429*/     OPC_EmitInteger32, 0, 
/*  3431*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 12511:{ *:[iPTR] }, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_WAIT64_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$timeout)
/*  3442*/    /*Scope*/ 20, /*->3463*/
/*  3443*/     OPC_CheckChild2TypeI64,
/*  3444*/     OPC_RecordChild3, // #2 = $exp
/*  3445*/     OPC_RecordChild4, // #3 = $timeout
/*  3446*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3447*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  3449*/     OPC_EmitMergeInputChains1_0,
/*  3450*/     OPC_EmitInteger32, 0, 
/*  3452*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::MEMORY_ATOMIC_WAIT64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 12511:{ *:[iPTR] }, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$exp, I64:{ *:[i64] }:$timeout) - Complexity = 17
               // Dst: (MEMORY_ATOMIC_WAIT64_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$timeout)
/*  3463*/    0, /*End of Scope*/
/*  3464*/   0, /*End of Scope*/
/*  3465*/  /*Scope*/ 9|128,2/*265*/, /*->3732*/
/*  3467*/   OPC_RecordNode, // #0 = 'intrinsic_w_chain' chained node
/*  3468*/   OPC_Scope, 26, /*->3496*/ // 9 children in Scope
/*  3470*/    OPC_CheckChild1Integer, 14|128,68|128,1/*25102*/, 
/*  3474*/    OPC_MoveChild2,
/*  3475*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3478*/    OPC_RecordChild0, // #1 = $table
/*  3479*/    OPC_MoveChild0,
/*  3480*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3483*/    OPC_MoveParent,
/*  3484*/    OPC_MoveParent,
/*  3485*/    OPC_RecordChild3, // #2 = $i
/*  3486*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  3487*/    OPC_EmitMergeInputChains1_0,
/*  3488*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GET_FUNCREF),
                  /*MVT::funcref*/99|128,1/*227*/, 2/*#Ops*/, 1, 2, 
              // Src: (intrinsic_w_chain:{ *:[funcref] } 12551:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i) - Complexity = 14
              // Dst: (TABLE_GET_FUNCREF:{ *:[funcref] } (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i)
/*  3496*/   /*Scope*/ 27, /*->3524*/
/*  3497*/    OPC_CheckChild1Integer, 20|128,68|128,1/*25108*/, 
/*  3501*/    OPC_MoveChild2,
/*  3502*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3505*/    OPC_RecordChild0, // #1 = $table
/*  3506*/    OPC_MoveChild0,
/*  3507*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3510*/    OPC_MoveParent,
/*  3511*/    OPC_MoveParent,
/*  3512*/    OPC_RecordChild3, // #2 = $val
/*  3513*/    OPC_RecordChild4, // #3 = $n
/*  3514*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  3515*/    OPC_EmitMergeInputChains1_0,
/*  3516*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GROW_FUNCREF),
                  /*MVT::i32*/7, 3/*#Ops*/, 1, 2, 3, 
              // Src: (intrinsic_w_chain:{ *:[i32] } 12554:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), FUNCREF:{ *:[funcref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
              // Dst: (TABLE_GROW_FUNCREF:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$table, FUNCREF:{ *:[funcref] }:$val, I32:{ *:[i32] }:$n)
/*  3524*/   /*Scope*/ 26, /*->3551*/
/*  3525*/    OPC_CheckChild1Integer, 12|128,68|128,1/*25100*/, 
/*  3529*/    OPC_MoveChild2,
/*  3530*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3533*/    OPC_RecordChild0, // #1 = $table
/*  3534*/    OPC_MoveChild0,
/*  3535*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3538*/    OPC_MoveParent,
/*  3539*/    OPC_MoveParent,
/*  3540*/    OPC_RecordChild3, // #2 = $i
/*  3541*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  3542*/    OPC_EmitMergeInputChains1_0,
/*  3543*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GET_EXTERNREF),
                  /*MVT::externref*/100|128,1/*228*/, 2/*#Ops*/, 1, 2, 
              // Src: (intrinsic_w_chain:{ *:[externref] } 12550:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i) - Complexity = 14
              // Dst: (TABLE_GET_EXTERNREF:{ *:[externref] } (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i)
/*  3551*/   /*Scope*/ 27, /*->3579*/
/*  3552*/    OPC_CheckChild1Integer, 18|128,68|128,1/*25106*/, 
/*  3556*/    OPC_MoveChild2,
/*  3557*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3560*/    OPC_RecordChild0, // #1 = $table
/*  3561*/    OPC_MoveChild0,
/*  3562*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3565*/    OPC_MoveParent,
/*  3566*/    OPC_MoveParent,
/*  3567*/    OPC_RecordChild3, // #2 = $val
/*  3568*/    OPC_RecordChild4, // #3 = $n
/*  3569*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  3570*/    OPC_EmitMergeInputChains1_0,
/*  3571*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GROW_EXTERNREF),
                  /*MVT::i32*/7, 3/*#Ops*/, 1, 2, 3, 
              // Src: (intrinsic_w_chain:{ *:[i32] } 12553:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), EXTERNREF:{ *:[externref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
              // Dst: (TABLE_GROW_EXTERNREF:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$table, EXTERNREF:{ *:[externref] }:$val, I32:{ *:[i32] }:$n)
/*  3579*/   /*Scope*/ 27, /*->3607*/
/*  3580*/    OPC_CheckChild1Integer, 10|128,68|128,1/*25098*/, 
/*  3584*/    OPC_MoveChild2,
/*  3585*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3588*/    OPC_RecordChild0, // #1 = $table
/*  3589*/    OPC_MoveChild0,
/*  3590*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3593*/    OPC_MoveParent,
/*  3594*/    OPC_MoveParent,
/*  3595*/    OPC_RecordChild3, // #2 = $i
/*  3596*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/*  3598*/    OPC_EmitMergeInputChains1_0,
/*  3599*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GET_EXNREF),
                  /*MVT::exnref*/101|128,1/*229*/, 2/*#Ops*/, 1, 2, 
              // Src: (intrinsic_w_chain:{ *:[exnref] } 12549:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), I32:{ *:[i32] }:$i) - Complexity = 14
              // Dst: (TABLE_GET_EXNREF:{ *:[exnref] } (tglobaladdr:{ *:[i32] }):$table, I32:{ *:[i32] }:$i)
/*  3607*/   /*Scope*/ 28, /*->3636*/
/*  3608*/    OPC_CheckChild1Integer, 16|128,68|128,1/*25104*/, 
/*  3612*/    OPC_MoveChild2,
/*  3613*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3616*/    OPC_RecordChild0, // #1 = $table
/*  3617*/    OPC_MoveChild0,
/*  3618*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3621*/    OPC_MoveParent,
/*  3622*/    OPC_MoveParent,
/*  3623*/    OPC_RecordChild3, // #2 = $val
/*  3624*/    OPC_RecordChild4, // #3 = $n
/*  3625*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/*  3627*/    OPC_EmitMergeInputChains1_0,
/*  3628*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_GROW_EXNREF),
                  /*MVT::i32*/7, 3/*#Ops*/, 1, 2, 3, 
              // Src: (intrinsic_w_chain:{ *:[i32] } 12552:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), EXNREF:{ *:[exnref] }:$val, I32:{ *:[i32] }:$n) - Complexity = 14
              // Dst: (TABLE_GROW_EXNREF:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$table, EXNREF:{ *:[exnref] }:$val, I32:{ *:[i32] }:$n)
/*  3636*/   /*Scope*/ 23, /*->3660*/
/*  3637*/    OPC_CheckChild1Integer, 28|128,68|128,1/*25116*/, 
/*  3641*/    OPC_MoveChild2,
/*  3642*/    OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/*  3645*/    OPC_RecordChild0, // #1 = $table
/*  3646*/    OPC_MoveChild0,
/*  3647*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/*  3650*/    OPC_MoveParent,
/*  3651*/    OPC_MoveParent,
/*  3652*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  3653*/    OPC_EmitMergeInputChains1_0,
/*  3654*/    OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::TABLE_SIZE),
                  /*MVT::i32*/7, 1/*#Ops*/, 1, 
              // Src: (intrinsic_w_chain:{ *:[i32] } 12558:{ *:[iPTR] }, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table)) - Complexity = 14
              // Dst: (TABLE_SIZE:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$table)
/*  3660*/   /*Scope*/ 32, /*->3693*/
/*  3661*/    OPC_CheckChild1Integer, 66|128,67|128,1/*25026*/, 
/*  3665*/    OPC_RecordChild2, // #1 = $flags
/*  3666*/    OPC_MoveChild2,
/*  3667*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  3670*/    OPC_MoveParent,
/*  3671*/    OPC_SwitchType /*2 cases */, 8, /*MVT::i32*/7, // ->3682
/*  3674*/     OPC_EmitMergeInputChains1_0,
/*  3675*/     OPC_EmitConvertToTarget1,
/*  3676*/     OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::anonymous_8295MEMORY_SIZE_A32),
                   /*MVT::i32*/7, 1/*#Ops*/, 2, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 12513:{ *:[iPTR] }, (imm:{ *:[i32] }):$flags) - Complexity = 11
               // Dst: (anonymous_8295MEMORY_SIZE_A32:{ *:[i32] } (imm:{ *:[i32] }):$flags)
/*  3682*/    /*SwitchType*/ 8, /*MVT::i64*/8, // ->3692
/*  3684*/     OPC_EmitMergeInputChains1_0,
/*  3685*/     OPC_EmitConvertToTarget1,
/*  3686*/     OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::anonymous_8296MEMORY_SIZE_A64),
                   /*MVT::i64*/8, 1/*#Ops*/, 2, 
               // Src: (intrinsic_w_chain:{ *:[i64] } 12513:{ *:[iPTR] }, (imm:{ *:[i32] }):$flags) - Complexity = 11
               // Dst: (anonymous_8296MEMORY_SIZE_A64:{ *:[i64] } (imm:{ *:[i32] }):$flags)
/*  3692*/    0, // EndSwitchType
/*  3693*/   /*Scope*/ 37, /*->3731*/
/*  3694*/    OPC_CheckChild1Integer, 64|128,67|128,1/*25024*/, 
/*  3698*/    OPC_RecordChild2, // #1 = $flags
/*  3699*/    OPC_MoveChild2,
/*  3700*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  3703*/    OPC_MoveParent,
/*  3704*/    OPC_RecordChild3, // #2 = $delta
/*  3705*/    OPC_SwitchType /*2 cases */, 10, /*MVT::i32*/7, // ->3718
/*  3708*/     OPC_CheckChild3TypeI32,
/*  3709*/     OPC_EmitMergeInputChains1_0,
/*  3710*/     OPC_EmitConvertToTarget1,
/*  3711*/     OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::anonymous_8295MEMORY_GROW_A32),
                   /*MVT::i32*/7, 2/*#Ops*/, 3, 2, 
               // Src: (intrinsic_w_chain:{ *:[i32] } 12512:{ *:[iPTR] }, (imm:{ *:[i32] }):$flags, I32:{ *:[i32] }:$delta) - Complexity = 11
               // Dst: (anonymous_8295MEMORY_GROW_A32:{ *:[i32] } (imm:{ *:[i32] }):$flags, I32:{ *:[i32] }:$delta)
/*  3718*/    /*SwitchType*/ 10, /*MVT::i64*/8, // ->3730
/*  3720*/     OPC_CheckChild3TypeI64,
/*  3721*/     OPC_EmitMergeInputChains1_0,
/*  3722*/     OPC_EmitConvertToTarget1,
/*  3723*/     OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::anonymous_8296MEMORY_GROW_A64),
                   /*MVT::i64*/8, 2/*#Ops*/, 3, 2, 
               // Src: (intrinsic_w_chain:{ *:[i64] } 12512:{ *:[iPTR] }, (imm:{ *:[i32] }):$flags, I64:{ *:[i64] }:$delta) - Complexity = 11
               // Dst: (anonymous_8296MEMORY_GROW_A64:{ *:[i64] } (imm:{ *:[i32] }):$flags, I64:{ *:[i64] }:$delta)
/*  3730*/    0, // EndSwitchType
/*  3731*/   0, /*End of Scope*/
/*  3732*/  /*Scope*/ 43, /*->3776*/
/*  3733*/   OPC_RecordMemRef,
/*  3734*/   OPC_RecordNode, // #0 = 'intrinsic_w_chain' chained node
/*  3735*/   OPC_CheckChild1Integer, 54|128,67|128,1/*25014*/, 
/*  3739*/   OPC_RecordChild2, // #1 = $AddrOps32:offset:addr
/*  3740*/   OPC_Scope, 16, /*->3758*/ // 2 children in Scope
/*  3742*/    OPC_CheckChild2TypeI32,
/*  3743*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  3744*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  3746*/    OPC_EmitMergeInputChains1_0,
/*  3747*/    OPC_EmitInteger32, 0, 
/*  3749*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F16_F32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::f32*/12, 3/*#Ops*/, 4, 2, 3, 
              // Src: (intrinsic_w_chain:{ *:[f32] } 12507:{ *:[iPTR] }, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)) - Complexity = 17
              // Dst: (LOAD_F16_F32_A32:{ *:[f32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  3758*/   /*Scope*/ 16, /*->3775*/
/*  3759*/    OPC_CheckChild2TypeI64,
/*  3760*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  3761*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  3763*/    OPC_EmitMergeInputChains1_0,
/*  3764*/    OPC_EmitInteger32, 0, 
/*  3766*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F16_F32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::f32*/12, 3/*#Ops*/, 4, 2, 3, 
              // Src: (intrinsic_w_chain:{ *:[f32] } 12507:{ *:[iPTR] }, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)) - Complexity = 17
              // Dst: (LOAD_F16_F32_A64:{ *:[f32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  3775*/   0, /*End of Scope*/
/*  3776*/  0, /*End of Scope*/
/*  3777*/ /*SwitchOpcode*/ 29|128,2/*285*/, TARGET_VAL(ISD::ATOMIC_STORE),// ->4066
/*  3781*/  OPC_RecordMemRef,
/*  3782*/  OPC_RecordNode, // #0 = 'atomic_store' chained node
/*  3783*/  OPC_Scope, 119, /*->3904*/ // 2 children in Scope
/*  3785*/   OPC_MoveChild1,
/*  3786*/   OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/*  3789*/   OPC_RecordChild0, // #1 = $val
/*  3790*/   OPC_MoveParent,
/*  3791*/   OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  3792*/   OPC_Scope, 54, /*->3848*/ // 2 children in Scope
/*  3794*/    OPC_CheckChild2TypeI32,
/*  3795*/    OPC_Scope, 16, /*->3813*/ // 3 children in Scope
/*  3797*/     OPC_CheckPredicate1,  // Predicate_atomic_store_8
/*  3798*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3799*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3801*/     OPC_EmitMergeInputChains1_0,
/*  3802*/     OPC_EmitInteger32, 0, 
/*  3804*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store (trunc:{ *:[i32] } i64:{ *:[i64] }:$val), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_8>> - Complexity = 16
               // Dst: (ATOMIC_STORE8_I64_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  3813*/    /*Scope*/ 16, /*->3830*/
/*  3814*/     OPC_CheckPredicate2,  // Predicate_atomic_store_16
/*  3815*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3816*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3818*/     OPC_EmitMergeInputChains1_0,
/*  3819*/     OPC_EmitInteger32, 0, 
/*  3821*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store (trunc:{ *:[i32] } i64:{ *:[i64] }:$val), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_16>> - Complexity = 16
               // Dst: (ATOMIC_STORE16_I64_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  3830*/    /*Scope*/ 16, /*->3847*/
/*  3831*/     OPC_CheckPredicate3,  // Predicate_atomic_store_32
/*  3832*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3833*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3835*/     OPC_EmitMergeInputChains1_0,
/*  3836*/     OPC_EmitInteger32, 0, 
/*  3838*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE32_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store (trunc:{ *:[i32] } i64:{ *:[i64] }:$val), (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_32>> - Complexity = 16
               // Dst: (ATOMIC_STORE32_I64_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  3847*/    0, /*End of Scope*/
/*  3848*/   /*Scope*/ 54, /*->3903*/
/*  3849*/    OPC_CheckChild2TypeI64,
/*  3850*/    OPC_Scope, 16, /*->3868*/ // 3 children in Scope
/*  3852*/     OPC_CheckPredicate1,  // Predicate_atomic_store_8
/*  3853*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3854*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3856*/     OPC_EmitMergeInputChains1_0,
/*  3857*/     OPC_EmitInteger32, 0, 
/*  3859*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store (trunc:{ *:[i32] } i64:{ *:[i64] }:$val), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_8>> - Complexity = 16
               // Dst: (ATOMIC_STORE8_I64_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  3868*/    /*Scope*/ 16, /*->3885*/
/*  3869*/     OPC_CheckPredicate2,  // Predicate_atomic_store_16
/*  3870*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3871*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3873*/     OPC_EmitMergeInputChains1_0,
/*  3874*/     OPC_EmitInteger32, 0, 
/*  3876*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store (trunc:{ *:[i32] } i64:{ *:[i64] }:$val), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_16>> - Complexity = 16
               // Dst: (ATOMIC_STORE16_I64_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  3885*/    /*Scope*/ 16, /*->3902*/
/*  3886*/     OPC_CheckPredicate3,  // Predicate_atomic_store_32
/*  3887*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3888*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3890*/     OPC_EmitMergeInputChains1_0,
/*  3891*/     OPC_EmitInteger32, 0, 
/*  3893*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE32_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store (trunc:{ *:[i32] } i64:{ *:[i64] }:$val), (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_32>> - Complexity = 16
               // Dst: (ATOMIC_STORE32_I64_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  3902*/    0, /*End of Scope*/
/*  3903*/   0, /*End of Scope*/
/*  3904*/  /*Scope*/ 31|128,1/*159*/, /*->4065*/
/*  3906*/   OPC_RecordChild1, // #1 = $val
/*  3907*/   OPC_Scope, 114, /*->4023*/ // 2 children in Scope
/*  3909*/    OPC_CheckChild1TypeI32,
/*  3910*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  3911*/    OPC_Scope, 54, /*->3967*/ // 2 children in Scope
/*  3913*/     OPC_CheckChild2TypeI32,
/*  3914*/     OPC_Scope, 16, /*->3932*/ // 3 children in Scope
/*  3916*/      OPC_CheckPredicate3,  // Predicate_atomic_store_32
/*  3917*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3918*/      OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3920*/      OPC_EmitMergeInputChains1_0,
/*  3921*/      OPC_EmitInteger32, 0, 
/*  3923*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (atomic_store i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_32>> - Complexity = 13
                // Dst: (ATOMIC_STORE_I32_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  3932*/     /*Scope*/ 16, /*->3949*/
/*  3933*/      OPC_CheckPredicate1,  // Predicate_atomic_store_8
/*  3934*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3935*/      OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3937*/      OPC_EmitMergeInputChains1_0,
/*  3938*/      OPC_EmitInteger32, 0, 
/*  3940*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (atomic_store i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_8>> - Complexity = 13
                // Dst: (ATOMIC_STORE8_I32_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  3949*/     /*Scope*/ 16, /*->3966*/
/*  3950*/      OPC_CheckPredicate2,  // Predicate_atomic_store_16
/*  3951*/      OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3952*/      OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  3954*/      OPC_EmitMergeInputChains1_0,
/*  3955*/      OPC_EmitInteger32, 0, 
/*  3957*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (atomic_store i32:{ *:[i32] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_16>> - Complexity = 13
                // Dst: (ATOMIC_STORE16_I32_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  3966*/     0, /*End of Scope*/
/*  3967*/    /*Scope*/ 54, /*->4022*/
/*  3968*/     OPC_CheckChild2TypeI64,
/*  3969*/     OPC_Scope, 16, /*->3987*/ // 3 children in Scope
/*  3971*/      OPC_CheckPredicate3,  // Predicate_atomic_store_32
/*  3972*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3973*/      OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3975*/      OPC_EmitMergeInputChains1_0,
/*  3976*/      OPC_EmitInteger32, 0, 
/*  3978*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (atomic_store i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_32>> - Complexity = 13
                // Dst: (ATOMIC_STORE_I32_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  3987*/     /*Scope*/ 16, /*->4004*/
/*  3988*/      OPC_CheckPredicate1,  // Predicate_atomic_store_8
/*  3989*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  3990*/      OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  3992*/      OPC_EmitMergeInputChains1_0,
/*  3993*/      OPC_EmitInteger32, 0, 
/*  3995*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE8_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (atomic_store i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_8>> - Complexity = 13
                // Dst: (ATOMIC_STORE8_I32_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  4004*/     /*Scope*/ 16, /*->4021*/
/*  4005*/      OPC_CheckPredicate2,  // Predicate_atomic_store_16
/*  4006*/      OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4007*/      OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  4009*/      OPC_EmitMergeInputChains1_0,
/*  4010*/      OPC_EmitInteger32, 0, 
/*  4012*/      OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE16_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    4/*#Ops*/, 5, 3, 4, 1, 
                // Src: (atomic_store i32:{ *:[i32] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_16>> - Complexity = 13
                // Dst: (ATOMIC_STORE16_I32_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  4021*/     0, /*End of Scope*/
/*  4022*/    0, /*End of Scope*/
/*  4023*/   /*Scope*/ 40, /*->4064*/
/*  4024*/    OPC_CheckChild1TypeI64,
/*  4025*/    OPC_RecordChild2, // #2 = $AddrOps32:offset:addr
/*  4026*/    OPC_Scope, 17, /*->4045*/ // 2 children in Scope
/*  4028*/     OPC_CheckChild2TypeI32,
/*  4029*/     OPC_CheckPredicate7,  // Predicate_atomic_store_64
/*  4030*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4031*/     OPC_CheckComplexPat0, /*#*/2, // SelectAddrOperands32:$ #3 #4
/*  4033*/     OPC_EmitMergeInputChains1_0,
/*  4034*/     OPC_EmitInteger32, 0, 
/*  4036*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store i64:{ *:[i64] }:$val, (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_store_64>> - Complexity = 13
               // Dst: (ATOMIC_STORE_I64_A32 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  4045*/    /*Scope*/ 17, /*->4063*/
/*  4046*/     OPC_CheckChild2TypeI64,
/*  4047*/     OPC_CheckPredicate7,  // Predicate_atomic_store_64
/*  4048*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  4049*/     OPC_CheckComplexPat1, /*#*/2, // SelectAddrOperands64:$ #3 #4
/*  4051*/     OPC_EmitMergeInputChains1_0,
/*  4052*/     OPC_EmitInteger32, 0, 
/*  4054*/     OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::ATOMIC_STORE_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   4/*#Ops*/, 5, 3, 4, 1, 
               // Src: (atomic_store i64:{ *:[i64] }:$val, (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_store_64>> - Complexity = 13
               // Dst: (ATOMIC_STORE_I64_A64 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  4063*/    0, /*End of Scope*/
/*  4064*/   0, /*End of Scope*/
/*  4065*/  0, /*End of Scope*/
/*  4066*/ /*SwitchOpcode*/ 90|128,2/*346*/, TARGET_VAL(ISD::AND),// ->4416
/*  4070*/  OPC_Scope, 118, /*->4190*/ // 6 children in Scope
/*  4072*/   OPC_MoveChild0,
/*  4073*/   OPC_CheckOpcode, TARGET_VAL(ISD::INTRINSIC_WO_CHAIN),
/*  4076*/   OPC_Scope, 55, /*->4133*/ // 2 children in Scope
/*  4078*/    OPC_CheckChild0Integer, 30|128,67|128,1/*24990*/, 
/*  4082*/    OPC_RecordChild1, // #0 = $x
/*  4083*/    OPC_Scope, 11, /*->4096*/ // 4 children in Scope
/*  4085*/     OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/*  4087*/     OPC_MoveParent,
/*  4088*/     OPC_CheckChild1Integer, 2, 
/*  4090*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12495:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4096*/    /*Scope*/ 11, /*->4108*/
/*  4097*/     OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/*  4099*/     OPC_MoveParent,
/*  4100*/     OPC_CheckChild1Integer, 2, 
/*  4102*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12495:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4108*/    /*Scope*/ 11, /*->4120*/
/*  4109*/     OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/*  4111*/     OPC_MoveParent,
/*  4112*/     OPC_CheckChild1Integer, 2, 
/*  4114*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12495:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4120*/    /*Scope*/ 11, /*->4132*/
/*  4121*/     OPC_CheckChild1Type, /*MVT::v2i64*/78, 
/*  4123*/     OPC_MoveParent,
/*  4124*/     OPC_CheckChild1Integer, 2, 
/*  4126*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12495:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4132*/    0, /*End of Scope*/
/*  4133*/   /*Scope*/ 55, /*->4189*/
/*  4134*/    OPC_CheckChild0Integer, 28|128,67|128,1/*24988*/, 
/*  4138*/    OPC_RecordChild1, // #0 = $x
/*  4139*/    OPC_Scope, 11, /*->4152*/ // 4 children in Scope
/*  4141*/     OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/*  4143*/     OPC_MoveParent,
/*  4144*/     OPC_CheckChild1Integer, 2, 
/*  4146*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I8x16),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12494:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ALLTRUE_I8x16:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4152*/    /*Scope*/ 11, /*->4164*/
/*  4153*/     OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/*  4155*/     OPC_MoveParent,
/*  4156*/     OPC_CheckChild1Integer, 2, 
/*  4158*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I16x8),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12494:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ALLTRUE_I16x8:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4164*/    /*Scope*/ 11, /*->4176*/
/*  4165*/     OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/*  4167*/     OPC_MoveParent,
/*  4168*/     OPC_CheckChild1Integer, 2, 
/*  4170*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I32x4),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12494:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ALLTRUE_I32x4:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4176*/    /*Scope*/ 11, /*->4188*/
/*  4177*/     OPC_CheckChild1Type, /*MVT::v2i64*/78, 
/*  4179*/     OPC_MoveParent,
/*  4180*/     OPC_CheckChild1Integer, 2, 
/*  4182*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I64x2),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (and:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12494:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 1:{ *:[i32] }) - Complexity = 16
               // Dst: (ALLTRUE_I64x2:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4188*/    0, /*End of Scope*/
/*  4189*/   0, /*End of Scope*/
/*  4190*/  /*Scope*/ 29, /*->4220*/
/*  4191*/   OPC_CheckAndImm, 127|128,1/*255*/, 
/*  4194*/   OPC_MoveChild0,
/*  4195*/   OPC_CheckOpcode, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
/*  4198*/   OPC_RecordChild0, // #0 = $vec
/*  4199*/   OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/*  4201*/   OPC_RecordChild1, // #1 = $idx
/*  4202*/   OPC_MoveChild1,
/*  4203*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  4206*/   OPC_CheckPredicate, 18, // Predicate_LaneIdx16
/*  4208*/   OPC_CheckTypeI32,
/*  4209*/   OPC_MoveParent,
/*  4210*/   OPC_MoveParent,
/*  4211*/   OPC_CheckTypeI32,
/*  4212*/   OPC_EmitConvertToTarget1,
/*  4213*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I8x16_u),
                 /*MVT::i32*/7, 2/*#Ops*/, 0, 2, 
             // Src: (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx), 255:{ *:[i32] }) - Complexity = 15
             // Dst: (EXTRACT_LANE_I8x16_u:{ *:[i32] } ?:{ *:[v16i8] }:$vec, (imm:{ *:[i32] }):$idx)
/*  4220*/  /*Scope*/ 30, /*->4251*/
/*  4221*/   OPC_CheckAndImm, 127|128,127|128,3/*65535*/, 
/*  4225*/   OPC_MoveChild0,
/*  4226*/   OPC_CheckOpcode, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
/*  4229*/   OPC_RecordChild0, // #0 = $vec
/*  4230*/   OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/*  4232*/   OPC_RecordChild1, // #1 = $idx
/*  4233*/   OPC_MoveChild1,
/*  4234*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/*  4237*/   OPC_CheckPredicate, 13, // Predicate_LaneIdx8
/*  4239*/   OPC_CheckTypeI32,
/*  4240*/   OPC_MoveParent,
/*  4241*/   OPC_MoveParent,
/*  4242*/   OPC_CheckTypeI32,
/*  4243*/   OPC_EmitConvertToTarget1,
/*  4244*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I16x8_u),
                 /*MVT::i32*/7, 2/*#Ops*/, 0, 2, 
             // Src: (and:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx), 65535:{ *:[i32] }) - Complexity = 15
             // Dst: (EXTRACT_LANE_I16x8_u:{ *:[i32] } ?:{ *:[v8i16] }:$vec, (imm:{ *:[i32] }):$idx)
/*  4251*/  /*Scope*/ 73, /*->4325*/
/*  4252*/   OPC_RecordChild0, // #0 = $lhs
/*  4253*/   OPC_Scope, 21, /*->4276*/ // 2 children in Scope
/*  4255*/    OPC_RecordChild1, // #1 = $rhs
/*  4256*/    OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->4266
/*  4259*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND_I32),
                   /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
               // Dst: (AND_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4266*/    /*SwitchType*/ 7, /*MVT::i64*/8, // ->4275
/*  4268*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND_I64),
                   /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
               // Dst: (AND_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4275*/    0, // EndSwitchType
/*  4276*/   /*Scope*/ 47, /*->4324*/
/*  4277*/    OPC_MoveChild1,
/*  4278*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/*  4281*/    OPC_RecordChild0, // #1 = $rhs
/*  4282*/    OPC_MoveChild1,
/*  4283*/    OPC_CheckImmAllOnesV,
/*  4284*/    OPC_MoveParent,
/*  4285*/    OPC_MoveParent,
/*  4286*/    OPC_SwitchType /*4 cases */, 7, /*MVT::v16i8*/39, // ->4296
/*  4289*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$rhs, immAllOnesV:{ *:[v16i8] })) - Complexity = 10
               // Dst: (ANDNOT:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/*  4296*/    /*SwitchType*/ 7, /*MVT::v8i16*/50, // ->4305
/*  4298*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                   /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$rhs, immAllOnesV:{ *:[v8i16] })) - Complexity = 10
               // Dst: (ANDNOT:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/*  4305*/    /*SwitchType*/ 7, /*MVT::v4i32*/60, // ->4314
/*  4307*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                   /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$rhs, immAllOnesV:{ *:[v4i32] })) - Complexity = 10
               // Dst: (ANDNOT:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/*  4314*/    /*SwitchType*/ 7, /*MVT::v2i64*/78, // ->4323
/*  4316*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                   /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
               // Src: (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$rhs, immAllOnesV:{ *:[v2i64] })) - Complexity = 10
               // Dst: (ANDNOT:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/*  4323*/    0, // EndSwitchType
/*  4324*/   0, /*End of Scope*/
/*  4325*/  /*Scope*/ 48, /*->4374*/
/*  4326*/   OPC_MoveChild0,
/*  4327*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/*  4330*/   OPC_RecordChild0, // #0 = $rhs
/*  4331*/   OPC_MoveChild1,
/*  4332*/   OPC_CheckImmAllOnesV,
/*  4333*/   OPC_MoveParent,
/*  4334*/   OPC_MoveParent,
/*  4335*/   OPC_RecordChild1, // #1 = $lhs
/*  4336*/   OPC_SwitchType /*4 cases */, 7, /*MVT::v16i8*/39, // ->4346
/*  4339*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                  /*MVT::v16i8*/39, 2/*#Ops*/, 1, 0, 
              // Src: (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$rhs, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$lhs) - Complexity = 10
              // Dst: (ANDNOT:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/*  4346*/   /*SwitchType*/ 7, /*MVT::v8i16*/50, // ->4355
/*  4348*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 1, 0, 
              // Src: (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$rhs, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$lhs) - Complexity = 10
              // Dst: (ANDNOT:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/*  4355*/   /*SwitchType*/ 7, /*MVT::v4i32*/60, // ->4364
/*  4357*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                  /*MVT::v4i32*/60, 2/*#Ops*/, 1, 0, 
              // Src: (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$rhs, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$lhs) - Complexity = 10
              // Dst: (ANDNOT:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/*  4364*/   /*SwitchType*/ 7, /*MVT::v2i64*/78, // ->4373
/*  4366*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANDNOT),
                  /*MVT::v2i64*/78, 2/*#Ops*/, 1, 0, 
              // Src: (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$rhs, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$lhs) - Complexity = 10
              // Dst: (ANDNOT:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/*  4373*/   0, // EndSwitchType
/*  4374*/  /*Scope*/ 40, /*->4415*/
/*  4375*/   OPC_RecordChild0, // #0 = $lhs
/*  4376*/   OPC_RecordChild1, // #1 = $rhs
/*  4377*/   OPC_SwitchType /*4 cases */, 7, /*MVT::v16i8*/39, // ->4387
/*  4380*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND),
                  /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
              // Src: (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
              // Dst: (AND:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/*  4387*/   /*SwitchType*/ 7, /*MVT::v8i16*/50, // ->4396
/*  4389*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
              // Src: (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (AND:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/*  4396*/   /*SwitchType*/ 7, /*MVT::v4i32*/60, // ->4405
/*  4398*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND),
                  /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
              // Src: (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (AND:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/*  4405*/   /*SwitchType*/ 7, /*MVT::v2i64*/78, // ->4414
/*  4407*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AND),
                  /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
              // Src: (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (AND:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/*  4414*/   0, // EndSwitchType
/*  4415*/  0, /*End of Scope*/
/*  4416*/ /*SwitchOpcode*/ 125|128,11/*1533*/, TARGET_VAL(ISD::SETCC),// ->5953
/*  4420*/  OPC_Scope, 126|128,1/*254*/, /*->4677*/ // 2 children in Scope
/*  4423*/   OPC_MoveChild0,
/*  4424*/   OPC_CheckOpcode, TARGET_VAL(ISD::INTRINSIC_WO_CHAIN),
/*  4427*/   OPC_Scope, 123, /*->4552*/ // 2 children in Scope
/*  4429*/    OPC_CheckChild0Integer, 30|128,67|128,1/*24990*/, 
/*  4433*/    OPC_RecordChild1, // #0 = $x
/*  4434*/    OPC_Scope, 28, /*->4464*/ // 4 children in Scope
/*  4436*/     OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/*  4438*/     OPC_MoveParent,
/*  4439*/     OPC_CheckTypeI32,
/*  4440*/     OPC_Scope, 10, /*->4452*/ // 2 children in Scope
/*  4442*/      OPC_CheckChild1Integer, 0, 
/*  4444*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4446*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12495:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4452*/     /*Scope*/ 10, /*->4463*/
/*  4453*/      OPC_CheckChild1Integer, 2, 
/*  4455*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4457*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12495:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4463*/     0, /*End of Scope*/
/*  4464*/    /*Scope*/ 28, /*->4493*/
/*  4465*/     OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/*  4467*/     OPC_MoveParent,
/*  4468*/     OPC_CheckTypeI32,
/*  4469*/     OPC_Scope, 10, /*->4481*/ // 2 children in Scope
/*  4471*/      OPC_CheckChild1Integer, 0, 
/*  4473*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4475*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12495:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4481*/     /*Scope*/ 10, /*->4492*/
/*  4482*/      OPC_CheckChild1Integer, 2, 
/*  4484*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4486*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12495:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4492*/     0, /*End of Scope*/
/*  4493*/    /*Scope*/ 28, /*->4522*/
/*  4494*/     OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/*  4496*/     OPC_MoveParent,
/*  4497*/     OPC_CheckTypeI32,
/*  4498*/     OPC_Scope, 10, /*->4510*/ // 2 children in Scope
/*  4500*/      OPC_CheckChild1Integer, 0, 
/*  4502*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4504*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12495:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4510*/     /*Scope*/ 10, /*->4521*/
/*  4511*/      OPC_CheckChild1Integer, 2, 
/*  4513*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4515*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12495:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4521*/     0, /*End of Scope*/
/*  4522*/    /*Scope*/ 28, /*->4551*/
/*  4523*/     OPC_CheckChild1Type, /*MVT::v2i64*/78, 
/*  4525*/     OPC_MoveParent,
/*  4526*/     OPC_CheckTypeI32,
/*  4527*/     OPC_Scope, 10, /*->4539*/ // 2 children in Scope
/*  4529*/      OPC_CheckChild1Integer, 0, 
/*  4531*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4533*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12495:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4539*/     /*Scope*/ 10, /*->4550*/
/*  4540*/      OPC_CheckChild1Integer, 2, 
/*  4542*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4544*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12495:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ANYTRUE:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4550*/     0, /*End of Scope*/
/*  4551*/    0, /*End of Scope*/
/*  4552*/   /*Scope*/ 123, /*->4676*/
/*  4553*/    OPC_CheckChild0Integer, 28|128,67|128,1/*24988*/, 
/*  4557*/    OPC_RecordChild1, // #0 = $x
/*  4558*/    OPC_Scope, 28, /*->4588*/ // 4 children in Scope
/*  4560*/     OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/*  4562*/     OPC_MoveParent,
/*  4563*/     OPC_CheckTypeI32,
/*  4564*/     OPC_Scope, 10, /*->4576*/ // 2 children in Scope
/*  4566*/      OPC_CheckChild1Integer, 0, 
/*  4568*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4570*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I8x16),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12494:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I8x16:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4576*/     /*Scope*/ 10, /*->4587*/
/*  4577*/      OPC_CheckChild1Integer, 2, 
/*  4579*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4581*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I8x16),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12494:{ *:[iPTR] }, V128:{ *:[v16i8] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I8x16:{ *:[i32] } ?:{ *:[v16i8] }:$x)
/*  4587*/     0, /*End of Scope*/
/*  4588*/    /*Scope*/ 28, /*->4617*/
/*  4589*/     OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/*  4591*/     OPC_MoveParent,
/*  4592*/     OPC_CheckTypeI32,
/*  4593*/     OPC_Scope, 10, /*->4605*/ // 2 children in Scope
/*  4595*/      OPC_CheckChild1Integer, 0, 
/*  4597*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4599*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I16x8),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12494:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I16x8:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4605*/     /*Scope*/ 10, /*->4616*/
/*  4606*/      OPC_CheckChild1Integer, 2, 
/*  4608*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4610*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I16x8),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12494:{ *:[iPTR] }, V128:{ *:[v8i16] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I16x8:{ *:[i32] } ?:{ *:[v8i16] }:$x)
/*  4616*/     0, /*End of Scope*/
/*  4617*/    /*Scope*/ 28, /*->4646*/
/*  4618*/     OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/*  4620*/     OPC_MoveParent,
/*  4621*/     OPC_CheckTypeI32,
/*  4622*/     OPC_Scope, 10, /*->4634*/ // 2 children in Scope
/*  4624*/      OPC_CheckChild1Integer, 0, 
/*  4626*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4628*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I32x4),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12494:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I32x4:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4634*/     /*Scope*/ 10, /*->4645*/
/*  4635*/      OPC_CheckChild1Integer, 2, 
/*  4637*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4639*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I32x4),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12494:{ *:[iPTR] }, V128:{ *:[v4i32] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I32x4:{ *:[i32] } ?:{ *:[v4i32] }:$x)
/*  4645*/     0, /*End of Scope*/
/*  4646*/    /*Scope*/ 28, /*->4675*/
/*  4647*/     OPC_CheckChild1Type, /*MVT::v2i64*/78, 
/*  4649*/     OPC_MoveParent,
/*  4650*/     OPC_CheckTypeI32,
/*  4651*/     OPC_Scope, 10, /*->4663*/ // 2 children in Scope
/*  4653*/      OPC_CheckChild1Integer, 0, 
/*  4655*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  4657*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I64x2),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12494:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 0:{ *:[i32] }, SETNE:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I64x2:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4663*/     /*Scope*/ 10, /*->4674*/
/*  4664*/      OPC_CheckChild1Integer, 2, 
/*  4666*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4668*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I64x2),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } (intrinsic_wo_chain:{ *:[i32] } 12494:{ *:[iPTR] }, V128:{ *:[v2i64] }:$x), 1:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 16
                // Dst: (ALLTRUE_I64x2:{ *:[i32] } ?:{ *:[v2i64] }:$x)
/*  4674*/     0, /*End of Scope*/
/*  4675*/    0, /*End of Scope*/
/*  4676*/   0, /*End of Scope*/
/*  4677*/  /*Scope*/ 121|128,9/*1273*/, /*->5952*/
/*  4679*/   OPC_RecordChild0, // #0 = $src
/*  4680*/   OPC_SwitchType /*5 cases */, 108|128,3/*492*/, /*MVT::i32*/7, // ->5176
/*  4684*/    OPC_Scope, 118, /*->4804*/ // 4 children in Scope
/*  4686*/     OPC_CheckChild0TypeI32,
/*  4687*/     OPC_Scope, 10, /*->4699*/ // 2 children in Scope
/*  4689*/      OPC_CheckChild1Integer, 0, 
/*  4691*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4693*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQZ_I32),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$src, 0:{ *:[i32] }, SETEQ:{ *:[Other] }) - Complexity = 8
                // Dst: (EQZ_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/*  4699*/     /*Scope*/ 103, /*->4803*/
/*  4700*/      OPC_RecordChild1, // #1 = $rhs
/*  4701*/      OPC_Scope, 9, /*->4712*/ // 10 children in Scope
/*  4703*/       OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4705*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I32),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                 // Dst: (EQ_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4712*/      /*Scope*/ 9, /*->4722*/
/*  4713*/       OPC_CheckChild2CondCode, ISD::SETNE,
/*  4715*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I32),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                 // Dst: (NE_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4722*/      /*Scope*/ 9, /*->4732*/
/*  4723*/       OPC_CheckChild2CondCode, ISD::SETLT,
/*  4725*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I32),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                 // Dst: (LT_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4732*/      /*Scope*/ 9, /*->4742*/
/*  4733*/       OPC_CheckChild2CondCode, ISD::SETULT,
/*  4735*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_U_I32),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
                 // Dst: (LT_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4742*/      /*Scope*/ 9, /*->4752*/
/*  4743*/       OPC_CheckChild2CondCode, ISD::SETGT,
/*  4745*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I32),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                 // Dst: (GT_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4752*/      /*Scope*/ 9, /*->4762*/
/*  4753*/       OPC_CheckChild2CondCode, ISD::SETUGT,
/*  4755*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_U_I32),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
                 // Dst: (GT_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4762*/      /*Scope*/ 9, /*->4772*/
/*  4763*/       OPC_CheckChild2CondCode, ISD::SETLE,
/*  4765*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I32),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                 // Dst: (LE_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4772*/      /*Scope*/ 9, /*->4782*/
/*  4773*/       OPC_CheckChild2CondCode, ISD::SETULE,
/*  4775*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_U_I32),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
                 // Dst: (LE_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4782*/      /*Scope*/ 9, /*->4792*/
/*  4783*/       OPC_CheckChild2CondCode, ISD::SETGE,
/*  4785*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I32),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                 // Dst: (GE_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4792*/      /*Scope*/ 9, /*->4802*/
/*  4793*/       OPC_CheckChild2CondCode, ISD::SETUGE,
/*  4795*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_U_I32),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
                 // Dst: (GE_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  4802*/      0, /*End of Scope*/
/*  4803*/     0, /*End of Scope*/
/*  4804*/    /*Scope*/ 118, /*->4923*/
/*  4805*/     OPC_CheckChild0TypeI64,
/*  4806*/     OPC_Scope, 10, /*->4818*/ // 2 children in Scope
/*  4808*/      OPC_CheckChild1Integer, 0, 
/*  4810*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4812*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQZ_I64),
                    /*MVT::i32*/7, 1/*#Ops*/, 0, 
                // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$src, 0:{ *:[i64] }, SETEQ:{ *:[Other] }) - Complexity = 8
                // Dst: (EQZ_I64:{ *:[i32] } I64:{ *:[i64] }:$src)
/*  4818*/     /*Scope*/ 103, /*->4922*/
/*  4819*/      OPC_RecordChild1, // #1 = $rhs
/*  4820*/      OPC_Scope, 9, /*->4831*/ // 10 children in Scope
/*  4822*/       OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4824*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I64),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                 // Dst: (EQ_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4831*/      /*Scope*/ 9, /*->4841*/
/*  4832*/       OPC_CheckChild2CondCode, ISD::SETNE,
/*  4834*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I64),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                 // Dst: (NE_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4841*/      /*Scope*/ 9, /*->4851*/
/*  4842*/       OPC_CheckChild2CondCode, ISD::SETLT,
/*  4844*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I64),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                 // Dst: (LT_S_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4851*/      /*Scope*/ 9, /*->4861*/
/*  4852*/       OPC_CheckChild2CondCode, ISD::SETULT,
/*  4854*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_U_I64),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
                 // Dst: (LT_U_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4861*/      /*Scope*/ 9, /*->4871*/
/*  4862*/       OPC_CheckChild2CondCode, ISD::SETGT,
/*  4864*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I64),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                 // Dst: (GT_S_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4871*/      /*Scope*/ 9, /*->4881*/
/*  4872*/       OPC_CheckChild2CondCode, ISD::SETUGT,
/*  4874*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_U_I64),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
                 // Dst: (GT_U_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4881*/      /*Scope*/ 9, /*->4891*/
/*  4882*/       OPC_CheckChild2CondCode, ISD::SETLE,
/*  4884*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I64),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                 // Dst: (LE_S_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4891*/      /*Scope*/ 9, /*->4901*/
/*  4892*/       OPC_CheckChild2CondCode, ISD::SETULE,
/*  4894*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_U_I64),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
                 // Dst: (LE_U_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4901*/      /*Scope*/ 9, /*->4911*/
/*  4902*/       OPC_CheckChild2CondCode, ISD::SETGE,
/*  4904*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I64),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                 // Dst: (GE_S_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4911*/      /*Scope*/ 9, /*->4921*/
/*  4912*/       OPC_CheckChild2CondCode, ISD::SETUGE,
/*  4914*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_U_I64),
                     /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                 // Src: (setcc:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
                 // Dst: (GE_U_I64:{ *:[i32] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  4921*/      0, /*End of Scope*/
/*  4922*/     0, /*End of Scope*/
/*  4923*/    /*Scope*/ 125, /*->5049*/
/*  4924*/     OPC_CheckChild0Type, /*MVT::f32*/12, 
/*  4926*/     OPC_RecordChild1, // #1 = $rhs
/*  4927*/     OPC_Scope, 9, /*->4938*/ // 12 children in Scope
/*  4929*/      OPC_CheckChild2CondCode, ISD::SETOEQ,
/*  4931*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F32),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  4938*/     /*Scope*/ 9, /*->4948*/
/*  4939*/      OPC_CheckChild2CondCode, ISD::SETUNE,
/*  4941*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F32),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  4948*/     /*Scope*/ 9, /*->4958*/
/*  4949*/      OPC_CheckChild2CondCode, ISD::SETOLT,
/*  4951*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F32),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  4958*/     /*Scope*/ 9, /*->4968*/
/*  4959*/      OPC_CheckChild2CondCode, ISD::SETOLE,
/*  4961*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F32),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  4968*/     /*Scope*/ 9, /*->4978*/
/*  4969*/      OPC_CheckChild2CondCode, ISD::SETOGT,
/*  4971*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F32),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  4978*/     /*Scope*/ 9, /*->4988*/
/*  4979*/      OPC_CheckChild2CondCode, ISD::SETOGE,
/*  4981*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F32),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F32:{ *:[i32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/*  4988*/     /*Scope*/ 9, /*->4998*/
/*  4989*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  4991*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F32),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  4998*/     /*Scope*/ 9, /*->5008*/
/*  4999*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5001*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F32),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  5008*/     /*Scope*/ 9, /*->5018*/
/*  5009*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5011*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F32),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  5018*/     /*Scope*/ 9, /*->5028*/
/*  5019*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5021*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F32),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  5028*/     /*Scope*/ 9, /*->5038*/
/*  5029*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5031*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F32),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  5038*/     /*Scope*/ 9, /*->5048*/
/*  5039*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5041*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F32),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F32:{ *:[i32] } f32:{ *:[f32] }:$lhs, f32:{ *:[f32] }:$rhs)
/*  5048*/     0, /*End of Scope*/
/*  5049*/    /*Scope*/ 125, /*->5175*/
/*  5050*/     OPC_CheckChild0Type, /*MVT::f64*/13, 
/*  5052*/     OPC_RecordChild1, // #1 = $rhs
/*  5053*/     OPC_Scope, 9, /*->5064*/ // 12 children in Scope
/*  5055*/      OPC_CheckChild2CondCode, ISD::SETOEQ,
/*  5057*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F64),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5064*/     /*Scope*/ 9, /*->5074*/
/*  5065*/      OPC_CheckChild2CondCode, ISD::SETUNE,
/*  5067*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F64),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5074*/     /*Scope*/ 9, /*->5084*/
/*  5075*/      OPC_CheckChild2CondCode, ISD::SETOLT,
/*  5077*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F64),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5084*/     /*Scope*/ 9, /*->5094*/
/*  5085*/      OPC_CheckChild2CondCode, ISD::SETOLE,
/*  5087*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F64),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5094*/     /*Scope*/ 9, /*->5104*/
/*  5095*/      OPC_CheckChild2CondCode, ISD::SETOGT,
/*  5097*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F64),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5104*/     /*Scope*/ 9, /*->5114*/
/*  5105*/      OPC_CheckChild2CondCode, ISD::SETOGE,
/*  5107*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F64),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F64:{ *:[i32] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/*  5114*/     /*Scope*/ 9, /*->5124*/
/*  5115*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5117*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F64),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5124*/     /*Scope*/ 9, /*->5134*/
/*  5125*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5127*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F64),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5134*/     /*Scope*/ 9, /*->5144*/
/*  5135*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5137*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F64),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5144*/     /*Scope*/ 9, /*->5154*/
/*  5145*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5147*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F64),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5154*/     /*Scope*/ 9, /*->5164*/
/*  5155*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5157*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F64),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5164*/     /*Scope*/ 9, /*->5174*/
/*  5165*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5167*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F64),
                    /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F64:{ *:[i32] } f64:{ *:[f64] }:$lhs, f64:{ *:[f64] }:$rhs)
/*  5174*/     0, /*End of Scope*/
/*  5175*/    0, /*End of Scope*/
/*  5176*/   /*SwitchType*/ 115, /*MVT::v16i8*/39, // ->5293
/*  5178*/    OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/*  5180*/    OPC_RecordChild1, // #1 = $rhs
/*  5181*/    OPC_Scope, 10, /*->5193*/ // 10 children in Scope
/*  5183*/     OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5185*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5186*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
               // Dst: (EQ_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5193*/    /*Scope*/ 10, /*->5204*/
/*  5194*/     OPC_CheckChild2CondCode, ISD::SETNE,
/*  5196*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5197*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
               // Dst: (NE_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5204*/    /*Scope*/ 10, /*->5215*/
/*  5205*/     OPC_CheckChild2CondCode, ISD::SETLT,
/*  5207*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5208*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
               // Dst: (LT_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5215*/    /*Scope*/ 10, /*->5226*/
/*  5216*/     OPC_CheckChild2CondCode, ISD::SETULT,
/*  5218*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5219*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_U_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
               // Dst: (LT_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5226*/    /*Scope*/ 10, /*->5237*/
/*  5227*/     OPC_CheckChild2CondCode, ISD::SETGT,
/*  5229*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5230*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
               // Dst: (GT_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5237*/    /*Scope*/ 10, /*->5248*/
/*  5238*/     OPC_CheckChild2CondCode, ISD::SETUGT,
/*  5240*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5241*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_U_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
               // Dst: (GT_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5248*/    /*Scope*/ 10, /*->5259*/
/*  5249*/     OPC_CheckChild2CondCode, ISD::SETLE,
/*  5251*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5252*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
               // Dst: (LE_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5259*/    /*Scope*/ 10, /*->5270*/
/*  5260*/     OPC_CheckChild2CondCode, ISD::SETULE,
/*  5262*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5263*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_U_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
               // Dst: (LE_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5270*/    /*Scope*/ 10, /*->5281*/
/*  5271*/     OPC_CheckChild2CondCode, ISD::SETGE,
/*  5273*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5274*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
               // Dst: (GE_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5281*/    /*Scope*/ 10, /*->5292*/
/*  5282*/     OPC_CheckChild2CondCode, ISD::SETUGE,
/*  5284*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5285*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_U_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (setcc:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
               // Dst: (GE_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/*  5292*/    0, /*End of Scope*/
/*  5293*/   /*SwitchType*/ 62|128,1/*190*/, /*MVT::v8i16*/50, // ->5486
/*  5296*/    OPC_Scope, 115, /*->5413*/ // 2 children in Scope
/*  5298*/     OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/*  5300*/     OPC_RecordChild1, // #1 = $rhs
/*  5301*/     OPC_Scope, 10, /*->5313*/ // 10 children in Scope
/*  5303*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5305*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5306*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5313*/     /*Scope*/ 10, /*->5324*/
/*  5314*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5316*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5317*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5324*/     /*Scope*/ 10, /*->5335*/
/*  5325*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5327*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5328*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5335*/     /*Scope*/ 10, /*->5346*/
/*  5336*/      OPC_CheckChild2CondCode, ISD::SETULT,
/*  5338*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5339*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_U_I16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5346*/     /*Scope*/ 10, /*->5357*/
/*  5347*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5349*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5350*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5357*/     /*Scope*/ 10, /*->5368*/
/*  5358*/      OPC_CheckChild2CondCode, ISD::SETUGT,
/*  5360*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5361*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_U_I16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5368*/     /*Scope*/ 10, /*->5379*/
/*  5369*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5371*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5372*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5379*/     /*Scope*/ 10, /*->5390*/
/*  5380*/      OPC_CheckChild2CondCode, ISD::SETULE,
/*  5382*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5383*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_U_I16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5390*/     /*Scope*/ 10, /*->5401*/
/*  5391*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5393*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5394*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5401*/     /*Scope*/ 10, /*->5412*/
/*  5402*/      OPC_CheckChild2CondCode, ISD::SETUGE,
/*  5404*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5405*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_U_I16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/*  5412*/     0, /*End of Scope*/
/*  5413*/    /*Scope*/ 71, /*->5485*/
/*  5414*/     OPC_CheckChild0Type, /*MVT::v8f16*/92, 
/*  5416*/     OPC_RecordChild1, // #1 = $rhs
/*  5417*/     OPC_Scope, 10, /*->5429*/ // 6 children in Scope
/*  5419*/      OPC_CheckChild2CondCode, ISD::SETOEQ,
/*  5421*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/*  5422*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F16x8:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/*  5429*/     /*Scope*/ 10, /*->5440*/
/*  5430*/      OPC_CheckChild2CondCode, ISD::SETUNE,
/*  5432*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/*  5433*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F16x8:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/*  5440*/     /*Scope*/ 10, /*->5451*/
/*  5441*/      OPC_CheckChild2CondCode, ISD::SETOLT,
/*  5443*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/*  5444*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F16x8:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/*  5451*/     /*Scope*/ 10, /*->5462*/
/*  5452*/      OPC_CheckChild2CondCode, ISD::SETOGT,
/*  5454*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/*  5455*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F16x8:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/*  5462*/     /*Scope*/ 10, /*->5473*/
/*  5463*/      OPC_CheckChild2CondCode, ISD::SETOLE,
/*  5465*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/*  5466*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F16x8:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/*  5473*/     /*Scope*/ 10, /*->5484*/
/*  5474*/      OPC_CheckChild2CondCode, ISD::SETOGE,
/*  5476*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/*  5477*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F16x8),
                    /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F16x8:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/*  5484*/     0, /*End of Scope*/
/*  5485*/    0, /*End of Scope*/
/*  5486*/   /*SwitchType*/ 123|128,1/*251*/, /*MVT::v4i32*/60, // ->5740
/*  5489*/    OPC_Scope, 115, /*->5606*/ // 2 children in Scope
/*  5491*/     OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/*  5493*/     OPC_RecordChild1, // #1 = $rhs
/*  5494*/     OPC_Scope, 10, /*->5506*/ // 10 children in Scope
/*  5496*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5498*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5499*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5506*/     /*Scope*/ 10, /*->5517*/
/*  5507*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5509*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5510*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5517*/     /*Scope*/ 10, /*->5528*/
/*  5518*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5520*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5521*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5528*/     /*Scope*/ 10, /*->5539*/
/*  5529*/      OPC_CheckChild2CondCode, ISD::SETULT,
/*  5531*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5532*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_U_I32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETULT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5539*/     /*Scope*/ 10, /*->5550*/
/*  5540*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5542*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5543*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5550*/     /*Scope*/ 10, /*->5561*/
/*  5551*/      OPC_CheckChild2CondCode, ISD::SETUGT,
/*  5553*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5554*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_U_I32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETUGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5561*/     /*Scope*/ 10, /*->5572*/
/*  5562*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5564*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5565*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5572*/     /*Scope*/ 10, /*->5583*/
/*  5573*/      OPC_CheckChild2CondCode, ISD::SETULE,
/*  5575*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5576*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_U_I32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETULE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5583*/     /*Scope*/ 10, /*->5594*/
/*  5584*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5586*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5587*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5594*/     /*Scope*/ 10, /*->5605*/
/*  5595*/      OPC_CheckChild2CondCode, ISD::SETUGE,
/*  5597*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5598*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_U_I32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs, SETUGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/*  5605*/     0, /*End of Scope*/
/*  5606*/    /*Scope*/ 3|128,1/*131*/, /*->5739*/
/*  5608*/     OPC_CheckChild0Type, /*MVT::v4f32*/111, 
/*  5610*/     OPC_RecordChild1, // #1 = $rhs
/*  5611*/     OPC_Scope, 10, /*->5623*/ // 12 children in Scope
/*  5613*/      OPC_CheckChild2CondCode, ISD::SETOEQ,
/*  5615*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5616*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  5623*/     /*Scope*/ 10, /*->5634*/
/*  5624*/      OPC_CheckChild2CondCode, ISD::SETUNE,
/*  5626*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5627*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  5634*/     /*Scope*/ 10, /*->5645*/
/*  5635*/      OPC_CheckChild2CondCode, ISD::SETOLT,
/*  5637*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5638*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  5645*/     /*Scope*/ 10, /*->5656*/
/*  5646*/      OPC_CheckChild2CondCode, ISD::SETOGT,
/*  5648*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5649*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  5656*/     /*Scope*/ 10, /*->5667*/
/*  5657*/      OPC_CheckChild2CondCode, ISD::SETOLE,
/*  5659*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5660*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  5667*/     /*Scope*/ 10, /*->5678*/
/*  5668*/      OPC_CheckChild2CondCode, ISD::SETOGE,
/*  5670*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5671*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/*  5678*/     /*Scope*/ 9, /*->5688*/
/*  5679*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5681*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  5688*/     /*Scope*/ 9, /*->5698*/
/*  5689*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5691*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  5698*/     /*Scope*/ 9, /*->5708*/
/*  5699*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5701*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  5708*/     /*Scope*/ 9, /*->5718*/
/*  5709*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5711*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  5718*/     /*Scope*/ 9, /*->5728*/
/*  5719*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5721*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  5728*/     /*Scope*/ 9, /*->5738*/
/*  5729*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5731*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F32x4),
                    /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs)
/*  5738*/     0, /*End of Scope*/
/*  5739*/    0, /*End of Scope*/
/*  5740*/   /*SwitchType*/ 80|128,1/*208*/, /*MVT::v2i64*/78, // ->5951
/*  5743*/    OPC_Scope, 71, /*->5816*/ // 2 children in Scope
/*  5745*/     OPC_CheckChild0Type, /*MVT::v2i64*/78, 
/*  5747*/     OPC_RecordChild1, // #1 = $rhs
/*  5748*/     OPC_Scope, 10, /*->5760*/ // 6 children in Scope
/*  5750*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5752*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5753*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_I64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  5760*/     /*Scope*/ 10, /*->5771*/
/*  5761*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5763*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5764*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_I64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  5771*/     /*Scope*/ 10, /*->5782*/
/*  5772*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5774*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5775*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_S_I64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  5782*/     /*Scope*/ 10, /*->5793*/
/*  5783*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5785*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5786*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_S_I64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  5793*/     /*Scope*/ 10, /*->5804*/
/*  5794*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5796*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5797*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_S_I64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  5804*/     /*Scope*/ 10, /*->5815*/
/*  5805*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5807*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5808*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_S_I64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/*  5815*/     0, /*End of Scope*/
/*  5816*/    /*Scope*/ 4|128,1/*132*/, /*->5950*/
/*  5818*/     OPC_CheckChild0Type, /*MVT::v2f64*/1|128,1/*129*/, 
/*  5821*/     OPC_RecordChild1, // #1 = $rhs
/*  5822*/     OPC_Scope, 10, /*->5834*/ // 12 children in Scope
/*  5824*/      OPC_CheckChild2CondCode, ISD::SETOEQ,
/*  5826*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5827*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  5834*/     /*Scope*/ 10, /*->5845*/
/*  5835*/      OPC_CheckChild2CondCode, ISD::SETUNE,
/*  5837*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5838*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETUNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  5845*/     /*Scope*/ 10, /*->5856*/
/*  5846*/      OPC_CheckChild2CondCode, ISD::SETOLT,
/*  5848*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5849*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  5856*/     /*Scope*/ 10, /*->5867*/
/*  5857*/      OPC_CheckChild2CondCode, ISD::SETOGT,
/*  5859*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5860*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  5867*/     /*Scope*/ 10, /*->5878*/
/*  5868*/      OPC_CheckChild2CondCode, ISD::SETOLE,
/*  5870*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5871*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  5878*/     /*Scope*/ 10, /*->5889*/
/*  5879*/      OPC_CheckChild2CondCode, ISD::SETOGE,
/*  5881*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/*  5882*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F64x2:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/*  5889*/     /*Scope*/ 9, /*->5899*/
/*  5890*/      OPC_CheckChild2CondCode, ISD::SETEQ,
/*  5892*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EQ_F64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETEQ:{ *:[Other] }) - Complexity = 3
                // Dst: (EQ_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  5899*/     /*Scope*/ 9, /*->5909*/
/*  5900*/      OPC_CheckChild2CondCode, ISD::SETNE,
/*  5902*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NE_F64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETNE:{ *:[Other] }) - Complexity = 3
                // Dst: (NE_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  5909*/     /*Scope*/ 9, /*->5919*/
/*  5910*/      OPC_CheckChild2CondCode, ISD::SETLT,
/*  5912*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LT_F64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETLT:{ *:[Other] }) - Complexity = 3
                // Dst: (LT_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  5919*/     /*Scope*/ 9, /*->5929*/
/*  5920*/      OPC_CheckChild2CondCode, ISD::SETGT,
/*  5922*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GT_F64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETGT:{ *:[Other] }) - Complexity = 3
                // Dst: (GT_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  5929*/     /*Scope*/ 9, /*->5939*/
/*  5930*/      OPC_CheckChild2CondCode, ISD::SETLE,
/*  5932*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LE_F64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETLE:{ *:[Other] }) - Complexity = 3
                // Dst: (LE_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  5939*/     /*Scope*/ 9, /*->5949*/
/*  5940*/      OPC_CheckChild2CondCode, ISD::SETGE,
/*  5942*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GE_F64x2),
                    /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
                // Src: (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETGE:{ *:[Other] }) - Complexity = 3
                // Dst: (GE_F64x2:{ *:[v2i64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs)
/*  5949*/     0, /*End of Scope*/
/*  5950*/    0, /*End of Scope*/
/*  5951*/   0, // EndSwitchType
/*  5952*/  0, /*End of Scope*/
/*  5953*/ /*SwitchOpcode*/ 59|128,11/*1467*/, TARGET_VAL(ISD::LOAD),// ->7424
/*  5957*/  OPC_RecordMemRef,
/*  5958*/  OPC_RecordNode, // #0 = 'ld' chained node
/*  5959*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  5960*/  OPC_Scope, 89|128,5/*729*/, /*->6692*/ // 2 children in Scope
/*  5963*/   OPC_CheckChild1TypeI32,
/*  5964*/   OPC_CheckPredicate, 8, // Predicate_unindexedload
/*  5966*/   OPC_Scope, 37, /*->6005*/ // 16 children in Scope
/*  5968*/    OPC_CheckPredicate6,  // Predicate_load
/*  5969*/    OPC_SwitchType /*2 cases */, 15, /*MVT::i32*/7, // ->5987
/*  5972*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  5973*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  5975*/     OPC_EmitMergeInputChains1_0,
/*  5976*/     OPC_EmitInteger32, 0, 
/*  5978*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  5987*/    /*SwitchType*/ 15, /*MVT::i64*/8, // ->6004
/*  5989*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  5990*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  5992*/     OPC_EmitMergeInputChains1_0,
/*  5993*/     OPC_EmitInteger32, 0, 
/*  5995*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6004*/    0, // EndSwitchType
/*  6005*/   /*Scope*/ 97, /*->6103*/
/*  6006*/    OPC_CheckPredicate, 15, // Predicate_sextload
/*  6008*/    OPC_SwitchType /*2 cases */, 36, /*MVT::i32*/7, // ->6047
/*  6011*/     OPC_Scope, 16, /*->6029*/ // 2 children in Scope
/*  6013*/      OPC_CheckPredicate1,  // Predicate_sextloadi8
/*  6014*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6015*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6017*/      OPC_EmitMergeInputChains1_0,
/*  6018*/      OPC_EmitInteger32, 0, 
/*  6020*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 13
                // Dst: (LOAD8_S_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6029*/     /*Scope*/ 16, /*->6046*/
/*  6030*/      OPC_CheckPredicate2,  // Predicate_sextloadi16
/*  6031*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6032*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6034*/      OPC_EmitMergeInputChains1_0,
/*  6035*/      OPC_EmitInteger32, 0, 
/*  6037*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 13
                // Dst: (LOAD16_S_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6046*/     0, /*End of Scope*/
/*  6047*/    /*SwitchType*/ 53, /*MVT::i64*/8, // ->6102
/*  6049*/     OPC_Scope, 16, /*->6067*/ // 3 children in Scope
/*  6051*/      OPC_CheckPredicate1,  // Predicate_sextloadi8
/*  6052*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6053*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6055*/      OPC_EmitMergeInputChains1_0,
/*  6056*/      OPC_EmitInteger32, 0, 
/*  6058*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 13
                // Dst: (LOAD8_S_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6067*/     /*Scope*/ 16, /*->6084*/
/*  6068*/      OPC_CheckPredicate2,  // Predicate_sextloadi16
/*  6069*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6070*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6072*/      OPC_EmitMergeInputChains1_0,
/*  6073*/      OPC_EmitInteger32, 0, 
/*  6075*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 13
                // Dst: (LOAD16_S_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6084*/     /*Scope*/ 16, /*->6101*/
/*  6085*/      OPC_CheckPredicate3,  // Predicate_sextloadi32
/*  6086*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6087*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6089*/      OPC_EmitMergeInputChains1_0,
/*  6090*/      OPC_EmitInteger32, 0, 
/*  6092*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_S_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>> - Complexity = 13
                // Dst: (LOAD32_S_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6101*/     0, /*End of Scope*/
/*  6102*/    0, // EndSwitchType
/*  6103*/   /*Scope*/ 97, /*->6201*/
/*  6104*/    OPC_CheckPredicate, 16, // Predicate_zextload
/*  6106*/    OPC_SwitchType /*2 cases */, 36, /*MVT::i32*/7, // ->6145
/*  6109*/     OPC_Scope, 16, /*->6127*/ // 2 children in Scope
/*  6111*/      OPC_CheckPredicate1,  // Predicate_zextloadi8
/*  6112*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6113*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6115*/      OPC_EmitMergeInputChains1_0,
/*  6116*/      OPC_EmitInteger32, 0, 
/*  6118*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6127*/     /*Scope*/ 16, /*->6144*/
/*  6128*/      OPC_CheckPredicate2,  // Predicate_zextloadi16
/*  6129*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6130*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6132*/      OPC_EmitMergeInputChains1_0,
/*  6133*/      OPC_EmitInteger32, 0, 
/*  6135*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6144*/     0, /*End of Scope*/
/*  6145*/    /*SwitchType*/ 53, /*MVT::i64*/8, // ->6200
/*  6147*/     OPC_Scope, 16, /*->6165*/ // 3 children in Scope
/*  6149*/      OPC_CheckPredicate1,  // Predicate_zextloadi8
/*  6150*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6151*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6153*/      OPC_EmitMergeInputChains1_0,
/*  6154*/      OPC_EmitInteger32, 0, 
/*  6156*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6165*/     /*Scope*/ 16, /*->6182*/
/*  6166*/      OPC_CheckPredicate2,  // Predicate_zextloadi16
/*  6167*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6168*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6170*/      OPC_EmitMergeInputChains1_0,
/*  6171*/      OPC_EmitInteger32, 0, 
/*  6173*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6182*/     /*Scope*/ 16, /*->6199*/
/*  6183*/      OPC_CheckPredicate3,  // Predicate_zextloadi32
/*  6184*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6185*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6187*/      OPC_EmitMergeInputChains1_0,
/*  6188*/      OPC_EmitInteger32, 0, 
/*  6190*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>> - Complexity = 13
                // Dst: (LOAD32_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6199*/     0, /*End of Scope*/
/*  6200*/    0, // EndSwitchType
/*  6201*/   /*Scope*/ 97, /*->6299*/
/*  6202*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  6204*/    OPC_SwitchType /*2 cases */, 36, /*MVT::i32*/7, // ->6243
/*  6207*/     OPC_Scope, 16, /*->6225*/ // 2 children in Scope
/*  6209*/      OPC_CheckPredicate1,  // Predicate_extloadi8
/*  6210*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6211*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6213*/      OPC_EmitMergeInputChains1_0,
/*  6214*/      OPC_EmitInteger32, 0, 
/*  6216*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6225*/     /*Scope*/ 16, /*->6242*/
/*  6226*/      OPC_CheckPredicate2,  // Predicate_extloadi16
/*  6227*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6228*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6230*/      OPC_EmitMergeInputChains1_0,
/*  6231*/      OPC_EmitInteger32, 0, 
/*  6233*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6242*/     0, /*End of Scope*/
/*  6243*/    /*SwitchType*/ 53, /*MVT::i64*/8, // ->6298
/*  6245*/     OPC_Scope, 16, /*->6263*/ // 3 children in Scope
/*  6247*/      OPC_CheckPredicate1,  // Predicate_extloadi8
/*  6248*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6249*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6251*/      OPC_EmitMergeInputChains1_0,
/*  6252*/      OPC_EmitInteger32, 0, 
/*  6254*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6263*/     /*Scope*/ 16, /*->6280*/
/*  6264*/      OPC_CheckPredicate2,  // Predicate_extloadi16
/*  6265*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6266*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6268*/      OPC_EmitMergeInputChains1_0,
/*  6269*/      OPC_EmitInteger32, 0, 
/*  6271*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6280*/     /*Scope*/ 16, /*->6297*/
/*  6281*/      OPC_CheckPredicate3,  // Predicate_extloadi32
/*  6282*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6283*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6285*/      OPC_EmitMergeInputChains1_0,
/*  6286*/      OPC_EmitInteger32, 0, 
/*  6288*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>> - Complexity = 13
                // Dst: (LOAD32_U_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6297*/     0, /*End of Scope*/
/*  6298*/    0, // EndSwitchType
/*  6299*/   /*Scope*/ 105, /*->6405*/
/*  6300*/    OPC_CheckPredicate6,  // Predicate_load
/*  6301*/    OPC_SwitchType /*6 cases */, 15, /*MVT::f32*/12, // ->6319
/*  6304*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6305*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6307*/     OPC_EmitMergeInputChains1_0,
/*  6308*/     OPC_EmitInteger32, 0, 
/*  6310*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::f32*/12, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[f32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_F32_A32:{ *:[f32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6319*/    /*SwitchType*/ 15, /*MVT::f64*/13, // ->6336
/*  6321*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6322*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6324*/     OPC_EmitMergeInputChains1_0,
/*  6325*/     OPC_EmitInteger32, 0, 
/*  6327*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::f64*/13, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[f64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_F64_A32:{ *:[f64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6336*/    /*SwitchType*/ 15, /*MVT::v16i8*/39, // ->6353
/*  6338*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6339*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6341*/     OPC_EmitMergeInputChains1_0,
/*  6342*/     OPC_EmitInteger32, 0, 
/*  6344*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v16i8*/39, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v16i8] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v16i8] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6353*/    /*SwitchType*/ 15, /*MVT::v8i16*/50, // ->6370
/*  6355*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6356*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6358*/     OPC_EmitMergeInputChains1_0,
/*  6359*/     OPC_EmitInteger32, 0, 
/*  6361*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v8i16*/50, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v8i16] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v8i16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6370*/    /*SwitchType*/ 15, /*MVT::v4i32*/60, // ->6387
/*  6372*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6373*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6375*/     OPC_EmitMergeInputChains1_0,
/*  6376*/     OPC_EmitInteger32, 0, 
/*  6378*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v4i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6387*/    /*SwitchType*/ 15, /*MVT::v2i64*/78, // ->6404
/*  6389*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6390*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6392*/     OPC_EmitMergeInputChains1_0,
/*  6393*/     OPC_EmitInteger32, 0, 
/*  6395*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v2i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6404*/    0, // EndSwitchType
/*  6405*/   /*Scope*/ 21, /*->6427*/
/*  6406*/    OPC_CheckPredicate, 15, // Predicate_sextload
/*  6408*/    OPC_CheckPredicate, 21, // Predicate_sextloadvi8
/*  6410*/    OPC_CheckType, /*MVT::v8i16*/50, 
/*  6412*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6413*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6415*/    OPC_EmitMergeInputChains1_0,
/*  6416*/    OPC_EmitInteger32, 0, 
/*  6418*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v8i16*/50, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I16x8_A32:{ *:[v8i16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6427*/   /*Scope*/ 21, /*->6449*/
/*  6428*/    OPC_CheckPredicate, 16, // Predicate_zextload
/*  6430*/    OPC_CheckPredicate, 21, // Predicate_zextloadvi8
/*  6432*/    OPC_CheckType, /*MVT::v8i16*/50, 
/*  6434*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6435*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6437*/    OPC_EmitMergeInputChains1_0,
/*  6438*/    OPC_EmitInteger32, 0, 
/*  6440*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v8i16*/50, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I16x8_A32:{ *:[v8i16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6449*/   /*Scope*/ 21, /*->6471*/
/*  6450*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  6452*/    OPC_CheckPredicate, 21, // Predicate_extloadvi8
/*  6454*/    OPC_CheckType, /*MVT::v8i16*/50, 
/*  6456*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6457*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6459*/    OPC_EmitMergeInputChains1_0,
/*  6460*/    OPC_EmitInteger32, 0, 
/*  6462*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v8i16*/50, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I16x8_A32:{ *:[v8i16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6471*/   /*Scope*/ 21, /*->6493*/
/*  6472*/    OPC_CheckPredicate, 15, // Predicate_sextload
/*  6474*/    OPC_CheckPredicate, 22, // Predicate_sextloadvi16
/*  6476*/    OPC_CheckType, /*MVT::v4i32*/60, 
/*  6478*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6479*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6481*/    OPC_EmitMergeInputChains1_0,
/*  6482*/    OPC_EmitInteger32, 0, 
/*  6484*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6493*/   /*Scope*/ 21, /*->6515*/
/*  6494*/    OPC_CheckPredicate, 16, // Predicate_zextload
/*  6496*/    OPC_CheckPredicate, 22, // Predicate_zextloadvi16
/*  6498*/    OPC_CheckType, /*MVT::v4i32*/60, 
/*  6500*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6501*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6503*/    OPC_EmitMergeInputChains1_0,
/*  6504*/    OPC_EmitInteger32, 0, 
/*  6506*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6515*/   /*Scope*/ 21, /*->6537*/
/*  6516*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  6518*/    OPC_CheckPredicate, 22, // Predicate_extloadvi16
/*  6520*/    OPC_CheckType, /*MVT::v4i32*/60, 
/*  6522*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6523*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6525*/    OPC_EmitMergeInputChains1_0,
/*  6526*/    OPC_EmitInteger32, 0, 
/*  6528*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I32x4_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6537*/   /*Scope*/ 21, /*->6559*/
/*  6538*/    OPC_CheckPredicate, 15, // Predicate_sextload
/*  6540*/    OPC_CheckPredicate, 23, // Predicate_sextloadvi32
/*  6542*/    OPC_CheckType, /*MVT::v2i64*/78, 
/*  6544*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6545*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6547*/    OPC_EmitMergeInputChains1_0,
/*  6548*/    OPC_EmitInteger32, 0, 
/*  6550*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6559*/   /*Scope*/ 21, /*->6581*/
/*  6560*/    OPC_CheckPredicate, 16, // Predicate_zextload
/*  6562*/    OPC_CheckPredicate, 23, // Predicate_zextloadvi32
/*  6564*/    OPC_CheckType, /*MVT::v2i64*/78, 
/*  6566*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6567*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6569*/    OPC_EmitMergeInputChains1_0,
/*  6570*/    OPC_EmitInteger32, 0, 
/*  6572*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6581*/   /*Scope*/ 21, /*->6603*/
/*  6582*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  6584*/    OPC_CheckPredicate, 23, // Predicate_extloadvi32
/*  6586*/    OPC_CheckType, /*MVT::v2i64*/78, 
/*  6588*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6589*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6591*/    OPC_EmitMergeInputChains1_0,
/*  6592*/    OPC_EmitInteger32, 0, 
/*  6594*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I64x2_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6603*/   /*Scope*/ 56, /*->6660*/
/*  6604*/    OPC_CheckPredicate6,  // Predicate_load
/*  6605*/    OPC_SwitchType /*3 cases */, 15, /*MVT::v4f32*/111, // ->6623
/*  6608*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6609*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6611*/     OPC_EmitMergeInputChains1_0,
/*  6612*/     OPC_EmitInteger32, 0, 
/*  6614*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v4f32*/111, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v4f32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v4f32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6623*/    /*SwitchType*/ 16, /*MVT::v2f64*/1|128,1/*129*/, // ->6642
/*  6626*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6627*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6629*/     OPC_EmitMergeInputChains1_0,
/*  6630*/     OPC_EmitInteger32, 0, 
/*  6632*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v2f64*/1|128,1/*129*/, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v2f64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v2f64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6642*/    /*SwitchType*/ 15, /*MVT::v8f16*/92, // ->6659
/*  6644*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6645*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  6647*/     OPC_EmitMergeInputChains1_0,
/*  6648*/     OPC_EmitInteger32, 0, 
/*  6650*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v8f16*/92, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v8f16] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A32:{ *:[v8f16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  6659*/    0, // EndSwitchType
/*  6660*/   /*Scope*/ 30, /*->6691*/
/*  6661*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  6663*/    OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/*  6666*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  6667*/    OPC_EmitMergeInputChains1_0,
/*  6668*/    OPC_EmitInteger32, 0, 
/*  6670*/    OPC_EmitInteger32, 0, 
/*  6672*/    OPC_EmitNode1, TARGET_VAL(WebAssembly::LOAD_ZERO_64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v16i8*/39, 3/*#Ops*/, 2, 3, 1,  // Results = #4
/*  6681*/    OPC_EmitNode1None, TARGET_VAL(WebAssembly::promote_low_F64x2),
                  /*MVT::v2f64*/1|128,1/*129*/, 1/*#Ops*/, 4,  // Results = #5
/*  6688*/    OPC_CompleteMatch, 1, 5, 
               // Src: (ld:{ *:[v2f64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>> - Complexity = 4
               // Dst: (promote_low_F64x2:{ *:[v2f64] } (LOAD_ZERO_64_A32:{ *:[v16i8] } 0:{ *:[i32] }, 0:{ *:[i32] }, I32:{ *:[i32] }:$addr))
/*  6691*/   0, /*End of Scope*/
/*  6692*/  /*Scope*/ 89|128,5/*729*/, /*->7423*/
/*  6694*/   OPC_CheckChild1TypeI64,
/*  6695*/   OPC_CheckPredicate, 8, // Predicate_unindexedload
/*  6697*/   OPC_Scope, 37, /*->6736*/ // 16 children in Scope
/*  6699*/    OPC_CheckPredicate6,  // Predicate_load
/*  6700*/    OPC_SwitchType /*2 cases */, 15, /*MVT::i32*/7, // ->6718
/*  6703*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6704*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6706*/     OPC_EmitMergeInputChains1_0,
/*  6707*/     OPC_EmitInteger32, 0, 
/*  6709*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6718*/    /*SwitchType*/ 15, /*MVT::i64*/8, // ->6735
/*  6720*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6721*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6723*/     OPC_EmitMergeInputChains1_0,
/*  6724*/     OPC_EmitInteger32, 0, 
/*  6726*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6735*/    0, // EndSwitchType
/*  6736*/   /*Scope*/ 97, /*->6834*/
/*  6737*/    OPC_CheckPredicate, 15, // Predicate_sextload
/*  6739*/    OPC_SwitchType /*2 cases */, 36, /*MVT::i32*/7, // ->6778
/*  6742*/     OPC_Scope, 16, /*->6760*/ // 2 children in Scope
/*  6744*/      OPC_CheckPredicate1,  // Predicate_sextloadi8
/*  6745*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6746*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6748*/      OPC_EmitMergeInputChains1_0,
/*  6749*/      OPC_EmitInteger32, 0, 
/*  6751*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 13
                // Dst: (LOAD8_S_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6760*/     /*Scope*/ 16, /*->6777*/
/*  6761*/      OPC_CheckPredicate2,  // Predicate_sextloadi16
/*  6762*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6763*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6765*/      OPC_EmitMergeInputChains1_0,
/*  6766*/      OPC_EmitInteger32, 0, 
/*  6768*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 13
                // Dst: (LOAD16_S_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6777*/     0, /*End of Scope*/
/*  6778*/    /*SwitchType*/ 53, /*MVT::i64*/8, // ->6833
/*  6780*/     OPC_Scope, 16, /*->6798*/ // 3 children in Scope
/*  6782*/      OPC_CheckPredicate1,  // Predicate_sextloadi8
/*  6783*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6784*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6786*/      OPC_EmitMergeInputChains1_0,
/*  6787*/      OPC_EmitInteger32, 0, 
/*  6789*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_S_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi8>> - Complexity = 13
                // Dst: (LOAD8_S_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6798*/     /*Scope*/ 16, /*->6815*/
/*  6799*/      OPC_CheckPredicate2,  // Predicate_sextloadi16
/*  6800*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6801*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6803*/      OPC_EmitMergeInputChains1_0,
/*  6804*/      OPC_EmitInteger32, 0, 
/*  6806*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_S_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi16>> - Complexity = 13
                // Dst: (LOAD16_S_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6815*/     /*Scope*/ 16, /*->6832*/
/*  6816*/      OPC_CheckPredicate3,  // Predicate_sextloadi32
/*  6817*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6818*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6820*/      OPC_EmitMergeInputChains1_0,
/*  6821*/      OPC_EmitInteger32, 0, 
/*  6823*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_S_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadi32>> - Complexity = 13
                // Dst: (LOAD32_S_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6832*/     0, /*End of Scope*/
/*  6833*/    0, // EndSwitchType
/*  6834*/   /*Scope*/ 97, /*->6932*/
/*  6835*/    OPC_CheckPredicate, 16, // Predicate_zextload
/*  6837*/    OPC_SwitchType /*2 cases */, 36, /*MVT::i32*/7, // ->6876
/*  6840*/     OPC_Scope, 16, /*->6858*/ // 2 children in Scope
/*  6842*/      OPC_CheckPredicate1,  // Predicate_zextloadi8
/*  6843*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6844*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6846*/      OPC_EmitMergeInputChains1_0,
/*  6847*/      OPC_EmitInteger32, 0, 
/*  6849*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6858*/     /*Scope*/ 16, /*->6875*/
/*  6859*/      OPC_CheckPredicate2,  // Predicate_zextloadi16
/*  6860*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6861*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6863*/      OPC_EmitMergeInputChains1_0,
/*  6864*/      OPC_EmitInteger32, 0, 
/*  6866*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6875*/     0, /*End of Scope*/
/*  6876*/    /*SwitchType*/ 53, /*MVT::i64*/8, // ->6931
/*  6878*/     OPC_Scope, 16, /*->6896*/ // 3 children in Scope
/*  6880*/      OPC_CheckPredicate1,  // Predicate_zextloadi8
/*  6881*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6882*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6884*/      OPC_EmitMergeInputChains1_0,
/*  6885*/      OPC_EmitInteger32, 0, 
/*  6887*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6896*/     /*Scope*/ 16, /*->6913*/
/*  6897*/      OPC_CheckPredicate2,  // Predicate_zextloadi16
/*  6898*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6899*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6901*/      OPC_EmitMergeInputChains1_0,
/*  6902*/      OPC_EmitInteger32, 0, 
/*  6904*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6913*/     /*Scope*/ 16, /*->6930*/
/*  6914*/      OPC_CheckPredicate3,  // Predicate_zextloadi32
/*  6915*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6916*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6918*/      OPC_EmitMergeInputChains1_0,
/*  6919*/      OPC_EmitInteger32, 0, 
/*  6921*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadi32>> - Complexity = 13
                // Dst: (LOAD32_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6930*/     0, /*End of Scope*/
/*  6931*/    0, // EndSwitchType
/*  6932*/   /*Scope*/ 97, /*->7030*/
/*  6933*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  6935*/    OPC_SwitchType /*2 cases */, 36, /*MVT::i32*/7, // ->6974
/*  6938*/     OPC_Scope, 16, /*->6956*/ // 2 children in Scope
/*  6940*/      OPC_CheckPredicate1,  // Predicate_extloadi8
/*  6941*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6942*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6944*/      OPC_EmitMergeInputChains1_0,
/*  6945*/      OPC_EmitInteger32, 0, 
/*  6947*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6956*/     /*Scope*/ 16, /*->6973*/
/*  6957*/      OPC_CheckPredicate2,  // Predicate_extloadi16
/*  6958*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6959*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6961*/      OPC_EmitMergeInputChains1_0,
/*  6962*/      OPC_EmitInteger32, 0, 
/*  6964*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6973*/     0, /*End of Scope*/
/*  6974*/    /*SwitchType*/ 53, /*MVT::i64*/8, // ->7029
/*  6976*/     OPC_Scope, 16, /*->6994*/ // 3 children in Scope
/*  6978*/      OPC_CheckPredicate1,  // Predicate_extloadi8
/*  6979*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6980*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6982*/      OPC_EmitMergeInputChains1_0,
/*  6983*/      OPC_EmitInteger32, 0, 
/*  6985*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>> - Complexity = 13
                // Dst: (LOAD8_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  6994*/     /*Scope*/ 16, /*->7011*/
/*  6995*/      OPC_CheckPredicate2,  // Predicate_extloadi16
/*  6996*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  6997*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  6999*/      OPC_EmitMergeInputChains1_0,
/*  7000*/      OPC_EmitInteger32, 0, 
/*  7002*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>> - Complexity = 13
                // Dst: (LOAD16_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7011*/     /*Scope*/ 16, /*->7028*/
/*  7012*/      OPC_CheckPredicate3,  // Predicate_extloadi32
/*  7013*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7014*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7016*/      OPC_EmitMergeInputChains1_0,
/*  7017*/      OPC_EmitInteger32, 0, 
/*  7019*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_U_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
                // Src: (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi32>> - Complexity = 13
                // Dst: (LOAD32_U_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7028*/     0, /*End of Scope*/
/*  7029*/    0, // EndSwitchType
/*  7030*/   /*Scope*/ 105, /*->7136*/
/*  7031*/    OPC_CheckPredicate6,  // Predicate_load
/*  7032*/    OPC_SwitchType /*6 cases */, 15, /*MVT::f32*/12, // ->7050
/*  7035*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7036*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7038*/     OPC_EmitMergeInputChains1_0,
/*  7039*/     OPC_EmitInteger32, 0, 
/*  7041*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::f32*/12, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[f32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_F32_A64:{ *:[f32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7050*/    /*SwitchType*/ 15, /*MVT::f64*/13, // ->7067
/*  7052*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7053*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7055*/     OPC_EmitMergeInputChains1_0,
/*  7056*/     OPC_EmitInteger32, 0, 
/*  7058*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_F64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::f64*/13, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[f64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_F64_A64:{ *:[f64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7067*/    /*SwitchType*/ 15, /*MVT::v16i8*/39, // ->7084
/*  7069*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7070*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7072*/     OPC_EmitMergeInputChains1_0,
/*  7073*/     OPC_EmitInteger32, 0, 
/*  7075*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v16i8*/39, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v16i8] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v16i8] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7084*/    /*SwitchType*/ 15, /*MVT::v8i16*/50, // ->7101
/*  7086*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7087*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7089*/     OPC_EmitMergeInputChains1_0,
/*  7090*/     OPC_EmitInteger32, 0, 
/*  7092*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v8i16*/50, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v8i16] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v8i16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7101*/    /*SwitchType*/ 15, /*MVT::v4i32*/60, // ->7118
/*  7103*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7104*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7106*/     OPC_EmitMergeInputChains1_0,
/*  7107*/     OPC_EmitInteger32, 0, 
/*  7109*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v4i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7118*/    /*SwitchType*/ 15, /*MVT::v2i64*/78, // ->7135
/*  7120*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7121*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7123*/     OPC_EmitMergeInputChains1_0,
/*  7124*/     OPC_EmitInteger32, 0, 
/*  7126*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v2i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7135*/    0, // EndSwitchType
/*  7136*/   /*Scope*/ 21, /*->7158*/
/*  7137*/    OPC_CheckPredicate, 15, // Predicate_sextload
/*  7139*/    OPC_CheckPredicate, 21, // Predicate_sextloadvi8
/*  7141*/    OPC_CheckType, /*MVT::v8i16*/50, 
/*  7143*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7144*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7146*/    OPC_EmitMergeInputChains1_0,
/*  7147*/    OPC_EmitInteger32, 0, 
/*  7149*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v8i16*/50, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I16x8_A64:{ *:[v8i16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7158*/   /*Scope*/ 21, /*->7180*/
/*  7159*/    OPC_CheckPredicate, 16, // Predicate_zextload
/*  7161*/    OPC_CheckPredicate, 21, // Predicate_zextloadvi8
/*  7163*/    OPC_CheckType, /*MVT::v8i16*/50, 
/*  7165*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7166*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7168*/    OPC_EmitMergeInputChains1_0,
/*  7169*/    OPC_EmitInteger32, 0, 
/*  7171*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v8i16*/50, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I16x8_A64:{ *:[v8i16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7180*/   /*Scope*/ 21, /*->7202*/
/*  7181*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  7183*/    OPC_CheckPredicate, 21, // Predicate_extloadvi8
/*  7185*/    OPC_CheckType, /*MVT::v8i16*/50, 
/*  7187*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7188*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7190*/    OPC_EmitMergeInputChains1_0,
/*  7191*/    OPC_EmitInteger32, 0, 
/*  7193*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I16x8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v8i16*/50, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v8i16] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi8>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I16x8_A64:{ *:[v8i16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7202*/   /*Scope*/ 21, /*->7224*/
/*  7203*/    OPC_CheckPredicate, 15, // Predicate_sextload
/*  7205*/    OPC_CheckPredicate, 22, // Predicate_sextloadvi16
/*  7207*/    OPC_CheckType, /*MVT::v4i32*/60, 
/*  7209*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7210*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7212*/    OPC_EmitMergeInputChains1_0,
/*  7213*/    OPC_EmitInteger32, 0, 
/*  7215*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7224*/   /*Scope*/ 21, /*->7246*/
/*  7225*/    OPC_CheckPredicate, 16, // Predicate_zextload
/*  7227*/    OPC_CheckPredicate, 22, // Predicate_zextloadvi16
/*  7229*/    OPC_CheckType, /*MVT::v4i32*/60, 
/*  7231*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7232*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7234*/    OPC_EmitMergeInputChains1_0,
/*  7235*/    OPC_EmitInteger32, 0, 
/*  7237*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7246*/   /*Scope*/ 21, /*->7268*/
/*  7247*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  7249*/    OPC_CheckPredicate, 22, // Predicate_extloadvi16
/*  7251*/    OPC_CheckType, /*MVT::v4i32*/60, 
/*  7253*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7254*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7256*/    OPC_EmitMergeInputChains1_0,
/*  7257*/    OPC_EmitInteger32, 0, 
/*  7259*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I32x4_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v4i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi16>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I32x4_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7268*/   /*Scope*/ 21, /*->7290*/
/*  7269*/    OPC_CheckPredicate, 15, // Predicate_sextload
/*  7271*/    OPC_CheckPredicate, 23, // Predicate_sextloadvi32
/*  7273*/    OPC_CheckType, /*MVT::v2i64*/78, 
/*  7275*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7276*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7278*/    OPC_EmitMergeInputChains1_0,
/*  7279*/    OPC_EmitInteger32, 0, 
/*  7281*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_S_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_sextload>><<P:Predicate_sextloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_S_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7290*/   /*Scope*/ 21, /*->7312*/
/*  7291*/    OPC_CheckPredicate, 16, // Predicate_zextload
/*  7293*/    OPC_CheckPredicate, 23, // Predicate_zextloadvi32
/*  7295*/    OPC_CheckType, /*MVT::v2i64*/78, 
/*  7297*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7298*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7300*/    OPC_EmitMergeInputChains1_0,
/*  7301*/    OPC_EmitInteger32, 0, 
/*  7303*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_zextload>><<P:Predicate_zextloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7312*/   /*Scope*/ 21, /*->7334*/
/*  7313*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  7315*/    OPC_CheckPredicate, 23, // Predicate_extloadvi32
/*  7317*/    OPC_CheckType, /*MVT::v2i64*/78, 
/*  7319*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7320*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7322*/    OPC_EmitMergeInputChains1_0,
/*  7323*/    OPC_EmitInteger32, 0, 
/*  7325*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_EXTEND_U_I64x2_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
              // Src: (ld:{ *:[v2i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadvi32>> - Complexity = 13
              // Dst: (LOAD_EXTEND_U_I64x2_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7334*/   /*Scope*/ 56, /*->7391*/
/*  7335*/    OPC_CheckPredicate6,  // Predicate_load
/*  7336*/    OPC_SwitchType /*3 cases */, 15, /*MVT::v4f32*/111, // ->7354
/*  7339*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7340*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7342*/     OPC_EmitMergeInputChains1_0,
/*  7343*/     OPC_EmitInteger32, 0, 
/*  7345*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v4f32*/111, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v4f32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v4f32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7354*/    /*SwitchType*/ 16, /*MVT::v2f64*/1|128,1/*129*/, // ->7373
/*  7357*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7358*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7360*/     OPC_EmitMergeInputChains1_0,
/*  7361*/     OPC_EmitInteger32, 0, 
/*  7363*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v2f64*/1|128,1/*129*/, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v2f64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v2f64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7373*/    /*SwitchType*/ 15, /*MVT::v8f16*/92, // ->7390
/*  7375*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7376*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7378*/     OPC_EmitMergeInputChains1_0,
/*  7379*/     OPC_EmitInteger32, 0, 
/*  7381*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_V128_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v8f16*/92, 3/*#Ops*/, 4, 2, 3, 
               // Src: (ld:{ *:[v8f16] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>> - Complexity = 13
               // Dst: (LOAD_V128_A64:{ *:[v8f16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7390*/    0, // EndSwitchType
/*  7391*/   /*Scope*/ 30, /*->7422*/
/*  7392*/    OPC_CheckPredicate, 10, // Predicate_extload
/*  7394*/    OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/*  7397*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7398*/    OPC_EmitMergeInputChains1_0,
/*  7399*/    OPC_EmitInteger32, 0, 
/*  7401*/    OPC_EmitInteger64, 0, 
/*  7403*/    OPC_EmitNode1, TARGET_VAL(WebAssembly::LOAD_ZERO_64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::v16i8*/39, 3/*#Ops*/, 2, 3, 1,  // Results = #4
/*  7412*/    OPC_EmitNode1None, TARGET_VAL(WebAssembly::promote_low_F64x2),
                  /*MVT::v2f64*/1|128,1/*129*/, 1/*#Ops*/, 4,  // Results = #5
/*  7419*/    OPC_CompleteMatch, 1, 5, 
               // Src: (ld:{ *:[v2f64] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>> - Complexity = 4
               // Dst: (promote_low_F64x2:{ *:[v2f64] } (LOAD_ZERO_64_A64:{ *:[v16i8] } 0:{ *:[i32] }, 0:{ *:[i64] }, I64:{ *:[i64] }:$addr))
/*  7422*/   0, /*End of Scope*/
/*  7423*/  0, /*End of Scope*/
/*  7424*/ /*SwitchOpcode*/ 31|128,1/*159*/, TARGET_VAL(ISD::ATOMIC_LOAD),// ->7587
/*  7428*/  OPC_RecordMemRef,
/*  7429*/  OPC_RecordNode, // #0 = 'atomic_load' chained node
/*  7430*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  7431*/  OPC_Scope, 76, /*->7509*/ // 2 children in Scope
/*  7433*/   OPC_CheckChild1TypeI32,
/*  7434*/   OPC_SwitchType /*2 cases */, 53, /*MVT::i32*/7, // ->7490
/*  7437*/    OPC_Scope, 16, /*->7455*/ // 3 children in Scope
/*  7439*/     OPC_CheckPredicate3,  // Predicate_atomic_load_32
/*  7440*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  7441*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7443*/     OPC_EmitMergeInputChains1_0,
/*  7444*/     OPC_EmitInteger32, 0, 
/*  7446*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_32>> - Complexity = 13
               // Dst: (ATOMIC_LOAD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7455*/    /*Scope*/ 16, /*->7472*/
/*  7456*/     OPC_CheckPredicate1,  // Predicate_atomic_load_8
/*  7457*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  7458*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7460*/     OPC_EmitMergeInputChains1_0,
/*  7461*/     OPC_EmitInteger32, 0, 
/*  7463*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_8>> - Complexity = 13
               // Dst: (ATOMIC_LOAD8_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7472*/    /*Scope*/ 16, /*->7489*/
/*  7473*/     OPC_CheckPredicate2,  // Predicate_atomic_load_16
/*  7474*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  7475*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7477*/     OPC_EmitMergeInputChains1_0,
/*  7478*/     OPC_EmitInteger32, 0, 
/*  7480*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_16>> - Complexity = 13
               // Dst: (ATOMIC_LOAD16_U_I32_A32:{ *:[i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7489*/    0, /*End of Scope*/
/*  7490*/   /*SwitchType*/ 16, /*MVT::i64*/8, // ->7508
/*  7492*/    OPC_CheckPredicate7,  // Predicate_atomic_load_64
/*  7493*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/*  7494*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/*  7496*/    OPC_EmitMergeInputChains1_0,
/*  7497*/    OPC_EmitInteger32, 0, 
/*  7499*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
              // Src: (atomic_load:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_atomic_load_64>> - Complexity = 13
              // Dst: (ATOMIC_LOAD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/*  7508*/   0, // EndSwitchType
/*  7509*/  /*Scope*/ 76, /*->7586*/
/*  7510*/   OPC_CheckChild1TypeI64,
/*  7511*/   OPC_SwitchType /*2 cases */, 53, /*MVT::i32*/7, // ->7567
/*  7514*/    OPC_Scope, 16, /*->7532*/ // 3 children in Scope
/*  7516*/     OPC_CheckPredicate3,  // Predicate_atomic_load_32
/*  7517*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7518*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7520*/     OPC_EmitMergeInputChains1_0,
/*  7521*/     OPC_EmitInteger32, 0, 
/*  7523*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_32>> - Complexity = 13
               // Dst: (ATOMIC_LOAD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7532*/    /*Scope*/ 16, /*->7549*/
/*  7533*/     OPC_CheckPredicate1,  // Predicate_atomic_load_8
/*  7534*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7535*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7537*/     OPC_EmitMergeInputChains1_0,
/*  7538*/     OPC_EmitInteger32, 0, 
/*  7540*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD8_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_8>> - Complexity = 13
               // Dst: (ATOMIC_LOAD8_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7549*/    /*Scope*/ 16, /*->7566*/
/*  7550*/     OPC_CheckPredicate2,  // Predicate_atomic_load_16
/*  7551*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7552*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7554*/     OPC_EmitMergeInputChains1_0,
/*  7555*/     OPC_EmitInteger32, 0, 
/*  7557*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD16_U_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 3/*#Ops*/, 4, 2, 3, 
               // Src: (atomic_load:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_16>> - Complexity = 13
               // Dst: (ATOMIC_LOAD16_U_I32_A64:{ *:[i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7566*/    0, /*End of Scope*/
/*  7567*/   /*SwitchType*/ 16, /*MVT::i64*/8, // ->7585
/*  7569*/    OPC_CheckPredicate7,  // Predicate_atomic_load_64
/*  7570*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/*  7571*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/*  7573*/    OPC_EmitMergeInputChains1_0,
/*  7574*/    OPC_EmitInteger32, 0, 
/*  7576*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_LOAD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 3/*#Ops*/, 4, 2, 3, 
              // Src: (atomic_load:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_atomic_load_64>> - Complexity = 13
              // Dst: (ATOMIC_LOAD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/*  7585*/   0, // EndSwitchType
/*  7586*/  0, /*End of Scope*/
/*  7587*/ /*SwitchOpcode*/ 113|128,1/*241*/, TARGET_VAL(ISD::ATOMIC_LOAD_ADD),// ->7832
/*  7591*/  OPC_RecordMemRef,
/*  7592*/  OPC_RecordNode, // #0 = 'atomic_load_add' chained node
/*  7593*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  7594*/  OPC_Scope, 117, /*->7713*/ // 2 children in Scope
/*  7596*/   OPC_CheckChild1TypeI32,
/*  7597*/   OPC_RecordChild2, // #2 = $val
/*  7598*/   OPC_SwitchType /*2 cases */, 92, /*MVT::i32*/7, // ->7693
/*  7601*/    OPC_Scope, 17, /*->7620*/ // 5 children in Scope
/*  7603*/     OPC_CheckPredicate3,  // Predicate_atomic_load_add_i32
/*  7604*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7605*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7607*/     OPC_EmitMergeInputChains1_0,
/*  7608*/     OPC_EmitInteger32, 0, 
/*  7610*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7620*/    /*Scope*/ 17, /*->7638*/
/*  7621*/     OPC_CheckPredicate1,  // Predicate_atomic_load_add_i8
/*  7622*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7623*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7625*/     OPC_EmitMergeInputChains1_0,
/*  7626*/     OPC_EmitInteger32, 0, 
/*  7628*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7638*/    /*Scope*/ 17, /*->7656*/
/*  7639*/     OPC_CheckPredicate2,  // Predicate_atomic_load_add_i16
/*  7640*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7641*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7643*/     OPC_EmitMergeInputChains1_0,
/*  7644*/     OPC_EmitInteger32, 0, 
/*  7646*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7656*/    /*Scope*/ 17, /*->7674*/
/*  7657*/     OPC_CheckPredicate1,  // Predicate_atomic_load_add_i8
/*  7658*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7659*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7661*/     OPC_EmitMergeInputChains1_0,
/*  7662*/     OPC_EmitInteger32, 0, 
/*  7664*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7674*/    /*Scope*/ 17, /*->7692*/
/*  7675*/     OPC_CheckPredicate2,  // Predicate_atomic_load_add_i16
/*  7676*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7677*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7679*/     OPC_EmitMergeInputChains1_0,
/*  7680*/     OPC_EmitInteger32, 0, 
/*  7682*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_ADD_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7692*/    0, /*End of Scope*/
/*  7693*/   /*SwitchType*/ 17, /*MVT::i64*/8, // ->7712
/*  7695*/    OPC_CheckPredicate7,  // Predicate_atomic_load_add_i64
/*  7696*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7697*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7699*/    OPC_EmitMergeInputChains1_0,
/*  7700*/    OPC_EmitInteger32, 0, 
/*  7702*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_add:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_add_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_ADD_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  7712*/   0, // EndSwitchType
/*  7713*/  /*Scope*/ 117, /*->7831*/
/*  7714*/   OPC_CheckChild1TypeI64,
/*  7715*/   OPC_RecordChild2, // #2 = $val
/*  7716*/   OPC_SwitchType /*2 cases */, 92, /*MVT::i32*/7, // ->7811
/*  7719*/    OPC_Scope, 17, /*->7738*/ // 5 children in Scope
/*  7721*/     OPC_CheckPredicate3,  // Predicate_atomic_load_add_i32
/*  7722*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7723*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7725*/     OPC_EmitMergeInputChains1_0,
/*  7726*/     OPC_EmitInteger32, 0, 
/*  7728*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7738*/    /*Scope*/ 17, /*->7756*/
/*  7739*/     OPC_CheckPredicate1,  // Predicate_atomic_load_add_i8
/*  7740*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7741*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7743*/     OPC_EmitMergeInputChains1_0,
/*  7744*/     OPC_EmitInteger32, 0, 
/*  7746*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7756*/    /*Scope*/ 17, /*->7774*/
/*  7757*/     OPC_CheckPredicate2,  // Predicate_atomic_load_add_i16
/*  7758*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7759*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7761*/     OPC_EmitMergeInputChains1_0,
/*  7762*/     OPC_EmitInteger32, 0, 
/*  7764*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7774*/    /*Scope*/ 17, /*->7792*/
/*  7775*/     OPC_CheckPredicate1,  // Predicate_atomic_load_add_i8
/*  7776*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7777*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7779*/     OPC_EmitMergeInputChains1_0,
/*  7780*/     OPC_EmitInteger32, 0, 
/*  7782*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7792*/    /*Scope*/ 17, /*->7810*/
/*  7793*/     OPC_CheckPredicate2,  // Predicate_atomic_load_add_i16
/*  7794*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7795*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7797*/     OPC_EmitMergeInputChains1_0,
/*  7798*/     OPC_EmitInteger32, 0, 
/*  7800*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_ADD_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_add:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_add_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_ADD_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7810*/    0, /*End of Scope*/
/*  7811*/   /*SwitchType*/ 17, /*MVT::i64*/8, // ->7830
/*  7813*/    OPC_CheckPredicate7,  // Predicate_atomic_load_add_i64
/*  7814*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7815*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7817*/    OPC_EmitMergeInputChains1_0,
/*  7818*/    OPC_EmitInteger32, 0, 
/*  7820*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_ADD_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_add:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_add_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_ADD_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  7830*/   0, // EndSwitchType
/*  7831*/  0, /*End of Scope*/
/*  7832*/ /*SwitchOpcode*/ 113|128,1/*241*/, TARGET_VAL(ISD::ATOMIC_LOAD_SUB),// ->8077
/*  7836*/  OPC_RecordMemRef,
/*  7837*/  OPC_RecordNode, // #0 = 'atomic_load_sub' chained node
/*  7838*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  7839*/  OPC_Scope, 117, /*->7958*/ // 2 children in Scope
/*  7841*/   OPC_CheckChild1TypeI32,
/*  7842*/   OPC_RecordChild2, // #2 = $val
/*  7843*/   OPC_SwitchType /*2 cases */, 92, /*MVT::i32*/7, // ->7938
/*  7846*/    OPC_Scope, 17, /*->7865*/ // 5 children in Scope
/*  7848*/     OPC_CheckPredicate3,  // Predicate_atomic_load_sub_i32
/*  7849*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7850*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7852*/     OPC_EmitMergeInputChains1_0,
/*  7853*/     OPC_EmitInteger32, 0, 
/*  7855*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7865*/    /*Scope*/ 17, /*->7883*/
/*  7866*/     OPC_CheckPredicate1,  // Predicate_atomic_load_sub_i8
/*  7867*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7868*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7870*/     OPC_EmitMergeInputChains1_0,
/*  7871*/     OPC_EmitInteger32, 0, 
/*  7873*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7883*/    /*Scope*/ 17, /*->7901*/
/*  7884*/     OPC_CheckPredicate2,  // Predicate_atomic_load_sub_i16
/*  7885*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7886*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7888*/     OPC_EmitMergeInputChains1_0,
/*  7889*/     OPC_EmitInteger32, 0, 
/*  7891*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7901*/    /*Scope*/ 17, /*->7919*/
/*  7902*/     OPC_CheckPredicate1,  // Predicate_atomic_load_sub_i8
/*  7903*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7904*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7906*/     OPC_EmitMergeInputChains1_0,
/*  7907*/     OPC_EmitInteger32, 0, 
/*  7909*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7919*/    /*Scope*/ 17, /*->7937*/
/*  7920*/     OPC_CheckPredicate2,  // Predicate_atomic_load_sub_i16
/*  7921*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7922*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7924*/     OPC_EmitMergeInputChains1_0,
/*  7925*/     OPC_EmitInteger32, 0, 
/*  7927*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_SUB_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  7937*/    0, /*End of Scope*/
/*  7938*/   /*SwitchType*/ 17, /*MVT::i64*/8, // ->7957
/*  7940*/    OPC_CheckPredicate7,  // Predicate_atomic_load_sub_i64
/*  7941*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7942*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  7944*/    OPC_EmitMergeInputChains1_0,
/*  7945*/    OPC_EmitInteger32, 0, 
/*  7947*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_sub:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_sub_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_SUB_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  7957*/   0, // EndSwitchType
/*  7958*/  /*Scope*/ 117, /*->8076*/
/*  7959*/   OPC_CheckChild1TypeI64,
/*  7960*/   OPC_RecordChild2, // #2 = $val
/*  7961*/   OPC_SwitchType /*2 cases */, 92, /*MVT::i32*/7, // ->8056
/*  7964*/    OPC_Scope, 17, /*->7983*/ // 5 children in Scope
/*  7966*/     OPC_CheckPredicate3,  // Predicate_atomic_load_sub_i32
/*  7967*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7968*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7970*/     OPC_EmitMergeInputChains1_0,
/*  7971*/     OPC_EmitInteger32, 0, 
/*  7973*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  7983*/    /*Scope*/ 17, /*->8001*/
/*  7984*/     OPC_CheckPredicate1,  // Predicate_atomic_load_sub_i8
/*  7985*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  7986*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  7988*/     OPC_EmitMergeInputChains1_0,
/*  7989*/     OPC_EmitInteger32, 0, 
/*  7991*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8001*/    /*Scope*/ 17, /*->8019*/
/*  8002*/     OPC_CheckPredicate2,  // Predicate_atomic_load_sub_i16
/*  8003*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8004*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8006*/     OPC_EmitMergeInputChains1_0,
/*  8007*/     OPC_EmitInteger32, 0, 
/*  8009*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8019*/    /*Scope*/ 17, /*->8037*/
/*  8020*/     OPC_CheckPredicate1,  // Predicate_atomic_load_sub_i8
/*  8021*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8022*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8024*/     OPC_EmitMergeInputChains1_0,
/*  8025*/     OPC_EmitInteger32, 0, 
/*  8027*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8037*/    /*Scope*/ 17, /*->8055*/
/*  8038*/     OPC_CheckPredicate2,  // Predicate_atomic_load_sub_i16
/*  8039*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8040*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8042*/     OPC_EmitMergeInputChains1_0,
/*  8043*/     OPC_EmitInteger32, 0, 
/*  8045*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_SUB_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_sub:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_sub_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_SUB_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8055*/    0, /*End of Scope*/
/*  8056*/   /*SwitchType*/ 17, /*MVT::i64*/8, // ->8075
/*  8058*/    OPC_CheckPredicate7,  // Predicate_atomic_load_sub_i64
/*  8059*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8060*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8062*/    OPC_EmitMergeInputChains1_0,
/*  8063*/    OPC_EmitInteger32, 0, 
/*  8065*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_SUB_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_sub:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_sub_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_SUB_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  8075*/   0, // EndSwitchType
/*  8076*/  0, /*End of Scope*/
/*  8077*/ /*SwitchOpcode*/ 113|128,1/*241*/, TARGET_VAL(ISD::ATOMIC_LOAD_AND),// ->8322
/*  8081*/  OPC_RecordMemRef,
/*  8082*/  OPC_RecordNode, // #0 = 'atomic_load_and' chained node
/*  8083*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  8084*/  OPC_Scope, 117, /*->8203*/ // 2 children in Scope
/*  8086*/   OPC_CheckChild1TypeI32,
/*  8087*/   OPC_RecordChild2, // #2 = $val
/*  8088*/   OPC_SwitchType /*2 cases */, 92, /*MVT::i32*/7, // ->8183
/*  8091*/    OPC_Scope, 17, /*->8110*/ // 5 children in Scope
/*  8093*/     OPC_CheckPredicate3,  // Predicate_atomic_load_and_i32
/*  8094*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8095*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8097*/     OPC_EmitMergeInputChains1_0,
/*  8098*/     OPC_EmitInteger32, 0, 
/*  8100*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8110*/    /*Scope*/ 17, /*->8128*/
/*  8111*/     OPC_CheckPredicate1,  // Predicate_atomic_load_and_i8
/*  8112*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8113*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8115*/     OPC_EmitMergeInputChains1_0,
/*  8116*/     OPC_EmitInteger32, 0, 
/*  8118*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8128*/    /*Scope*/ 17, /*->8146*/
/*  8129*/     OPC_CheckPredicate2,  // Predicate_atomic_load_and_i16
/*  8130*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8131*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8133*/     OPC_EmitMergeInputChains1_0,
/*  8134*/     OPC_EmitInteger32, 0, 
/*  8136*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8146*/    /*Scope*/ 17, /*->8164*/
/*  8147*/     OPC_CheckPredicate1,  // Predicate_atomic_load_and_i8
/*  8148*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8149*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8151*/     OPC_EmitMergeInputChains1_0,
/*  8152*/     OPC_EmitInteger32, 0, 
/*  8154*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8164*/    /*Scope*/ 17, /*->8182*/
/*  8165*/     OPC_CheckPredicate2,  // Predicate_atomic_load_and_i16
/*  8166*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8167*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8169*/     OPC_EmitMergeInputChains1_0,
/*  8170*/     OPC_EmitInteger32, 0, 
/*  8172*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_AND_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8182*/    0, /*End of Scope*/
/*  8183*/   /*SwitchType*/ 17, /*MVT::i64*/8, // ->8202
/*  8185*/    OPC_CheckPredicate7,  // Predicate_atomic_load_and_i64
/*  8186*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8187*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8189*/    OPC_EmitMergeInputChains1_0,
/*  8190*/    OPC_EmitInteger32, 0, 
/*  8192*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_and:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_and_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_AND_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  8202*/   0, // EndSwitchType
/*  8203*/  /*Scope*/ 117, /*->8321*/
/*  8204*/   OPC_CheckChild1TypeI64,
/*  8205*/   OPC_RecordChild2, // #2 = $val
/*  8206*/   OPC_SwitchType /*2 cases */, 92, /*MVT::i32*/7, // ->8301
/*  8209*/    OPC_Scope, 17, /*->8228*/ // 5 children in Scope
/*  8211*/     OPC_CheckPredicate3,  // Predicate_atomic_load_and_i32
/*  8212*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8213*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8215*/     OPC_EmitMergeInputChains1_0,
/*  8216*/     OPC_EmitInteger32, 0, 
/*  8218*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8228*/    /*Scope*/ 17, /*->8246*/
/*  8229*/     OPC_CheckPredicate1,  // Predicate_atomic_load_and_i8
/*  8230*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8231*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8233*/     OPC_EmitMergeInputChains1_0,
/*  8234*/     OPC_EmitInteger32, 0, 
/*  8236*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8246*/    /*Scope*/ 17, /*->8264*/
/*  8247*/     OPC_CheckPredicate2,  // Predicate_atomic_load_and_i16
/*  8248*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8249*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8251*/     OPC_EmitMergeInputChains1_0,
/*  8252*/     OPC_EmitInteger32, 0, 
/*  8254*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8264*/    /*Scope*/ 17, /*->8282*/
/*  8265*/     OPC_CheckPredicate1,  // Predicate_atomic_load_and_i8
/*  8266*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8267*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8269*/     OPC_EmitMergeInputChains1_0,
/*  8270*/     OPC_EmitInteger32, 0, 
/*  8272*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8282*/    /*Scope*/ 17, /*->8300*/
/*  8283*/     OPC_CheckPredicate2,  // Predicate_atomic_load_and_i16
/*  8284*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8285*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8287*/     OPC_EmitMergeInputChains1_0,
/*  8288*/     OPC_EmitInteger32, 0, 
/*  8290*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_AND_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_and:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_and_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_AND_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8300*/    0, /*End of Scope*/
/*  8301*/   /*SwitchType*/ 17, /*MVT::i64*/8, // ->8320
/*  8303*/    OPC_CheckPredicate7,  // Predicate_atomic_load_and_i64
/*  8304*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8305*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8307*/    OPC_EmitMergeInputChains1_0,
/*  8308*/    OPC_EmitInteger32, 0, 
/*  8310*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_AND_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_and:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_and_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_AND_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  8320*/   0, // EndSwitchType
/*  8321*/  0, /*End of Scope*/
/*  8322*/ /*SwitchOpcode*/ 113|128,1/*241*/, TARGET_VAL(ISD::ATOMIC_LOAD_OR),// ->8567
/*  8326*/  OPC_RecordMemRef,
/*  8327*/  OPC_RecordNode, // #0 = 'atomic_load_or' chained node
/*  8328*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  8329*/  OPC_Scope, 117, /*->8448*/ // 2 children in Scope
/*  8331*/   OPC_CheckChild1TypeI32,
/*  8332*/   OPC_RecordChild2, // #2 = $val
/*  8333*/   OPC_SwitchType /*2 cases */, 92, /*MVT::i32*/7, // ->8428
/*  8336*/    OPC_Scope, 17, /*->8355*/ // 5 children in Scope
/*  8338*/     OPC_CheckPredicate3,  // Predicate_atomic_load_or_i32
/*  8339*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8340*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8342*/     OPC_EmitMergeInputChains1_0,
/*  8343*/     OPC_EmitInteger32, 0, 
/*  8345*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8355*/    /*Scope*/ 17, /*->8373*/
/*  8356*/     OPC_CheckPredicate1,  // Predicate_atomic_load_or_i8
/*  8357*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8358*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8360*/     OPC_EmitMergeInputChains1_0,
/*  8361*/     OPC_EmitInteger32, 0, 
/*  8363*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8373*/    /*Scope*/ 17, /*->8391*/
/*  8374*/     OPC_CheckPredicate2,  // Predicate_atomic_load_or_i16
/*  8375*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8376*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8378*/     OPC_EmitMergeInputChains1_0,
/*  8379*/     OPC_EmitInteger32, 0, 
/*  8381*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8391*/    /*Scope*/ 17, /*->8409*/
/*  8392*/     OPC_CheckPredicate1,  // Predicate_atomic_load_or_i8
/*  8393*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8394*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8396*/     OPC_EmitMergeInputChains1_0,
/*  8397*/     OPC_EmitInteger32, 0, 
/*  8399*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8409*/    /*Scope*/ 17, /*->8427*/
/*  8410*/     OPC_CheckPredicate2,  // Predicate_atomic_load_or_i16
/*  8411*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8412*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8414*/     OPC_EmitMergeInputChains1_0,
/*  8415*/     OPC_EmitInteger32, 0, 
/*  8417*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_OR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8427*/    0, /*End of Scope*/
/*  8428*/   /*SwitchType*/ 17, /*MVT::i64*/8, // ->8447
/*  8430*/    OPC_CheckPredicate7,  // Predicate_atomic_load_or_i64
/*  8431*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8432*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8434*/    OPC_EmitMergeInputChains1_0,
/*  8435*/    OPC_EmitInteger32, 0, 
/*  8437*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_or:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_or_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_OR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  8447*/   0, // EndSwitchType
/*  8448*/  /*Scope*/ 117, /*->8566*/
/*  8449*/   OPC_CheckChild1TypeI64,
/*  8450*/   OPC_RecordChild2, // #2 = $val
/*  8451*/   OPC_SwitchType /*2 cases */, 92, /*MVT::i32*/7, // ->8546
/*  8454*/    OPC_Scope, 17, /*->8473*/ // 5 children in Scope
/*  8456*/     OPC_CheckPredicate3,  // Predicate_atomic_load_or_i32
/*  8457*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8458*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8460*/     OPC_EmitMergeInputChains1_0,
/*  8461*/     OPC_EmitInteger32, 0, 
/*  8463*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8473*/    /*Scope*/ 17, /*->8491*/
/*  8474*/     OPC_CheckPredicate1,  // Predicate_atomic_load_or_i8
/*  8475*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8476*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8478*/     OPC_EmitMergeInputChains1_0,
/*  8479*/     OPC_EmitInteger32, 0, 
/*  8481*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8491*/    /*Scope*/ 17, /*->8509*/
/*  8492*/     OPC_CheckPredicate2,  // Predicate_atomic_load_or_i16
/*  8493*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8494*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8496*/     OPC_EmitMergeInputChains1_0,
/*  8497*/     OPC_EmitInteger32, 0, 
/*  8499*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8509*/    /*Scope*/ 17, /*->8527*/
/*  8510*/     OPC_CheckPredicate1,  // Predicate_atomic_load_or_i8
/*  8511*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8512*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8514*/     OPC_EmitMergeInputChains1_0,
/*  8515*/     OPC_EmitInteger32, 0, 
/*  8517*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8527*/    /*Scope*/ 17, /*->8545*/
/*  8528*/     OPC_CheckPredicate2,  // Predicate_atomic_load_or_i16
/*  8529*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8530*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8532*/     OPC_EmitMergeInputChains1_0,
/*  8533*/     OPC_EmitInteger32, 0, 
/*  8535*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_OR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_or:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_or_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_OR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8545*/    0, /*End of Scope*/
/*  8546*/   /*SwitchType*/ 17, /*MVT::i64*/8, // ->8565
/*  8548*/    OPC_CheckPredicate7,  // Predicate_atomic_load_or_i64
/*  8549*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8550*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8552*/    OPC_EmitMergeInputChains1_0,
/*  8553*/    OPC_EmitInteger32, 0, 
/*  8555*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_OR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_or:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_or_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_OR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  8565*/   0, // EndSwitchType
/*  8566*/  0, /*End of Scope*/
/*  8567*/ /*SwitchOpcode*/ 113|128,1/*241*/, TARGET_VAL(ISD::ATOMIC_LOAD_XOR),// ->8812
/*  8571*/  OPC_RecordMemRef,
/*  8572*/  OPC_RecordNode, // #0 = 'atomic_load_xor' chained node
/*  8573*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  8574*/  OPC_Scope, 117, /*->8693*/ // 2 children in Scope
/*  8576*/   OPC_CheckChild1TypeI32,
/*  8577*/   OPC_RecordChild2, // #2 = $val
/*  8578*/   OPC_SwitchType /*2 cases */, 92, /*MVT::i32*/7, // ->8673
/*  8581*/    OPC_Scope, 17, /*->8600*/ // 5 children in Scope
/*  8583*/     OPC_CheckPredicate3,  // Predicate_atomic_load_xor_i32
/*  8584*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8585*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8587*/     OPC_EmitMergeInputChains1_0,
/*  8588*/     OPC_EmitInteger32, 0, 
/*  8590*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8600*/    /*Scope*/ 17, /*->8618*/
/*  8601*/     OPC_CheckPredicate1,  // Predicate_atomic_load_xor_i8
/*  8602*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8603*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8605*/     OPC_EmitMergeInputChains1_0,
/*  8606*/     OPC_EmitInteger32, 0, 
/*  8608*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8618*/    /*Scope*/ 17, /*->8636*/
/*  8619*/     OPC_CheckPredicate2,  // Predicate_atomic_load_xor_i16
/*  8620*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8621*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8623*/     OPC_EmitMergeInputChains1_0,
/*  8624*/     OPC_EmitInteger32, 0, 
/*  8626*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8636*/    /*Scope*/ 17, /*->8654*/
/*  8637*/     OPC_CheckPredicate1,  // Predicate_atomic_load_xor_i8
/*  8638*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8639*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8641*/     OPC_EmitMergeInputChains1_0,
/*  8642*/     OPC_EmitInteger32, 0, 
/*  8644*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8654*/    /*Scope*/ 17, /*->8672*/
/*  8655*/     OPC_CheckPredicate2,  // Predicate_atomic_load_xor_i16
/*  8656*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8657*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8659*/     OPC_EmitMergeInputChains1_0,
/*  8660*/     OPC_EmitInteger32, 0, 
/*  8662*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XOR_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8672*/    0, /*End of Scope*/
/*  8673*/   /*SwitchType*/ 17, /*MVT::i64*/8, // ->8692
/*  8675*/    OPC_CheckPredicate7,  // Predicate_atomic_load_xor_i64
/*  8676*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8677*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8679*/    OPC_EmitMergeInputChains1_0,
/*  8680*/    OPC_EmitInteger32, 0, 
/*  8682*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_xor:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_xor_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_XOR_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  8692*/   0, // EndSwitchType
/*  8693*/  /*Scope*/ 117, /*->8811*/
/*  8694*/   OPC_CheckChild1TypeI64,
/*  8695*/   OPC_RecordChild2, // #2 = $val
/*  8696*/   OPC_SwitchType /*2 cases */, 92, /*MVT::i32*/7, // ->8791
/*  8699*/    OPC_Scope, 17, /*->8718*/ // 5 children in Scope
/*  8701*/     OPC_CheckPredicate3,  // Predicate_atomic_load_xor_i32
/*  8702*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8703*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8705*/     OPC_EmitMergeInputChains1_0,
/*  8706*/     OPC_EmitInteger32, 0, 
/*  8708*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8718*/    /*Scope*/ 17, /*->8736*/
/*  8719*/     OPC_CheckPredicate1,  // Predicate_atomic_load_xor_i8
/*  8720*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8721*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8723*/     OPC_EmitMergeInputChains1_0,
/*  8724*/     OPC_EmitInteger32, 0, 
/*  8726*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8736*/    /*Scope*/ 17, /*->8754*/
/*  8737*/     OPC_CheckPredicate2,  // Predicate_atomic_load_xor_i16
/*  8738*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8739*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8741*/     OPC_EmitMergeInputChains1_0,
/*  8742*/     OPC_EmitInteger32, 0, 
/*  8744*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8754*/    /*Scope*/ 17, /*->8772*/
/*  8755*/     OPC_CheckPredicate1,  // Predicate_atomic_load_xor_i8
/*  8756*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8757*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8759*/     OPC_EmitMergeInputChains1_0,
/*  8760*/     OPC_EmitInteger32, 0, 
/*  8762*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8772*/    /*Scope*/ 17, /*->8790*/
/*  8773*/     OPC_CheckPredicate2,  // Predicate_atomic_load_xor_i16
/*  8774*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8775*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8777*/     OPC_EmitMergeInputChains1_0,
/*  8778*/     OPC_EmitInteger32, 0, 
/*  8780*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XOR_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_load_xor:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_load_xor_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XOR_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8790*/    0, /*End of Scope*/
/*  8791*/   /*SwitchType*/ 17, /*MVT::i64*/8, // ->8810
/*  8793*/    OPC_CheckPredicate7,  // Predicate_atomic_load_xor_i64
/*  8794*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8795*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8797*/    OPC_EmitMergeInputChains1_0,
/*  8798*/    OPC_EmitInteger32, 0, 
/*  8800*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XOR_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_load_xor:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_load_xor_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_XOR_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  8810*/   0, // EndSwitchType
/*  8811*/  0, /*End of Scope*/
/*  8812*/ /*SwitchOpcode*/ 113|128,1/*241*/, TARGET_VAL(ISD::ATOMIC_SWAP),// ->9057
/*  8816*/  OPC_RecordMemRef,
/*  8817*/  OPC_RecordNode, // #0 = 'atomic_swap' chained node
/*  8818*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  8819*/  OPC_Scope, 117, /*->8938*/ // 2 children in Scope
/*  8821*/   OPC_CheckChild1TypeI32,
/*  8822*/   OPC_RecordChild2, // #2 = $val
/*  8823*/   OPC_SwitchType /*2 cases */, 92, /*MVT::i32*/7, // ->8918
/*  8826*/    OPC_Scope, 17, /*->8845*/ // 5 children in Scope
/*  8828*/     OPC_CheckPredicate3,  // Predicate_atomic_swap_i32
/*  8829*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8830*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8832*/     OPC_EmitMergeInputChains1_0,
/*  8833*/     OPC_EmitInteger32, 0, 
/*  8835*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8845*/    /*Scope*/ 17, /*->8863*/
/*  8846*/     OPC_CheckPredicate1,  // Predicate_atomic_swap_i8
/*  8847*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8848*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8850*/     OPC_EmitMergeInputChains1_0,
/*  8851*/     OPC_EmitInteger32, 0, 
/*  8853*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8863*/    /*Scope*/ 17, /*->8881*/
/*  8864*/     OPC_CheckPredicate2,  // Predicate_atomic_swap_i16
/*  8865*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8866*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8868*/     OPC_EmitMergeInputChains1_0,
/*  8869*/     OPC_EmitInteger32, 0, 
/*  8871*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8881*/    /*Scope*/ 17, /*->8899*/
/*  8882*/     OPC_CheckPredicate1,  // Predicate_atomic_swap_i8
/*  8883*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8884*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8886*/     OPC_EmitMergeInputChains1_0,
/*  8887*/     OPC_EmitInteger32, 0, 
/*  8889*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8899*/    /*Scope*/ 17, /*->8917*/
/*  8900*/     OPC_CheckPredicate2,  // Predicate_atomic_swap_i16
/*  8901*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8902*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8904*/     OPC_EmitMergeInputChains1_0,
/*  8905*/     OPC_EmitInteger32, 0, 
/*  8907*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$val)
/*  8917*/    0, /*End of Scope*/
/*  8918*/   /*SwitchType*/ 17, /*MVT::i64*/8, // ->8937
/*  8920*/    OPC_CheckPredicate7,  // Predicate_atomic_swap_i64
/*  8921*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8922*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #3 #4
/*  8924*/    OPC_EmitMergeInputChains1_0,
/*  8925*/    OPC_EmitInteger32, 0, 
/*  8927*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_swap:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_swap_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_XCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$val)
/*  8937*/   0, // EndSwitchType
/*  8938*/  /*Scope*/ 117, /*->9056*/
/*  8939*/   OPC_CheckChild1TypeI64,
/*  8940*/   OPC_RecordChild2, // #2 = $val
/*  8941*/   OPC_SwitchType /*2 cases */, 92, /*MVT::i32*/7, // ->9036
/*  8944*/    OPC_Scope, 17, /*->8963*/ // 5 children in Scope
/*  8946*/     OPC_CheckPredicate3,  // Predicate_atomic_swap_i32
/*  8947*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8948*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8950*/     OPC_EmitMergeInputChains1_0,
/*  8951*/     OPC_EmitInteger32, 0, 
/*  8953*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8963*/    /*Scope*/ 17, /*->8981*/
/*  8964*/     OPC_CheckPredicate1,  // Predicate_atomic_swap_i8
/*  8965*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8966*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8968*/     OPC_EmitMergeInputChains1_0,
/*  8969*/     OPC_EmitInteger32, 0, 
/*  8971*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8981*/    /*Scope*/ 17, /*->8999*/
/*  8982*/     OPC_CheckPredicate2,  // Predicate_atomic_swap_i16
/*  8983*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  8984*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  8986*/     OPC_EmitMergeInputChains1_0,
/*  8987*/     OPC_EmitInteger32, 0, 
/*  8989*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  8999*/    /*Scope*/ 17, /*->9017*/
/*  9000*/     OPC_CheckPredicate1,  // Predicate_atomic_swap_i8
/*  9001*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9002*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9004*/     OPC_EmitMergeInputChains1_0,
/*  9005*/     OPC_EmitInteger32, 0, 
/*  9007*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  9017*/    /*Scope*/ 17, /*->9035*/
/*  9018*/     OPC_CheckPredicate2,  // Predicate_atomic_swap_i16
/*  9019*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9020*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9022*/     OPC_EmitMergeInputChains1_0,
/*  9023*/     OPC_EmitInteger32, 0, 
/*  9025*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_XCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 4/*#Ops*/, 5, 3, 4, 2, 
               // Src: (atomic_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$val)<<P:Predicate_atomic_swap_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_XCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$val)
/*  9035*/    0, /*End of Scope*/
/*  9036*/   /*SwitchType*/ 17, /*MVT::i64*/8, // ->9055
/*  9038*/    OPC_CheckPredicate7,  // Predicate_atomic_swap_i64
/*  9039*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9040*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #3 #4
/*  9042*/    OPC_EmitMergeInputChains1_0,
/*  9043*/    OPC_EmitInteger32, 0, 
/*  9045*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_XCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 4/*#Ops*/, 5, 3, 4, 2, 
              // Src: (atomic_swap:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$val)<<P:Predicate_atomic_swap_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_XCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$val)
/*  9055*/   0, // EndSwitchType
/*  9056*/  0, /*End of Scope*/
/*  9057*/ /*SwitchOpcode*/ 127|128,1/*255*/, TARGET_VAL(ISD::ATOMIC_CMP_SWAP),// ->9316
/*  9061*/  OPC_RecordMemRef,
/*  9062*/  OPC_RecordNode, // #0 = 'atomic_cmp_swap' chained node
/*  9063*/  OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/*  9064*/  OPC_Scope, 124, /*->9190*/ // 2 children in Scope
/*  9066*/   OPC_CheckChild1TypeI32,
/*  9067*/   OPC_RecordChild2, // #2 = $exp
/*  9068*/   OPC_RecordChild3, // #3 = $new
/*  9069*/   OPC_SwitchType /*2 cases */, 97, /*MVT::i32*/7, // ->9169
/*  9072*/    OPC_Scope, 18, /*->9092*/ // 5 children in Scope
/*  9074*/     OPC_CheckPredicate3,  // Predicate_atomic_cmp_swap_i32
/*  9075*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9076*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  9078*/     OPC_EmitMergeInputChains1_0,
/*  9079*/     OPC_EmitInteger32, 0, 
/*  9081*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9092*/    /*Scope*/ 18, /*->9111*/
/*  9093*/     OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_i8
/*  9094*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9095*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  9097*/     OPC_EmitMergeInputChains1_0,
/*  9098*/     OPC_EmitInteger32, 0, 
/*  9100*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9111*/    /*Scope*/ 18, /*->9130*/
/*  9112*/     OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_i16
/*  9113*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9114*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  9116*/     OPC_EmitMergeInputChains1_0,
/*  9117*/     OPC_EmitInteger32, 0, 
/*  9119*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9130*/    /*Scope*/ 18, /*->9149*/
/*  9131*/     OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_i8
/*  9132*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9133*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  9135*/     OPC_EmitMergeInputChains1_0,
/*  9136*/     OPC_EmitInteger32, 0, 
/*  9138*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9149*/    /*Scope*/ 18, /*->9168*/
/*  9150*/     OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_i16
/*  9151*/     OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9152*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  9154*/     OPC_EmitMergeInputChains1_0,
/*  9155*/     OPC_EmitInteger32, 0, 
/*  9157*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A32:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9168*/    0, /*End of Scope*/
/*  9169*/   /*SwitchType*/ 18, /*MVT::i64*/8, // ->9189
/*  9171*/    OPC_CheckPredicate7,  // Predicate_atomic_cmp_swap_i64
/*  9172*/    OPC_CheckPatternPredicate3, // (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9173*/    OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #4 #5
/*  9175*/    OPC_EmitMergeInputChains1_0,
/*  9176*/    OPC_EmitInteger32, 0, 
/*  9178*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 5/*#Ops*/, 6, 4, 5, 2, 3, 
              // Src: (atomic_cmp_swap:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_CMPXCHG_I64_A32:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i32] }:$offset, ?:{ *:[i32] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  9189*/   0, // EndSwitchType
/*  9190*/  /*Scope*/ 124, /*->9315*/
/*  9191*/   OPC_CheckChild1TypeI64,
/*  9192*/   OPC_RecordChild2, // #2 = $exp
/*  9193*/   OPC_RecordChild3, // #3 = $new
/*  9194*/   OPC_SwitchType /*2 cases */, 97, /*MVT::i32*/7, // ->9294
/*  9197*/    OPC_Scope, 18, /*->9217*/ // 5 children in Scope
/*  9199*/     OPC_CheckPredicate3,  // Predicate_atomic_cmp_swap_i32
/*  9200*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9201*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  9203*/     OPC_EmitMergeInputChains1_0,
/*  9204*/     OPC_EmitInteger32, 0, 
/*  9206*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i32>> - Complexity = 13
               // Dst: (ATOMIC_RMW_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9217*/    /*Scope*/ 18, /*->9236*/
/*  9218*/     OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_i8
/*  9219*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9220*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  9222*/     OPC_EmitMergeInputChains1_0,
/*  9223*/     OPC_EmitInteger32, 0, 
/*  9225*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9236*/    /*Scope*/ 18, /*->9255*/
/*  9237*/     OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_i16
/*  9238*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9239*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  9241*/     OPC_EmitMergeInputChains1_0,
/*  9242*/     OPC_EmitInteger32, 0, 
/*  9244*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9255*/    /*Scope*/ 18, /*->9274*/
/*  9256*/     OPC_CheckPredicate1,  // Predicate_atomic_cmp_swap_i8
/*  9257*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9258*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  9260*/     OPC_EmitMergeInputChains1_0,
/*  9261*/     OPC_EmitInteger32, 0, 
/*  9263*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW8_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i8>> - Complexity = 13
               // Dst: (ATOMIC_RMW8_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9274*/    /*Scope*/ 18, /*->9293*/
/*  9275*/     OPC_CheckPredicate2,  // Predicate_atomic_cmp_swap_i16
/*  9276*/     OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9277*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  9279*/     OPC_EmitMergeInputChains1_0,
/*  9280*/     OPC_EmitInteger32, 0, 
/*  9282*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW16_U_CMPXCHG_I32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::i32*/7, 5/*#Ops*/, 6, 4, 5, 2, 3, 
               // Src: (atomic_cmp_swap:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i32:{ *:[i32] }:$exp, i32:{ *:[i32] }:$new)<<P:Predicate_atomic_cmp_swap_i16>> - Complexity = 13
               // Dst: (ATOMIC_RMW16_U_CMPXCHG_I32_A64:{ *:[i32] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i32] }:$exp, ?:{ *:[i32] }:$new)
/*  9293*/    0, /*End of Scope*/
/*  9294*/   /*SwitchType*/ 18, /*MVT::i64*/8, // ->9314
/*  9296*/    OPC_CheckPredicate7,  // Predicate_atomic_cmp_swap_i64
/*  9297*/    OPC_CheckPatternPredicate4, // (Subtarget->hasAddr64()) && (Subtarget->hasAtomics())
/*  9298*/    OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #4 #5
/*  9300*/    OPC_EmitMergeInputChains1_0,
/*  9301*/    OPC_EmitInteger32, 0, 
/*  9303*/    OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ATOMIC_RMW_CMPXCHG_I64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                  /*MVT::i64*/8, 5/*#Ops*/, 6, 4, 5, 2, 3, 
              // Src: (atomic_cmp_swap:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr), i64:{ *:[i64] }:$exp, i64:{ *:[i64] }:$new)<<P:Predicate_atomic_cmp_swap_i64>> - Complexity = 13
              // Dst: (ATOMIC_RMW_CMPXCHG_I64_A64:{ *:[i64] } 0:{ *:[i32] }, ?:{ *:[i64] }:$offset, ?:{ *:[i64] }:$addr, ?:{ *:[i64] }:$exp, ?:{ *:[i64] }:$new)
/*  9314*/   0, // EndSwitchType
/*  9315*/  0, /*End of Scope*/
/*  9316*/ /*SwitchOpcode*/ 89, TARGET_VAL(ISD::BRCOND),// ->9408
/*  9319*/  OPC_RecordNode, // #0 = 'brcond' chained node
/*  9320*/  OPC_Scope, 69, /*->9391*/ // 2 children in Scope
/*  9322*/   OPC_MoveChild1,
/*  9323*/   OPC_SwitchOpcode /*2 cases */, 21, TARGET_VAL(ISD::XOR),// ->9348
/*  9327*/    OPC_RecordChild0, // #1 = $cond
/*  9328*/    OPC_MoveChild0,
/*  9329*/    OPC_CheckPredicate, 26, // Predicate_bool_node
/*  9331*/    OPC_MoveParent,
/*  9332*/    OPC_CheckChild1Integer, 2, 
/*  9334*/    OPC_CheckTypeI32,
/*  9335*/    OPC_MoveSibling2,
/*  9336*/    OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/*  9339*/    OPC_RecordNode, // #2 = $dst
/*  9340*/    OPC_MoveParent,
/*  9341*/    OPC_EmitMergeInputChains1_0,
/*  9342*/    OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::BR_UNLESS),
                  2/*#Ops*/, 2, 1, 
              // Src: (brcond (xor:{ *:[i32] } I32:{ *:[i32] }<<P:Predicate_bool_node>>:$cond, 1:{ *:[i32] }), (bb:{ *:[Other] }):$dst) - Complexity = 12
              // Dst: (BR_UNLESS bb_op:{ *:[Other] }:$dst, I32:{ *:[i32] }:$cond)
/*  9348*/   /*SwitchOpcode*/ 39, TARGET_VAL(ISD::SETCC),// ->9390
/*  9351*/    OPC_RecordChild0, // #1 = $cond
/*  9352*/    OPC_CheckChild0TypeI32,
/*  9353*/    OPC_CheckChild1Integer, 0, 
/*  9355*/    OPC_CheckTypeI32,
/*  9356*/    OPC_Scope, 15, /*->9373*/ // 2 children in Scope
/*  9358*/     OPC_CheckChild2CondCode, ISD::SETNE,
/*  9360*/     OPC_MoveSibling2,
/*  9361*/     OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/*  9364*/     OPC_RecordNode, // #2 = $dst
/*  9365*/     OPC_MoveParent,
/*  9366*/     OPC_EmitMergeInputChains1_0,
/*  9367*/     OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::BR_IF),
                   2/*#Ops*/, 2, 1, 
               // Src: (brcond (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), (bb:{ *:[Other] }):$dst) - Complexity = 11
               // Dst: (BR_IF bb_op:{ *:[Other] }:$dst, I32:{ *:[i32] }:$cond)
/*  9373*/    /*Scope*/ 15, /*->9389*/
/*  9374*/     OPC_CheckChild2CondCode, ISD::SETEQ,
/*  9376*/     OPC_MoveSibling2,
/*  9377*/     OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/*  9380*/     OPC_RecordNode, // #2 = $dst
/*  9381*/     OPC_MoveParent,
/*  9382*/     OPC_EmitMergeInputChains1_0,
/*  9383*/     OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::BR_UNLESS),
                   2/*#Ops*/, 2, 1, 
               // Src: (brcond (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), (bb:{ *:[Other] }):$dst) - Complexity = 11
               // Dst: (BR_UNLESS bb_op:{ *:[Other] }:$dst, I32:{ *:[i32] }:$cond)
/*  9389*/    0, /*End of Scope*/
/*  9390*/   0, // EndSwitchOpcode
/*  9391*/  /*Scope*/ 15, /*->9407*/
/*  9392*/   OPC_RecordChild1, // #1 = $cond
/*  9393*/   OPC_CheckChild1TypeI32,
/*  9394*/   OPC_RecordChild2, // #2 = $dst
/*  9395*/   OPC_MoveChild2,
/*  9396*/   OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/*  9399*/   OPC_MoveParent,
/*  9400*/   OPC_EmitMergeInputChains1_0,
/*  9401*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::BR_IF),
                 2/*#Ops*/, 2, 1, 
             // Src: (brcond I32:{ *:[i32] }:$cond, (bb:{ *:[Other] }):$dst) - Complexity = 3
             // Dst: (BR_IF (bb:{ *:[Other] }):$dst, I32:{ *:[i32] }:$cond)
/*  9407*/  0, /*End of Scope*/
/*  9408*/ /*SwitchOpcode*/ 59, TARGET_VAL(ISD::SHL),// ->9470
/*  9411*/  OPC_RecordChild0, // #0 = $lhs
/*  9412*/  OPC_Scope, 31, /*->9445*/ // 2 children in Scope
/*  9414*/   OPC_MoveChild1,
/*  9415*/   OPC_SwitchType /*2 cases */, 12, /*MVT::i32*/7, // ->9430
/*  9418*/    OPC_CheckAndImm, 31, 
/*  9420*/    OPC_RecordChild0, // #1 = $rhs
/*  9421*/    OPC_MoveParent,
/*  9422*/    OPC_CheckTypeI32,
/*  9423*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (shl:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9430*/   /*SwitchType*/ 12, /*MVT::i64*/8, // ->9444
/*  9432*/    OPC_CheckAndImm, 63, 
/*  9434*/    OPC_RecordChild0, // #1 = $rhs
/*  9435*/    OPC_MoveParent,
/*  9436*/    OPC_CheckTypeI64,
/*  9437*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (shl:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (SHL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9444*/   0, // EndSwitchType
/*  9445*/  /*Scope*/ 23, /*->9469*/
/*  9446*/   OPC_RecordChild1, // #1 = $rhs
/*  9447*/   OPC_SwitchType /*2 cases */, 8, /*MVT::i32*/7, // ->9458
/*  9450*/    OPC_CheckChild1TypeI32,
/*  9451*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (shl:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SHL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9458*/   /*SwitchType*/ 8, /*MVT::i64*/8, // ->9468
/*  9460*/    OPC_CheckChild1TypeI64,
/*  9461*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (shl:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SHL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9468*/   0, // EndSwitchType
/*  9469*/  0, /*End of Scope*/
/*  9470*/ /*SwitchOpcode*/ 59, TARGET_VAL(ISD::SRA),// ->9532
/*  9473*/  OPC_RecordChild0, // #0 = $lhs
/*  9474*/  OPC_Scope, 31, /*->9507*/ // 2 children in Scope
/*  9476*/   OPC_MoveChild1,
/*  9477*/   OPC_SwitchType /*2 cases */, 12, /*MVT::i32*/7, // ->9492
/*  9480*/    OPC_CheckAndImm, 31, 
/*  9482*/    OPC_RecordChild0, // #1 = $rhs
/*  9483*/    OPC_MoveParent,
/*  9484*/    OPC_CheckTypeI32,
/*  9485*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (sra:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9492*/   /*SwitchType*/ 12, /*MVT::i64*/8, // ->9506
/*  9494*/    OPC_CheckAndImm, 63, 
/*  9496*/    OPC_RecordChild0, // #1 = $rhs
/*  9497*/    OPC_MoveParent,
/*  9498*/    OPC_CheckTypeI64,
/*  9499*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (sra:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (SHR_S_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9506*/   0, // EndSwitchType
/*  9507*/  /*Scope*/ 23, /*->9531*/
/*  9508*/   OPC_RecordChild1, // #1 = $rhs
/*  9509*/   OPC_SwitchType /*2 cases */, 8, /*MVT::i32*/7, // ->9520
/*  9512*/    OPC_CheckChild1TypeI32,
/*  9513*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (sra:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SHR_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9520*/   /*SwitchType*/ 8, /*MVT::i64*/8, // ->9530
/*  9522*/    OPC_CheckChild1TypeI64,
/*  9523*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (sra:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SHR_S_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9530*/   0, // EndSwitchType
/*  9531*/  0, /*End of Scope*/
/*  9532*/ /*SwitchOpcode*/ 59, TARGET_VAL(ISD::SRL),// ->9594
/*  9535*/  OPC_RecordChild0, // #0 = $lhs
/*  9536*/  OPC_Scope, 31, /*->9569*/ // 2 children in Scope
/*  9538*/   OPC_MoveChild1,
/*  9539*/   OPC_SwitchType /*2 cases */, 12, /*MVT::i32*/7, // ->9554
/*  9542*/    OPC_CheckAndImm, 31, 
/*  9544*/    OPC_RecordChild0, // #1 = $rhs
/*  9545*/    OPC_MoveParent,
/*  9546*/    OPC_CheckTypeI32,
/*  9547*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (srl:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9554*/   /*SwitchType*/ 12, /*MVT::i64*/8, // ->9568
/*  9556*/    OPC_CheckAndImm, 63, 
/*  9558*/    OPC_RecordChild0, // #1 = $rhs
/*  9559*/    OPC_MoveParent,
/*  9560*/    OPC_CheckTypeI64,
/*  9561*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (srl:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (SHR_U_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9568*/   0, // EndSwitchType
/*  9569*/  /*Scope*/ 23, /*->9593*/
/*  9570*/   OPC_RecordChild1, // #1 = $rhs
/*  9571*/   OPC_SwitchType /*2 cases */, 8, /*MVT::i32*/7, // ->9582
/*  9574*/    OPC_CheckChild1TypeI32,
/*  9575*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (srl:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SHR_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9582*/   /*SwitchType*/ 8, /*MVT::i64*/8, // ->9592
/*  9584*/    OPC_CheckChild1TypeI64,
/*  9585*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (srl:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SHR_U_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9592*/   0, // EndSwitchType
/*  9593*/  0, /*End of Scope*/
/*  9594*/ /*SwitchOpcode*/ 59, TARGET_VAL(ISD::ROTL),// ->9656
/*  9597*/  OPC_RecordChild0, // #0 = $lhs
/*  9598*/  OPC_Scope, 31, /*->9631*/ // 2 children in Scope
/*  9600*/   OPC_MoveChild1,
/*  9601*/   OPC_SwitchType /*2 cases */, 12, /*MVT::i32*/7, // ->9616
/*  9604*/    OPC_CheckAndImm, 31, 
/*  9606*/    OPC_RecordChild0, // #1 = $rhs
/*  9607*/    OPC_MoveParent,
/*  9608*/    OPC_CheckTypeI32,
/*  9609*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTL_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (rotl:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (ROTL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9616*/   /*SwitchType*/ 12, /*MVT::i64*/8, // ->9630
/*  9618*/    OPC_CheckAndImm, 63, 
/*  9620*/    OPC_RecordChild0, // #1 = $rhs
/*  9621*/    OPC_MoveParent,
/*  9622*/    OPC_CheckTypeI64,
/*  9623*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTL_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (rotl:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (ROTL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9630*/   0, // EndSwitchType
/*  9631*/  /*Scope*/ 23, /*->9655*/
/*  9632*/   OPC_RecordChild1, // #1 = $rhs
/*  9633*/   OPC_SwitchType /*2 cases */, 8, /*MVT::i32*/7, // ->9644
/*  9636*/    OPC_CheckChild1TypeI32,
/*  9637*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTL_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (rotl:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (ROTL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9644*/   /*SwitchType*/ 8, /*MVT::i64*/8, // ->9654
/*  9646*/    OPC_CheckChild1TypeI64,
/*  9647*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTL_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (rotl:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (ROTL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9654*/   0, // EndSwitchType
/*  9655*/  0, /*End of Scope*/
/*  9656*/ /*SwitchOpcode*/ 59, TARGET_VAL(ISD::ROTR),// ->9718
/*  9659*/  OPC_RecordChild0, // #0 = $lhs
/*  9660*/  OPC_Scope, 31, /*->9693*/ // 2 children in Scope
/*  9662*/   OPC_MoveChild1,
/*  9663*/   OPC_SwitchType /*2 cases */, 12, /*MVT::i32*/7, // ->9678
/*  9666*/    OPC_CheckAndImm, 31, 
/*  9668*/    OPC_RecordChild0, // #1 = $rhs
/*  9669*/    OPC_MoveParent,
/*  9670*/    OPC_CheckTypeI32,
/*  9671*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTR_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (rotr:{ *:[i32] } I32:{ *:[i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (ROTR_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9678*/   /*SwitchType*/ 12, /*MVT::i64*/8, // ->9692
/*  9680*/    OPC_CheckAndImm, 63, 
/*  9682*/    OPC_RecordChild0, // #1 = $rhs
/*  9683*/    OPC_MoveParent,
/*  9684*/    OPC_CheckTypeI64,
/*  9685*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTR_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (rotr:{ *:[i64] } I64:{ *:[i64] }:$lhs, (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] })) - Complexity = 11
              // Dst: (ROTR_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9692*/   0, // EndSwitchType
/*  9693*/  /*Scope*/ 23, /*->9717*/
/*  9694*/   OPC_RecordChild1, // #1 = $rhs
/*  9695*/   OPC_SwitchType /*2 cases */, 8, /*MVT::i32*/7, // ->9706
/*  9698*/    OPC_CheckChild1TypeI32,
/*  9699*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTR_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (rotr:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (ROTR_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/*  9706*/   /*SwitchType*/ 8, /*MVT::i64*/8, // ->9716
/*  9708*/    OPC_CheckChild1TypeI64,
/*  9709*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ROTR_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (rotr:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (ROTR_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/*  9716*/   0, // EndSwitchType
/*  9717*/  0, /*End of Scope*/
/*  9718*/ /*SwitchOpcode*/ 48|128,4/*560*/, TARGET_VAL(ISD::SELECT),// ->10282
/*  9722*/  OPC_Scope, 11|128,1/*139*/, /*->9864*/ // 8 children in Scope
/*  9725*/   OPC_MoveChild0,
/*  9726*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/*  9729*/   OPC_RecordChild0, // #0 = $cond
/*  9730*/   OPC_CheckChild0TypeI32,
/*  9731*/   OPC_CheckChild1Integer, 0, 
/*  9733*/   OPC_CheckTypeI32,
/*  9734*/   OPC_Scope, 63, /*->9799*/ // 2 children in Scope
/*  9736*/    OPC_CheckChild2CondCode, ISD::SETNE,
/*  9738*/    OPC_MoveParent,
/*  9739*/    OPC_RecordChild1, // #1 = $lhs
/*  9740*/    OPC_RecordChild2, // #2 = $rhs
/*  9741*/    OPC_SwitchType /*5 cases */, 8, /*MVT::i32*/7, // ->9752
/*  9744*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I32),
                   /*MVT::i32*/7, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[i32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9752*/    /*SwitchType*/ 8, /*MVT::i64*/8, // ->9762
/*  9754*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I64),
                   /*MVT::i64*/8, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[i64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9762*/    /*SwitchType*/ 9, /*MVT::funcref*/99|128,1/*227*/, // ->9774
/*  9765*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_FUNCREF),
                   /*MVT::funcref*/99|128,1/*227*/, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[funcref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_FUNCREF:{ *:[funcref] } FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9774*/    /*SwitchType*/ 9, /*MVT::externref*/100|128,1/*228*/, // ->9786
/*  9777*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_EXTERNREF),
                   /*MVT::externref*/100|128,1/*228*/, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[externref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_EXTERNREF:{ *:[externref] } EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9786*/    /*SwitchType*/ 9, /*MVT::exnref*/101|128,1/*229*/, // ->9798
/*  9789*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_EXNREF),
                   /*MVT::exnref*/101|128,1/*229*/, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[exnref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), EXNREF:{ *:[exnref] }:$lhs, EXNREF:{ *:[exnref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_EXNREF:{ *:[exnref] } EXNREF:{ *:[exnref] }:$lhs, EXNREF:{ *:[exnref] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9798*/    0, // EndSwitchType
/*  9799*/   /*Scope*/ 63, /*->9863*/
/*  9800*/    OPC_CheckChild2CondCode, ISD::SETEQ,
/*  9802*/    OPC_MoveParent,
/*  9803*/    OPC_RecordChild1, // #1 = $lhs
/*  9804*/    OPC_RecordChild2, // #2 = $rhs
/*  9805*/    OPC_SwitchType /*5 cases */, 8, /*MVT::i32*/7, // ->9816
/*  9808*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I32),
                   /*MVT::i32*/7, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[i32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_I32:{ *:[i32] } I32:{ *:[i32] }:$rhs, I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$cond)
/*  9816*/    /*SwitchType*/ 8, /*MVT::i64*/8, // ->9826
/*  9818*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I64),
                   /*MVT::i64*/8, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[i64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_I64:{ *:[i64] } I64:{ *:[i64] }:$rhs, I64:{ *:[i64] }:$lhs, I32:{ *:[i32] }:$cond)
/*  9826*/    /*SwitchType*/ 9, /*MVT::funcref*/99|128,1/*227*/, // ->9838
/*  9829*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_FUNCREF),
                   /*MVT::funcref*/99|128,1/*227*/, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[funcref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_FUNCREF:{ *:[funcref] } FUNCREF:{ *:[funcref] }:$rhs, FUNCREF:{ *:[funcref] }:$lhs, I32:{ *:[i32] }:$cond)
/*  9838*/    /*SwitchType*/ 9, /*MVT::externref*/100|128,1/*228*/, // ->9850
/*  9841*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_EXTERNREF),
                   /*MVT::externref*/100|128,1/*228*/, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[externref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_EXTERNREF:{ *:[externref] } EXTERNREF:{ *:[externref] }:$rhs, EXTERNREF:{ *:[externref] }:$lhs, I32:{ *:[i32] }:$cond)
/*  9850*/    /*SwitchType*/ 9, /*MVT::exnref*/101|128,1/*229*/, // ->9862
/*  9853*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_EXNREF),
                   /*MVT::exnref*/101|128,1/*229*/, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[exnref] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), EXNREF:{ *:[exnref] }:$lhs, EXNREF:{ *:[exnref] }:$rhs) - Complexity = 11
               // Dst: (SELECT_EXNREF:{ *:[exnref] } EXNREF:{ *:[exnref] }:$rhs, EXNREF:{ *:[exnref] }:$lhs, I32:{ *:[i32] }:$cond)
/*  9862*/    0, // EndSwitchType
/*  9863*/   0, /*End of Scope*/
/*  9864*/  /*Scope*/ 65, /*->9930*/
/*  9865*/   OPC_RecordChild0, // #0 = $cond
/*  9866*/   OPC_CheckChild0TypeI32,
/*  9867*/   OPC_RecordChild1, // #1 = $lhs
/*  9868*/   OPC_RecordChild2, // #2 = $rhs
/*  9869*/   OPC_SwitchType /*5 cases */, 8, /*MVT::i32*/7, // ->9880
/*  9872*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I32),
                  /*MVT::i32*/7, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[i32] } I32:{ *:[i32] }:$cond, I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SELECT_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9880*/   /*SwitchType*/ 8, /*MVT::i64*/8, // ->9890
/*  9882*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_I64),
                  /*MVT::i64*/8, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[i64] } I32:{ *:[i32] }:$cond, I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SELECT_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9890*/   /*SwitchType*/ 10, /*MVT::funcref*/99|128,1/*227*/, // ->9903
/*  9893*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  9894*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_FUNCREF),
                  /*MVT::funcref*/99|128,1/*227*/, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[funcref] } I32:{ *:[i32] }:$cond, FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs) - Complexity = 3
              // Dst: (SELECT_FUNCREF:{ *:[funcref] } FUNCREF:{ *:[funcref] }:$lhs, FUNCREF:{ *:[funcref] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9903*/   /*SwitchType*/ 10, /*MVT::externref*/100|128,1/*228*/, // ->9916
/*  9906*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  9907*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_EXTERNREF),
                  /*MVT::externref*/100|128,1/*228*/, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[externref] } I32:{ *:[i32] }:$cond, EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs) - Complexity = 3
              // Dst: (SELECT_EXTERNREF:{ *:[externref] } EXTERNREF:{ *:[externref] }:$lhs, EXTERNREF:{ *:[externref] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9916*/   /*SwitchType*/ 10, /*MVT::exnref*/101|128,1/*229*/, // ->9929
/*  9919*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/*  9920*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_EXNREF),
                  /*MVT::exnref*/101|128,1/*229*/, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[exnref] } I32:{ *:[i32] }:$cond, EXNREF:{ *:[exnref] }:$lhs, EXNREF:{ *:[exnref] }:$rhs) - Complexity = 3
              // Dst: (SELECT_EXNREF:{ *:[exnref] } EXNREF:{ *:[exnref] }:$lhs, EXNREF:{ *:[exnref] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9929*/   0, // EndSwitchType
/*  9930*/  /*Scope*/ 67, /*->9998*/
/*  9931*/   OPC_MoveChild0,
/*  9932*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/*  9935*/   OPC_RecordChild0, // #0 = $cond
/*  9936*/   OPC_CheckChild0TypeI32,
/*  9937*/   OPC_CheckChild1Integer, 0, 
/*  9939*/   OPC_CheckTypeI32,
/*  9940*/   OPC_Scope, 27, /*->9969*/ // 2 children in Scope
/*  9942*/    OPC_CheckChild2CondCode, ISD::SETNE,
/*  9944*/    OPC_MoveParent,
/*  9945*/    OPC_RecordChild1, // #1 = $lhs
/*  9946*/    OPC_RecordChild2, // #2 = $rhs
/*  9947*/    OPC_SwitchType /*2 cases */, 8, /*MVT::f32*/12, // ->9958
/*  9950*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F32),
                   /*MVT::f32*/12, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[f32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9958*/    /*SwitchType*/ 8, /*MVT::f64*/13, // ->9968
/*  9960*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F64),
                   /*MVT::f64*/13, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[f64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, I32:{ *:[i32] }:$cond)
/*  9968*/    0, // EndSwitchType
/*  9969*/   /*Scope*/ 27, /*->9997*/
/*  9970*/    OPC_CheckChild2CondCode, ISD::SETEQ,
/*  9972*/    OPC_MoveParent,
/*  9973*/    OPC_RecordChild1, // #1 = $lhs
/*  9974*/    OPC_RecordChild2, // #2 = $rhs
/*  9975*/    OPC_SwitchType /*2 cases */, 8, /*MVT::f32*/12, // ->9986
/*  9978*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F32),
                   /*MVT::f32*/12, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[f32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_F32:{ *:[f32] } F32:{ *:[f32] }:$rhs, F32:{ *:[f32] }:$lhs, I32:{ *:[i32] }:$cond)
/*  9986*/    /*SwitchType*/ 8, /*MVT::f64*/13, // ->9996
/*  9988*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F64),
                   /*MVT::f64*/13, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[f64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_F64:{ *:[f64] } F64:{ *:[f64] }:$rhs, F64:{ *:[f64] }:$lhs, I32:{ *:[i32] }:$cond)
/*  9996*/    0, // EndSwitchType
/*  9997*/   0, /*End of Scope*/
/*  9998*/  /*Scope*/ 26, /*->10025*/
/*  9999*/   OPC_RecordChild0, // #0 = $cond
/* 10000*/   OPC_CheckChild0TypeI32,
/* 10001*/   OPC_RecordChild1, // #1 = $lhs
/* 10002*/   OPC_RecordChild2, // #2 = $rhs
/* 10003*/   OPC_SwitchType /*2 cases */, 8, /*MVT::f32*/12, // ->10014
/* 10006*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F32),
                  /*MVT::f32*/12, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[f32] } I32:{ *:[i32] }:$cond, F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
              // Dst: (SELECT_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs, I32:{ *:[i32] }:$cond)
/* 10014*/   /*SwitchType*/ 8, /*MVT::f64*/13, // ->10024
/* 10016*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_F64),
                  /*MVT::f64*/13, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[f64] } I32:{ *:[i32] }:$cond, F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
              // Dst: (SELECT_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs, I32:{ *:[i32] }:$cond)
/* 10024*/   0, // EndSwitchType
/* 10025*/  /*Scope*/ 107, /*->10133*/
/* 10026*/   OPC_MoveChild0,
/* 10027*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/* 10030*/   OPC_RecordChild0, // #0 = $cond
/* 10031*/   OPC_CheckChild0TypeI32,
/* 10032*/   OPC_CheckChild1Integer, 0, 
/* 10034*/   OPC_CheckTypeI32,
/* 10035*/   OPC_Scope, 47, /*->10084*/ // 2 children in Scope
/* 10037*/    OPC_CheckChild2CondCode, ISD::SETNE,
/* 10039*/    OPC_MoveParent,
/* 10040*/    OPC_RecordChild1, // #1 = $lhs
/* 10041*/    OPC_RecordChild2, // #2 = $rhs
/* 10042*/    OPC_SwitchType /*4 cases */, 8, /*MVT::v16i8*/39, // ->10053
/* 10045*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v16i8] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10053*/    /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->10063
/* 10055*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v8i16] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10063*/    /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->10073
/* 10065*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v4i32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10073*/    /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->10083
/* 10075*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   /*MVT::v2i64*/78, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v2i64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10083*/    0, // EndSwitchType
/* 10084*/   /*Scope*/ 47, /*->10132*/
/* 10085*/    OPC_CheckChild2CondCode, ISD::SETEQ,
/* 10087*/    OPC_MoveParent,
/* 10088*/    OPC_RecordChild1, // #1 = $lhs
/* 10089*/    OPC_RecordChild2, // #2 = $rhs
/* 10090*/    OPC_SwitchType /*4 cases */, 8, /*MVT::v16i8*/39, // ->10101
/* 10093*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v16i8] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v16i8] } ?:{ *:[v16i8] }:$rhs, ?:{ *:[v16i8] }:$lhs, ?:{ *:[i32] }:$cond)
/* 10101*/    /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->10111
/* 10103*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v8i16] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v8i16] } ?:{ *:[v8i16] }:$rhs, ?:{ *:[v8i16] }:$lhs, ?:{ *:[i32] }:$cond)
/* 10111*/    /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->10121
/* 10113*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v4i32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v4i32] } ?:{ *:[v4i32] }:$rhs, ?:{ *:[v4i32] }:$lhs, ?:{ *:[i32] }:$cond)
/* 10121*/    /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->10131
/* 10123*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   /*MVT::v2i64*/78, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v2i64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v2i64] } ?:{ *:[v2i64] }:$rhs, ?:{ *:[v2i64] }:$lhs, ?:{ *:[i32] }:$cond)
/* 10131*/    0, // EndSwitchType
/* 10132*/   0, /*End of Scope*/
/* 10133*/  /*Scope*/ 46, /*->10180*/
/* 10134*/   OPC_RecordChild0, // #0 = $cond
/* 10135*/   OPC_CheckChild0TypeI32,
/* 10136*/   OPC_RecordChild1, // #1 = $lhs
/* 10137*/   OPC_RecordChild2, // #2 = $rhs
/* 10138*/   OPC_SwitchType /*4 cases */, 8, /*MVT::v16i8*/39, // ->10149
/* 10141*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  /*MVT::v16i8*/39, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v16i8] } I32:{ *:[i32] }:$cond, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10149*/   /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->10159
/* 10151*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  /*MVT::v8i16*/50, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v8i16] } I32:{ *:[i32] }:$cond, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10159*/   /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->10169
/* 10161*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  /*MVT::v4i32*/60, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v4i32] } I32:{ *:[i32] }:$cond, V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10169*/   /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->10179
/* 10171*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  /*MVT::v2i64*/78, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v2i64] } I32:{ *:[i32] }:$cond, V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10179*/   0, // EndSwitchType
/* 10180*/  /*Scope*/ 71, /*->10252*/
/* 10181*/   OPC_MoveChild0,
/* 10182*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/* 10185*/   OPC_RecordChild0, // #0 = $cond
/* 10186*/   OPC_CheckChild0TypeI32,
/* 10187*/   OPC_CheckChild1Integer, 0, 
/* 10189*/   OPC_CheckTypeI32,
/* 10190*/   OPC_Scope, 29, /*->10221*/ // 2 children in Scope
/* 10192*/    OPC_CheckChild2CondCode, ISD::SETNE,
/* 10194*/    OPC_MoveParent,
/* 10195*/    OPC_RecordChild1, // #1 = $lhs
/* 10196*/    OPC_RecordChild2, // #2 = $rhs
/* 10197*/    OPC_SwitchType /*2 cases */, 8, /*MVT::v4f32*/111, // ->10208
/* 10200*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   /*MVT::v4f32*/111, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v4f32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v4f32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10208*/    /*SwitchType*/ 9, /*MVT::v2f64*/1|128,1/*129*/, // ->10220
/* 10211*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   /*MVT::v2f64*/1|128,1/*129*/, 3/*#Ops*/, 1, 2, 0, 
               // Src: (select:{ *:[v2f64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETNE:{ *:[Other] }), V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v2f64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10220*/    0, // EndSwitchType
/* 10221*/   /*Scope*/ 29, /*->10251*/
/* 10222*/    OPC_CheckChild2CondCode, ISD::SETEQ,
/* 10224*/    OPC_MoveParent,
/* 10225*/    OPC_RecordChild1, // #1 = $lhs
/* 10226*/    OPC_RecordChild2, // #2 = $rhs
/* 10227*/    OPC_SwitchType /*2 cases */, 8, /*MVT::v4f32*/111, // ->10238
/* 10230*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   /*MVT::v4f32*/111, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v4f32] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v4f32] } ?:{ *:[v4f32] }:$rhs, ?:{ *:[v4f32] }:$lhs, ?:{ *:[i32] }:$cond)
/* 10238*/    /*SwitchType*/ 9, /*MVT::v2f64*/1|128,1/*129*/, // ->10250
/* 10241*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                   /*MVT::v2f64*/1|128,1/*129*/, 3/*#Ops*/, 2, 1, 0, 
               // Src: (select:{ *:[v2f64] } (setcc:{ *:[i32] } I32:{ *:[i32] }:$cond, 0:{ *:[i32] }, SETEQ:{ *:[Other] }), V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 11
               // Dst: (SELECT_V128:{ *:[v2f64] } ?:{ *:[v2f64] }:$rhs, ?:{ *:[v2f64] }:$lhs, ?:{ *:[i32] }:$cond)
/* 10250*/    0, // EndSwitchType
/* 10251*/   0, /*End of Scope*/
/* 10252*/  /*Scope*/ 28, /*->10281*/
/* 10253*/   OPC_RecordChild0, // #0 = $cond
/* 10254*/   OPC_CheckChild0TypeI32,
/* 10255*/   OPC_RecordChild1, // #1 = $lhs
/* 10256*/   OPC_RecordChild2, // #2 = $rhs
/* 10257*/   OPC_SwitchType /*2 cases */, 8, /*MVT::v4f32*/111, // ->10268
/* 10260*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  /*MVT::v4f32*/111, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v4f32] } I32:{ *:[i32] }:$cond, V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v4f32] } ?:{ *:[v4f32] }:$lhs, ?:{ *:[v4f32] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10268*/   /*SwitchType*/ 9, /*MVT::v2f64*/1|128,1/*129*/, // ->10280
/* 10271*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SELECT_V128),
                  /*MVT::v2f64*/1|128,1/*129*/, 3/*#Ops*/, 1, 2, 0, 
              // Src: (select:{ *:[v2f64] } I32:{ *:[i32] }:$cond, V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
              // Dst: (SELECT_V128:{ *:[v2f64] } ?:{ *:[v2f64] }:$lhs, ?:{ *:[v2f64] }:$rhs, ?:{ *:[i32] }:$cond)
/* 10280*/   0, // EndSwitchType
/* 10281*/  0, /*End of Scope*/
/* 10282*/ /*SwitchOpcode*/ 1|128,1/*129*/, TARGET_VAL(ISD::SIGN_EXTEND_INREG),// ->10415
/* 10286*/  OPC_Scope, 57, /*->10345*/ // 2 children in Scope
/* 10288*/   OPC_MoveChild0,
/* 10289*/   OPC_CheckOpcode, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),
/* 10292*/   OPC_RecordChild0, // #0 = $vec
/* 10293*/   OPC_Scope, 24, /*->10319*/ // 2 children in Scope
/* 10295*/    OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 10297*/    OPC_RecordChild1, // #1 = $idx
/* 10298*/    OPC_MoveChild1,
/* 10299*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 10302*/    OPC_CheckPredicate, 18, // Predicate_LaneIdx16
/* 10304*/    OPC_CheckTypeI32,
/* 10305*/    OPC_MoveParent,
/* 10306*/    OPC_MoveSibling1,
/* 10307*/    OPC_CheckValueType, /*MVT::i8*/5, 
/* 10309*/    OPC_MoveParent,
/* 10310*/    OPC_CheckTypeI32,
/* 10311*/    OPC_EmitConvertToTarget1,
/* 10312*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I8x16_s),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 2, 
              // Src: (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx), i8:{ *:[Other] }) - Complexity = 10
              // Dst: (EXTRACT_LANE_I8x16_s:{ *:[i32] } ?:{ *:[v16i8] }:$vec, (imm:{ *:[i32] }):$idx)
/* 10319*/   /*Scope*/ 24, /*->10344*/
/* 10320*/    OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 10322*/    OPC_RecordChild1, // #1 = $idx
/* 10323*/    OPC_MoveChild1,
/* 10324*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 10327*/    OPC_CheckPredicate, 13, // Predicate_LaneIdx8
/* 10329*/    OPC_CheckTypeI32,
/* 10330*/    OPC_MoveParent,
/* 10331*/    OPC_MoveSibling1,
/* 10332*/    OPC_CheckValueType, /*MVT::i16*/6, 
/* 10334*/    OPC_MoveParent,
/* 10335*/    OPC_CheckTypeI32,
/* 10336*/    OPC_EmitConvertToTarget1,
/* 10337*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I16x8_s),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 2, 
              // Src: (sext_inreg:{ *:[i32] } (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx), i16:{ *:[Other] }) - Complexity = 10
              // Dst: (EXTRACT_LANE_I16x8_s:{ *:[i32] } ?:{ *:[v8i16] }:$vec, (imm:{ *:[i32] }):$idx)
/* 10344*/   0, /*End of Scope*/
/* 10345*/  /*Scope*/ 68, /*->10414*/
/* 10346*/   OPC_RecordChild0, // #0 = $src
/* 10347*/   OPC_MoveChild1,
/* 10348*/   OPC_Scope, 25, /*->10375*/ // 3 children in Scope
/* 10350*/    OPC_CheckValueType, /*MVT::i8*/5, 
/* 10352*/    OPC_MoveParent,
/* 10353*/    OPC_SwitchType /*2 cases */, 8, /*MVT::i32*/7, // ->10364
/* 10356*/     OPC_CheckPatternPredicate, 11, // (Subtarget->hasSignExt())
/* 10358*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_EXTEND8_S_I32),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (sext_inreg:{ *:[i32] } I32:{ *:[i32] }:$src, i8:{ *:[Other] }) - Complexity = 3
               // Dst: (I32_EXTEND8_S_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 10364*/    /*SwitchType*/ 8, /*MVT::i64*/8, // ->10374
/* 10366*/     OPC_CheckPatternPredicate, 11, // (Subtarget->hasSignExt())
/* 10368*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND8_S_I64),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (sext_inreg:{ *:[i64] } I64:{ *:[i64] }:$src, i8:{ *:[Other] }) - Complexity = 3
               // Dst: (I64_EXTEND8_S_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 10374*/    0, // EndSwitchType
/* 10375*/   /*Scope*/ 25, /*->10401*/
/* 10376*/    OPC_CheckValueType, /*MVT::i16*/6, 
/* 10378*/    OPC_MoveParent,
/* 10379*/    OPC_SwitchType /*2 cases */, 8, /*MVT::i32*/7, // ->10390
/* 10382*/     OPC_CheckPatternPredicate, 11, // (Subtarget->hasSignExt())
/* 10384*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_EXTEND16_S_I32),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (sext_inreg:{ *:[i32] } I32:{ *:[i32] }:$src, i16:{ *:[Other] }) - Complexity = 3
               // Dst: (I32_EXTEND16_S_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 10390*/    /*SwitchType*/ 8, /*MVT::i64*/8, // ->10400
/* 10392*/     OPC_CheckPatternPredicate, 11, // (Subtarget->hasSignExt())
/* 10394*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND16_S_I64),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (sext_inreg:{ *:[i64] } I64:{ *:[i64] }:$src, i16:{ *:[Other] }) - Complexity = 3
               // Dst: (I64_EXTEND16_S_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 10400*/    0, // EndSwitchType
/* 10401*/   /*Scope*/ 11, /*->10413*/
/* 10402*/    OPC_CheckValueType, /*MVT::i32*/7, 
/* 10404*/    OPC_MoveParent,
/* 10405*/    OPC_CheckPatternPredicate, 11, // (Subtarget->hasSignExt())
/* 10407*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND32_S_I64),
                  /*MVT::i64*/8, 1/*#Ops*/, 0, 
              // Src: (sext_inreg:{ *:[i64] } I64:{ *:[i64] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_EXTEND32_S_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 10413*/   0, /*End of Scope*/
/* 10414*/  0, /*End of Scope*/
/* 10415*/ /*SwitchOpcode*/ 46|128,1/*174*/, TARGET_VAL(WebAssemblyISD::GLOBAL_GET),// ->10593
/* 10419*/  OPC_RecordMemRef,
/* 10420*/  OPC_RecordNode, // #0 = 'WebAssemblyglobal_get' chained node
/* 10421*/  OPC_MoveChild1,
/* 10422*/  OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10425*/  OPC_RecordChild0, // #1 = $addr
/* 10426*/  OPC_MoveChild0,
/* 10427*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10430*/  OPC_MoveParent,
/* 10431*/  OPC_MoveParent,
/* 10432*/  OPC_SwitchType /*14 cases */, 8, /*MVT::i32*/7, // ->10443
/* 10435*/   OPC_EmitMergeInputChains1_0,
/* 10436*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_I32), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::i32*/7, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[i32] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_I32:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10443*/  /*SwitchType*/ 8, /*MVT::i64*/8, // ->10453
/* 10445*/   OPC_EmitMergeInputChains1_0,
/* 10446*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_I64), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::i64*/8, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[i64] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_I64:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr)
/* 10453*/  /*SwitchType*/ 10, /*MVT::funcref*/99|128,1/*227*/, // ->10466
/* 10456*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 10457*/   OPC_EmitMergeInputChains1_0,
/* 10458*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::funcref*/99|128,1/*227*/, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[funcref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_FUNCREF:{ *:[funcref] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10466*/  /*SwitchType*/ 10, /*MVT::externref*/100|128,1/*228*/, // ->10479
/* 10469*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 10470*/   OPC_EmitMergeInputChains1_0,
/* 10471*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_EXTERNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::externref*/100|128,1/*228*/, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[externref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_EXTERNREF:{ *:[externref] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10479*/  /*SwitchType*/ 11, /*MVT::exnref*/101|128,1/*229*/, // ->10493
/* 10482*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/* 10484*/   OPC_EmitMergeInputChains1_0,
/* 10485*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_EXNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::exnref*/101|128,1/*229*/, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[exnref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_EXNREF:{ *:[exnref] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10493*/  /*SwitchType*/ 8, /*MVT::f32*/12, // ->10503
/* 10495*/   OPC_EmitMergeInputChains1_0,
/* 10496*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_F32), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::f32*/12, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[f32] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_F32:{ *:[f32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10503*/  /*SwitchType*/ 8, /*MVT::f64*/13, // ->10513
/* 10505*/   OPC_EmitMergeInputChains1_0,
/* 10506*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_F64), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::f64*/13, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[f64] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_F64:{ *:[f64] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10513*/  /*SwitchType*/ 9, /*MVT::v2i64*/78, // ->10524
/* 10515*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10516*/   OPC_EmitMergeInputChains1_0,
/* 10517*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::v2i64*/78, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v2i64] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v2i64] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10524*/  /*SwitchType*/ 9, /*MVT::v4i32*/60, // ->10535
/* 10526*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10527*/   OPC_EmitMergeInputChains1_0,
/* 10528*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::v4i32*/60, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v4i32] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v4i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10535*/  /*SwitchType*/ 9, /*MVT::v16i8*/39, // ->10546
/* 10537*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10538*/   OPC_EmitMergeInputChains1_0,
/* 10539*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::v16i8*/39, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v16i8] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v16i8] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10546*/  /*SwitchType*/ 9, /*MVT::v8i16*/50, // ->10557
/* 10548*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10549*/   OPC_EmitMergeInputChains1_0,
/* 10550*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::v8i16*/50, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v8i16] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v8i16] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10557*/  /*SwitchType*/ 9, /*MVT::v8f16*/92, // ->10568
/* 10559*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10560*/   OPC_EmitMergeInputChains1_0,
/* 10561*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::v8f16*/92, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v8f16] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v8f16] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10568*/  /*SwitchType*/ 9, /*MVT::v4f32*/111, // ->10579
/* 10570*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10571*/   OPC_EmitMergeInputChains1_0,
/* 10572*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::v4f32*/111, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v4f32] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v4f32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10579*/  /*SwitchType*/ 10, /*MVT::v2f64*/1|128,1/*129*/, // ->10592
/* 10582*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10583*/   OPC_EmitMergeInputChains1_0,
/* 10584*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::GLOBAL_GET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::v2f64*/1|128,1/*129*/, 1/*#Ops*/, 1, 
             // Src: (WebAssemblyglobal_get:{ *:[v2f64] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_GET_V128:{ *:[v2f64] } (tglobaladdr:{ *:[i32] }):$addr)
/* 10592*/  0, // EndSwitchType
/* 10593*/ /*SwitchOpcode*/ 70|128,2/*326*/, TARGET_VAL(WebAssemblyISD::GLOBAL_SET),// ->10923
/* 10597*/  OPC_RecordMemRef,
/* 10598*/  OPC_RecordNode, // #0 = 'WebAssemblyglobal_set' chained node
/* 10599*/  OPC_RecordChild1, // #1 = $src
/* 10600*/  OPC_Scope, 20, /*->10622*/ // 14 children in Scope
/* 10602*/   OPC_CheckChild1TypeI32,
/* 10603*/   OPC_MoveChild2,
/* 10604*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10607*/   OPC_RecordChild0, // #2 = $addr
/* 10608*/   OPC_MoveChild0,
/* 10609*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10612*/   OPC_MoveParent,
/* 10613*/   OPC_MoveParent,
/* 10614*/   OPC_EmitMergeInputChains1_0,
/* 10615*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_I32), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set i32:{ *:[i32] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_I32 (tglobaladdr:{ *:[i32] }):$addr, i32:{ *:[i32] }:$src)
/* 10622*/  /*Scope*/ 20, /*->10643*/
/* 10623*/   OPC_CheckChild1TypeI64,
/* 10624*/   OPC_MoveChild2,
/* 10625*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10628*/   OPC_RecordChild0, // #2 = $addr
/* 10629*/   OPC_MoveChild0,
/* 10630*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10633*/   OPC_MoveParent,
/* 10634*/   OPC_MoveParent,
/* 10635*/   OPC_EmitMergeInputChains1_0,
/* 10636*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_I64), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set i64:{ *:[i64] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_I64 (tglobaladdr:{ *:[i64] }):$addr, i64:{ *:[i64] }:$src)
/* 10643*/  /*Scope*/ 21, /*->10665*/
/* 10644*/   OPC_CheckChild1Type, /*MVT::f32*/12, 
/* 10646*/   OPC_MoveChild2,
/* 10647*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10650*/   OPC_RecordChild0, // #2 = $addr
/* 10651*/   OPC_MoveChild0,
/* 10652*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10655*/   OPC_MoveParent,
/* 10656*/   OPC_MoveParent,
/* 10657*/   OPC_EmitMergeInputChains1_0,
/* 10658*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_F32), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set f32:{ *:[f32] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_F32 (tglobaladdr:{ *:[i32] }):$addr, f32:{ *:[f32] }:$src)
/* 10665*/  /*Scope*/ 21, /*->10687*/
/* 10666*/   OPC_CheckChild1Type, /*MVT::f64*/13, 
/* 10668*/   OPC_MoveChild2,
/* 10669*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10672*/   OPC_RecordChild0, // #2 = $addr
/* 10673*/   OPC_MoveChild0,
/* 10674*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10677*/   OPC_MoveParent,
/* 10678*/   OPC_MoveParent,
/* 10679*/   OPC_EmitMergeInputChains1_0,
/* 10680*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_F64), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set f64:{ *:[f64] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_F64 (tglobaladdr:{ *:[i32] }):$addr, f64:{ *:[f64] }:$src)
/* 10687*/  /*Scope*/ 22, /*->10710*/
/* 10688*/   OPC_CheckChild1Type, /*MVT::v8f16*/92, 
/* 10690*/   OPC_MoveChild2,
/* 10691*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10694*/   OPC_RecordChild0, // #2 = $addr
/* 10695*/   OPC_MoveChild0,
/* 10696*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10699*/   OPC_MoveParent,
/* 10700*/   OPC_MoveParent,
/* 10701*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10702*/   OPC_EmitMergeInputChains1_0,
/* 10703*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v8f16:{ *:[v8f16] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v8f16:{ *:[v8f16] }:$src)
/* 10710*/  /*Scope*/ 22, /*->10733*/
/* 10711*/   OPC_CheckChild1Type, /*MVT::v4f32*/111, 
/* 10713*/   OPC_MoveChild2,
/* 10714*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10717*/   OPC_RecordChild0, // #2 = $addr
/* 10718*/   OPC_MoveChild0,
/* 10719*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10722*/   OPC_MoveParent,
/* 10723*/   OPC_MoveParent,
/* 10724*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10725*/   OPC_EmitMergeInputChains1_0,
/* 10726*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v4f32:{ *:[v4f32] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v4f32:{ *:[v4f32] }:$src)
/* 10733*/  /*Scope*/ 23, /*->10757*/
/* 10734*/   OPC_CheckChild1Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 10737*/   OPC_MoveChild2,
/* 10738*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10741*/   OPC_RecordChild0, // #2 = $addr
/* 10742*/   OPC_MoveChild0,
/* 10743*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10746*/   OPC_MoveParent,
/* 10747*/   OPC_MoveParent,
/* 10748*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10749*/   OPC_EmitMergeInputChains1_0,
/* 10750*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v2f64:{ *:[v2f64] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v2f64:{ *:[v2f64] }:$src)
/* 10757*/  /*Scope*/ 22, /*->10780*/
/* 10758*/   OPC_CheckChild1Type, /*MVT::v2i64*/78, 
/* 10760*/   OPC_MoveChild2,
/* 10761*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10764*/   OPC_RecordChild0, // #2 = $addr
/* 10765*/   OPC_MoveChild0,
/* 10766*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10769*/   OPC_MoveParent,
/* 10770*/   OPC_MoveParent,
/* 10771*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10772*/   OPC_EmitMergeInputChains1_0,
/* 10773*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v2i64:{ *:[v2i64] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v2i64:{ *:[v2i64] }:$src)
/* 10780*/  /*Scope*/ 22, /*->10803*/
/* 10781*/   OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/* 10783*/   OPC_MoveChild2,
/* 10784*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10787*/   OPC_RecordChild0, // #2 = $addr
/* 10788*/   OPC_MoveChild0,
/* 10789*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10792*/   OPC_MoveParent,
/* 10793*/   OPC_MoveParent,
/* 10794*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10795*/   OPC_EmitMergeInputChains1_0,
/* 10796*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v4i32:{ *:[v4i32] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v4i32:{ *:[v4i32] }:$src)
/* 10803*/  /*Scope*/ 22, /*->10826*/
/* 10804*/   OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/* 10806*/   OPC_MoveChild2,
/* 10807*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10810*/   OPC_RecordChild0, // #2 = $addr
/* 10811*/   OPC_MoveChild0,
/* 10812*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10815*/   OPC_MoveParent,
/* 10816*/   OPC_MoveParent,
/* 10817*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10818*/   OPC_EmitMergeInputChains1_0,
/* 10819*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v16i8:{ *:[v16i8] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v16i8:{ *:[v16i8] }:$src)
/* 10826*/  /*Scope*/ 22, /*->10849*/
/* 10827*/   OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 10829*/   OPC_MoveChild2,
/* 10830*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10833*/   OPC_RecordChild0, // #2 = $addr
/* 10834*/   OPC_MoveChild0,
/* 10835*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10838*/   OPC_MoveParent,
/* 10839*/   OPC_MoveParent,
/* 10840*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 10841*/   OPC_EmitMergeInputChains1_0,
/* 10842*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_V128), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set v8i16:{ *:[v8i16] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_V128 (tglobaladdr:{ *:[i32] }):$addr, v8i16:{ *:[v8i16] }:$src)
/* 10849*/  /*Scope*/ 23, /*->10873*/
/* 10850*/   OPC_CheckChild1Type, /*MVT::funcref*/99|128,1/*227*/, 
/* 10853*/   OPC_MoveChild2,
/* 10854*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10857*/   OPC_RecordChild0, // #2 = $addr
/* 10858*/   OPC_MoveChild0,
/* 10859*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10862*/   OPC_MoveParent,
/* 10863*/   OPC_MoveParent,
/* 10864*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 10865*/   OPC_EmitMergeInputChains1_0,
/* 10866*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set funcref:{ *:[funcref] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_FUNCREF (tglobaladdr:{ *:[i32] }):$addr, funcref:{ *:[funcref] }:$src)
/* 10873*/  /*Scope*/ 23, /*->10897*/
/* 10874*/   OPC_CheckChild1Type, /*MVT::externref*/100|128,1/*228*/, 
/* 10877*/   OPC_MoveChild2,
/* 10878*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10881*/   OPC_RecordChild0, // #2 = $addr
/* 10882*/   OPC_MoveChild0,
/* 10883*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10886*/   OPC_MoveParent,
/* 10887*/   OPC_MoveParent,
/* 10888*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 10889*/   OPC_EmitMergeInputChains1_0,
/* 10890*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_EXTERNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set externref:{ *:[externref] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_EXTERNREF (tglobaladdr:{ *:[i32] }):$addr, externref:{ *:[externref] }:$src)
/* 10897*/  /*Scope*/ 24, /*->10922*/
/* 10898*/   OPC_CheckChild1Type, /*MVT::exnref*/101|128,1/*229*/, 
/* 10901*/   OPC_MoveChild2,
/* 10902*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10905*/   OPC_RecordChild0, // #2 = $addr
/* 10906*/   OPC_MoveChild0,
/* 10907*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10910*/   OPC_MoveParent,
/* 10911*/   OPC_MoveParent,
/* 10912*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/* 10914*/   OPC_EmitMergeInputChains1_0,
/* 10915*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::GLOBAL_SET_EXNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 2/*#Ops*/, 2, 1, 
             // Src: (WebAssemblyglobal_set exnref:{ *:[exnref] }:$src, (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$addr)) - Complexity = 9
             // Dst: (GLOBAL_SET_EXNREF (tglobaladdr:{ *:[i32] }):$addr, exnref:{ *:[exnref] }:$src)
/* 10922*/  0, /*End of Scope*/
/* 10923*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::CALLSEQ_START),// ->10947
/* 10926*/  OPC_RecordNode, // #0 = 'WebAssemblycallseq_start' chained node
/* 10927*/  OPC_RecordChild1, // #1 = $amt
/* 10928*/  OPC_MoveChild1,
/* 10929*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 10932*/  OPC_MoveSibling2,
/* 10933*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 10936*/  OPC_RecordNode, // #2 = $amt2
/* 10937*/  OPC_MoveParent,
/* 10938*/  OPC_EmitMergeInputChains1_0,
/* 10939*/  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADJCALLSTACKDOWN), 0|OPFL_Chain|OPFL_GlueOutput,
                /*MVT::i32*/7, 2/*#Ops*/, 1, 2, 
            // Src: (WebAssemblycallseq_start (timm:{ *:[iPTR] }):$amt, (timm:{ *:[iPTR] }):$amt2) - Complexity = 9
            // Dst: (ADJCALLSTACKDOWN:{ *:[i32] } (timm:{ *:[i32] }):$amt, (timm:{ *:[i32] }):$amt2)
/* 10947*/ /*SwitchOpcode*/ 22, TARGET_VAL(ISD::CALLSEQ_END),// ->10972
/* 10950*/  OPC_RecordNode, // #0 = 'WebAssemblycallseq_end' chained node
/* 10951*/  OPC_CaptureGlueInput,
/* 10952*/  OPC_RecordChild1, // #1 = $amt
/* 10953*/  OPC_MoveChild1,
/* 10954*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 10957*/  OPC_MoveSibling2,
/* 10958*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 10961*/  OPC_RecordNode, // #2 = $amt2
/* 10962*/  OPC_MoveParent,
/* 10963*/  OPC_EmitMergeInputChains1_0,
/* 10964*/  OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::ADJCALLSTACKUP), 0|OPFL_Chain|OPFL_GlueInput|OPFL_GlueOutput,
                /*MVT::i32*/7, 2/*#Ops*/, 1, 2, 
            // Src: (WebAssemblycallseq_end (timm:{ *:[iPTR] }):$amt, (timm:{ *:[iPTR] }):$amt2) - Complexity = 9
            // Dst: (ADJCALLSTACKUP:{ *:[i32] } (timm:{ *:[i32] }):$amt, (timm:{ *:[i32] }):$amt2)
/* 10972*/ /*SwitchOpcode*/ 60, TARGET_VAL(WebAssemblyISD::TABLE_GET),// ->11035
/* 10975*/  OPC_RecordMemRef,
/* 10976*/  OPC_RecordNode, // #0 = 'WebAssemblyTableGet' chained node
/* 10977*/  OPC_MoveChild1,
/* 10978*/  OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 10981*/  OPC_RecordChild0, // #1 = $table
/* 10982*/  OPC_MoveChild0,
/* 10983*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 10986*/  OPC_MoveParent,
/* 10987*/  OPC_MoveParent,
/* 10988*/  OPC_RecordChild2, // #2 = $idx
/* 10989*/  OPC_CheckChild2TypeI32,
/* 10990*/  OPC_SwitchType /*3 cases */, 11, /*MVT::funcref*/99|128,1/*227*/, // ->11005
/* 10994*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 10995*/   OPC_EmitMergeInputChains1_0,
/* 10996*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::TABLE_GET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::funcref*/99|128,1/*227*/, 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblyTableGet:{ *:[funcref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx) - Complexity = 9
             // Dst: (TABLE_GET_FUNCREF:{ *:[funcref] } (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx)
/* 11005*/  /*SwitchType*/ 11, /*MVT::externref*/100|128,1/*228*/, // ->11019
/* 11008*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 11009*/   OPC_EmitMergeInputChains1_0,
/* 11010*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::TABLE_GET_EXTERNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::externref*/100|128,1/*228*/, 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblyTableGet:{ *:[externref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx) - Complexity = 9
             // Dst: (TABLE_GET_EXTERNREF:{ *:[externref] } (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx)
/* 11019*/  /*SwitchType*/ 12, /*MVT::exnref*/101|128,1/*229*/, // ->11034
/* 11022*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/* 11024*/   OPC_EmitMergeInputChains1_0,
/* 11025*/   OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::TABLE_GET_EXNREF), 0|OPFL_Chain|OPFL_MemRefs,
                 /*MVT::exnref*/101|128,1/*229*/, 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblyTableGet:{ *:[exnref] } (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx) - Complexity = 9
             // Dst: (TABLE_GET_EXNREF:{ *:[exnref] } (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx)
/* 11034*/  0, // EndSwitchType
/* 11035*/ /*SwitchOpcode*/ 87, TARGET_VAL(WebAssemblyISD::TABLE_SET),// ->11125
/* 11038*/  OPC_RecordMemRef,
/* 11039*/  OPC_RecordNode, // #0 = 'WebAssemblyTableSet' chained node
/* 11040*/  OPC_Scope, 59, /*->11101*/ // 2 children in Scope
/* 11042*/   OPC_MoveChild1,
/* 11043*/   OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::Wrapper),
/* 11046*/   OPC_RecordChild0, // #1 = $table
/* 11047*/   OPC_MoveChild0,
/* 11048*/   OPC_CheckOpcode, TARGET_VAL(ISD::TargetGlobalAddress),
/* 11051*/   OPC_MoveParent,
/* 11052*/   OPC_MoveParent,
/* 11053*/   OPC_RecordChild2, // #2 = $idx
/* 11054*/   OPC_CheckChild2TypeI32,
/* 11055*/   OPC_RecordChild3, // #3 = $src
/* 11056*/   OPC_Scope, 13, /*->11071*/ // 3 children in Scope
/* 11058*/    OPC_CheckChild3Type, /*MVT::funcref*/99|128,1/*227*/, 
/* 11061*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 11062*/    OPC_EmitMergeInputChains1_0,
/* 11063*/    OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::TABLE_SET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                  3/*#Ops*/, 1, 2, 3, 
              // Src: (WebAssemblyTableSet (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx, funcref:{ *:[funcref] }:$src) - Complexity = 9
              // Dst: (TABLE_SET_FUNCREF (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx, funcref:{ *:[funcref] }:$src)
/* 11071*/   /*Scope*/ 13, /*->11085*/
/* 11072*/    OPC_CheckChild3Type, /*MVT::externref*/100|128,1/*228*/, 
/* 11075*/    OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 11076*/    OPC_EmitMergeInputChains1_0,
/* 11077*/    OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::TABLE_SET_EXTERNREF), 0|OPFL_Chain|OPFL_MemRefs,
                  3/*#Ops*/, 1, 2, 3, 
              // Src: (WebAssemblyTableSet (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx, externref:{ *:[externref] }:$src) - Complexity = 9
              // Dst: (TABLE_SET_EXTERNREF (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx, externref:{ *:[externref] }:$src)
/* 11085*/   /*Scope*/ 14, /*->11100*/
/* 11086*/    OPC_CheckChild3Type, /*MVT::exnref*/101|128,1/*229*/, 
/* 11089*/    OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/* 11091*/    OPC_EmitMergeInputChains1_0,
/* 11092*/    OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::TABLE_SET_EXNREF), 0|OPFL_Chain|OPFL_MemRefs,
                  3/*#Ops*/, 1, 2, 3, 
              // Src: (WebAssemblyTableSet (WebAssemblyWrapper:{ *:[iPTR] } (tglobaladdr:{ *:[iPTR] }):$table), i32:{ *:[i32] }:$idx, exnref:{ *:[exnref] }:$src) - Complexity = 9
              // Dst: (TABLE_SET_EXNREF (tglobaladdr:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx, exnref:{ *:[exnref] }:$src)
/* 11100*/   0, /*End of Scope*/
/* 11101*/  /*Scope*/ 22, /*->11124*/
/* 11102*/   OPC_RecordChild1, // #1 = $table
/* 11103*/   OPC_MoveChild1,
/* 11104*/   OPC_CheckOpcode, TARGET_VAL(ISD::MCSymbol),
/* 11107*/   OPC_MoveParent,
/* 11108*/   OPC_RecordChild2, // #2 = $idx
/* 11109*/   OPC_CheckChild2TypeI32,
/* 11110*/   OPC_RecordChild3, // #3 = $r
/* 11111*/   OPC_CheckChild3Type, /*MVT::funcref*/99|128,1/*227*/, 
/* 11114*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 11115*/   OPC_EmitMergeInputChains1_0,
/* 11116*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::TABLE_SET_FUNCREF), 0|OPFL_Chain|OPFL_MemRefs,
                 3/*#Ops*/, 1, 2, 3, 
             // Src: (WebAssemblyTableSet (mcsym:{ *:[iPTR] }):$table, i32:{ *:[i32] }:$idx, funcref:{ *:[funcref] }:$r) - Complexity = 6
             // Dst: (TABLE_SET_FUNCREF (mcsym:{ *:[i32] }):$table, i32:{ *:[i32] }:$idx, funcref:{ *:[funcref] }:$r)
/* 11124*/  0, /*End of Scope*/
/* 11125*/ /*SwitchOpcode*/ 57, TARGET_VAL(WebAssemblyISD::MEMCPY),// ->11185
/* 11128*/  OPC_RecordNode, // #0 = 'wasm_memcpy' chained node
/* 11129*/  OPC_RecordChild1, // #1 = $src_idx
/* 11130*/  OPC_MoveChild1,
/* 11131*/  OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 11134*/  OPC_CheckTypeI32,
/* 11135*/  OPC_MoveSibling2,
/* 11136*/  OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 11139*/  OPC_RecordNode, // #2 = $dst_idx
/* 11140*/  OPC_CheckTypeI32,
/* 11141*/  OPC_MoveParent,
/* 11142*/  OPC_RecordChild3, // #3 = $dst
/* 11143*/  OPC_Scope, 19, /*->11164*/ // 2 children in Scope
/* 11145*/   OPC_CheckChild3TypeI32,
/* 11146*/   OPC_RecordChild4, // #4 = $src
/* 11147*/   OPC_CheckChild4TypeI32,
/* 11148*/   OPC_RecordChild5, // #5 = $len
/* 11149*/   OPC_CheckChild5TypeI32,
/* 11150*/   OPC_CheckPatternPredicate, 12, // (Subtarget->hasBulkMemory())
/* 11152*/   OPC_EmitMergeInputChains1_0,
/* 11153*/   OPC_EmitConvertToTarget1,
/* 11154*/   OPC_EmitConvertToTarget2,
/* 11155*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::MEMCPY_A32),
                 5/*#Ops*/, 6, 7, 3, 4, 5, 
             // Src: (wasm_memcpy (imm:{ *:[i32] }):$src_idx, (imm:{ *:[i32] }):$dst_idx, I32:{ *:[i32] }:$dst, I32:{ *:[i32] }:$src, I32:{ *:[i32] }:$len) - Complexity = 9
             // Dst: (MEMCPY_A32 (imm:{ *:[i32] }):$src_idx, (imm:{ *:[i32] }):$dst_idx, I32:{ *:[i32] }:$dst, I32:{ *:[i32] }:$src, I32:{ *:[i32] }:$len)
/* 11164*/  /*Scope*/ 19, /*->11184*/
/* 11165*/   OPC_CheckChild3TypeI64,
/* 11166*/   OPC_RecordChild4, // #4 = $src
/* 11167*/   OPC_CheckChild4TypeI64,
/* 11168*/   OPC_RecordChild5, // #5 = $len
/* 11169*/   OPC_CheckChild5TypeI64,
/* 11170*/   OPC_CheckPatternPredicate, 12, // (Subtarget->hasBulkMemory())
/* 11172*/   OPC_EmitMergeInputChains1_0,
/* 11173*/   OPC_EmitConvertToTarget1,
/* 11174*/   OPC_EmitConvertToTarget2,
/* 11175*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::MEMCPY_A64),
                 5/*#Ops*/, 6, 7, 3, 4, 5, 
             // Src: (wasm_memcpy (imm:{ *:[i32] }):$src_idx, (imm:{ *:[i32] }):$dst_idx, I64:{ *:[i64] }:$dst, I64:{ *:[i64] }:$src, I64:{ *:[i64] }:$len) - Complexity = 9
             // Dst: (MEMCPY_A64 (imm:{ *:[i32] }):$src_idx, (imm:{ *:[i32] }):$dst_idx, I64:{ *:[i64] }:$dst, I64:{ *:[i64] }:$src, I64:{ *:[i64] }:$len)
/* 11184*/  0, /*End of Scope*/
/* 11185*/ /*SwitchOpcode*/ 119|128,9/*1271*/, TARGET_VAL(ISD::INTRINSIC_WO_CHAIN),// ->12460
/* 11189*/  OPC_Scope, 49, /*->11240*/ // 39 children in Scope
/* 11191*/   OPC_CheckChild0Integer, 42|128,68|128,1/*25130*/, 
/* 11195*/   OPC_RecordChild1, // #0 = $src
/* 11196*/   OPC_Scope, 20, /*->11218*/ // 2 children in Scope
/* 11198*/    OPC_CheckChild1Type, /*MVT::f32*/12, 
/* 11200*/    OPC_SwitchType /*2 cases */, 6, /*MVT::i32*/7, // ->11209
/* 11203*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_F32),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i32] } 12565:{ *:[iPTR] }, F32:{ *:[f32] }:$src) - Complexity = 8
               // Dst: (I32_TRUNC_S_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 11209*/    /*SwitchType*/ 6, /*MVT::i64*/8, // ->11217
/* 11211*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_F32),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i64] } 12565:{ *:[iPTR] }, F32:{ *:[f32] }:$src) - Complexity = 8
               // Dst: (I64_TRUNC_S_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 11217*/    0, // EndSwitchType
/* 11218*/   /*Scope*/ 20, /*->11239*/
/* 11219*/    OPC_CheckChild1Type, /*MVT::f64*/13, 
/* 11221*/    OPC_SwitchType /*2 cases */, 6, /*MVT::i32*/7, // ->11230
/* 11224*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_F64),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i32] } 12565:{ *:[iPTR] }, F64:{ *:[f64] }:$src) - Complexity = 8
               // Dst: (I32_TRUNC_S_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 11230*/    /*SwitchType*/ 6, /*MVT::i64*/8, // ->11238
/* 11232*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_F64),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i64] } 12565:{ *:[iPTR] }, F64:{ *:[f64] }:$src) - Complexity = 8
               // Dst: (I64_TRUNC_S_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 11238*/    0, // EndSwitchType
/* 11239*/   0, /*End of Scope*/
/* 11240*/  /*Scope*/ 49, /*->11290*/
/* 11241*/   OPC_CheckChild0Integer, 44|128,68|128,1/*25132*/, 
/* 11245*/   OPC_RecordChild1, // #0 = $src
/* 11246*/   OPC_Scope, 20, /*->11268*/ // 2 children in Scope
/* 11248*/    OPC_CheckChild1Type, /*MVT::f32*/12, 
/* 11250*/    OPC_SwitchType /*2 cases */, 6, /*MVT::i32*/7, // ->11259
/* 11253*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_F32),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i32] } 12566:{ *:[iPTR] }, F32:{ *:[f32] }:$src) - Complexity = 8
               // Dst: (I32_TRUNC_U_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 11259*/    /*SwitchType*/ 6, /*MVT::i64*/8, // ->11267
/* 11261*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_F32),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i64] } 12566:{ *:[iPTR] }, F32:{ *:[f32] }:$src) - Complexity = 8
               // Dst: (I64_TRUNC_U_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 11267*/    0, // EndSwitchType
/* 11268*/   /*Scope*/ 20, /*->11289*/
/* 11269*/    OPC_CheckChild1Type, /*MVT::f64*/13, 
/* 11271*/    OPC_SwitchType /*2 cases */, 6, /*MVT::i32*/7, // ->11280
/* 11274*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_F64),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i32] } 12566:{ *:[iPTR] }, F64:{ *:[f64] }:$src) - Complexity = 8
               // Dst: (I32_TRUNC_U_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 11280*/    /*SwitchType*/ 6, /*MVT::i64*/8, // ->11288
/* 11282*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_F64),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (intrinsic_wo_chain:{ *:[i64] } 12566:{ *:[iPTR] }, F64:{ *:[f64] }:$src) - Complexity = 8
               // Dst: (I64_TRUNC_U_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 11288*/    0, // EndSwitchType
/* 11289*/   0, /*End of Scope*/
/* 11290*/  /*Scope*/ 43, /*->11334*/
/* 11291*/   OPC_CheckChild0Integer, 30|128,67|128,1/*24990*/, 
/* 11295*/   OPC_RecordChild1, // #0 = $vec
/* 11296*/   OPC_Scope, 8, /*->11306*/ // 4 children in Scope
/* 11298*/    OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/* 11300*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12495:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (ANYTRUE:{ *:[i32] } V128:{ *:[v16i8] }:$vec)
/* 11306*/   /*Scope*/ 8, /*->11315*/
/* 11307*/    OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 11309*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12495:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (ANYTRUE:{ *:[i32] } V128:{ *:[v8i16] }:$vec)
/* 11315*/   /*Scope*/ 8, /*->11324*/
/* 11316*/    OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/* 11318*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12495:{ *:[iPTR] }, V128:{ *:[v4i32] }:$vec) - Complexity = 8
              // Dst: (ANYTRUE:{ *:[i32] } V128:{ *:[v4i32] }:$vec)
/* 11324*/   /*Scope*/ 8, /*->11333*/
/* 11325*/    OPC_CheckChild1Type, /*MVT::v2i64*/78, 
/* 11327*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ANYTRUE),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12495:{ *:[iPTR] }, V128:{ *:[v2i64] }:$vec) - Complexity = 8
              // Dst: (ANYTRUE:{ *:[i32] } V128:{ *:[v2i64] }:$vec)
/* 11333*/   0, /*End of Scope*/
/* 11334*/  /*Scope*/ 47, /*->11382*/
/* 11335*/   OPC_CheckChild0Integer, 28|128,67|128,1/*24988*/, 
/* 11339*/   OPC_RecordChild1, // #0 = $vec
/* 11340*/   OPC_Scope, 9, /*->11351*/ // 4 children in Scope
/* 11342*/    OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/* 11344*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11345*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I8x16),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12494:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (ALLTRUE_I8x16:{ *:[i32] } V128:{ *:[v16i8] }:$vec)
/* 11351*/   /*Scope*/ 9, /*->11361*/
/* 11352*/    OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 11354*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11355*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I16x8),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12494:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (ALLTRUE_I16x8:{ *:[i32] } V128:{ *:[v8i16] }:$vec)
/* 11361*/   /*Scope*/ 9, /*->11371*/
/* 11362*/    OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/* 11364*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11365*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I32x4),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12494:{ *:[iPTR] }, V128:{ *:[v4i32] }:$vec) - Complexity = 8
              // Dst: (ALLTRUE_I32x4:{ *:[i32] } V128:{ *:[v4i32] }:$vec)
/* 11371*/   /*Scope*/ 9, /*->11381*/
/* 11372*/    OPC_CheckChild1Type, /*MVT::v2i64*/78, 
/* 11374*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11375*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ALLTRUE_I64x2),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12494:{ *:[iPTR] }, V128:{ *:[v2i64] }:$vec) - Complexity = 8
              // Dst: (ALLTRUE_I64x2:{ *:[i32] } V128:{ *:[v2i64] }:$vec)
/* 11381*/   0, /*End of Scope*/
/* 11382*/  /*Scope*/ 47, /*->11430*/
/* 11383*/   OPC_CheckChild0Integer, 34|128,67|128,1/*24994*/, 
/* 11387*/   OPC_RecordChild1, // #0 = $vec
/* 11388*/   OPC_Scope, 9, /*->11399*/ // 4 children in Scope
/* 11390*/    OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/* 11392*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11393*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITMASK_I8x16),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12497:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (BITMASK_I8x16:{ *:[i32] } V128:{ *:[v16i8] }:$vec)
/* 11399*/   /*Scope*/ 9, /*->11409*/
/* 11400*/    OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 11402*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11403*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITMASK_I16x8),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12497:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (BITMASK_I16x8:{ *:[i32] } V128:{ *:[v8i16] }:$vec)
/* 11409*/   /*Scope*/ 9, /*->11419*/
/* 11410*/    OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/* 11412*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11413*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITMASK_I32x4),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12497:{ *:[iPTR] }, V128:{ *:[v4i32] }:$vec) - Complexity = 8
              // Dst: (BITMASK_I32x4:{ *:[i32] } V128:{ *:[v4i32] }:$vec)
/* 11419*/   /*Scope*/ 9, /*->11429*/
/* 11420*/    OPC_CheckChild1Type, /*MVT::v2i64*/78, 
/* 11422*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11423*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITMASK_I64x2),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[i32] } 12497:{ *:[iPTR] }, V128:{ *:[v2i64] }:$vec) - Complexity = 8
              // Dst: (BITMASK_I64x2:{ *:[i32] } V128:{ *:[v2i64] }:$vec)
/* 11429*/   0, /*End of Scope*/
/* 11430*/  /*Scope*/ 11, /*->11442*/
/* 11431*/   OPC_CheckChild0Integer, 88|128,67|128,1/*25048*/, 
/* 11435*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 11436*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_NULL_FUNCREF),
                 /*MVT::funcref*/99|128,1/*227*/, 0/*#Ops*/, 
             // Src: (intrinsic_wo_chain:{ *:[funcref] } 12524:{ *:[iPTR] }) - Complexity = 8
             // Dst: (REF_NULL_FUNCREF:{ *:[funcref] })
/* 11442*/  /*Scope*/ 12, /*->11455*/
/* 11443*/   OPC_CheckChild0Integer, 82|128,67|128,1/*25042*/, 
/* 11447*/   OPC_RecordChild1, // #0 = $ref
/* 11448*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 11449*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_IS_NULL_FUNCREF),
                 /*MVT::i32*/7, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[i32] } 12521:{ *:[iPTR] }, FUNCREF:{ *:[funcref] }:$ref) - Complexity = 8
             // Dst: (REF_IS_NULL_FUNCREF:{ *:[i32] } FUNCREF:{ *:[funcref] }:$ref)
/* 11455*/  /*Scope*/ 11, /*->11467*/
/* 11456*/   OPC_CheckChild0Integer, 86|128,67|128,1/*25046*/, 
/* 11460*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 11461*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_NULL_EXTERNREF),
                 /*MVT::externref*/100|128,1/*228*/, 0/*#Ops*/, 
             // Src: (intrinsic_wo_chain:{ *:[externref] } 12523:{ *:[iPTR] }) - Complexity = 8
             // Dst: (REF_NULL_EXTERNREF:{ *:[externref] })
/* 11467*/  /*Scope*/ 12, /*->11480*/
/* 11468*/   OPC_CheckChild0Integer, 80|128,67|128,1/*25040*/, 
/* 11472*/   OPC_RecordChild1, // #0 = $ref
/* 11473*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 11474*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_IS_NULL_EXTERNREF),
                 /*MVT::i32*/7, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[i32] } 12520:{ *:[iPTR] }, EXTERNREF:{ *:[externref] }:$ref) - Complexity = 8
             // Dst: (REF_IS_NULL_EXTERNREF:{ *:[i32] } EXTERNREF:{ *:[externref] }:$ref)
/* 11480*/  /*Scope*/ 11, /*->11492*/
/* 11481*/   OPC_CheckChild0Integer, 84|128,67|128,1/*25044*/, 
/* 11485*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 11486*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_NULL_EXNREF),
                 /*MVT::exnref*/101|128,1/*229*/, 0/*#Ops*/, 
             // Src: (intrinsic_wo_chain:{ *:[exnref] } 12522:{ *:[iPTR] }) - Complexity = 8
             // Dst: (REF_NULL_EXNREF:{ *:[exnref] })
/* 11492*/  /*Scope*/ 12, /*->11505*/
/* 11493*/   OPC_CheckChild0Integer, 78|128,67|128,1/*25038*/, 
/* 11497*/   OPC_RecordChild1, // #0 = $ref
/* 11498*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 11499*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REF_IS_NULL_EXNREF),
                 /*MVT::i32*/7, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[i32] } 12519:{ *:[iPTR] }, EXNREF:{ *:[exnref] }:$ref) - Complexity = 8
             // Dst: (REF_IS_NULL_EXNREF:{ *:[i32] } EXNREF:{ *:[exnref] }:$ref)
/* 11505*/  /*Scope*/ 23, /*->11529*/
/* 11506*/   OPC_CheckChild0Integer, 46|128,67|128,1/*25006*/, 
/* 11510*/   OPC_RecordChild1, // #0 = $vec
/* 11511*/   OPC_RecordChild2, // #1 = $idx
/* 11512*/   OPC_MoveChild2,
/* 11513*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 11516*/   OPC_CheckPredicate, 13, // Predicate_LaneIdx8
/* 11518*/   OPC_MoveParent,
/* 11519*/   OPC_CheckPatternPredicate, 17, // (Subtarget->hasFP16())
/* 11521*/   OPC_EmitConvertToTarget1,
/* 11522*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_F16x8),
                 /*MVT::f32*/12, 2/*#Ops*/, 0, 2, 
             // Src: (intrinsic_wo_chain:{ *:[f32] } 12503:{ *:[iPTR] }, V128:{ *:[v8f16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx) - Complexity = 12
             // Dst: (EXTRACT_LANE_F16x8:{ *:[f32] } V128:{ *:[v8f16] }:$vec, (imm:{ *:[i32] }):$idx)
/* 11529*/  /*Scope*/ 13, /*->11543*/
/* 11530*/   OPC_CheckChild0Integer, 0|128,68|128,1/*25088*/, 
/* 11534*/   OPC_RecordChild1, // #0 = $src
/* 11535*/   OPC_RecordChild2, // #1 = $mask
/* 11536*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SWIZZLE),
                 /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12544:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask) - Complexity = 8
             // Dst: (SWIZZLE:{ *:[v16i8] } ?:{ *:[v16i8] }:$src, ?:{ *:[v16i8] }:$mask)
/* 11543*/  /*Scope*/ 120, /*->11664*/
/* 11544*/   OPC_CheckChild0Integer, 36|128,67|128,1/*24996*/, 
/* 11548*/   OPC_RecordChild1, // #0 = $v1
/* 11549*/   OPC_SwitchType /*6 cases */, 16, /*MVT::v16i8*/39, // ->11568
/* 11552*/    OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/* 11554*/    OPC_RecordChild2, // #1 = $v2
/* 11555*/    OPC_CheckChild2Type, /*MVT::v16i8*/39, 
/* 11557*/    OPC_RecordChild3, // #2 = $c
/* 11558*/    OPC_CheckChild3Type, /*MVT::v16i8*/39, 
/* 11560*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v16i8*/39, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12498:{ *:[iPTR] }, V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 11568*/   /*SwitchType*/ 16, /*MVT::v8i16*/50, // ->11586
/* 11570*/    OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 11572*/    OPC_RecordChild2, // #1 = $v2
/* 11573*/    OPC_CheckChild2Type, /*MVT::v8i16*/50, 
/* 11575*/    OPC_RecordChild3, // #2 = $c
/* 11576*/    OPC_CheckChild3Type, /*MVT::v8i16*/50, 
/* 11578*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v8i16*/50, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12498:{ *:[iPTR] }, V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 11586*/   /*SwitchType*/ 16, /*MVT::v4i32*/60, // ->11604
/* 11588*/    OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/* 11590*/    OPC_RecordChild2, // #1 = $v2
/* 11591*/    OPC_CheckChild2Type, /*MVT::v4i32*/60, 
/* 11593*/    OPC_RecordChild3, // #2 = $c
/* 11594*/    OPC_CheckChild3Type, /*MVT::v4i32*/60, 
/* 11596*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v4i32*/60, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12498:{ *:[iPTR] }, V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 11604*/   /*SwitchType*/ 16, /*MVT::v2i64*/78, // ->11622
/* 11606*/    OPC_CheckChild1Type, /*MVT::v2i64*/78, 
/* 11608*/    OPC_RecordChild2, // #1 = $v2
/* 11609*/    OPC_CheckChild2Type, /*MVT::v2i64*/78, 
/* 11611*/    OPC_RecordChild3, // #2 = $c
/* 11612*/    OPC_CheckChild3Type, /*MVT::v2i64*/78, 
/* 11614*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v2i64*/78, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2i64] } 12498:{ *:[iPTR] }, V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 11622*/   /*SwitchType*/ 16, /*MVT::v4f32*/111, // ->11640
/* 11624*/    OPC_CheckChild1Type, /*MVT::v4f32*/111, 
/* 11626*/    OPC_RecordChild2, // #1 = $v2
/* 11627*/    OPC_CheckChild2Type, /*MVT::v4f32*/111, 
/* 11629*/    OPC_RecordChild3, // #2 = $c
/* 11630*/    OPC_CheckChild3Type, /*MVT::v4f32*/111, 
/* 11632*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v4f32*/111, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 12498:{ *:[iPTR] }, V128:{ *:[v4f32] }:$v1, V128:{ *:[v4f32] }:$v2, V128:{ *:[v4f32] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v4f32] } ?:{ *:[v4f32] }:$v1, ?:{ *:[v4f32] }:$v2, ?:{ *:[v4f32] }:$c)
/* 11640*/   /*SwitchType*/ 20, /*MVT::v2f64*/1|128,1/*129*/, // ->11663
/* 11643*/    OPC_CheckChild1Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 11646*/    OPC_RecordChild2, // #1 = $v2
/* 11647*/    OPC_CheckChild2Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 11650*/    OPC_RecordChild3, // #2 = $c
/* 11651*/    OPC_CheckChild3Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 11654*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v2f64*/1|128,1/*129*/, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 12498:{ *:[iPTR] }, V128:{ *:[v2f64] }:$v1, V128:{ *:[v2f64] }:$v2, V128:{ *:[v2f64] }:$c) - Complexity = 8
              // Dst: (BITSELECT:{ *:[v2f64] } ?:{ *:[v2f64] }:$v1, ?:{ *:[v2f64] }:$v2, ?:{ *:[v2f64] }:$c)
/* 11663*/   0, // EndSwitchType
/* 11664*/  /*Scope*/ 37, /*->11702*/
/* 11665*/   OPC_CheckChild0Integer, 32|128,67|128,1/*24992*/, 
/* 11669*/   OPC_RecordChild1, // #0 = $lhs
/* 11670*/   OPC_SwitchType /*2 cases */, 13, /*MVT::v16i8*/39, // ->11686
/* 11673*/    OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/* 11675*/    OPC_RecordChild2, // #1 = $rhs
/* 11676*/    OPC_CheckChild2Type, /*MVT::v16i8*/39, 
/* 11678*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11679*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I8x16),
                  /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12496:{ *:[iPTR] }, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 8
              // Dst: (AVGR_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 11686*/   /*SwitchType*/ 13, /*MVT::v8i16*/50, // ->11701
/* 11688*/    OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 11690*/    OPC_RecordChild2, // #1 = $rhs
/* 11691*/    OPC_CheckChild2Type, /*MVT::v8i16*/50, 
/* 11693*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11694*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I16x8),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12496:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
              // Dst: (AVGR_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 11701*/   0, // EndSwitchType
/* 11702*/  /*Scope*/ 14, /*->11717*/
/* 11703*/   OPC_CheckChild0Integer, 40|128,67|128,1/*25000*/, 
/* 11707*/   OPC_RecordChild1, // #0 = $lhs
/* 11708*/   OPC_RecordChild2, // #1 = $rhs
/* 11709*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11710*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DOT),
                 /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12500:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
             // Dst: (DOT:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 11717*/  /*Scope*/ 37, /*->11755*/
/* 11718*/   OPC_CheckChild0Integer, 68|128,67|128,1/*25028*/, 
/* 11722*/   OPC_RecordChild1, // #0 = $low
/* 11723*/   OPC_SwitchType /*2 cases */, 13, /*MVT::v16i8*/39, // ->11739
/* 11726*/    OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 11728*/    OPC_RecordChild2, // #1 = $high
/* 11729*/    OPC_CheckChild2Type, /*MVT::v8i16*/50, 
/* 11731*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11732*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_S_I8x16),
                  /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12514:{ *:[iPTR] }, V128:{ *:[v8i16] }:$low, V128:{ *:[v8i16] }:$high) - Complexity = 8
              // Dst: (NARROW_S_I8x16:{ *:[v16i8] } V128:{ *:[v8i16] }:$low, V128:{ *:[v8i16] }:$high)
/* 11739*/   /*SwitchType*/ 13, /*MVT::v8i16*/50, // ->11754
/* 11741*/    OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/* 11743*/    OPC_RecordChild2, // #1 = $high
/* 11744*/    OPC_CheckChild2Type, /*MVT::v4i32*/60, 
/* 11746*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11747*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_S_I16x8),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12514:{ *:[iPTR] }, V128:{ *:[v4i32] }:$low, V128:{ *:[v4i32] }:$high) - Complexity = 8
              // Dst: (NARROW_S_I16x8:{ *:[v8i16] } V128:{ *:[v4i32] }:$low, V128:{ *:[v4i32] }:$high)
/* 11754*/   0, // EndSwitchType
/* 11755*/  /*Scope*/ 37, /*->11793*/
/* 11756*/   OPC_CheckChild0Integer, 70|128,67|128,1/*25030*/, 
/* 11760*/   OPC_RecordChild1, // #0 = $low
/* 11761*/   OPC_SwitchType /*2 cases */, 13, /*MVT::v16i8*/39, // ->11777
/* 11764*/    OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 11766*/    OPC_RecordChild2, // #1 = $high
/* 11767*/    OPC_CheckChild2Type, /*MVT::v8i16*/50, 
/* 11769*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11770*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_U_I8x16),
                  /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12515:{ *:[iPTR] }, V128:{ *:[v8i16] }:$low, V128:{ *:[v8i16] }:$high) - Complexity = 8
              // Dst: (NARROW_U_I8x16:{ *:[v16i8] } V128:{ *:[v8i16] }:$low, V128:{ *:[v8i16] }:$high)
/* 11777*/   /*SwitchType*/ 13, /*MVT::v8i16*/50, // ->11792
/* 11779*/    OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/* 11781*/    OPC_RecordChild2, // #1 = $high
/* 11782*/    OPC_CheckChild2Type, /*MVT::v4i32*/60, 
/* 11784*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11785*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_U_I16x8),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12515:{ *:[iPTR] }, V128:{ *:[v4i32] }:$low, V128:{ *:[v4i32] }:$high) - Complexity = 8
              // Dst: (NARROW_U_I16x8:{ *:[v8i16] } V128:{ *:[v4i32] }:$low, V128:{ *:[v4i32] }:$high)
/* 11792*/   0, // EndSwitchType
/* 11793*/  /*Scope*/ 29, /*->11823*/
/* 11794*/   OPC_CheckChild0Integer, 42|128,67|128,1/*25002*/, 
/* 11798*/   OPC_RecordChild1, // #0 = $vec
/* 11799*/   OPC_SwitchType /*2 cases */, 9, /*MVT::v8i16*/50, // ->11811
/* 11802*/    OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/* 11804*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11805*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_extadd_pairwise_signed_I16x8),
                  /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12501:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (int_wasm_extadd_pairwise_signed_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 11811*/   /*SwitchType*/ 9, /*MVT::v4i32*/60, // ->11822
/* 11813*/    OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 11815*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11816*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_extadd_pairwise_signed_I32x4),
                  /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12501:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (int_wasm_extadd_pairwise_signed_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 11822*/   0, // EndSwitchType
/* 11823*/  /*Scope*/ 29, /*->11853*/
/* 11824*/   OPC_CheckChild0Integer, 44|128,67|128,1/*25004*/, 
/* 11828*/   OPC_RecordChild1, // #0 = $vec
/* 11829*/   OPC_SwitchType /*2 cases */, 9, /*MVT::v8i16*/50, // ->11841
/* 11832*/    OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/* 11834*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11835*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_extadd_pairwise_unsigned_I16x8),
                  /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12502:{ *:[iPTR] }, V128:{ *:[v16i8] }:$vec) - Complexity = 8
              // Dst: (int_wasm_extadd_pairwise_unsigned_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 11841*/   /*SwitchType*/ 9, /*MVT::v4i32*/60, // ->11852
/* 11843*/    OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 11845*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11846*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_extadd_pairwise_unsigned_I32x4),
                  /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
              // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12502:{ *:[iPTR] }, V128:{ *:[v8i16] }:$vec) - Complexity = 8
              // Dst: (int_wasm_extadd_pairwise_unsigned_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 11852*/   0, // EndSwitchType
/* 11853*/  /*Scope*/ 14, /*->11868*/
/* 11854*/   OPC_CheckChild0Integer, 76|128,67|128,1/*25036*/, 
/* 11858*/   OPC_RecordChild1, // #0 = $lhs
/* 11859*/   OPC_RecordChild2, // #1 = $rhs
/* 11860*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 11861*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::Q15MULR_SAT_S_I16x8),
                 /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12518:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
             // Dst: (Q15MULR_SAT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 11868*/  /*Scope*/ 14, /*->11883*/
/* 11869*/   OPC_CheckChild0Integer, 108|128,67|128,1/*25068*/, 
/* 11873*/   OPC_RecordChild1, // #0 = $src
/* 11874*/   OPC_RecordChild2, // #1 = $mask
/* 11875*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11876*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::RELAXED_SWIZZLE),
                 /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12534:{ *:[iPTR] }, V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask) - Complexity = 8
             // Dst: (RELAXED_SWIZZLE:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask)
/* 11883*/  /*Scope*/ 12, /*->11896*/
/* 11884*/   OPC_CheckChild0Integer, 110|128,67|128,1/*25070*/, 
/* 11888*/   OPC_RecordChild1, // #0 = $vec
/* 11889*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11890*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_relaxed_trunc_signed_I32x4),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12535:{ *:[iPTR] }, V128:{ *:[v4f32] }:$vec) - Complexity = 8
             // Dst: (int_wasm_relaxed_trunc_signed_I32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec)
/* 11896*/  /*Scope*/ 12, /*->11909*/
/* 11897*/   OPC_CheckChild0Integer, 114|128,67|128,1/*25074*/, 
/* 11901*/   OPC_RecordChild1, // #0 = $vec
/* 11902*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11903*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_relaxed_trunc_unsigned_I32x4),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12537:{ *:[iPTR] }, V128:{ *:[v4f32] }:$vec) - Complexity = 8
             // Dst: (int_wasm_relaxed_trunc_unsigned_I32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec)
/* 11909*/  /*Scope*/ 12, /*->11922*/
/* 11910*/   OPC_CheckChild0Integer, 112|128,67|128,1/*25072*/, 
/* 11914*/   OPC_RecordChild1, // #0 = $vec
/* 11915*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11916*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_relaxed_trunc_signed_zero_I32x4),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12536:{ *:[iPTR] }, V128:{ *:[v2f64] }:$vec) - Complexity = 8
             // Dst: (int_wasm_relaxed_trunc_signed_zero_I32x4:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec)
/* 11922*/  /*Scope*/ 12, /*->11935*/
/* 11923*/   OPC_CheckChild0Integer, 116|128,67|128,1/*25076*/, 
/* 11927*/   OPC_RecordChild1, // #0 = $vec
/* 11928*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11929*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::int_wasm_relaxed_trunc_unsigned_zero_I32x4),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12538:{ *:[iPTR] }, V128:{ *:[v2f64] }:$vec) - Complexity = 8
             // Dst: (int_wasm_relaxed_trunc_unsigned_zero_I32x4:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec)
/* 11935*/  /*Scope*/ 83, /*->12019*/
/* 11936*/   OPC_CheckChild0Integer, 96|128,67|128,1/*25056*/, 
/* 11940*/   OPC_RecordChild1, // #0 = $a
/* 11941*/   OPC_SwitchType /*4 cases */, 17, /*MVT::v16i8*/39, // ->11961
/* 11944*/    OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/* 11946*/    OPC_RecordChild2, // #1 = $b
/* 11947*/    OPC_CheckChild2Type, /*MVT::v16i8*/39, 
/* 11949*/    OPC_RecordChild3, // #2 = $c
/* 11950*/    OPC_CheckChild3Type, /*MVT::v16i8*/39, 
/* 11952*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11953*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LANESELECT_I8x16),
                  /*MVT::v16i8*/39, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v16i8] } 12528:{ *:[iPTR] }, V128:{ *:[v16i8] }:$a, V128:{ *:[v16i8] }:$b, V128:{ *:[v16i8] }:$c) - Complexity = 8
              // Dst: (LANESELECT_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$a, V128:{ *:[v16i8] }:$b, V128:{ *:[v16i8] }:$c)
/* 11961*/   /*SwitchType*/ 17, /*MVT::v8i16*/50, // ->11980
/* 11963*/    OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 11965*/    OPC_RecordChild2, // #1 = $b
/* 11966*/    OPC_CheckChild2Type, /*MVT::v8i16*/50, 
/* 11968*/    OPC_RecordChild3, // #2 = $c
/* 11969*/    OPC_CheckChild3Type, /*MVT::v8i16*/50, 
/* 11971*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11972*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LANESELECT_I16x8),
                  /*MVT::v8i16*/50, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12528:{ *:[iPTR] }, V128:{ *:[v8i16] }:$a, V128:{ *:[v8i16] }:$b, V128:{ *:[v8i16] }:$c) - Complexity = 8
              // Dst: (LANESELECT_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$a, V128:{ *:[v8i16] }:$b, V128:{ *:[v8i16] }:$c)
/* 11980*/   /*SwitchType*/ 17, /*MVT::v4i32*/60, // ->11999
/* 11982*/    OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/* 11984*/    OPC_RecordChild2, // #1 = $b
/* 11985*/    OPC_CheckChild2Type, /*MVT::v4i32*/60, 
/* 11987*/    OPC_RecordChild3, // #2 = $c
/* 11988*/    OPC_CheckChild3Type, /*MVT::v4i32*/60, 
/* 11990*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 11991*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LANESELECT_I32x4),
                  /*MVT::v4i32*/60, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12528:{ *:[iPTR] }, V128:{ *:[v4i32] }:$a, V128:{ *:[v4i32] }:$b, V128:{ *:[v4i32] }:$c) - Complexity = 8
              // Dst: (LANESELECT_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$a, V128:{ *:[v4i32] }:$b, V128:{ *:[v4i32] }:$c)
/* 11999*/   /*SwitchType*/ 17, /*MVT::v2i64*/78, // ->12018
/* 12001*/    OPC_CheckChild1Type, /*MVT::v2i64*/78, 
/* 12003*/    OPC_RecordChild2, // #1 = $b
/* 12004*/    OPC_CheckChild2Type, /*MVT::v2i64*/78, 
/* 12006*/    OPC_RecordChild3, // #2 = $c
/* 12007*/    OPC_CheckChild3Type, /*MVT::v2i64*/78, 
/* 12009*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12010*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::LANESELECT_I64x2),
                  /*MVT::v2i64*/78, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2i64] } 12528:{ *:[iPTR] }, V128:{ *:[v2i64] }:$a, V128:{ *:[v2i64] }:$b, V128:{ *:[v2i64] }:$c) - Complexity = 8
              // Dst: (LANESELECT_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$a, V128:{ *:[v2i64] }:$b, V128:{ *:[v2i64] }:$c)
/* 12018*/   0, // EndSwitchType
/* 12019*/  /*Scope*/ 14, /*->12034*/
/* 12020*/   OPC_CheckChild0Integer, 106|128,67|128,1/*25066*/, 
/* 12024*/   OPC_RecordChild1, // #0 = $lhs
/* 12025*/   OPC_RecordChild2, // #1 = $rhs
/* 12026*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12027*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::RELAXED_Q15MULR_S_I16x8),
                 /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12533:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 8
             // Dst: (RELAXED_Q15MULR_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 12034*/  /*Scope*/ 14, /*->12049*/
/* 12035*/   OPC_CheckChild0Integer, 94|128,67|128,1/*25054*/, 
/* 12039*/   OPC_RecordChild1, // #0 = $lhs
/* 12040*/   OPC_RecordChild2, // #1 = $rhs
/* 12041*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12042*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::RELAXED_DOT),
                 /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
             // Src: (intrinsic_wo_chain:{ *:[v8i16] } 12527:{ *:[iPTR] }, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 8
             // Dst: (RELAXED_DOT:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 12049*/  /*Scope*/ 16, /*->12066*/
/* 12050*/   OPC_CheckChild0Integer, 92|128,67|128,1/*25052*/, 
/* 12054*/   OPC_RecordChild1, // #0 = $lhs
/* 12055*/   OPC_RecordChild2, // #1 = $rhs
/* 12056*/   OPC_RecordChild3, // #2 = $acc
/* 12057*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12058*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::RELAXED_DOT_ADD),
                 /*MVT::v4i32*/60, 3/*#Ops*/, 0, 1, 2, 
             // Src: (intrinsic_wo_chain:{ *:[v4i32] } 12526:{ *:[iPTR] }, V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, V128:{ *:[v4i32] }:$acc) - Complexity = 8
             // Dst: (RELAXED_DOT_ADD:{ *:[v4i32] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs, V128:{ *:[v4i32] }:$acc)
/* 12066*/  /*Scope*/ 25, /*->12092*/
/* 12067*/   OPC_CheckChild0Integer, 118|128,67|128,1/*25078*/, 
/* 12071*/   OPC_RecordChild1, // #0 = $vec
/* 12072*/   OPC_RecordChild2, // #1 = $idx
/* 12073*/   OPC_MoveChild2,
/* 12074*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12077*/   OPC_CheckPredicate, 13, // Predicate_LaneIdx8
/* 12079*/   OPC_MoveParent,
/* 12080*/   OPC_RecordChild3, // #2 = $x
/* 12081*/   OPC_CheckPatternPredicate, 17, // (Subtarget->hasFP16())
/* 12083*/   OPC_EmitConvertToTarget1,
/* 12084*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_F16x8),
                 /*MVT::v8f16*/92, 3/*#Ops*/, 0, 3, 2, 
             // Src: (intrinsic_wo_chain:{ *:[v8f16] } 12539:{ *:[iPTR] }, V128:{ *:[v8f16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx, F32:{ *:[f32] }:$x) - Complexity = 12
             // Dst: (REPLACE_LANE_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$vec, (imm:{ *:[i32] }):$idx, F32:{ *:[f32] }:$x)
/* 12092*/  /*Scope*/ 13, /*->12106*/
/* 12093*/   OPC_CheckChild0Integer, 124|128,67|128,1/*25084*/, 
/* 12097*/   OPC_RecordChild1, // #0 = $x
/* 12098*/   OPC_CheckPatternPredicate, 17, // (Subtarget->hasFP16())
/* 12100*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_F16x8),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (intrinsic_wo_chain:{ *:[v8f16] } 12542:{ *:[iPTR] }, F32:{ *:[f32] }:$x) - Complexity = 8
             // Dst: (SPLAT_F16x8:{ *:[v8f16] } F32:{ *:[f32] }:$x)
/* 12106*/  /*Scope*/ 53, /*->12160*/
/* 12107*/   OPC_CheckChild0Integer, 74|128,67|128,1/*25034*/, 
/* 12111*/   OPC_RecordChild1, // #0 = $lhs
/* 12112*/   OPC_SwitchType /*3 cases */, 12, /*MVT::v4f32*/111, // ->12127
/* 12115*/    OPC_CheckChild1Type, /*MVT::v4f32*/111, 
/* 12117*/    OPC_RecordChild2, // #1 = $rhs
/* 12118*/    OPC_CheckChild2Type, /*MVT::v4f32*/111, 
/* 12120*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                  /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 12517:{ *:[iPTR] }, V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 8
              // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 12127*/   /*SwitchType*/ 15, /*MVT::v2f64*/1|128,1/*129*/, // ->12145
/* 12130*/    OPC_CheckChild1Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 12133*/    OPC_RecordChild2, // #1 = $rhs
/* 12134*/    OPC_CheckChild2Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 12137*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                  /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 12517:{ *:[iPTR] }, V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 8
              // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 12145*/   /*SwitchType*/ 12, /*MVT::v8f16*/92, // ->12159
/* 12147*/    OPC_CheckChild1Type, /*MVT::v8f16*/92, 
/* 12149*/    OPC_RecordChild2, // #1 = $rhs
/* 12150*/    OPC_CheckChild2Type, /*MVT::v8f16*/92, 
/* 12152*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                  /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8f16] } 12517:{ *:[iPTR] }, V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 8
              // Dst: (PMIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 12159*/   0, // EndSwitchType
/* 12160*/  /*Scope*/ 53, /*->12214*/
/* 12161*/   OPC_CheckChild0Integer, 72|128,67|128,1/*25032*/, 
/* 12165*/   OPC_RecordChild1, // #0 = $lhs
/* 12166*/   OPC_SwitchType /*3 cases */, 12, /*MVT::v4f32*/111, // ->12181
/* 12169*/    OPC_CheckChild1Type, /*MVT::v4f32*/111, 
/* 12171*/    OPC_RecordChild2, // #1 = $rhs
/* 12172*/    OPC_CheckChild2Type, /*MVT::v4f32*/111, 
/* 12174*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                  /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 12516:{ *:[iPTR] }, V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 8
              // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 12181*/   /*SwitchType*/ 15, /*MVT::v2f64*/1|128,1/*129*/, // ->12199
/* 12184*/    OPC_CheckChild1Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 12187*/    OPC_RecordChild2, // #1 = $rhs
/* 12188*/    OPC_CheckChild2Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 12191*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                  /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 12516:{ *:[iPTR] }, V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 8
              // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 12199*/   /*SwitchType*/ 12, /*MVT::v8f16*/92, // ->12213
/* 12201*/    OPC_CheckChild1Type, /*MVT::v8f16*/92, 
/* 12203*/    OPC_RecordChild2, // #1 = $rhs
/* 12204*/    OPC_CheckChild2Type, /*MVT::v8f16*/92, 
/* 12206*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                  /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v8f16] } 12516:{ *:[iPTR] }, V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 8
              // Dst: (PMAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 12213*/   0, // EndSwitchType
/* 12214*/  /*Scope*/ 71, /*->12286*/
/* 12215*/   OPC_CheckChild0Integer, 98|128,67|128,1/*25058*/, 
/* 12219*/   OPC_RecordChild1, // #0 = $a
/* 12220*/   OPC_SwitchType /*3 cases */, 18, /*MVT::v4f32*/111, // ->12241
/* 12223*/    OPC_CheckChild1Type, /*MVT::v4f32*/111, 
/* 12225*/    OPC_RecordChild2, // #1 = $b
/* 12226*/    OPC_CheckChild2Type, /*MVT::v4f32*/111, 
/* 12228*/    OPC_RecordChild3, // #2 = $c
/* 12229*/    OPC_CheckChild3Type, /*MVT::v4f32*/111, 
/* 12231*/    OPC_CheckPatternPredicate, 13, // (Subtarget->hasRelaxedSIMD()) && (Subtarget->hasSIMD128())
/* 12233*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MADD_F32x4),
                  /*MVT::v4f32*/111, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 12529:{ *:[iPTR] }, V128:{ *:[v4f32] }:$a, V128:{ *:[v4f32] }:$b, V128:{ *:[v4f32] }:$c) - Complexity = 8
              // Dst: (MADD_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$a, V128:{ *:[v4f32] }:$b, V128:{ *:[v4f32] }:$c)
/* 12241*/   /*SwitchType*/ 22, /*MVT::v2f64*/1|128,1/*129*/, // ->12266
/* 12244*/    OPC_CheckChild1Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 12247*/    OPC_RecordChild2, // #1 = $b
/* 12248*/    OPC_CheckChild2Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 12251*/    OPC_RecordChild3, // #2 = $c
/* 12252*/    OPC_CheckChild3Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 12255*/    OPC_CheckPatternPredicate, 13, // (Subtarget->hasRelaxedSIMD()) && (Subtarget->hasSIMD128())
/* 12257*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MADD_F64x2),
                  /*MVT::v2f64*/1|128,1/*129*/, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 12529:{ *:[iPTR] }, V128:{ *:[v2f64] }:$a, V128:{ *:[v2f64] }:$b, V128:{ *:[v2f64] }:$c) - Complexity = 8
              // Dst: (MADD_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$a, V128:{ *:[v2f64] }:$b, V128:{ *:[v2f64] }:$c)
/* 12266*/   /*SwitchType*/ 17, /*MVT::v8f16*/92, // ->12285
/* 12268*/    OPC_CheckChild1Type, /*MVT::v8f16*/92, 
/* 12270*/    OPC_RecordChild2, // #1 = $b
/* 12271*/    OPC_CheckChild2Type, /*MVT::v8f16*/92, 
/* 12273*/    OPC_RecordChild3, // #2 = $c
/* 12274*/    OPC_CheckChild3Type, /*MVT::v8f16*/92, 
/* 12276*/    OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 12277*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MADD_F16x8),
                  /*MVT::v8f16*/92, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v8f16] } 12529:{ *:[iPTR] }, V128:{ *:[v8f16] }:$a, V128:{ *:[v8f16] }:$b, V128:{ *:[v8f16] }:$c) - Complexity = 8
              // Dst: (MADD_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$a, V128:{ *:[v8f16] }:$b, V128:{ *:[v8f16] }:$c)
/* 12285*/   0, // EndSwitchType
/* 12286*/  /*Scope*/ 71, /*->12358*/
/* 12287*/   OPC_CheckChild0Integer, 104|128,67|128,1/*25064*/, 
/* 12291*/   OPC_RecordChild1, // #0 = $a
/* 12292*/   OPC_SwitchType /*3 cases */, 18, /*MVT::v4f32*/111, // ->12313
/* 12295*/    OPC_CheckChild1Type, /*MVT::v4f32*/111, 
/* 12297*/    OPC_RecordChild2, // #1 = $b
/* 12298*/    OPC_CheckChild2Type, /*MVT::v4f32*/111, 
/* 12300*/    OPC_RecordChild3, // #2 = $c
/* 12301*/    OPC_CheckChild3Type, /*MVT::v4f32*/111, 
/* 12303*/    OPC_CheckPatternPredicate, 13, // (Subtarget->hasRelaxedSIMD()) && (Subtarget->hasSIMD128())
/* 12305*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NMADD_F32x4),
                  /*MVT::v4f32*/111, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 12532:{ *:[iPTR] }, V128:{ *:[v4f32] }:$a, V128:{ *:[v4f32] }:$b, V128:{ *:[v4f32] }:$c) - Complexity = 8
              // Dst: (NMADD_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$a, V128:{ *:[v4f32] }:$b, V128:{ *:[v4f32] }:$c)
/* 12313*/   /*SwitchType*/ 22, /*MVT::v2f64*/1|128,1/*129*/, // ->12338
/* 12316*/    OPC_CheckChild1Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 12319*/    OPC_RecordChild2, // #1 = $b
/* 12320*/    OPC_CheckChild2Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 12323*/    OPC_RecordChild3, // #2 = $c
/* 12324*/    OPC_CheckChild3Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 12327*/    OPC_CheckPatternPredicate, 13, // (Subtarget->hasRelaxedSIMD()) && (Subtarget->hasSIMD128())
/* 12329*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NMADD_F64x2),
                  /*MVT::v2f64*/1|128,1/*129*/, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 12532:{ *:[iPTR] }, V128:{ *:[v2f64] }:$a, V128:{ *:[v2f64] }:$b, V128:{ *:[v2f64] }:$c) - Complexity = 8
              // Dst: (NMADD_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$a, V128:{ *:[v2f64] }:$b, V128:{ *:[v2f64] }:$c)
/* 12338*/   /*SwitchType*/ 17, /*MVT::v8f16*/92, // ->12357
/* 12340*/    OPC_CheckChild1Type, /*MVT::v8f16*/92, 
/* 12342*/    OPC_RecordChild2, // #1 = $b
/* 12343*/    OPC_CheckChild2Type, /*MVT::v8f16*/92, 
/* 12345*/    OPC_RecordChild3, // #2 = $c
/* 12346*/    OPC_CheckChild3Type, /*MVT::v8f16*/92, 
/* 12348*/    OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 12349*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NMADD_F16x8),
                  /*MVT::v8f16*/92, 3/*#Ops*/, 0, 1, 2, 
              // Src: (intrinsic_wo_chain:{ *:[v8f16] } 12532:{ *:[iPTR] }, V128:{ *:[v8f16] }:$a, V128:{ *:[v8f16] }:$b, V128:{ *:[v8f16] }:$c) - Complexity = 8
              // Dst: (NMADD_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$a, V128:{ *:[v8f16] }:$b, V128:{ *:[v8f16] }:$c)
/* 12357*/   0, // EndSwitchType
/* 12358*/  /*Scope*/ 41, /*->12400*/
/* 12359*/   OPC_CheckChild0Integer, 102|128,67|128,1/*25062*/, 
/* 12363*/   OPC_RecordChild1, // #0 = $lhs
/* 12364*/   OPC_SwitchType /*2 cases */, 13, /*MVT::v4f32*/111, // ->12380
/* 12367*/    OPC_CheckChild1Type, /*MVT::v4f32*/111, 
/* 12369*/    OPC_RecordChild2, // #1 = $rhs
/* 12370*/    OPC_CheckChild2Type, /*MVT::v4f32*/111, 
/* 12372*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12373*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SIMD_RELAXED_FMIN_F32x4),
                  /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 12531:{ *:[iPTR] }, V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 8
              // Dst: (SIMD_RELAXED_FMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 12380*/   /*SwitchType*/ 16, /*MVT::v2f64*/1|128,1/*129*/, // ->12399
/* 12383*/    OPC_CheckChild1Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 12386*/    OPC_RecordChild2, // #1 = $rhs
/* 12387*/    OPC_CheckChild2Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 12390*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12391*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SIMD_RELAXED_FMIN_F64x2),
                  /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 12531:{ *:[iPTR] }, V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 8
              // Dst: (SIMD_RELAXED_FMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 12399*/   0, // EndSwitchType
/* 12400*/  /*Scope*/ 41, /*->12442*/
/* 12401*/   OPC_CheckChild0Integer, 100|128,67|128,1/*25060*/, 
/* 12405*/   OPC_RecordChild1, // #0 = $lhs
/* 12406*/   OPC_SwitchType /*2 cases */, 13, /*MVT::v4f32*/111, // ->12422
/* 12409*/    OPC_CheckChild1Type, /*MVT::v4f32*/111, 
/* 12411*/    OPC_RecordChild2, // #1 = $rhs
/* 12412*/    OPC_CheckChild2Type, /*MVT::v4f32*/111, 
/* 12414*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12415*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SIMD_RELAXED_FMAX_F32x4),
                  /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v4f32] } 12530:{ *:[iPTR] }, V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 8
              // Dst: (SIMD_RELAXED_FMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 12422*/   /*SwitchType*/ 16, /*MVT::v2f64*/1|128,1/*129*/, // ->12441
/* 12425*/    OPC_CheckChild1Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 12428*/    OPC_RecordChild2, // #1 = $rhs
/* 12429*/    OPC_CheckChild2Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 12432*/    OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12433*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SIMD_RELAXED_FMAX_F64x2),
                  /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
              // Src: (intrinsic_wo_chain:{ *:[v2f64] } 12530:{ *:[iPTR] }, V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 8
              // Dst: (SIMD_RELAXED_FMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 12441*/   0, // EndSwitchType
/* 12442*/  /*Scope*/ 16, /*->12459*/
/* 12443*/   OPC_CheckChild0Integer, 90|128,67|128,1/*25050*/, 
/* 12447*/   OPC_RecordChild1, // #0 = $lhs
/* 12448*/   OPC_RecordChild2, // #1 = $rhs
/* 12449*/   OPC_RecordChild3, // #2 = $acc
/* 12450*/   OPC_CheckPatternPredicate7, // (Subtarget->hasRelaxedSIMD())
/* 12451*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::RELAXED_DOT_BFLOAT),
                 /*MVT::v4f32*/111, 3/*#Ops*/, 0, 1, 2, 
             // Src: (intrinsic_wo_chain:{ *:[v4f32] } 12525:{ *:[iPTR] }, V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, V128:{ *:[v4f32] }:$acc) - Complexity = 8
             // Dst: (RELAXED_DOT_BFLOAT:{ *:[v4f32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs, V128:{ *:[v4f32] }:$acc)
/* 12459*/  0, /*End of Scope*/
/* 12460*/ /*SwitchOpcode*/ 4|128,1/*132*/, TARGET_VAL(ISD::EXTRACT_VECTOR_ELT),// ->12596
/* 12464*/  OPC_RecordChild0, // #0 = $vec
/* 12465*/  OPC_Scope, 20, /*->12487*/ // 6 children in Scope
/* 12467*/   OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 12469*/   OPC_RecordChild1, // #1 = $idx
/* 12470*/   OPC_MoveChild1,
/* 12471*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12474*/   OPC_CheckPredicate, 18, // Predicate_LaneIdx16
/* 12476*/   OPC_CheckTypeI32,
/* 12477*/   OPC_MoveParent,
/* 12478*/   OPC_CheckTypeI32,
/* 12479*/   OPC_EmitConvertToTarget1,
/* 12480*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I8x16_u),
                 /*MVT::i32*/7, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[i32] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_I8x16_u:{ *:[i32] } ?:{ *:[v16i8] }:$vec, (imm:{ *:[i32] }):$idx)
/* 12487*/  /*Scope*/ 20, /*->12508*/
/* 12488*/   OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 12490*/   OPC_RecordChild1, // #1 = $idx
/* 12491*/   OPC_MoveChild1,
/* 12492*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12495*/   OPC_CheckPredicate, 13, // Predicate_LaneIdx8
/* 12497*/   OPC_CheckTypeI32,
/* 12498*/   OPC_MoveParent,
/* 12499*/   OPC_CheckTypeI32,
/* 12500*/   OPC_EmitConvertToTarget1,
/* 12501*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I16x8_u),
                 /*MVT::i32*/7, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[i32] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_I16x8_u:{ *:[i32] } ?:{ *:[v8i16] }:$vec, (imm:{ *:[i32] }):$idx)
/* 12508*/  /*Scope*/ 20, /*->12529*/
/* 12509*/   OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 12511*/   OPC_RecordChild1, // #1 = $idx
/* 12512*/   OPC_MoveChild1,
/* 12513*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12516*/   OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/* 12518*/   OPC_CheckTypeI32,
/* 12519*/   OPC_MoveParent,
/* 12520*/   OPC_CheckTypeI32,
/* 12521*/   OPC_EmitConvertToTarget1,
/* 12522*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I32x4),
                 /*MVT::i32*/7, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[i32] } V128:{ *:[v4i32] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_I32x4:{ *:[i32] } ?:{ *:[v4i32] }:$vec, (imm:{ *:[i32] }):$idx)
/* 12529*/  /*Scope*/ 20, /*->12550*/
/* 12530*/   OPC_CheckChild0Type, /*MVT::v2i64*/78, 
/* 12532*/   OPC_RecordChild1, // #1 = $idx
/* 12533*/   OPC_MoveChild1,
/* 12534*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12537*/   OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/* 12539*/   OPC_CheckTypeI32,
/* 12540*/   OPC_MoveParent,
/* 12541*/   OPC_CheckTypeI64,
/* 12542*/   OPC_EmitConvertToTarget1,
/* 12543*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_I64x2),
                 /*MVT::i64*/8, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[i64] } V128:{ *:[v2i64] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_I64x2:{ *:[i64] } ?:{ *:[v2i64] }:$vec, (imm:{ *:[i32] }):$idx)
/* 12550*/  /*Scope*/ 21, /*->12572*/
/* 12551*/   OPC_CheckChild0Type, /*MVT::v4f32*/111, 
/* 12553*/   OPC_RecordChild1, // #1 = $idx
/* 12554*/   OPC_MoveChild1,
/* 12555*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12558*/   OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/* 12560*/   OPC_CheckTypeI32,
/* 12561*/   OPC_MoveParent,
/* 12562*/   OPC_CheckType, /*MVT::f32*/12, 
/* 12564*/   OPC_EmitConvertToTarget1,
/* 12565*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_F32x4),
                 /*MVT::f32*/12, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[f32] } V128:{ *:[v4f32] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_F32x4:{ *:[f32] } ?:{ *:[v4f32] }:$vec, (imm:{ *:[i32] }):$idx)
/* 12572*/  /*Scope*/ 22, /*->12595*/
/* 12573*/   OPC_CheckChild0Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 12576*/   OPC_RecordChild1, // #1 = $idx
/* 12577*/   OPC_MoveChild1,
/* 12578*/   OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 12581*/   OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/* 12583*/   OPC_CheckTypeI32,
/* 12584*/   OPC_MoveParent,
/* 12585*/   OPC_CheckType, /*MVT::f64*/13, 
/* 12587*/   OPC_EmitConvertToTarget1,
/* 12588*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTRACT_LANE_F64x2),
                 /*MVT::f64*/13, 2/*#Ops*/, 0, 2, 
             // Src: (vector_extract:{ *:[f64] } V128:{ *:[v2f64] }:$vec, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 7
             // Dst: (EXTRACT_LANE_F64x2:{ *:[f64] } ?:{ *:[v2f64] }:$vec, (imm:{ *:[i32] }):$idx)
/* 12595*/  0, /*End of Scope*/
/* 12596*/ /*SwitchOpcode*/ 0|128,1/*128*/, TARGET_VAL(WebAssemblyISD::ARGUMENT),// ->12728
/* 12600*/  OPC_RecordChild0, // #0 = $argno
/* 12601*/  OPC_MoveChild0,
/* 12602*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 12605*/  OPC_MoveParent,
/* 12606*/  OPC_SwitchType /*14 cases */, 6, /*MVT::i32*/7, // ->12615
/* 12609*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_i32),
                 /*MVT::i32*/7, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[i32] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_i32:{ *:[i32] } (timm:{ *:[i32] }):$argno)
/* 12615*/  /*SwitchType*/ 6, /*MVT::i64*/8, // ->12623
/* 12617*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_i64),
                 /*MVT::i64*/8, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[i64] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_i64:{ *:[i64] } (timm:{ *:[i32] }):$argno)
/* 12623*/  /*SwitchType*/ 7, /*MVT::funcref*/99|128,1/*227*/, // ->12633
/* 12626*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_funcref),
                 /*MVT::funcref*/99|128,1/*227*/, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[funcref] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_funcref:{ *:[funcref] } (timm:{ *:[i32] }):$argno)
/* 12633*/  /*SwitchType*/ 7, /*MVT::externref*/100|128,1/*228*/, // ->12643
/* 12636*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_externref),
                 /*MVT::externref*/100|128,1/*228*/, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[externref] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_externref:{ *:[externref] } (timm:{ *:[i32] }):$argno)
/* 12643*/  /*SwitchType*/ 7, /*MVT::exnref*/101|128,1/*229*/, // ->12653
/* 12646*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_exnref),
                 /*MVT::exnref*/101|128,1/*229*/, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[exnref] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_exnref:{ *:[exnref] } (timm:{ *:[i32] }):$argno)
/* 12653*/  /*SwitchType*/ 6, /*MVT::f32*/12, // ->12661
/* 12655*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_f32),
                 /*MVT::f32*/12, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[f32] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_f32:{ *:[f32] } (timm:{ *:[i32] }):$argno)
/* 12661*/  /*SwitchType*/ 6, /*MVT::f64*/13, // ->12669
/* 12663*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_f64),
                 /*MVT::f64*/13, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[f64] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_f64:{ *:[f64] } (timm:{ *:[i32] }):$argno)
/* 12669*/  /*SwitchType*/ 6, /*MVT::v16i8*/39, // ->12677
/* 12671*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v16i8),
                 /*MVT::v16i8*/39, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v16i8] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v16i8:{ *:[v16i8] } (timm:{ *:[i32] }):$argno)
/* 12677*/  /*SwitchType*/ 6, /*MVT::v8i16*/50, // ->12685
/* 12679*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v8i16),
                 /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v8i16] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v8i16:{ *:[v8i16] } (timm:{ *:[i32] }):$argno)
/* 12685*/  /*SwitchType*/ 6, /*MVT::v4i32*/60, // ->12693
/* 12687*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v4i32),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v4i32] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v4i32:{ *:[v4i32] } (timm:{ *:[i32] }):$argno)
/* 12693*/  /*SwitchType*/ 6, /*MVT::v2i64*/78, // ->12701
/* 12695*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v2i64),
                 /*MVT::v2i64*/78, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v2i64] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v2i64:{ *:[v2i64] } (timm:{ *:[i32] }):$argno)
/* 12701*/  /*SwitchType*/ 6, /*MVT::v4f32*/111, // ->12709
/* 12703*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v4f32),
                 /*MVT::v4f32*/111, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v4f32] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v4f32:{ *:[v4f32] } (timm:{ *:[i32] }):$argno)
/* 12709*/  /*SwitchType*/ 7, /*MVT::v2f64*/1|128,1/*129*/, // ->12719
/* 12712*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v2f64),
                 /*MVT::v2f64*/1|128,1/*129*/, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v2f64] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v2f64:{ *:[v2f64] } (timm:{ *:[i32] }):$argno)
/* 12719*/  /*SwitchType*/ 6, /*MVT::v8f16*/92, // ->12727
/* 12721*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ARGUMENT_v8f16),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (WebAssemblyargument:{ *:[v8f16] } (timm:{ *:[i32] }):$argno) - Complexity = 6
             // Dst: (ARGUMENT_v8f16:{ *:[v8f16] } (timm:{ *:[i32] }):$argno)
/* 12727*/  0, // EndSwitchType
/* 12728*/ /*SwitchOpcode*/ 26|128,1/*154*/, TARGET_VAL(WebAssemblyISD::LOCAL_GET),// ->12886
/* 12732*/  OPC_RecordNode, // #0 = 'WebAssemblylocal_get' chained node
/* 12733*/  OPC_RecordChild1, // #1 = $local
/* 12734*/  OPC_MoveChild1,
/* 12735*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 12738*/  OPC_MoveParent,
/* 12739*/  OPC_SwitchType /*14 cases */, 7, /*MVT::i32*/7, // ->12749
/* 12742*/   OPC_EmitMergeInputChains1_0,
/* 12743*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_I32),
                 /*MVT::i32*/7, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[i32] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_I32:{ *:[i32] } (timm:{ *:[i32] }):$local)
/* 12749*/  /*SwitchType*/ 7, /*MVT::i64*/8, // ->12758
/* 12751*/   OPC_EmitMergeInputChains1_0,
/* 12752*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_I64),
                 /*MVT::i64*/8, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[i64] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_I64:{ *:[i64] } (timm:{ *:[i32] }):$local)
/* 12758*/  /*SwitchType*/ 9, /*MVT::funcref*/99|128,1/*227*/, // ->12770
/* 12761*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 12762*/   OPC_EmitMergeInputChains1_0,
/* 12763*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_FUNCREF),
                 /*MVT::funcref*/99|128,1/*227*/, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[funcref] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_FUNCREF:{ *:[funcref] } (timm:{ *:[i32] }):$local)
/* 12770*/  /*SwitchType*/ 9, /*MVT::externref*/100|128,1/*228*/, // ->12782
/* 12773*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 12774*/   OPC_EmitMergeInputChains1_0,
/* 12775*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_EXTERNREF),
                 /*MVT::externref*/100|128,1/*228*/, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[externref] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_EXTERNREF:{ *:[externref] } (timm:{ *:[i32] }):$local)
/* 12782*/  /*SwitchType*/ 10, /*MVT::exnref*/101|128,1/*229*/, // ->12795
/* 12785*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/* 12787*/   OPC_EmitMergeInputChains1_0,
/* 12788*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_EXNREF),
                 /*MVT::exnref*/101|128,1/*229*/, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[exnref] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_EXNREF:{ *:[exnref] } (timm:{ *:[i32] }):$local)
/* 12795*/  /*SwitchType*/ 7, /*MVT::f32*/12, // ->12804
/* 12797*/   OPC_EmitMergeInputChains1_0,
/* 12798*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_F32),
                 /*MVT::f32*/12, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[f32] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_F32:{ *:[f32] } (timm:{ *:[i32] }):$local)
/* 12804*/  /*SwitchType*/ 7, /*MVT::f64*/13, // ->12813
/* 12806*/   OPC_EmitMergeInputChains1_0,
/* 12807*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_F64),
                 /*MVT::f64*/13, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[f64] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_F64:{ *:[f64] } (timm:{ *:[i32] }):$local)
/* 12813*/  /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->12823
/* 12815*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12816*/   OPC_EmitMergeInputChains1_0,
/* 12817*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 /*MVT::v2i64*/78, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v2i64] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v2i64] } (timm:{ *:[i32] }):$local)
/* 12823*/  /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->12833
/* 12825*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12826*/   OPC_EmitMergeInputChains1_0,
/* 12827*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v4i32] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v4i32] } (timm:{ *:[i32] }):$local)
/* 12833*/  /*SwitchType*/ 8, /*MVT::v16i8*/39, // ->12843
/* 12835*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12836*/   OPC_EmitMergeInputChains1_0,
/* 12837*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 /*MVT::v16i8*/39, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v16i8] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v16i8] } (timm:{ *:[i32] }):$local)
/* 12843*/  /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->12853
/* 12845*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12846*/   OPC_EmitMergeInputChains1_0,
/* 12847*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 /*MVT::v8i16*/50, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v8i16] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v8i16] } (timm:{ *:[i32] }):$local)
/* 12853*/  /*SwitchType*/ 8, /*MVT::v8f16*/92, // ->12863
/* 12855*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12856*/   OPC_EmitMergeInputChains1_0,
/* 12857*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v8f16] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v8f16] } (timm:{ *:[i32] }):$local)
/* 12863*/  /*SwitchType*/ 8, /*MVT::v4f32*/111, // ->12873
/* 12865*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12866*/   OPC_EmitMergeInputChains1_0,
/* 12867*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 /*MVT::v4f32*/111, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v4f32] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v4f32] } (timm:{ *:[i32] }):$local)
/* 12873*/  /*SwitchType*/ 9, /*MVT::v2f64*/1|128,1/*129*/, // ->12885
/* 12876*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12877*/   OPC_EmitMergeInputChains1_0,
/* 12878*/   OPC_MorphNodeTo1Chain, TARGET_VAL(WebAssembly::LOCAL_GET_V128),
                 /*MVT::v2f64*/1|128,1/*129*/, 1/*#Ops*/, 1, 
             // Src: (WebAssemblylocal_get:{ *:[v2f64] } (timm:{ *:[i32] }):$local) - Complexity = 6
             // Dst: (LOCAL_GET_V128:{ *:[v2f64] } (timm:{ *:[i32] }):$local)
/* 12885*/  0, // EndSwitchType
/* 12886*/ /*SwitchOpcode*/ 35|128,1/*163*/, TARGET_VAL(WebAssemblyISD::LOCAL_SET),// ->13053
/* 12890*/  OPC_RecordNode, // #0 = 'WebAssemblylocal_set' chained node
/* 12891*/  OPC_RecordChild1, // #1 = $local
/* 12892*/  OPC_MoveChild1,
/* 12893*/  OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 12896*/  OPC_MoveParent,
/* 12897*/  OPC_RecordChild2, // #2 = $src
/* 12898*/  OPC_Scope, 8, /*->12908*/ // 14 children in Scope
/* 12900*/   OPC_CheckChild2TypeI32,
/* 12901*/   OPC_EmitMergeInputChains1_0,
/* 12902*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_I32),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, i32:{ *:[i32] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_I32 (timm:{ *:[i32] }):$local, i32:{ *:[i32] }:$src)
/* 12908*/  /*Scope*/ 8, /*->12917*/
/* 12909*/   OPC_CheckChild2TypeI64,
/* 12910*/   OPC_EmitMergeInputChains1_0,
/* 12911*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_I64),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, i64:{ *:[i64] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_I64 (timm:{ *:[i32] }):$local, i64:{ *:[i64] }:$src)
/* 12917*/  /*Scope*/ 9, /*->12927*/
/* 12918*/   OPC_CheckChild2Type, /*MVT::f32*/12, 
/* 12920*/   OPC_EmitMergeInputChains1_0,
/* 12921*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_F32),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, f32:{ *:[f32] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_F32 (timm:{ *:[i32] }):$local, f32:{ *:[f32] }:$src)
/* 12927*/  /*Scope*/ 9, /*->12937*/
/* 12928*/   OPC_CheckChild2Type, /*MVT::f64*/13, 
/* 12930*/   OPC_EmitMergeInputChains1_0,
/* 12931*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_F64),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, f64:{ *:[f64] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_F64 (timm:{ *:[i32] }):$local, f64:{ *:[f64] }:$src)
/* 12937*/  /*Scope*/ 10, /*->12948*/
/* 12938*/   OPC_CheckChild2Type, /*MVT::v8f16*/92, 
/* 12940*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12941*/   OPC_EmitMergeInputChains1_0,
/* 12942*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v8f16:{ *:[v8f16] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v8f16:{ *:[v8f16] }:$src)
/* 12948*/  /*Scope*/ 10, /*->12959*/
/* 12949*/   OPC_CheckChild2Type, /*MVT::v4f32*/111, 
/* 12951*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12952*/   OPC_EmitMergeInputChains1_0,
/* 12953*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v4f32:{ *:[v4f32] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v4f32:{ *:[v4f32] }:$src)
/* 12959*/  /*Scope*/ 11, /*->12971*/
/* 12960*/   OPC_CheckChild2Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 12963*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12964*/   OPC_EmitMergeInputChains1_0,
/* 12965*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v2f64:{ *:[v2f64] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v2f64:{ *:[v2f64] }:$src)
/* 12971*/  /*Scope*/ 10, /*->12982*/
/* 12972*/   OPC_CheckChild2Type, /*MVT::v2i64*/78, 
/* 12974*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12975*/   OPC_EmitMergeInputChains1_0,
/* 12976*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v2i64:{ *:[v2i64] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v2i64:{ *:[v2i64] }:$src)
/* 12982*/  /*Scope*/ 10, /*->12993*/
/* 12983*/   OPC_CheckChild2Type, /*MVT::v4i32*/60, 
/* 12985*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12986*/   OPC_EmitMergeInputChains1_0,
/* 12987*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v4i32:{ *:[v4i32] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v4i32:{ *:[v4i32] }:$src)
/* 12993*/  /*Scope*/ 10, /*->13004*/
/* 12994*/   OPC_CheckChild2Type, /*MVT::v16i8*/39, 
/* 12996*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 12997*/   OPC_EmitMergeInputChains1_0,
/* 12998*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v16i8:{ *:[v16i8] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v16i8:{ *:[v16i8] }:$src)
/* 13004*/  /*Scope*/ 10, /*->13015*/
/* 13005*/   OPC_CheckChild2Type, /*MVT::v8i16*/50, 
/* 13007*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13008*/   OPC_EmitMergeInputChains1_0,
/* 13009*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_V128),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, v8i16:{ *:[v8i16] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_V128 (timm:{ *:[i32] }):$local, v8i16:{ *:[v8i16] }:$src)
/* 13015*/  /*Scope*/ 11, /*->13027*/
/* 13016*/   OPC_CheckChild2Type, /*MVT::funcref*/99|128,1/*227*/, 
/* 13019*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 13020*/   OPC_EmitMergeInputChains1_0,
/* 13021*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_FUNCREF),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, funcref:{ *:[funcref] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_FUNCREF (timm:{ *:[i32] }):$local, funcref:{ *:[funcref] }:$src)
/* 13027*/  /*Scope*/ 11, /*->13039*/
/* 13028*/   OPC_CheckChild2Type, /*MVT::externref*/100|128,1/*228*/, 
/* 13031*/   OPC_CheckPatternPredicate6, // (Subtarget->hasReferenceTypes())
/* 13032*/   OPC_EmitMergeInputChains1_0,
/* 13033*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_EXTERNREF),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, externref:{ *:[externref] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_EXTERNREF (timm:{ *:[i32] }):$local, externref:{ *:[externref] }:$src)
/* 13039*/  /*Scope*/ 12, /*->13052*/
/* 13040*/   OPC_CheckChild2Type, /*MVT::exnref*/101|128,1/*229*/, 
/* 13043*/   OPC_CheckPatternPredicate, 8, // (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes())
/* 13045*/   OPC_EmitMergeInputChains1_0,
/* 13046*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::LOCAL_SET_EXNREF),
                 2/*#Ops*/, 1, 2, 
             // Src: (WebAssemblylocal_set (timm:{ *:[i32] }):$local, exnref:{ *:[exnref] }:$src) - Complexity = 6
             // Dst: (LOCAL_SET_EXNREF (timm:{ *:[i32] }):$local, exnref:{ *:[exnref] }:$src)
/* 13052*/  0, /*End of Scope*/
/* 13053*/ /*SwitchOpcode*/ 0|128,1/*128*/, TARGET_VAL(WebAssemblyISD::Wrapper),// ->13185
/* 13057*/  OPC_RecordChild0, // #0 = $addr
/* 13058*/  OPC_MoveChild0,
/* 13059*/  OPC_SwitchOpcode /*3 cases */, 47, TARGET_VAL(ISD::TargetGlobalAddress),// ->13110
/* 13063*/   OPC_MoveParent,
/* 13064*/   OPC_SwitchType /*2 cases */, 20, /*MVT::i32*/7, // ->13087
/* 13067*/    OPC_Scope, 8, /*->13077*/ // 2 children in Scope
/* 13069*/     OPC_CheckPatternPredicate, 18, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 13071*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr) - Complexity = 6
               // Dst: (CONST_I32:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 13077*/    /*Scope*/ 8, /*->13086*/
/* 13078*/     OPC_CheckPatternPredicate, 14, // (!Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13080*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I32),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr) - Complexity = 6
               // Dst: (GLOBAL_GET_I32:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 13086*/    0, /*End of Scope*/
/* 13087*/   /*SwitchType*/ 20, /*MVT::i64*/8, // ->13109
/* 13089*/    OPC_Scope, 8, /*->13099*/ // 2 children in Scope
/* 13091*/     OPC_CheckPatternPredicate, 19, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 13093*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr) - Complexity = 6
               // Dst: (CONST_I64:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr)
/* 13099*/    /*Scope*/ 8, /*->13108*/
/* 13100*/     OPC_CheckPatternPredicate, 15, // (Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13102*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I64),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr) - Complexity = 6
               // Dst: (GLOBAL_GET_I64:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr)
/* 13108*/    0, /*End of Scope*/
/* 13109*/   0, // EndSwitchType
/* 13110*/  /*SwitchOpcode*/ 21, TARGET_VAL(ISD::TargetGlobalTLSAddress),// ->13134
/* 13113*/   OPC_MoveParent,
/* 13114*/   OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->13124
/* 13117*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 13118*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I32),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapper:{ *:[i32] } (tglobaltlsaddr:{ *:[i32] }):$addr) - Complexity = 6
              // Dst: (GLOBAL_GET_I32:{ *:[i32] } (tglobaltlsaddr:{ *:[i32] }):$addr)
/* 13124*/   /*SwitchType*/ 7, /*MVT::i64*/8, // ->13133
/* 13126*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 13127*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I64),
                  /*MVT::i64*/8, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapper:{ *:[i64] } (tglobaltlsaddr:{ *:[i64] }):$addr) - Complexity = 6
              // Dst: (GLOBAL_GET_I64:{ *:[i64] } (tglobaltlsaddr:{ *:[i64] }):$addr)
/* 13133*/   0, // EndSwitchType
/* 13134*/  /*SwitchOpcode*/ 47, TARGET_VAL(ISD::TargetExternalSymbol),// ->13184
/* 13137*/   OPC_MoveParent,
/* 13138*/   OPC_SwitchType /*2 cases */, 20, /*MVT::i32*/7, // ->13161
/* 13141*/    OPC_Scope, 8, /*->13151*/ // 2 children in Scope
/* 13143*/     OPC_CheckPatternPredicate, 14, // (!Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13145*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I32),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr) - Complexity = 6
               // Dst: (GLOBAL_GET_I32:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr)
/* 13151*/    /*Scope*/ 8, /*->13160*/
/* 13152*/     OPC_CheckPatternPredicate, 18, // (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 13154*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr) - Complexity = 6
               // Dst: (CONST_I32:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr)
/* 13160*/    0, /*End of Scope*/
/* 13161*/   /*SwitchType*/ 20, /*MVT::i64*/8, // ->13183
/* 13163*/    OPC_Scope, 8, /*->13173*/ // 2 children in Scope
/* 13165*/     OPC_CheckPatternPredicate, 15, // (Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13167*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::GLOBAL_GET_I64),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr) - Complexity = 6
               // Dst: (GLOBAL_GET_I64:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr)
/* 13173*/    /*Scope*/ 8, /*->13182*/
/* 13174*/     OPC_CheckPatternPredicate, 19, // (Subtarget->hasAddr64()) && (!TM.isPositionIndependent())
/* 13176*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (WebAssemblyWrapper:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr) - Complexity = 6
               // Dst: (CONST_I64:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr)
/* 13182*/    0, /*End of Scope*/
/* 13183*/   0, // EndSwitchType
/* 13184*/  0, // EndSwitchOpcode
/* 13185*/ /*SwitchOpcode*/ 80, TARGET_VAL(WebAssemblyISD::WrapperREL),// ->13268
/* 13188*/  OPC_RecordChild0, // #0 = $addr
/* 13189*/  OPC_MoveChild0,
/* 13190*/  OPC_SwitchOpcode /*3 cases */, 23, TARGET_VAL(ISD::TargetGlobalAddress),// ->13217
/* 13194*/   OPC_MoveParent,
/* 13195*/   OPC_SwitchType /*2 cases */, 8, /*MVT::i32*/7, // ->13206
/* 13198*/    OPC_CheckPatternPredicate, 14, // (!Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13200*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr) - Complexity = 6
              // Dst: (CONST_I32:{ *:[i32] } (tglobaladdr:{ *:[i32] }):$addr)
/* 13206*/   /*SwitchType*/ 8, /*MVT::i64*/8, // ->13216
/* 13208*/    OPC_CheckPatternPredicate, 15, // (Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13210*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                  /*MVT::i64*/8, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr) - Complexity = 6
              // Dst: (CONST_I64:{ *:[i64] } (tglobaladdr:{ *:[i64] }):$addr)
/* 13216*/   0, // EndSwitchType
/* 13217*/  /*SwitchOpcode*/ 21, TARGET_VAL(ISD::TargetGlobalTLSAddress),// ->13241
/* 13220*/   OPC_MoveParent,
/* 13221*/   OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->13231
/* 13224*/    OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 13225*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i32] } (tglobaltlsaddr:{ *:[i32] }):$addr) - Complexity = 6
              // Dst: (CONST_I32:{ *:[i32] } (tglobaltlsaddr:{ *:[i32] }):$addr)
/* 13231*/   /*SwitchType*/ 7, /*MVT::i64*/8, // ->13240
/* 13233*/    OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 13234*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                  /*MVT::i64*/8, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i64] } (tglobaltlsaddr:{ *:[i64] }):$addr) - Complexity = 6
              // Dst: (CONST_I64:{ *:[i64] } (tglobaltlsaddr:{ *:[i64] }):$addr)
/* 13240*/   0, // EndSwitchType
/* 13241*/  /*SwitchOpcode*/ 23, TARGET_VAL(ISD::TargetExternalSymbol),// ->13267
/* 13244*/   OPC_MoveParent,
/* 13245*/   OPC_SwitchType /*2 cases */, 8, /*MVT::i32*/7, // ->13256
/* 13248*/    OPC_CheckPatternPredicate, 14, // (!Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13250*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr) - Complexity = 6
              // Dst: (CONST_I32:{ *:[i32] } (texternalsym:{ *:[i32] }):$addr)
/* 13256*/   /*SwitchType*/ 8, /*MVT::i64*/8, // ->13266
/* 13258*/    OPC_CheckPatternPredicate, 15, // (Subtarget->hasAddr64()) && (TM.isPositionIndependent())
/* 13260*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                  /*MVT::i64*/8, 1/*#Ops*/, 0, 
              // Src: (WebAssemblyWrapperREL:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr) - Complexity = 6
              // Dst: (CONST_I64:{ *:[i64] } (texternalsym:{ *:[i64] }):$addr)
/* 13266*/   0, // EndSwitchType
/* 13267*/  0, // EndSwitchOpcode
/* 13268*/ /*SwitchOpcode*/ 47, TARGET_VAL(WebAssemblyISD::MEMSET),// ->13318
/* 13271*/  OPC_RecordNode, // #0 = 'wasm_memset' chained node
/* 13272*/  OPC_RecordChild1, // #1 = $idx
/* 13273*/  OPC_MoveChild1,
/* 13274*/  OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 13277*/  OPC_CheckTypeI32,
/* 13278*/  OPC_MoveParent,
/* 13279*/  OPC_RecordChild2, // #2 = $dst
/* 13280*/  OPC_Scope, 17, /*->13299*/ // 2 children in Scope
/* 13282*/   OPC_CheckChild2TypeI32,
/* 13283*/   OPC_RecordChild3, // #3 = $value
/* 13284*/   OPC_CheckChild3TypeI32,
/* 13285*/   OPC_RecordChild4, // #4 = $size
/* 13286*/   OPC_CheckChild4TypeI32,
/* 13287*/   OPC_CheckPatternPredicate, 12, // (Subtarget->hasBulkMemory())
/* 13289*/   OPC_EmitMergeInputChains1_0,
/* 13290*/   OPC_EmitConvertToTarget1,
/* 13291*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::MEMSET_A32),
                 4/*#Ops*/, 5, 2, 3, 4, 
             // Src: (wasm_memset (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$dst, I32:{ *:[i32] }:$value, I32:{ *:[i32] }:$size) - Complexity = 6
             // Dst: (MEMSET_A32 (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$dst, I32:{ *:[i32] }:$value, I32:{ *:[i32] }:$size)
/* 13299*/  /*Scope*/ 17, /*->13317*/
/* 13300*/   OPC_CheckChild2TypeI64,
/* 13301*/   OPC_RecordChild3, // #3 = $value
/* 13302*/   OPC_CheckChild3TypeI32,
/* 13303*/   OPC_RecordChild4, // #4 = $size
/* 13304*/   OPC_CheckChild4TypeI64,
/* 13305*/   OPC_CheckPatternPredicate, 12, // (Subtarget->hasBulkMemory())
/* 13307*/   OPC_EmitMergeInputChains1_0,
/* 13308*/   OPC_EmitConvertToTarget1,
/* 13309*/   OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::MEMSET_A64),
                 4/*#Ops*/, 5, 2, 3, 4, 
             // Src: (wasm_memset (imm:{ *:[i32] }):$idx, I64:{ *:[i64] }:$dst, I32:{ *:[i32] }:$value, I64:{ *:[i64] }:$size) - Complexity = 6
             // Dst: (MEMSET_A64 (imm:{ *:[i32] }):$idx, I64:{ *:[i64] }:$dst, I32:{ *:[i32] }:$value, I64:{ *:[i64] }:$size)
/* 13317*/  0, /*End of Scope*/
/* 13318*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::Constant),// ->13342
/* 13321*/  OPC_RecordNode, // #0 = $imm
/* 13322*/  OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->13332
/* 13325*/   OPC_EmitConvertToTarget0,
/* 13326*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I32),
                 /*MVT::i32*/7, 1/*#Ops*/, 1, 
             // Src: (imm:{ *:[i32] }):$imm - Complexity = 3
             // Dst: (CONST_I32:{ *:[i32] } (imm:{ *:[i32] }):$imm)
/* 13332*/  /*SwitchType*/ 7, /*MVT::i64*/8, // ->13341
/* 13334*/   OPC_EmitConvertToTarget0,
/* 13335*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_I64),
                 /*MVT::i64*/8, 1/*#Ops*/, 1, 
             // Src: (imm:{ *:[i64] }):$imm - Complexity = 3
             // Dst: (CONST_I64:{ *:[i64] } (imm:{ *:[i64] }):$imm)
/* 13341*/  0, // EndSwitchType
/* 13342*/ /*SwitchOpcode*/ 13, TARGET_VAL(ISD::BR),// ->13358
/* 13345*/  OPC_RecordNode, // #0 = 'br' chained node
/* 13346*/  OPC_RecordChild1, // #1 = $dst
/* 13347*/  OPC_MoveChild1,
/* 13348*/  OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/* 13351*/  OPC_MoveParent,
/* 13352*/  OPC_EmitMergeInputChains1_0,
/* 13353*/  OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::BR),
                1/*#Ops*/, 1, 
            // Src: (br (bb:{ *:[Other] }):$dst) - Complexity = 3
            // Dst: (BR (bb:{ *:[Other] }):$dst)
/* 13358*/ /*SwitchOpcode*/ 22, TARGET_VAL(WebAssemblyISD::BR_TABLE),// ->13383
/* 13361*/  OPC_RecordNode, // #0 = 'WebAssemblybr_table' chained node
/* 13362*/  OPC_RecordChild1, // #1 = $index
/* 13363*/  OPC_Scope, 8, /*->13373*/ // 2 children in Scope
/* 13365*/   OPC_CheckChild1TypeI32,
/* 13366*/   OPC_EmitMergeInputChains1_0,
/* 13367*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::BR_TABLE_I32), 0|OPFL_Chain|OPFL_Variadic1,
                 1/*#Ops*/, 1, 
             // Src: (WebAssemblybr_table I32:{ *:[i32] }:$index) - Complexity = 3
             // Dst: (BR_TABLE_I32 I32:{ *:[i32] }:$index)
/* 13373*/  /*Scope*/ 8, /*->13382*/
/* 13374*/   OPC_CheckChild1TypeI64,
/* 13375*/   OPC_EmitMergeInputChains1_0,
/* 13376*/   OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::BR_TABLE_I64), 0|OPFL_Chain|OPFL_Variadic1,
                 1/*#Ops*/, 1, 
             // Src: (WebAssemblybr_table I64:{ *:[i64] }:$index) - Complexity = 3
             // Dst: (BR_TABLE_I64 I64:{ *:[i64] }:$index)
/* 13382*/  0, /*End of Scope*/
/* 13383*/ /*SwitchOpcode*/ 7, TARGET_VAL(WebAssemblyISD::RETURN),// ->13393
/* 13386*/  OPC_RecordNode, // #0 = 'WebAssemblyreturn' chained node
/* 13387*/  OPC_EmitMergeInputChains1_0,
/* 13388*/  OPC_MorphNodeTo0, TARGET_VAL(WebAssembly::RETURN), 0|OPFL_Chain|OPFL_Variadic0,
                0/*#Ops*/, 
            // Src: (WebAssemblyreturn) - Complexity = 3
            // Dst: (RETURN)
/* 13393*/ /*SwitchOpcode*/ 6, TARGET_VAL(ISD::TRAP),// ->13402
/* 13396*/  OPC_RecordNode, // #0 = 'trap' chained node
/* 13397*/  OPC_EmitMergeInputChains1_0,
/* 13398*/  OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::UNREACHABLE),
                0/*#Ops*/, 
            // Src: (trap) - Complexity = 3
            // Dst: (UNREACHABLE)
/* 13402*/ /*SwitchOpcode*/ 6, TARGET_VAL(ISD::DEBUGTRAP),// ->13411
/* 13405*/  OPC_RecordNode, // #0 = 'debugtrap' chained node
/* 13406*/  OPC_EmitMergeInputChains1_0,
/* 13407*/  OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::DEBUG_UNREACHABLE),
                0/*#Ops*/, 
            // Src: (debugtrap) - Complexity = 3
            // Dst: (DEBUG_UNREACHABLE)
/* 13411*/ /*SwitchOpcode*/ 8, TARGET_VAL(ISD::CLEANUPRET),// ->13422
/* 13414*/  OPC_RecordNode, // #0 = 'cleanupret' chained node
/* 13415*/  OPC_CheckPatternPredicate, 16, // (Subtarget->hasExceptionHandling())
/* 13417*/  OPC_EmitMergeInputChains1_0,
/* 13418*/  OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::CLEANUPRET),
                0/*#Ops*/, 
            // Src: (cleanupret) - Complexity = 3
            // Dst: (CLEANUPRET)
/* 13422*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::CATCHRET),// ->13446
/* 13425*/  OPC_RecordNode, // #0 = 'catchret' chained node
/* 13426*/  OPC_RecordChild1, // #1 = $dst
/* 13427*/  OPC_MoveChild1,
/* 13428*/  OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/* 13431*/  OPC_MoveSibling2,
/* 13432*/  OPC_CheckOpcode, TARGET_VAL(ISD::BasicBlock),
/* 13435*/  OPC_RecordNode, // #2 = $from
/* 13436*/  OPC_MoveParent,
/* 13437*/  OPC_CheckPatternPredicate, 16, // (Subtarget->hasExceptionHandling())
/* 13439*/  OPC_EmitMergeInputChains1_0,
/* 13440*/  OPC_MorphNodeTo0Chain, TARGET_VAL(WebAssembly::CATCHRET),
                2/*#Ops*/, 1, 2, 
            // Src: (catchret (bb:{ *:[Other] }):$dst, (bb:{ *:[Other] }):$from) - Complexity = 3
            // Dst: (CATCHRET (bb:{ *:[Other] }):$dst, (bb:{ *:[Other] }):$from)
/* 13446*/ /*SwitchOpcode*/ 62, TARGET_VAL(ISD::ADD),// ->13511
/* 13449*/  OPC_RecordChild0, // #0 = $lhs
/* 13450*/  OPC_RecordChild1, // #1 = $rhs
/* 13451*/  OPC_SwitchType /*6 cases */, 7, /*MVT::i32*/7, // ->13461
/* 13454*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I32),
                 /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (ADD_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 13461*/  /*SwitchType*/ 7, /*MVT::i64*/8, // ->13470
/* 13463*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I64),
                 /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (ADD_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 13470*/  /*SwitchType*/ 8, /*MVT::v16i8*/39, // ->13480
/* 13472*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13473*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I8x16),
                 /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (ADD_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 13480*/  /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->13490
/* 13482*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13483*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I16x8),
                 /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (ADD_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13490*/  /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->13500
/* 13492*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13493*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I32x4),
                 /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (ADD_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 13500*/  /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->13510
/* 13502*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13503*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_I64x2),
                 /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
             // Src: (add:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
             // Dst: (ADD_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/* 13510*/  0, // EndSwitchType
/* 13511*/ /*SwitchOpcode*/ 113, TARGET_VAL(ISD::SUB),// ->13627
/* 13514*/  OPC_Scope, 22, /*->13538*/ // 3 children in Scope
/* 13516*/   OPC_RecordChild0, // #0 = $lhs
/* 13517*/   OPC_RecordChild1, // #1 = $rhs
/* 13518*/   OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->13528
/* 13521*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (SUB_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 13528*/   /*SwitchType*/ 7, /*MVT::i64*/8, // ->13537
/* 13530*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (SUB_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 13537*/   0, // EndSwitchType
/* 13538*/  /*Scope*/ 42, /*->13581*/
/* 13539*/   OPC_MoveChild0,
/* 13540*/   OPC_CheckImmAllZerosV,
/* 13541*/   OPC_MoveParent,
/* 13542*/   OPC_RecordChild1, // #0 = $v
/* 13543*/   OPC_SwitchType /*4 cases */, 7, /*MVT::v16i8*/39, // ->13553
/* 13546*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13547*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_I8x16),
                  /*MVT::v16i8*/39, 1/*#Ops*/, 0, 
              // Src: (sub:{ *:[v16i8] } immAllZerosV:{ *:[v16i8] }, V128:{ *:[v16i8] }:$v) - Complexity = 7
              // Dst: (NEG_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$v)
/* 13553*/   /*SwitchType*/ 7, /*MVT::v8i16*/50, // ->13562
/* 13555*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13556*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_I16x8),
                  /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
              // Src: (sub:{ *:[v8i16] } immAllZerosV:{ *:[v8i16] }, V128:{ *:[v8i16] }:$v) - Complexity = 7
              // Dst: (NEG_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$v)
/* 13562*/   /*SwitchType*/ 7, /*MVT::v4i32*/60, // ->13571
/* 13564*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13565*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_I32x4),
                  /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
              // Src: (sub:{ *:[v4i32] } immAllZerosV:{ *:[v4i32] }, V128:{ *:[v4i32] }:$v) - Complexity = 7
              // Dst: (NEG_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$v)
/* 13571*/   /*SwitchType*/ 7, /*MVT::v2i64*/78, // ->13580
/* 13573*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13574*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_I64x2),
                  /*MVT::v2i64*/78, 1/*#Ops*/, 0, 
              // Src: (sub:{ *:[v2i64] } immAllZerosV:{ *:[v2i64] }, V128:{ *:[v2i64] }:$v) - Complexity = 7
              // Dst: (NEG_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$v)
/* 13580*/   0, // EndSwitchType
/* 13581*/  /*Scope*/ 44, /*->13626*/
/* 13582*/   OPC_RecordChild0, // #0 = $lhs
/* 13583*/   OPC_RecordChild1, // #1 = $rhs
/* 13584*/   OPC_SwitchType /*4 cases */, 8, /*MVT::v16i8*/39, // ->13595
/* 13587*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13588*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I8x16),
                  /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
              // Dst: (SUB_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 13595*/   /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->13605
/* 13597*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13598*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I16x8),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (SUB_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13605*/   /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->13615
/* 13607*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13608*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I32x4),
                  /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (SUB_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 13615*/   /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->13625
/* 13617*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13618*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_I64x2),
                  /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
              // Src: (sub:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (SUB_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/* 13625*/   0, // EndSwitchType
/* 13626*/  0, /*End of Scope*/
/* 13627*/ /*SwitchOpcode*/ 85|128,2/*341*/, TARGET_VAL(ISD::MUL),// ->13972
/* 13631*/  OPC_Scope, 22, /*->13655*/ // 3 children in Scope
/* 13633*/   OPC_RecordChild0, // #0 = $lhs
/* 13634*/   OPC_RecordChild1, // #1 = $rhs
/* 13635*/   OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->13645
/* 13638*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (MUL_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 13645*/   /*SwitchType*/ 7, /*MVT::i64*/8, // ->13654
/* 13647*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (MUL_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 13654*/   0, // EndSwitchType
/* 13655*/  /*Scope*/ 23|128,2/*279*/, /*->13936*/
/* 13657*/   OPC_MoveChild0,
/* 13658*/   OPC_SwitchOpcode /*4 cases */, 66, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),// ->13728
/* 13662*/    OPC_RecordChild0, // #0 = $lhs
/* 13663*/    OPC_Scope, 20, /*->13685*/ // 3 children in Scope
/* 13665*/     OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 13667*/     OPC_MoveSibling1,
/* 13668*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),
/* 13671*/     OPC_RecordChild0, // #1 = $rhs
/* 13672*/     OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 13674*/     OPC_MoveParent,
/* 13675*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 13677*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13678*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_S_I16x8),
                   /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v8i16] } (extend_low_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs), (extend_low_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_S_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 13685*/    /*Scope*/ 20, /*->13706*/
/* 13686*/     OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 13688*/     OPC_MoveSibling1,
/* 13689*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),
/* 13692*/     OPC_RecordChild0, // #1 = $rhs
/* 13693*/     OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 13695*/     OPC_MoveParent,
/* 13696*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 13698*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13699*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_S_I32x4),
                   /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v4i32] } (extend_low_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs), (extend_low_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_S_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13706*/    /*Scope*/ 20, /*->13727*/
/* 13707*/     OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 13709*/     OPC_MoveSibling1,
/* 13710*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),
/* 13713*/     OPC_RecordChild0, // #1 = $rhs
/* 13714*/     OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 13716*/     OPC_MoveParent,
/* 13717*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 13719*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13720*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_S_I64x2),
                   /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v2i64] } (extend_low_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs), (extend_low_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_S_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 13727*/    0, /*End of Scope*/
/* 13728*/   /*SwitchOpcode*/ 66, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),// ->13797
/* 13731*/    OPC_RecordChild0, // #0 = $lhs
/* 13732*/    OPC_Scope, 20, /*->13754*/ // 3 children in Scope
/* 13734*/     OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 13736*/     OPC_MoveSibling1,
/* 13737*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),
/* 13740*/     OPC_RecordChild0, // #1 = $rhs
/* 13741*/     OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 13743*/     OPC_MoveParent,
/* 13744*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 13746*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13747*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_S_I16x8),
                   /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v8i16] } (extend_high_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs), (extend_high_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_S_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 13754*/    /*Scope*/ 20, /*->13775*/
/* 13755*/     OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 13757*/     OPC_MoveSibling1,
/* 13758*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),
/* 13761*/     OPC_RecordChild0, // #1 = $rhs
/* 13762*/     OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 13764*/     OPC_MoveParent,
/* 13765*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 13767*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13768*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_S_I32x4),
                   /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v4i32] } (extend_high_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs), (extend_high_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_S_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13775*/    /*Scope*/ 20, /*->13796*/
/* 13776*/     OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 13778*/     OPC_MoveSibling1,
/* 13779*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),
/* 13782*/     OPC_RecordChild0, // #1 = $rhs
/* 13783*/     OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 13785*/     OPC_MoveParent,
/* 13786*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 13788*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13789*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_S_I64x2),
                   /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v2i64] } (extend_high_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs), (extend_high_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_S_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 13796*/    0, /*End of Scope*/
/* 13797*/   /*SwitchOpcode*/ 66, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),// ->13866
/* 13800*/    OPC_RecordChild0, // #0 = $lhs
/* 13801*/    OPC_Scope, 20, /*->13823*/ // 3 children in Scope
/* 13803*/     OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 13805*/     OPC_MoveSibling1,
/* 13806*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),
/* 13809*/     OPC_RecordChild0, // #1 = $rhs
/* 13810*/     OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 13812*/     OPC_MoveParent,
/* 13813*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 13815*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13816*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_U_I16x8),
                   /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v8i16] } (extend_low_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs), (extend_low_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_U_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 13823*/    /*Scope*/ 20, /*->13844*/
/* 13824*/     OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 13826*/     OPC_MoveSibling1,
/* 13827*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),
/* 13830*/     OPC_RecordChild0, // #1 = $rhs
/* 13831*/     OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 13833*/     OPC_MoveParent,
/* 13834*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 13836*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13837*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_U_I32x4),
                   /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v4i32] } (extend_low_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs), (extend_low_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_U_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13844*/    /*Scope*/ 20, /*->13865*/
/* 13845*/     OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 13847*/     OPC_MoveSibling1,
/* 13848*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),
/* 13851*/     OPC_RecordChild0, // #1 = $rhs
/* 13852*/     OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 13854*/     OPC_MoveParent,
/* 13855*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 13857*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13858*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_LOW_U_I64x2),
                   /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v2i64] } (extend_low_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs), (extend_low_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_LOW_U_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 13865*/    0, /*End of Scope*/
/* 13866*/   /*SwitchOpcode*/ 66, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),// ->13935
/* 13869*/    OPC_RecordChild0, // #0 = $lhs
/* 13870*/    OPC_Scope, 20, /*->13892*/ // 3 children in Scope
/* 13872*/     OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 13874*/     OPC_MoveSibling1,
/* 13875*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),
/* 13878*/     OPC_RecordChild0, // #1 = $rhs
/* 13879*/     OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 13881*/     OPC_MoveParent,
/* 13882*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 13884*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13885*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_U_I16x8),
                   /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v8i16] } (extend_high_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs), (extend_high_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_U_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 13892*/    /*Scope*/ 20, /*->13913*/
/* 13893*/     OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 13895*/     OPC_MoveSibling1,
/* 13896*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),
/* 13899*/     OPC_RecordChild0, // #1 = $rhs
/* 13900*/     OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 13902*/     OPC_MoveParent,
/* 13903*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 13905*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13906*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_U_I32x4),
                   /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v4i32] } (extend_high_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs), (extend_high_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_U_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13913*/    /*Scope*/ 20, /*->13934*/
/* 13914*/     OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 13916*/     OPC_MoveSibling1,
/* 13917*/     OPC_CheckOpcode, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),
/* 13920*/     OPC_RecordChild0, // #1 = $rhs
/* 13921*/     OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 13923*/     OPC_MoveParent,
/* 13924*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 13926*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13927*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::EXTMUL_HIGH_U_I64x2),
                   /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
               // Src: (mul:{ *:[v2i64] } (extend_high_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs), (extend_high_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$rhs)) - Complexity = 9
               // Dst: (EXTMUL_HIGH_U_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 13934*/    0, /*End of Scope*/
/* 13935*/   0, // EndSwitchOpcode
/* 13936*/  /*Scope*/ 34, /*->13971*/
/* 13937*/   OPC_RecordChild0, // #0 = $lhs
/* 13938*/   OPC_RecordChild1, // #1 = $rhs
/* 13939*/   OPC_SwitchType /*3 cases */, 8, /*MVT::v8i16*/50, // ->13950
/* 13942*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13943*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_I16x8),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (MUL_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 13950*/   /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->13960
/* 13952*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13953*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_I32x4),
                  /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (MUL_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 13960*/   /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->13970
/* 13962*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 13963*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_I64x2),
                  /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
              // Src: (mul:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (MUL_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs)
/* 13970*/   0, // EndSwitchType
/* 13971*/  0, /*End of Scope*/
/* 13972*/ /*SwitchOpcode*/ 22, TARGET_VAL(ISD::SDIV),// ->13997
/* 13975*/  OPC_RecordChild0, // #0 = $lhs
/* 13976*/  OPC_RecordChild1, // #1 = $rhs
/* 13977*/  OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->13987
/* 13980*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_S_I32),
                 /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
             // Src: (sdiv:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (DIV_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 13987*/  /*SwitchType*/ 7, /*MVT::i64*/8, // ->13996
/* 13989*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_S_I64),
                 /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
             // Src: (sdiv:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (DIV_S_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 13996*/  0, // EndSwitchType
/* 13997*/ /*SwitchOpcode*/ 22, TARGET_VAL(ISD::UDIV),// ->14022
/* 14000*/  OPC_RecordChild0, // #0 = $lhs
/* 14001*/  OPC_RecordChild1, // #1 = $rhs
/* 14002*/  OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->14012
/* 14005*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_U_I32),
                 /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
             // Src: (udiv:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (DIV_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 14012*/  /*SwitchType*/ 7, /*MVT::i64*/8, // ->14021
/* 14014*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_U_I64),
                 /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
             // Src: (udiv:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (DIV_U_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 14021*/  0, // EndSwitchType
/* 14022*/ /*SwitchOpcode*/ 22, TARGET_VAL(ISD::SREM),// ->14047
/* 14025*/  OPC_RecordChild0, // #0 = $lhs
/* 14026*/  OPC_RecordChild1, // #1 = $rhs
/* 14027*/  OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->14037
/* 14030*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REM_S_I32),
                 /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
             // Src: (srem:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (REM_S_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 14037*/  /*SwitchType*/ 7, /*MVT::i64*/8, // ->14046
/* 14039*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REM_S_I64),
                 /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
             // Src: (srem:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (REM_S_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 14046*/  0, // EndSwitchType
/* 14047*/ /*SwitchOpcode*/ 22, TARGET_VAL(ISD::UREM),// ->14072
/* 14050*/  OPC_RecordChild0, // #0 = $lhs
/* 14051*/  OPC_RecordChild1, // #1 = $rhs
/* 14052*/  OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->14062
/* 14055*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REM_U_I32),
                 /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
             // Src: (urem:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
             // Dst: (REM_U_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 14062*/  /*SwitchType*/ 7, /*MVT::i64*/8, // ->14071
/* 14064*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REM_U_I64),
                 /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
             // Src: (urem:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
             // Dst: (REM_U_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 14071*/  0, // EndSwitchType
/* 14072*/ /*SwitchOpcode*/ 56|128,6/*824*/, TARGET_VAL(ISD::OR),// ->14900
/* 14076*/  OPC_Scope, 22, /*->14100*/ // 3 children in Scope
/* 14078*/   OPC_RecordChild0, // #0 = $lhs
/* 14079*/   OPC_RecordChild1, // #1 = $rhs
/* 14080*/   OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->14090
/* 14083*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (OR_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 14090*/   /*SwitchType*/ 7, /*MVT::i64*/8, // ->14099
/* 14092*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (OR_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 14099*/   0, // EndSwitchType
/* 14100*/  /*Scope*/ 116|128,5/*756*/, /*->14858*/
/* 14102*/   OPC_MoveChild0,
/* 14103*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14106*/   OPC_Scope, 4|128,1/*132*/, /*->14241*/ // 9 children in Scope
/* 14109*/    OPC_RecordChild0, // #0 = $c
/* 14110*/    OPC_RecordChild1, // #1 = $v1
/* 14111*/    OPC_MoveSibling1,
/* 14112*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14115*/    OPC_Scope, 54, /*->14171*/ // 4 children in Scope
/* 14117*/     OPC_MoveChild0,
/* 14118*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14121*/     OPC_CheckChild0Same, 0,
/* 14123*/     OPC_MoveChild1,
/* 14124*/     OPC_CheckImmAllOnesV,
/* 14125*/     OPC_MoveParent,
/* 14126*/     OPC_MoveParent,
/* 14127*/     OPC_RecordChild1, // #2 = $v2
/* 14128*/     OPC_MoveParent,
/* 14129*/     OPC_SwitchType /*4 cases */, 8, /*MVT::v16i8*/39, // ->14140
/* 14132*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v16i8*/39, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14140*/     /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->14150
/* 14142*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v8i16*/50, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14150*/     /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->14160
/* 14152*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v4i32*/60, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14160*/     /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->14170
/* 14162*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v2i64*/78, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14170*/     0, // EndSwitchType
/* 14171*/    /*Scope*/ 22, /*->14194*/
/* 14172*/     OPC_RecordChild0, // #2 = $v2
/* 14173*/     OPC_MoveChild1,
/* 14174*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14177*/     OPC_CheckChild0Same, 0,
/* 14179*/     OPC_MoveChild1,
/* 14180*/     OPC_CheckImmAllOnesV,
/* 14181*/     OPC_MoveParent,
/* 14182*/     OPC_MoveParent,
/* 14183*/     OPC_MoveParent,
/* 14184*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 14186*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 1, 2, 0, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14194*/    /*Scope*/ 22, /*->14217*/
/* 14195*/     OPC_MoveChild0,
/* 14196*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14199*/     OPC_CheckChild0Same, 1,
/* 14201*/     OPC_MoveChild1,
/* 14202*/     OPC_CheckImmAllOnesV,
/* 14203*/     OPC_MoveParent,
/* 14204*/     OPC_MoveParent,
/* 14205*/     OPC_RecordChild1, // #2 = $v2
/* 14206*/     OPC_MoveParent,
/* 14207*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 14209*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 0, 2, 1, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$c), (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$v2)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14217*/    /*Scope*/ 22, /*->14240*/
/* 14218*/     OPC_RecordChild0, // #2 = $v2
/* 14219*/     OPC_MoveChild1,
/* 14220*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14223*/     OPC_CheckChild0Same, 1,
/* 14225*/     OPC_MoveChild1,
/* 14226*/     OPC_CheckImmAllOnesV,
/* 14227*/     OPC_MoveParent,
/* 14228*/     OPC_MoveParent,
/* 14229*/     OPC_MoveParent,
/* 14230*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 14232*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 0, 2, 1, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$c), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14240*/    0, /*End of Scope*/
/* 14241*/   /*Scope*/ 46, /*->14288*/
/* 14242*/    OPC_MoveChild0,
/* 14243*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14246*/    OPC_RecordChild0, // #0 = $c
/* 14247*/    OPC_MoveChild1,
/* 14248*/    OPC_CheckImmAllOnesV,
/* 14249*/    OPC_MoveParent,
/* 14250*/    OPC_MoveParent,
/* 14251*/    OPC_RecordChild1, // #1 = $v2
/* 14252*/    OPC_MoveSibling1,
/* 14253*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14256*/    OPC_Scope, 14, /*->14272*/ // 2 children in Scope
/* 14258*/     OPC_CheckChild0Same, 0,
/* 14260*/     OPC_RecordChild1, // #2 = $v1
/* 14261*/     OPC_MoveParent,
/* 14262*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 14264*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$v2), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14272*/    /*Scope*/ 14, /*->14287*/
/* 14273*/     OPC_RecordChild0, // #2 = $v1
/* 14274*/     OPC_CheckChild1Same, 0,
/* 14276*/     OPC_MoveParent,
/* 14277*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 14279*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), V128:{ *:[v16i8] }:$v2), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14287*/    0, /*End of Scope*/
/* 14288*/   /*Scope*/ 126, /*->14415*/
/* 14289*/    OPC_RecordChild0, // #0 = $v2
/* 14290*/    OPC_Scope, 45, /*->14337*/ // 2 children in Scope
/* 14292*/     OPC_MoveChild1,
/* 14293*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14296*/     OPC_RecordChild0, // #1 = $c
/* 14297*/     OPC_MoveChild1,
/* 14298*/     OPC_CheckImmAllOnesV,
/* 14299*/     OPC_MoveParent,
/* 14300*/     OPC_MoveParent,
/* 14301*/     OPC_MoveSibling1,
/* 14302*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14305*/     OPC_Scope, 14, /*->14321*/ // 2 children in Scope
/* 14307*/      OPC_CheckChild0Same, 1,
/* 14309*/      OPC_RecordChild1, // #2 = $v1
/* 14310*/      OPC_MoveParent,
/* 14311*/      OPC_CheckType, /*MVT::v16i8*/39, 
/* 14313*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v16i8*/39, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14321*/     /*Scope*/ 14, /*->14336*/
/* 14322*/      OPC_RecordChild0, // #2 = $v1
/* 14323*/      OPC_CheckChild1Same, 1,
/* 14325*/      OPC_MoveParent,
/* 14326*/      OPC_CheckType, /*MVT::v16i8*/39, 
/* 14328*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v16i8*/39, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] })), (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$c)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 14336*/     0, /*End of Scope*/
/* 14337*/    /*Scope*/ 76, /*->14414*/
/* 14338*/     OPC_RecordChild1, // #1 = $v1
/* 14339*/     OPC_MoveSibling1,
/* 14340*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14343*/     OPC_Scope, 22, /*->14367*/ // 3 children in Scope
/* 14345*/      OPC_RecordChild0, // #2 = $v2
/* 14346*/      OPC_MoveChild1,
/* 14347*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14350*/      OPC_CheckChild0Same, 0,
/* 14352*/      OPC_MoveChild1,
/* 14353*/      OPC_CheckImmAllOnesV,
/* 14354*/      OPC_MoveParent,
/* 14355*/      OPC_MoveParent,
/* 14356*/      OPC_MoveParent,
/* 14357*/      OPC_CheckType, /*MVT::v8i16*/50, 
/* 14359*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v8i16*/50, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14367*/     /*Scope*/ 22, /*->14390*/
/* 14368*/      OPC_MoveChild0,
/* 14369*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14372*/      OPC_CheckChild0Same, 1,
/* 14374*/      OPC_MoveChild1,
/* 14375*/      OPC_CheckImmAllOnesV,
/* 14376*/      OPC_MoveParent,
/* 14377*/      OPC_MoveParent,
/* 14378*/      OPC_RecordChild1, // #2 = $v2
/* 14379*/      OPC_MoveParent,
/* 14380*/      OPC_CheckType, /*MVT::v8i16*/50, 
/* 14382*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v8i16*/50, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$c), (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14390*/     /*Scope*/ 22, /*->14413*/
/* 14391*/      OPC_RecordChild0, // #2 = $v2
/* 14392*/      OPC_MoveChild1,
/* 14393*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14396*/      OPC_CheckChild0Same, 1,
/* 14398*/      OPC_MoveChild1,
/* 14399*/      OPC_CheckImmAllOnesV,
/* 14400*/      OPC_MoveParent,
/* 14401*/      OPC_MoveParent,
/* 14402*/      OPC_MoveParent,
/* 14403*/      OPC_CheckType, /*MVT::v8i16*/50, 
/* 14405*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v8i16*/50, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$c), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14413*/     0, /*End of Scope*/
/* 14414*/    0, /*End of Scope*/
/* 14415*/   /*Scope*/ 46, /*->14462*/
/* 14416*/    OPC_MoveChild0,
/* 14417*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14420*/    OPC_RecordChild0, // #0 = $c
/* 14421*/    OPC_MoveChild1,
/* 14422*/    OPC_CheckImmAllOnesV,
/* 14423*/    OPC_MoveParent,
/* 14424*/    OPC_MoveParent,
/* 14425*/    OPC_RecordChild1, // #1 = $v2
/* 14426*/    OPC_MoveSibling1,
/* 14427*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14430*/    OPC_Scope, 14, /*->14446*/ // 2 children in Scope
/* 14432*/     OPC_CheckChild0Same, 0,
/* 14434*/     OPC_RecordChild1, // #2 = $v1
/* 14435*/     OPC_MoveParent,
/* 14436*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 14438*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$v2), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14446*/    /*Scope*/ 14, /*->14461*/
/* 14447*/     OPC_RecordChild0, // #2 = $v1
/* 14448*/     OPC_CheckChild1Same, 0,
/* 14450*/     OPC_MoveParent,
/* 14451*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 14453*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), V128:{ *:[v8i16] }:$v2), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14461*/    0, /*End of Scope*/
/* 14462*/   /*Scope*/ 126, /*->14589*/
/* 14463*/    OPC_RecordChild0, // #0 = $v2
/* 14464*/    OPC_Scope, 45, /*->14511*/ // 2 children in Scope
/* 14466*/     OPC_MoveChild1,
/* 14467*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14470*/     OPC_RecordChild0, // #1 = $c
/* 14471*/     OPC_MoveChild1,
/* 14472*/     OPC_CheckImmAllOnesV,
/* 14473*/     OPC_MoveParent,
/* 14474*/     OPC_MoveParent,
/* 14475*/     OPC_MoveSibling1,
/* 14476*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14479*/     OPC_Scope, 14, /*->14495*/ // 2 children in Scope
/* 14481*/      OPC_CheckChild0Same, 1,
/* 14483*/      OPC_RecordChild1, // #2 = $v1
/* 14484*/      OPC_MoveParent,
/* 14485*/      OPC_CheckType, /*MVT::v8i16*/50, 
/* 14487*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v8i16*/50, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14495*/     /*Scope*/ 14, /*->14510*/
/* 14496*/      OPC_RecordChild0, // #2 = $v1
/* 14497*/      OPC_CheckChild1Same, 1,
/* 14499*/      OPC_MoveParent,
/* 14500*/      OPC_CheckType, /*MVT::v8i16*/50, 
/* 14502*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v8i16*/50, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] })), (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$c)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 14510*/     0, /*End of Scope*/
/* 14511*/    /*Scope*/ 76, /*->14588*/
/* 14512*/     OPC_RecordChild1, // #1 = $v1
/* 14513*/     OPC_MoveSibling1,
/* 14514*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14517*/     OPC_Scope, 22, /*->14541*/ // 3 children in Scope
/* 14519*/      OPC_RecordChild0, // #2 = $v2
/* 14520*/      OPC_MoveChild1,
/* 14521*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14524*/      OPC_CheckChild0Same, 0,
/* 14526*/      OPC_MoveChild1,
/* 14527*/      OPC_CheckImmAllOnesV,
/* 14528*/      OPC_MoveParent,
/* 14529*/      OPC_MoveParent,
/* 14530*/      OPC_MoveParent,
/* 14531*/      OPC_CheckType, /*MVT::v4i32*/60, 
/* 14533*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v4i32*/60, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14541*/     /*Scope*/ 22, /*->14564*/
/* 14542*/      OPC_MoveChild0,
/* 14543*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14546*/      OPC_CheckChild0Same, 1,
/* 14548*/      OPC_MoveChild1,
/* 14549*/      OPC_CheckImmAllOnesV,
/* 14550*/      OPC_MoveParent,
/* 14551*/      OPC_MoveParent,
/* 14552*/      OPC_RecordChild1, // #2 = $v2
/* 14553*/      OPC_MoveParent,
/* 14554*/      OPC_CheckType, /*MVT::v4i32*/60, 
/* 14556*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v4i32*/60, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$c), (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14564*/     /*Scope*/ 22, /*->14587*/
/* 14565*/      OPC_RecordChild0, // #2 = $v2
/* 14566*/      OPC_MoveChild1,
/* 14567*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14570*/      OPC_CheckChild0Same, 1,
/* 14572*/      OPC_MoveChild1,
/* 14573*/      OPC_CheckImmAllOnesV,
/* 14574*/      OPC_MoveParent,
/* 14575*/      OPC_MoveParent,
/* 14576*/      OPC_MoveParent,
/* 14577*/      OPC_CheckType, /*MVT::v4i32*/60, 
/* 14579*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v4i32*/60, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$c), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14587*/     0, /*End of Scope*/
/* 14588*/    0, /*End of Scope*/
/* 14589*/   /*Scope*/ 46, /*->14636*/
/* 14590*/    OPC_MoveChild0,
/* 14591*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14594*/    OPC_RecordChild0, // #0 = $c
/* 14595*/    OPC_MoveChild1,
/* 14596*/    OPC_CheckImmAllOnesV,
/* 14597*/    OPC_MoveParent,
/* 14598*/    OPC_MoveParent,
/* 14599*/    OPC_RecordChild1, // #1 = $v2
/* 14600*/    OPC_MoveSibling1,
/* 14601*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14604*/    OPC_Scope, 14, /*->14620*/ // 2 children in Scope
/* 14606*/     OPC_CheckChild0Same, 0,
/* 14608*/     OPC_RecordChild1, // #2 = $v1
/* 14609*/     OPC_MoveParent,
/* 14610*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 14612*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$v2), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14620*/    /*Scope*/ 14, /*->14635*/
/* 14621*/     OPC_RecordChild0, // #2 = $v1
/* 14622*/     OPC_CheckChild1Same, 0,
/* 14624*/     OPC_MoveParent,
/* 14625*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 14627*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), V128:{ *:[v4i32] }:$v2), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14635*/    0, /*End of Scope*/
/* 14636*/   /*Scope*/ 126, /*->14763*/
/* 14637*/    OPC_RecordChild0, // #0 = $v2
/* 14638*/    OPC_Scope, 45, /*->14685*/ // 2 children in Scope
/* 14640*/     OPC_MoveChild1,
/* 14641*/     OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14644*/     OPC_RecordChild0, // #1 = $c
/* 14645*/     OPC_MoveChild1,
/* 14646*/     OPC_CheckImmAllOnesV,
/* 14647*/     OPC_MoveParent,
/* 14648*/     OPC_MoveParent,
/* 14649*/     OPC_MoveSibling1,
/* 14650*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14653*/     OPC_Scope, 14, /*->14669*/ // 2 children in Scope
/* 14655*/      OPC_CheckChild0Same, 1,
/* 14657*/      OPC_RecordChild1, // #2 = $v1
/* 14658*/      OPC_MoveParent,
/* 14659*/      OPC_CheckType, /*MVT::v4i32*/60, 
/* 14661*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v4i32*/60, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14669*/     /*Scope*/ 14, /*->14684*/
/* 14670*/      OPC_RecordChild0, // #2 = $v1
/* 14671*/      OPC_CheckChild1Same, 1,
/* 14673*/      OPC_MoveParent,
/* 14674*/      OPC_CheckType, /*MVT::v4i32*/60, 
/* 14676*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v4i32*/60, 3/*#Ops*/, 2, 0, 1, 
                // Src: (or:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] })), (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$c)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 14684*/     0, /*End of Scope*/
/* 14685*/    /*Scope*/ 76, /*->14762*/
/* 14686*/     OPC_RecordChild1, // #1 = $v1
/* 14687*/     OPC_MoveSibling1,
/* 14688*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14691*/     OPC_Scope, 22, /*->14715*/ // 3 children in Scope
/* 14693*/      OPC_RecordChild0, // #2 = $v2
/* 14694*/      OPC_MoveChild1,
/* 14695*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14698*/      OPC_CheckChild0Same, 0,
/* 14700*/      OPC_MoveChild1,
/* 14701*/      OPC_CheckImmAllOnesV,
/* 14702*/      OPC_MoveParent,
/* 14703*/      OPC_MoveParent,
/* 14704*/      OPC_MoveParent,
/* 14705*/      OPC_CheckType, /*MVT::v2i64*/78, 
/* 14707*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v2i64*/78, 3/*#Ops*/, 1, 2, 0, 
                // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14715*/     /*Scope*/ 22, /*->14738*/
/* 14716*/      OPC_MoveChild0,
/* 14717*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14720*/      OPC_CheckChild0Same, 1,
/* 14722*/      OPC_MoveChild1,
/* 14723*/      OPC_CheckImmAllOnesV,
/* 14724*/      OPC_MoveParent,
/* 14725*/      OPC_MoveParent,
/* 14726*/      OPC_RecordChild1, // #2 = $v2
/* 14727*/      OPC_MoveParent,
/* 14728*/      OPC_CheckType, /*MVT::v2i64*/78, 
/* 14730*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v2i64*/78, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$c), (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$v2)) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14738*/     /*Scope*/ 22, /*->14761*/
/* 14739*/      OPC_RecordChild0, // #2 = $v2
/* 14740*/      OPC_MoveChild1,
/* 14741*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14744*/      OPC_CheckChild0Same, 1,
/* 14746*/      OPC_MoveChild1,
/* 14747*/      OPC_CheckImmAllOnesV,
/* 14748*/      OPC_MoveParent,
/* 14749*/      OPC_MoveParent,
/* 14750*/      OPC_MoveParent,
/* 14751*/      OPC_CheckType, /*MVT::v2i64*/78, 
/* 14753*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v2i64*/78, 3/*#Ops*/, 0, 2, 1, 
                // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$c), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }))) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14761*/     0, /*End of Scope*/
/* 14762*/    0, /*End of Scope*/
/* 14763*/   /*Scope*/ 46, /*->14810*/
/* 14764*/    OPC_MoveChild0,
/* 14765*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14768*/    OPC_RecordChild0, // #0 = $c
/* 14769*/    OPC_MoveChild1,
/* 14770*/    OPC_CheckImmAllOnesV,
/* 14771*/    OPC_MoveParent,
/* 14772*/    OPC_MoveParent,
/* 14773*/    OPC_RecordChild1, // #1 = $v2
/* 14774*/    OPC_MoveSibling1,
/* 14775*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14778*/    OPC_Scope, 14, /*->14794*/ // 2 children in Scope
/* 14780*/     OPC_CheckChild0Same, 0,
/* 14782*/     OPC_RecordChild1, // #2 = $v1
/* 14783*/     OPC_MoveParent,
/* 14784*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 14786*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v2i64*/78, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$v2), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14794*/    /*Scope*/ 14, /*->14809*/
/* 14795*/     OPC_RecordChild0, // #2 = $v1
/* 14796*/     OPC_CheckChild1Same, 0,
/* 14798*/     OPC_MoveParent,
/* 14799*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 14801*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v2i64*/78, 3/*#Ops*/, 2, 1, 0, 
               // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), V128:{ *:[v2i64] }:$v2), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14809*/    0, /*End of Scope*/
/* 14810*/   /*Scope*/ 46, /*->14857*/
/* 14811*/    OPC_RecordChild0, // #0 = $v2
/* 14812*/    OPC_MoveChild1,
/* 14813*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14816*/    OPC_RecordChild0, // #1 = $c
/* 14817*/    OPC_MoveChild1,
/* 14818*/    OPC_CheckImmAllOnesV,
/* 14819*/    OPC_MoveParent,
/* 14820*/    OPC_MoveParent,
/* 14821*/    OPC_MoveSibling1,
/* 14822*/    OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14825*/    OPC_Scope, 14, /*->14841*/ // 2 children in Scope
/* 14827*/     OPC_CheckChild0Same, 1,
/* 14829*/     OPC_RecordChild1, // #2 = $v1
/* 14830*/     OPC_MoveParent,
/* 14831*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 14833*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v2i64*/78, 3/*#Ops*/, 2, 0, 1, 
               // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14841*/    /*Scope*/ 14, /*->14856*/
/* 14842*/     OPC_RecordChild0, // #2 = $v1
/* 14843*/     OPC_CheckChild1Same, 1,
/* 14845*/     OPC_MoveParent,
/* 14846*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 14848*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v2i64*/78, 3/*#Ops*/, 2, 0, 1, 
               // Src: (or:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] })), (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$c)) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 14856*/    0, /*End of Scope*/
/* 14857*/   0, /*End of Scope*/
/* 14858*/  /*Scope*/ 40, /*->14899*/
/* 14859*/   OPC_RecordChild0, // #0 = $lhs
/* 14860*/   OPC_RecordChild1, // #1 = $rhs
/* 14861*/   OPC_SwitchType /*4 cases */, 7, /*MVT::v16i8*/39, // ->14871
/* 14864*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR),
                  /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
              // Dst: (OR:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/* 14871*/   /*SwitchType*/ 7, /*MVT::v8i16*/50, // ->14880
/* 14873*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
              // Dst: (OR:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 14880*/   /*SwitchType*/ 7, /*MVT::v4i32*/60, // ->14889
/* 14882*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR),
                  /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
              // Dst: (OR:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/* 14889*/   /*SwitchType*/ 7, /*MVT::v2i64*/78, // ->14898
/* 14891*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::OR),
                  /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
              // Src: (or:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
              // Dst: (OR:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/* 14898*/   0, // EndSwitchType
/* 14899*/  0, /*End of Scope*/
/* 14900*/ /*SwitchOpcode*/ 121|128,11/*1529*/, TARGET_VAL(ISD::XOR),// ->16433
/* 14904*/  OPC_Scope, 22, /*->14928*/ // 17 children in Scope
/* 14906*/   OPC_RecordChild0, // #0 = $lhs
/* 14907*/   OPC_RecordChild1, // #1 = $rhs
/* 14908*/   OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->14918
/* 14911*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR_I32),
                  /*MVT::i32*/7, 2/*#Ops*/, 0, 1, 
              // Src: (xor:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs) - Complexity = 3
              // Dst: (XOR_I32:{ *:[i32] } I32:{ *:[i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 14918*/   /*SwitchType*/ 7, /*MVT::i64*/8, // ->14927
/* 14920*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR_I64),
                  /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
              // Src: (xor:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs) - Complexity = 3
              // Dst: (XOR_I64:{ *:[i64] } I64:{ *:[i64] }:$lhs, I64:{ *:[i64] }:$rhs)
/* 14927*/   0, // EndSwitchType
/* 14928*/  /*Scope*/ 121, /*->15050*/
/* 14929*/   OPC_MoveChild0,
/* 14930*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 14933*/   OPC_MoveChild0,
/* 14934*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14937*/   OPC_RecordChild0, // #0 = $v1
/* 14938*/   OPC_Scope, 71, /*->15011*/ // 2 children in Scope
/* 14940*/    OPC_RecordChild1, // #1 = $v2
/* 14941*/    OPC_MoveSibling1,
/* 14942*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 14945*/    OPC_RecordChild0, // #2 = $c
/* 14946*/    OPC_MoveChild1,
/* 14947*/    OPC_CheckImmAllOnesV,
/* 14948*/    OPC_MoveParent,
/* 14949*/    OPC_MoveParent,
/* 14950*/    OPC_MoveParent,
/* 14951*/    OPC_Scope, 44, /*->14997*/ // 2 children in Scope
/* 14953*/     OPC_CheckChild1Same, 1,
/* 14955*/     OPC_SwitchType /*4 cases */, 8, /*MVT::v16i8*/39, // ->14966
/* 14958*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v16i8*/39, 3/*#Ops*/, 1, 0, 2, 
                // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] })), V128:{ *:[v16i8] }:$v2) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 14966*/     /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->14976
/* 14968*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v8i16*/50, 3/*#Ops*/, 1, 0, 2, 
                // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] })), V128:{ *:[v8i16] }:$v2) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 14976*/     /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->14986
/* 14978*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v4i32*/60, 3/*#Ops*/, 1, 0, 2, 
                // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] })), V128:{ *:[v4i32] }:$v2) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 14986*/     /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->14996
/* 14988*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v2i64*/78, 3/*#Ops*/, 1, 0, 2, 
                // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] })), V128:{ *:[v2i64] }:$v2) - Complexity = 16
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 14996*/     0, // EndSwitchType
/* 14997*/    /*Scope*/ 12, /*->15010*/
/* 14998*/     OPC_CheckChild1Same, 0,
/* 15000*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 15002*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 0, 1, 2, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] })), V128:{ *:[v16i8] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 15010*/    0, /*End of Scope*/
/* 15011*/   /*Scope*/ 37, /*->15049*/
/* 15012*/    OPC_MoveChild1,
/* 15013*/    OPC_CheckImmAllOnesV,
/* 15014*/    OPC_MoveParent,
/* 15015*/    OPC_MoveSibling1,
/* 15016*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15019*/    OPC_RecordChild0, // #1 = $v1
/* 15020*/    OPC_RecordChild1, // #2 = $v2
/* 15021*/    OPC_MoveParent,
/* 15022*/    OPC_MoveParent,
/* 15023*/    OPC_CheckType, /*MVT::v16i8*/39, 
/* 15025*/    OPC_Scope, 10, /*->15037*/ // 2 children in Scope
/* 15027*/     OPC_CheckChild1Same, 2,
/* 15029*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2)), V128:{ *:[v16i8] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 15037*/    /*Scope*/ 10, /*->15048*/
/* 15038*/     OPC_CheckChild1Same, 1,
/* 15040*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1)), V128:{ *:[v16i8] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 15048*/    0, /*End of Scope*/
/* 15049*/   0, /*End of Scope*/
/* 15050*/  /*Scope*/ 102, /*->15153*/
/* 15051*/   OPC_RecordChild0, // #0 = $v2
/* 15052*/   OPC_MoveChild1,
/* 15053*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15056*/   OPC_MoveChild0,
/* 15057*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15060*/   OPC_Scope, 23, /*->15085*/ // 3 children in Scope
/* 15062*/    OPC_RecordChild0, // #1 = $v1
/* 15063*/    OPC_CheckChild1Same, 0,
/* 15065*/    OPC_MoveSibling1,
/* 15066*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15069*/    OPC_RecordChild0, // #2 = $c
/* 15070*/    OPC_MoveChild1,
/* 15071*/    OPC_CheckImmAllOnesV,
/* 15072*/    OPC_MoveParent,
/* 15073*/    OPC_MoveParent,
/* 15074*/    OPC_MoveParent,
/* 15075*/    OPC_CheckType, /*MVT::v16i8*/39, 
/* 15077*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v16i8*/39, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 15085*/   /*Scope*/ 23, /*->15109*/
/* 15086*/    OPC_CheckChild0Same, 0,
/* 15088*/    OPC_RecordChild1, // #1 = $v1
/* 15089*/    OPC_MoveSibling1,
/* 15090*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15093*/    OPC_RecordChild0, // #2 = $c
/* 15094*/    OPC_MoveChild1,
/* 15095*/    OPC_CheckImmAllOnesV,
/* 15096*/    OPC_MoveParent,
/* 15097*/    OPC_MoveParent,
/* 15098*/    OPC_MoveParent,
/* 15099*/    OPC_CheckType, /*MVT::v16i8*/39, 
/* 15101*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v16i8*/39, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 15109*/   /*Scope*/ 42, /*->15152*/
/* 15110*/    OPC_RecordChild0, // #1 = $c
/* 15111*/    OPC_MoveChild1,
/* 15112*/    OPC_CheckImmAllOnesV,
/* 15113*/    OPC_MoveParent,
/* 15114*/    OPC_MoveSibling1,
/* 15115*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15118*/    OPC_Scope, 15, /*->15135*/ // 2 children in Scope
/* 15120*/     OPC_RecordChild0, // #2 = $v1
/* 15121*/     OPC_CheckChild1Same, 0,
/* 15123*/     OPC_MoveParent,
/* 15124*/     OPC_MoveParent,
/* 15125*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 15127*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 15135*/    /*Scope*/ 15, /*->15151*/
/* 15136*/     OPC_CheckChild0Same, 0,
/* 15138*/     OPC_RecordChild1, // #2 = $v1
/* 15139*/     OPC_MoveParent,
/* 15140*/     OPC_MoveParent,
/* 15141*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 15143*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, immAllOnesV:{ *:[v16i8] }), (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$c)
/* 15151*/    0, /*End of Scope*/
/* 15152*/   0, /*End of Scope*/
/* 15153*/  /*Scope*/ 73, /*->15227*/
/* 15154*/   OPC_MoveChild0,
/* 15155*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15158*/   OPC_MoveChild0,
/* 15159*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15162*/   OPC_RecordChild0, // #0 = $v2
/* 15163*/   OPC_Scope, 23, /*->15188*/ // 2 children in Scope
/* 15165*/    OPC_RecordChild1, // #1 = $v1
/* 15166*/    OPC_MoveSibling1,
/* 15167*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15170*/    OPC_RecordChild0, // #2 = $c
/* 15171*/    OPC_MoveChild1,
/* 15172*/    OPC_CheckImmAllOnesV,
/* 15173*/    OPC_MoveParent,
/* 15174*/    OPC_MoveParent,
/* 15175*/    OPC_MoveParent,
/* 15176*/    OPC_CheckChild1Same, 0,
/* 15178*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 15180*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v8i16*/50, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] })), V128:{ *:[v8i16] }:$v2) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15188*/   /*Scope*/ 37, /*->15226*/
/* 15189*/    OPC_MoveChild1,
/* 15190*/    OPC_CheckImmAllOnesV,
/* 15191*/    OPC_MoveParent,
/* 15192*/    OPC_MoveSibling1,
/* 15193*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15196*/    OPC_RecordChild0, // #1 = $v1
/* 15197*/    OPC_RecordChild1, // #2 = $v2
/* 15198*/    OPC_MoveParent,
/* 15199*/    OPC_MoveParent,
/* 15200*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 15202*/    OPC_Scope, 10, /*->15214*/ // 2 children in Scope
/* 15204*/     OPC_CheckChild1Same, 2,
/* 15206*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2)), V128:{ *:[v8i16] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15214*/    /*Scope*/ 10, /*->15225*/
/* 15215*/     OPC_CheckChild1Same, 1,
/* 15217*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1)), V128:{ *:[v8i16] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15225*/    0, /*End of Scope*/
/* 15226*/   0, /*End of Scope*/
/* 15227*/  /*Scope*/ 102, /*->15330*/
/* 15228*/   OPC_RecordChild0, // #0 = $v2
/* 15229*/   OPC_MoveChild1,
/* 15230*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15233*/   OPC_MoveChild0,
/* 15234*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15237*/   OPC_Scope, 23, /*->15262*/ // 3 children in Scope
/* 15239*/    OPC_RecordChild0, // #1 = $v1
/* 15240*/    OPC_CheckChild1Same, 0,
/* 15242*/    OPC_MoveSibling1,
/* 15243*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15246*/    OPC_RecordChild0, // #2 = $c
/* 15247*/    OPC_MoveChild1,
/* 15248*/    OPC_CheckImmAllOnesV,
/* 15249*/    OPC_MoveParent,
/* 15250*/    OPC_MoveParent,
/* 15251*/    OPC_MoveParent,
/* 15252*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 15254*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v8i16*/50, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15262*/   /*Scope*/ 23, /*->15286*/
/* 15263*/    OPC_CheckChild0Same, 0,
/* 15265*/    OPC_RecordChild1, // #1 = $v1
/* 15266*/    OPC_MoveSibling1,
/* 15267*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15270*/    OPC_RecordChild0, // #2 = $c
/* 15271*/    OPC_MoveChild1,
/* 15272*/    OPC_CheckImmAllOnesV,
/* 15273*/    OPC_MoveParent,
/* 15274*/    OPC_MoveParent,
/* 15275*/    OPC_MoveParent,
/* 15276*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 15278*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v8i16*/50, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15286*/   /*Scope*/ 42, /*->15329*/
/* 15287*/    OPC_RecordChild0, // #1 = $c
/* 15288*/    OPC_MoveChild1,
/* 15289*/    OPC_CheckImmAllOnesV,
/* 15290*/    OPC_MoveParent,
/* 15291*/    OPC_MoveSibling1,
/* 15292*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15295*/    OPC_Scope, 15, /*->15312*/ // 2 children in Scope
/* 15297*/     OPC_RecordChild0, // #2 = $v1
/* 15298*/     OPC_CheckChild1Same, 0,
/* 15300*/     OPC_MoveParent,
/* 15301*/     OPC_MoveParent,
/* 15302*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 15304*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15312*/    /*Scope*/ 15, /*->15328*/
/* 15313*/     OPC_CheckChild0Same, 0,
/* 15315*/     OPC_RecordChild1, // #2 = $v1
/* 15316*/     OPC_MoveParent,
/* 15317*/     OPC_MoveParent,
/* 15318*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 15320*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, immAllOnesV:{ *:[v8i16] }), (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$c)
/* 15328*/    0, /*End of Scope*/
/* 15329*/   0, /*End of Scope*/
/* 15330*/  /*Scope*/ 73, /*->15404*/
/* 15331*/   OPC_MoveChild0,
/* 15332*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15335*/   OPC_MoveChild0,
/* 15336*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15339*/   OPC_RecordChild0, // #0 = $v2
/* 15340*/   OPC_Scope, 23, /*->15365*/ // 2 children in Scope
/* 15342*/    OPC_RecordChild1, // #1 = $v1
/* 15343*/    OPC_MoveSibling1,
/* 15344*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15347*/    OPC_RecordChild0, // #2 = $c
/* 15348*/    OPC_MoveChild1,
/* 15349*/    OPC_CheckImmAllOnesV,
/* 15350*/    OPC_MoveParent,
/* 15351*/    OPC_MoveParent,
/* 15352*/    OPC_MoveParent,
/* 15353*/    OPC_CheckChild1Same, 0,
/* 15355*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 15357*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v4i32*/60, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] })), V128:{ *:[v4i32] }:$v2) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15365*/   /*Scope*/ 37, /*->15403*/
/* 15366*/    OPC_MoveChild1,
/* 15367*/    OPC_CheckImmAllOnesV,
/* 15368*/    OPC_MoveParent,
/* 15369*/    OPC_MoveSibling1,
/* 15370*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15373*/    OPC_RecordChild0, // #1 = $v1
/* 15374*/    OPC_RecordChild1, // #2 = $v2
/* 15375*/    OPC_MoveParent,
/* 15376*/    OPC_MoveParent,
/* 15377*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 15379*/    OPC_Scope, 10, /*->15391*/ // 2 children in Scope
/* 15381*/     OPC_CheckChild1Same, 2,
/* 15383*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2)), V128:{ *:[v4i32] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15391*/    /*Scope*/ 10, /*->15402*/
/* 15392*/     OPC_CheckChild1Same, 1,
/* 15394*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1)), V128:{ *:[v4i32] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15402*/    0, /*End of Scope*/
/* 15403*/   0, /*End of Scope*/
/* 15404*/  /*Scope*/ 102, /*->15507*/
/* 15405*/   OPC_RecordChild0, // #0 = $v2
/* 15406*/   OPC_MoveChild1,
/* 15407*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15410*/   OPC_MoveChild0,
/* 15411*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15414*/   OPC_Scope, 23, /*->15439*/ // 3 children in Scope
/* 15416*/    OPC_RecordChild0, // #1 = $v1
/* 15417*/    OPC_CheckChild1Same, 0,
/* 15419*/    OPC_MoveSibling1,
/* 15420*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15423*/    OPC_RecordChild0, // #2 = $c
/* 15424*/    OPC_MoveChild1,
/* 15425*/    OPC_CheckImmAllOnesV,
/* 15426*/    OPC_MoveParent,
/* 15427*/    OPC_MoveParent,
/* 15428*/    OPC_MoveParent,
/* 15429*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 15431*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v4i32*/60, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15439*/   /*Scope*/ 23, /*->15463*/
/* 15440*/    OPC_CheckChild0Same, 0,
/* 15442*/    OPC_RecordChild1, // #1 = $v1
/* 15443*/    OPC_MoveSibling1,
/* 15444*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15447*/    OPC_RecordChild0, // #2 = $c
/* 15448*/    OPC_MoveChild1,
/* 15449*/    OPC_CheckImmAllOnesV,
/* 15450*/    OPC_MoveParent,
/* 15451*/    OPC_MoveParent,
/* 15452*/    OPC_MoveParent,
/* 15453*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 15455*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v4i32*/60, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15463*/   /*Scope*/ 42, /*->15506*/
/* 15464*/    OPC_RecordChild0, // #1 = $c
/* 15465*/    OPC_MoveChild1,
/* 15466*/    OPC_CheckImmAllOnesV,
/* 15467*/    OPC_MoveParent,
/* 15468*/    OPC_MoveSibling1,
/* 15469*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15472*/    OPC_Scope, 15, /*->15489*/ // 2 children in Scope
/* 15474*/     OPC_RecordChild0, // #2 = $v1
/* 15475*/     OPC_CheckChild1Same, 0,
/* 15477*/     OPC_MoveParent,
/* 15478*/     OPC_MoveParent,
/* 15479*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 15481*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15489*/    /*Scope*/ 15, /*->15505*/
/* 15490*/     OPC_CheckChild0Same, 0,
/* 15492*/     OPC_RecordChild1, // #2 = $v1
/* 15493*/     OPC_MoveParent,
/* 15494*/     OPC_MoveParent,
/* 15495*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 15497*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, immAllOnesV:{ *:[v4i32] }), (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$c)
/* 15505*/    0, /*End of Scope*/
/* 15506*/   0, /*End of Scope*/
/* 15507*/  /*Scope*/ 73, /*->15581*/
/* 15508*/   OPC_MoveChild0,
/* 15509*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15512*/   OPC_MoveChild0,
/* 15513*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15516*/   OPC_RecordChild0, // #0 = $v2
/* 15517*/   OPC_Scope, 23, /*->15542*/ // 2 children in Scope
/* 15519*/    OPC_RecordChild1, // #1 = $v1
/* 15520*/    OPC_MoveSibling1,
/* 15521*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15524*/    OPC_RecordChild0, // #2 = $c
/* 15525*/    OPC_MoveChild1,
/* 15526*/    OPC_CheckImmAllOnesV,
/* 15527*/    OPC_MoveParent,
/* 15528*/    OPC_MoveParent,
/* 15529*/    OPC_MoveParent,
/* 15530*/    OPC_CheckChild1Same, 0,
/* 15532*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 15534*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v2i64*/78, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] })), V128:{ *:[v2i64] }:$v2) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15542*/   /*Scope*/ 37, /*->15580*/
/* 15543*/    OPC_MoveChild1,
/* 15544*/    OPC_CheckImmAllOnesV,
/* 15545*/    OPC_MoveParent,
/* 15546*/    OPC_MoveSibling1,
/* 15547*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15550*/    OPC_RecordChild0, // #1 = $v1
/* 15551*/    OPC_RecordChild1, // #2 = $v2
/* 15552*/    OPC_MoveParent,
/* 15553*/    OPC_MoveParent,
/* 15554*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 15556*/    OPC_Scope, 10, /*->15568*/ // 2 children in Scope
/* 15558*/     OPC_CheckChild1Same, 2,
/* 15560*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v2i64*/78, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2)), V128:{ *:[v2i64] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15568*/    /*Scope*/ 10, /*->15579*/
/* 15569*/     OPC_CheckChild1Same, 1,
/* 15571*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v2i64*/78, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1)), V128:{ *:[v2i64] }:$v2) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15579*/    0, /*End of Scope*/
/* 15580*/   0, /*End of Scope*/
/* 15581*/  /*Scope*/ 102, /*->15684*/
/* 15582*/   OPC_RecordChild0, // #0 = $v2
/* 15583*/   OPC_MoveChild1,
/* 15584*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15587*/   OPC_MoveChild0,
/* 15588*/   OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15591*/   OPC_Scope, 23, /*->15616*/ // 3 children in Scope
/* 15593*/    OPC_RecordChild0, // #1 = $v1
/* 15594*/    OPC_CheckChild1Same, 0,
/* 15596*/    OPC_MoveSibling1,
/* 15597*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15600*/    OPC_RecordChild0, // #2 = $c
/* 15601*/    OPC_MoveChild1,
/* 15602*/    OPC_CheckImmAllOnesV,
/* 15603*/    OPC_MoveParent,
/* 15604*/    OPC_MoveParent,
/* 15605*/    OPC_MoveParent,
/* 15606*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 15608*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v2i64*/78, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15616*/   /*Scope*/ 23, /*->15640*/
/* 15617*/    OPC_CheckChild0Same, 0,
/* 15619*/    OPC_RecordChild1, // #1 = $v1
/* 15620*/    OPC_MoveSibling1,
/* 15621*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15624*/    OPC_RecordChild0, // #2 = $c
/* 15625*/    OPC_MoveChild1,
/* 15626*/    OPC_CheckImmAllOnesV,
/* 15627*/    OPC_MoveParent,
/* 15628*/    OPC_MoveParent,
/* 15629*/    OPC_MoveParent,
/* 15630*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 15632*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v2i64*/78, 3/*#Ops*/, 0, 1, 2, 
              // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }))) - Complexity = 16
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15640*/   /*Scope*/ 42, /*->15683*/
/* 15641*/    OPC_RecordChild0, // #1 = $c
/* 15642*/    OPC_MoveChild1,
/* 15643*/    OPC_CheckImmAllOnesV,
/* 15644*/    OPC_MoveParent,
/* 15645*/    OPC_MoveSibling1,
/* 15646*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15649*/    OPC_Scope, 15, /*->15666*/ // 2 children in Scope
/* 15651*/     OPC_RecordChild0, // #2 = $v1
/* 15652*/     OPC_CheckChild1Same, 0,
/* 15654*/     OPC_MoveParent,
/* 15655*/     OPC_MoveParent,
/* 15656*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 15658*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v2i64*/78, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15666*/    /*Scope*/ 15, /*->15682*/
/* 15667*/     OPC_CheckChild0Same, 0,
/* 15669*/     OPC_RecordChild1, // #2 = $v1
/* 15670*/     OPC_MoveParent,
/* 15671*/     OPC_MoveParent,
/* 15672*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 15674*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v2i64*/78, 3/*#Ops*/, 0, 2, 1, 
               // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, immAllOnesV:{ *:[v2i64] }), (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1))) - Complexity = 16
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$c)
/* 15682*/    0, /*End of Scope*/
/* 15683*/   0, /*End of Scope*/
/* 15684*/  /*Scope*/ 112, /*->15797*/
/* 15685*/   OPC_MoveChild0,
/* 15686*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15689*/   OPC_Scope, 69, /*->15760*/ // 2 children in Scope
/* 15691*/    OPC_MoveChild0,
/* 15692*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15695*/    OPC_RecordChild0, // #0 = $v1
/* 15696*/    OPC_RecordChild1, // #1 = $v2
/* 15697*/    OPC_MoveParent,
/* 15698*/    OPC_RecordChild1, // #2 = $c
/* 15699*/    OPC_MoveParent,
/* 15700*/    OPC_Scope, 44, /*->15746*/ // 2 children in Scope
/* 15702*/     OPC_CheckChild1Same, 1,
/* 15704*/     OPC_SwitchType /*4 cases */, 8, /*MVT::v16i8*/39, // ->15715
/* 15707*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v16i8*/39, 3/*#Ops*/, 0, 1, 2, 
                // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2), V128:{ *:[v16i8] }:$c), V128:{ *:[v16i8] }:$v2) - Complexity = 9
                // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15715*/     /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->15725
/* 15717*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v8i16*/50, 3/*#Ops*/, 0, 1, 2, 
                // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2), V128:{ *:[v8i16] }:$c), V128:{ *:[v8i16] }:$v2) - Complexity = 9
                // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15725*/     /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->15735
/* 15727*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v4i32*/60, 3/*#Ops*/, 0, 1, 2, 
                // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2), V128:{ *:[v4i32] }:$c), V128:{ *:[v4i32] }:$v2) - Complexity = 9
                // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 15735*/     /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->15745
/* 15737*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                    /*MVT::v2i64*/78, 3/*#Ops*/, 0, 1, 2, 
                // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2), V128:{ *:[v2i64] }:$c), V128:{ *:[v2i64] }:$v2) - Complexity = 9
                // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 15745*/     0, // EndSwitchType
/* 15746*/    /*Scope*/ 12, /*->15759*/
/* 15747*/     OPC_CheckChild1Same, 0,
/* 15749*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 15751*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1), V128:{ *:[v16i8] }:$c), V128:{ *:[v16i8] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15759*/    0, /*End of Scope*/
/* 15760*/   /*Scope*/ 35, /*->15796*/
/* 15761*/    OPC_RecordChild0, // #0 = $c
/* 15762*/    OPC_MoveChild1,
/* 15763*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15766*/    OPC_RecordChild0, // #1 = $v1
/* 15767*/    OPC_RecordChild1, // #2 = $v2
/* 15768*/    OPC_MoveParent,
/* 15769*/    OPC_MoveParent,
/* 15770*/    OPC_CheckType, /*MVT::v16i8*/39, 
/* 15772*/    OPC_Scope, 10, /*->15784*/ // 2 children in Scope
/* 15774*/     OPC_CheckChild1Same, 2,
/* 15776*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2)), V128:{ *:[v16i8] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15784*/    /*Scope*/ 10, /*->15795*/
/* 15785*/     OPC_CheckChild1Same, 1,
/* 15787*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v16i8] } (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1)), V128:{ *:[v16i8] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15795*/    0, /*End of Scope*/
/* 15796*/   0, /*End of Scope*/
/* 15797*/  /*Scope*/ 88, /*->15886*/
/* 15798*/   OPC_RecordChild0, // #0 = $v2
/* 15799*/   OPC_MoveChild1,
/* 15800*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15803*/   OPC_Scope, 40, /*->15845*/ // 2 children in Scope
/* 15805*/    OPC_MoveChild0,
/* 15806*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15809*/    OPC_Scope, 16, /*->15827*/ // 2 children in Scope
/* 15811*/     OPC_RecordChild0, // #1 = $v1
/* 15812*/     OPC_CheckChild1Same, 0,
/* 15814*/     OPC_MoveParent,
/* 15815*/     OPC_RecordChild1, // #2 = $c
/* 15816*/     OPC_MoveParent,
/* 15817*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 15819*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2), V128:{ *:[v16i8] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15827*/    /*Scope*/ 16, /*->15844*/
/* 15828*/     OPC_CheckChild0Same, 0,
/* 15830*/     OPC_RecordChild1, // #1 = $v1
/* 15831*/     OPC_MoveParent,
/* 15832*/     OPC_RecordChild1, // #2 = $c
/* 15833*/     OPC_MoveParent,
/* 15834*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 15836*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1), V128:{ *:[v16i8] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15844*/    0, /*End of Scope*/
/* 15845*/   /*Scope*/ 39, /*->15885*/
/* 15846*/    OPC_RecordChild0, // #1 = $c
/* 15847*/    OPC_MoveChild1,
/* 15848*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15851*/    OPC_Scope, 15, /*->15868*/ // 2 children in Scope
/* 15853*/     OPC_RecordChild0, // #2 = $v1
/* 15854*/     OPC_CheckChild1Same, 0,
/* 15856*/     OPC_MoveParent,
/* 15857*/     OPC_MoveParent,
/* 15858*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 15860*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15868*/    /*Scope*/ 15, /*->15884*/
/* 15869*/     OPC_CheckChild0Same, 0,
/* 15871*/     OPC_RecordChild1, // #2 = $v1
/* 15872*/     OPC_MoveParent,
/* 15873*/     OPC_MoveParent,
/* 15874*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 15876*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v16i8*/39, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, (and:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v2, V128:{ *:[v16i8] }:$v1))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 15884*/    0, /*End of Scope*/
/* 15885*/   0, /*End of Scope*/
/* 15886*/  /*Scope*/ 64, /*->15951*/
/* 15887*/   OPC_MoveChild0,
/* 15888*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15891*/   OPC_Scope, 21, /*->15914*/ // 2 children in Scope
/* 15893*/    OPC_MoveChild0,
/* 15894*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15897*/    OPC_RecordChild0, // #0 = $v2
/* 15898*/    OPC_RecordChild1, // #1 = $v1
/* 15899*/    OPC_MoveParent,
/* 15900*/    OPC_RecordChild1, // #2 = $c
/* 15901*/    OPC_MoveParent,
/* 15902*/    OPC_CheckChild1Same, 0,
/* 15904*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 15906*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v8i16*/50, 3/*#Ops*/, 1, 0, 2, 
              // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1), V128:{ *:[v8i16] }:$c), V128:{ *:[v8i16] }:$v2) - Complexity = 9
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15914*/   /*Scope*/ 35, /*->15950*/
/* 15915*/    OPC_RecordChild0, // #0 = $c
/* 15916*/    OPC_MoveChild1,
/* 15917*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15920*/    OPC_RecordChild0, // #1 = $v1
/* 15921*/    OPC_RecordChild1, // #2 = $v2
/* 15922*/    OPC_MoveParent,
/* 15923*/    OPC_MoveParent,
/* 15924*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 15926*/    OPC_Scope, 10, /*->15938*/ // 2 children in Scope
/* 15928*/     OPC_CheckChild1Same, 2,
/* 15930*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2)), V128:{ *:[v8i16] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15938*/    /*Scope*/ 10, /*->15949*/
/* 15939*/     OPC_CheckChild1Same, 1,
/* 15941*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v8i16] } (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1)), V128:{ *:[v8i16] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15949*/    0, /*End of Scope*/
/* 15950*/   0, /*End of Scope*/
/* 15951*/  /*Scope*/ 88, /*->16040*/
/* 15952*/   OPC_RecordChild0, // #0 = $v2
/* 15953*/   OPC_MoveChild1,
/* 15954*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 15957*/   OPC_Scope, 40, /*->15999*/ // 2 children in Scope
/* 15959*/    OPC_MoveChild0,
/* 15960*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 15963*/    OPC_Scope, 16, /*->15981*/ // 2 children in Scope
/* 15965*/     OPC_RecordChild0, // #1 = $v1
/* 15966*/     OPC_CheckChild1Same, 0,
/* 15968*/     OPC_MoveParent,
/* 15969*/     OPC_RecordChild1, // #2 = $c
/* 15970*/     OPC_MoveParent,
/* 15971*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 15973*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2), V128:{ *:[v8i16] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15981*/    /*Scope*/ 16, /*->15998*/
/* 15982*/     OPC_CheckChild0Same, 0,
/* 15984*/     OPC_RecordChild1, // #1 = $v1
/* 15985*/     OPC_MoveParent,
/* 15986*/     OPC_RecordChild1, // #2 = $c
/* 15987*/     OPC_MoveParent,
/* 15988*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 15990*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1), V128:{ *:[v8i16] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 15998*/    0, /*End of Scope*/
/* 15999*/   /*Scope*/ 39, /*->16039*/
/* 16000*/    OPC_RecordChild0, // #1 = $c
/* 16001*/    OPC_MoveChild1,
/* 16002*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16005*/    OPC_Scope, 15, /*->16022*/ // 2 children in Scope
/* 16007*/     OPC_RecordChild0, // #2 = $v1
/* 16008*/     OPC_CheckChild1Same, 0,
/* 16010*/     OPC_MoveParent,
/* 16011*/     OPC_MoveParent,
/* 16012*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 16014*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 16022*/    /*Scope*/ 15, /*->16038*/
/* 16023*/     OPC_CheckChild0Same, 0,
/* 16025*/     OPC_RecordChild1, // #2 = $v1
/* 16026*/     OPC_MoveParent,
/* 16027*/     OPC_MoveParent,
/* 16028*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 16030*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v8i16*/50, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, (and:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v2, V128:{ *:[v8i16] }:$v1))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 16038*/    0, /*End of Scope*/
/* 16039*/   0, /*End of Scope*/
/* 16040*/  /*Scope*/ 64, /*->16105*/
/* 16041*/   OPC_MoveChild0,
/* 16042*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 16045*/   OPC_Scope, 21, /*->16068*/ // 2 children in Scope
/* 16047*/    OPC_MoveChild0,
/* 16048*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16051*/    OPC_RecordChild0, // #0 = $v2
/* 16052*/    OPC_RecordChild1, // #1 = $v1
/* 16053*/    OPC_MoveParent,
/* 16054*/    OPC_RecordChild1, // #2 = $c
/* 16055*/    OPC_MoveParent,
/* 16056*/    OPC_CheckChild1Same, 0,
/* 16058*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 16060*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v4i32*/60, 3/*#Ops*/, 1, 0, 2, 
              // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1), V128:{ *:[v4i32] }:$c), V128:{ *:[v4i32] }:$v2) - Complexity = 9
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 16068*/   /*Scope*/ 35, /*->16104*/
/* 16069*/    OPC_RecordChild0, // #0 = $c
/* 16070*/    OPC_MoveChild1,
/* 16071*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16074*/    OPC_RecordChild0, // #1 = $v1
/* 16075*/    OPC_RecordChild1, // #2 = $v2
/* 16076*/    OPC_MoveParent,
/* 16077*/    OPC_MoveParent,
/* 16078*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 16080*/    OPC_Scope, 10, /*->16092*/ // 2 children in Scope
/* 16082*/     OPC_CheckChild1Same, 2,
/* 16084*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2)), V128:{ *:[v4i32] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 16092*/    /*Scope*/ 10, /*->16103*/
/* 16093*/     OPC_CheckChild1Same, 1,
/* 16095*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v4i32] } (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1)), V128:{ *:[v4i32] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 16103*/    0, /*End of Scope*/
/* 16104*/   0, /*End of Scope*/
/* 16105*/  /*Scope*/ 88, /*->16194*/
/* 16106*/   OPC_RecordChild0, // #0 = $v2
/* 16107*/   OPC_MoveChild1,
/* 16108*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 16111*/   OPC_Scope, 40, /*->16153*/ // 2 children in Scope
/* 16113*/    OPC_MoveChild0,
/* 16114*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16117*/    OPC_Scope, 16, /*->16135*/ // 2 children in Scope
/* 16119*/     OPC_RecordChild0, // #1 = $v1
/* 16120*/     OPC_CheckChild1Same, 0,
/* 16122*/     OPC_MoveParent,
/* 16123*/     OPC_RecordChild1, // #2 = $c
/* 16124*/     OPC_MoveParent,
/* 16125*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 16127*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2), V128:{ *:[v4i32] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 16135*/    /*Scope*/ 16, /*->16152*/
/* 16136*/     OPC_CheckChild0Same, 0,
/* 16138*/     OPC_RecordChild1, // #1 = $v1
/* 16139*/     OPC_MoveParent,
/* 16140*/     OPC_RecordChild1, // #2 = $c
/* 16141*/     OPC_MoveParent,
/* 16142*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 16144*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 1, 0, 2, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1), V128:{ *:[v4i32] }:$c)) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 16152*/    0, /*End of Scope*/
/* 16153*/   /*Scope*/ 39, /*->16193*/
/* 16154*/    OPC_RecordChild0, // #1 = $c
/* 16155*/    OPC_MoveChild1,
/* 16156*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16159*/    OPC_Scope, 15, /*->16176*/ // 2 children in Scope
/* 16161*/     OPC_RecordChild0, // #2 = $v1
/* 16162*/     OPC_CheckChild1Same, 0,
/* 16164*/     OPC_MoveParent,
/* 16165*/     OPC_MoveParent,
/* 16166*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 16168*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 16176*/    /*Scope*/ 15, /*->16192*/
/* 16177*/     OPC_CheckChild0Same, 0,
/* 16179*/     OPC_RecordChild1, // #2 = $v1
/* 16180*/     OPC_MoveParent,
/* 16181*/     OPC_MoveParent,
/* 16182*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 16184*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v4i32*/60, 3/*#Ops*/, 2, 0, 1, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, (and:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v2, V128:{ *:[v4i32] }:$v1))) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 16192*/    0, /*End of Scope*/
/* 16193*/   0, /*End of Scope*/
/* 16194*/  /*Scope*/ 64, /*->16259*/
/* 16195*/   OPC_MoveChild0,
/* 16196*/   OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 16199*/   OPC_Scope, 21, /*->16222*/ // 2 children in Scope
/* 16201*/    OPC_MoveChild0,
/* 16202*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16205*/    OPC_RecordChild0, // #0 = $v2
/* 16206*/    OPC_RecordChild1, // #1 = $v1
/* 16207*/    OPC_MoveParent,
/* 16208*/    OPC_RecordChild1, // #2 = $c
/* 16209*/    OPC_MoveParent,
/* 16210*/    OPC_CheckChild1Same, 0,
/* 16212*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 16214*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v2i64*/78, 3/*#Ops*/, 1, 0, 2, 
              // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1), V128:{ *:[v2i64] }:$c), V128:{ *:[v2i64] }:$v2) - Complexity = 9
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16222*/   /*Scope*/ 35, /*->16258*/
/* 16223*/    OPC_RecordChild0, // #0 = $c
/* 16224*/    OPC_MoveChild1,
/* 16225*/    OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16228*/    OPC_RecordChild0, // #1 = $v1
/* 16229*/    OPC_RecordChild1, // #2 = $v2
/* 16230*/    OPC_MoveParent,
/* 16231*/    OPC_MoveParent,
/* 16232*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 16234*/    OPC_Scope, 10, /*->16246*/ // 2 children in Scope
/* 16236*/     OPC_CheckChild1Same, 2,
/* 16238*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v2i64*/78, 3/*#Ops*/, 1, 2, 0, 
               // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2)), V128:{ *:[v2i64] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16246*/    /*Scope*/ 10, /*->16257*/
/* 16247*/     OPC_CheckChild1Same, 1,
/* 16249*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                   /*MVT::v2i64*/78, 3/*#Ops*/, 2, 1, 0, 
               // Src: (xor:{ *:[v2i64] } (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1)), V128:{ *:[v2i64] }:$v2) - Complexity = 9
               // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16257*/    0, /*End of Scope*/
/* 16258*/   0, /*End of Scope*/
/* 16259*/  /*Scope*/ 43|128,1/*171*/, /*->16432*/
/* 16261*/   OPC_RecordChild0, // #0 = $v2
/* 16262*/   OPC_Scope, 127, /*->16391*/ // 2 children in Scope
/* 16264*/    OPC_MoveChild1,
/* 16265*/    OPC_Scope, 86, /*->16353*/ // 2 children in Scope
/* 16267*/     OPC_CheckOpcode, TARGET_VAL(ISD::AND),
/* 16270*/     OPC_Scope, 40, /*->16312*/ // 2 children in Scope
/* 16272*/      OPC_MoveChild0,
/* 16273*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16276*/      OPC_Scope, 16, /*->16294*/ // 2 children in Scope
/* 16278*/       OPC_RecordChild0, // #1 = $v1
/* 16279*/       OPC_CheckChild1Same, 0,
/* 16281*/       OPC_MoveParent,
/* 16282*/       OPC_RecordChild1, // #2 = $c
/* 16283*/       OPC_MoveParent,
/* 16284*/       OPC_CheckType, /*MVT::v2i64*/78, 
/* 16286*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                     /*MVT::v2i64*/78, 3/*#Ops*/, 1, 0, 2, 
                 // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2), V128:{ *:[v2i64] }:$c)) - Complexity = 9
                 // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16294*/      /*Scope*/ 16, /*->16311*/
/* 16295*/       OPC_CheckChild0Same, 0,
/* 16297*/       OPC_RecordChild1, // #1 = $v1
/* 16298*/       OPC_MoveParent,
/* 16299*/       OPC_RecordChild1, // #2 = $c
/* 16300*/       OPC_MoveParent,
/* 16301*/       OPC_CheckType, /*MVT::v2i64*/78, 
/* 16303*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                     /*MVT::v2i64*/78, 3/*#Ops*/, 1, 0, 2, 
                 // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1), V128:{ *:[v2i64] }:$c)) - Complexity = 9
                 // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16311*/      0, /*End of Scope*/
/* 16312*/     /*Scope*/ 39, /*->16352*/
/* 16313*/      OPC_RecordChild0, // #1 = $c
/* 16314*/      OPC_MoveChild1,
/* 16315*/      OPC_CheckOpcode, TARGET_VAL(ISD::XOR),
/* 16318*/      OPC_Scope, 15, /*->16335*/ // 2 children in Scope
/* 16320*/       OPC_RecordChild0, // #2 = $v1
/* 16321*/       OPC_CheckChild1Same, 0,
/* 16323*/       OPC_MoveParent,
/* 16324*/       OPC_MoveParent,
/* 16325*/       OPC_CheckType, /*MVT::v2i64*/78, 
/* 16327*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                     /*MVT::v2i64*/78, 3/*#Ops*/, 2, 0, 1, 
                 // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2))) - Complexity = 9
                 // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16335*/      /*Scope*/ 15, /*->16351*/
/* 16336*/       OPC_CheckChild0Same, 0,
/* 16338*/       OPC_RecordChild1, // #2 = $v1
/* 16339*/       OPC_MoveParent,
/* 16340*/       OPC_MoveParent,
/* 16341*/       OPC_CheckType, /*MVT::v2i64*/78, 
/* 16343*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                     /*MVT::v2i64*/78, 3/*#Ops*/, 2, 0, 1, 
                 // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, (and:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v2, V128:{ *:[v2i64] }:$v1))) - Complexity = 9
                 // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 16351*/      0, /*End of Scope*/
/* 16352*/     0, /*End of Scope*/
/* 16353*/    /*Scope*/ 36, /*->16390*/
/* 16354*/     OPC_CheckImmAllOnesV,
/* 16355*/     OPC_MoveParent,
/* 16356*/     OPC_SwitchType /*4 cases */, 6, /*MVT::v16i8*/39, // ->16365
/* 16359*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NOT),
                    /*MVT::v16i8*/39, 1/*#Ops*/, 0, 
                // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$v, immAllOnesV:{ *:[v16i8] }) - Complexity = 7
                // Dst: (NOT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v)
/* 16365*/     /*SwitchType*/ 6, /*MVT::v8i16*/50, // ->16373
/* 16367*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NOT),
                    /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
                // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$v, immAllOnesV:{ *:[v8i16] }) - Complexity = 7
                // Dst: (NOT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v)
/* 16373*/     /*SwitchType*/ 6, /*MVT::v4i32*/60, // ->16381
/* 16375*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NOT),
                    /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
                // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$v, immAllOnesV:{ *:[v4i32] }) - Complexity = 7
                // Dst: (NOT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v)
/* 16381*/     /*SwitchType*/ 6, /*MVT::v2i64*/78, // ->16389
/* 16383*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NOT),
                    /*MVT::v2i64*/78, 1/*#Ops*/, 0, 
                // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$v, immAllOnesV:{ *:[v2i64] }) - Complexity = 7
                // Dst: (NOT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v)
/* 16389*/     0, // EndSwitchType
/* 16390*/    0, /*End of Scope*/
/* 16391*/   /*Scope*/ 39, /*->16431*/
/* 16392*/    OPC_RecordChild1, // #1 = $rhs
/* 16393*/    OPC_SwitchType /*4 cases */, 7, /*MVT::v16i8*/39, // ->16403
/* 16396*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (xor:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
               // Dst: (XOR:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/* 16403*/    /*SwitchType*/ 7, /*MVT::v8i16*/50, // ->16412
/* 16405*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR),
                   /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
               // Src: (xor:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
               // Dst: (XOR:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 16412*/    /*SwitchType*/ 7, /*MVT::v4i32*/60, // ->16421
/* 16414*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR),
                   /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
               // Src: (xor:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
               // Dst: (XOR:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/* 16421*/    /*SwitchType*/ 7, /*MVT::v2i64*/78, // ->16430
/* 16423*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::XOR),
                   /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
               // Src: (xor:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, V128:{ *:[v2i64] }:$rhs) - Complexity = 3
               // Dst: (XOR:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/* 16430*/    0, // EndSwitchType
/* 16431*/   0, /*End of Scope*/
/* 16432*/  0, /*End of Scope*/
/* 16433*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::CTLZ),// ->16457
/* 16436*/  OPC_RecordChild0, // #0 = $src
/* 16437*/  OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->16447
/* 16440*/   OPC_CheckChild0TypeI32,
/* 16441*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CLZ_I32),
                 /*MVT::i32*/7, 1/*#Ops*/, 0, 
             // Src: (ctlz:{ *:[i32] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (CLZ_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 16447*/  /*SwitchType*/ 7, /*MVT::i64*/8, // ->16456
/* 16449*/   OPC_CheckChild0TypeI64,
/* 16450*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CLZ_I64),
                 /*MVT::i64*/8, 1/*#Ops*/, 0, 
             // Src: (ctlz:{ *:[i64] } I64:{ *:[i64] }:$src) - Complexity = 3
             // Dst: (CLZ_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 16456*/  0, // EndSwitchType
/* 16457*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::CTTZ),// ->16481
/* 16460*/  OPC_RecordChild0, // #0 = $src
/* 16461*/  OPC_SwitchType /*2 cases */, 7, /*MVT::i32*/7, // ->16471
/* 16464*/   OPC_CheckChild0TypeI32,
/* 16465*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CTZ_I32),
                 /*MVT::i32*/7, 1/*#Ops*/, 0, 
             // Src: (cttz:{ *:[i32] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (CTZ_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 16471*/  /*SwitchType*/ 7, /*MVT::i64*/8, // ->16480
/* 16473*/   OPC_CheckChild0TypeI64,
/* 16474*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CTZ_I64),
                 /*MVT::i64*/8, 1/*#Ops*/, 0, 
             // Src: (cttz:{ *:[i64] } I64:{ *:[i64] }:$src) - Complexity = 3
             // Dst: (CTZ_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 16480*/  0, // EndSwitchType
/* 16481*/ /*SwitchOpcode*/ 32, TARGET_VAL(ISD::CTPOP),// ->16516
/* 16484*/  OPC_RecordChild0, // #0 = $src
/* 16485*/  OPC_SwitchType /*3 cases */, 7, /*MVT::i32*/7, // ->16495
/* 16488*/   OPC_CheckChild0TypeI32,
/* 16489*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::POPCNT_I32),
                 /*MVT::i32*/7, 1/*#Ops*/, 0, 
             // Src: (ctpop:{ *:[i32] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (POPCNT_I32:{ *:[i32] } I32:{ *:[i32] }:$src)
/* 16495*/  /*SwitchType*/ 7, /*MVT::i64*/8, // ->16504
/* 16497*/   OPC_CheckChild0TypeI64,
/* 16498*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::POPCNT_I64),
                 /*MVT::i64*/8, 1/*#Ops*/, 0, 
             // Src: (ctpop:{ *:[i64] } I64:{ *:[i64] }:$src) - Complexity = 3
             // Dst: (POPCNT_I64:{ *:[i64] } I64:{ *:[i64] }:$src)
/* 16504*/  /*SwitchType*/ 9, /*MVT::v16i8*/39, // ->16515
/* 16506*/   OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 16508*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 16509*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::POPCNT_I8x16),
                 /*MVT::v16i8*/39, 1/*#Ops*/, 0, 
             // Src: (ctpop:{ *:[v16i8] } V128:{ *:[v16i8] }:$v) - Complexity = 3
             // Dst: (POPCNT_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$v)
/* 16515*/  0, // EndSwitchType
/* 16516*/ /*SwitchOpcode*/ 22, TARGET_VAL(WebAssemblyISD::I64_ADD128),// ->16541
/* 16519*/  OPC_RecordChild0, // #0 = $a
/* 16520*/  OPC_CheckChild0TypeI64,
/* 16521*/  OPC_RecordChild1, // #1 = $b
/* 16522*/  OPC_CheckChild1TypeI64,
/* 16523*/  OPC_RecordChild2, // #2 = $c
/* 16524*/  OPC_CheckChild2TypeI64,
/* 16525*/  OPC_RecordChild3, // #3 = $d
/* 16526*/  OPC_CheckChild3TypeI64,
/* 16527*/  OPC_CheckTypeI64,
/* 16528*/  OPC_CheckTypeRes, 1, /*MVT::i64*/8, 
/* 16531*/  OPC_MorphNodeTo2None, TARGET_VAL(WebAssembly::I64_ADD128),
                /*MVT::i64*/8, /*MVT::i64*/8, 4/*#Ops*/, 0, 1, 2, 3, 
            // Src: (wasm_add128:{ *:[i64] }:{ *:[i64] } I64:{ *:[i64] }:$a, I64:{ *:[i64] }:$b, I64:{ *:[i64] }:$c, I64:{ *:[i64] }:$d) - Complexity = 3
            // Dst: (I64_ADD128:{ *:[i64] }:{ *:[i64] } ?:{ *:[i64] }:$a, ?:{ *:[i64] }:$b, ?:{ *:[i64] }:$c, ?:{ *:[i64] }:$d)
/* 16541*/ /*SwitchOpcode*/ 22, TARGET_VAL(WebAssemblyISD::I64_SUB128),// ->16566
/* 16544*/  OPC_RecordChild0, // #0 = $a
/* 16545*/  OPC_CheckChild0TypeI64,
/* 16546*/  OPC_RecordChild1, // #1 = $b
/* 16547*/  OPC_CheckChild1TypeI64,
/* 16548*/  OPC_RecordChild2, // #2 = $c
/* 16549*/  OPC_CheckChild2TypeI64,
/* 16550*/  OPC_RecordChild3, // #3 = $d
/* 16551*/  OPC_CheckChild3TypeI64,
/* 16552*/  OPC_CheckTypeI64,
/* 16553*/  OPC_CheckTypeRes, 1, /*MVT::i64*/8, 
/* 16556*/  OPC_MorphNodeTo2None, TARGET_VAL(WebAssembly::I64_SUB128),
                /*MVT::i64*/8, /*MVT::i64*/8, 4/*#Ops*/, 0, 1, 2, 3, 
            // Src: (wasm_sub128:{ *:[i64] }:{ *:[i64] } I64:{ *:[i64] }:$a, I64:{ *:[i64] }:$b, I64:{ *:[i64] }:$c, I64:{ *:[i64] }:$d) - Complexity = 3
            // Dst: (I64_SUB128:{ *:[i64] }:{ *:[i64] } ?:{ *:[i64] }:$a, ?:{ *:[i64] }:$b, ?:{ *:[i64] }:$c, ?:{ *:[i64] }:$d)
/* 16566*/ /*SwitchOpcode*/ 16, TARGET_VAL(WebAssemblyISD::I64_MUL_WIDE_S),// ->16585
/* 16569*/  OPC_RecordChild0, // #0 = $x
/* 16570*/  OPC_CheckChild0TypeI64,
/* 16571*/  OPC_RecordChild1, // #1 = $y
/* 16572*/  OPC_CheckChild1TypeI64,
/* 16573*/  OPC_CheckTypeI64,
/* 16574*/  OPC_CheckTypeRes, 1, /*MVT::i64*/8, 
/* 16577*/  OPC_MorphNodeTo2None, TARGET_VAL(WebAssembly::I64_MUL_WIDE_S),
                /*MVT::i64*/8, /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
            // Src: (wasm_mul_wide_s:{ *:[i64] }:{ *:[i64] } I64:{ *:[i64] }:$x, I64:{ *:[i64] }:$y) - Complexity = 3
            // Dst: (I64_MUL_WIDE_S:{ *:[i64] }:{ *:[i64] } ?:{ *:[i64] }:$x, ?:{ *:[i64] }:$y)
/* 16585*/ /*SwitchOpcode*/ 16, TARGET_VAL(WebAssemblyISD::I64_MUL_WIDE_U),// ->16604
/* 16588*/  OPC_RecordChild0, // #0 = $x
/* 16589*/  OPC_CheckChild0TypeI64,
/* 16590*/  OPC_RecordChild1, // #1 = $y
/* 16591*/  OPC_CheckChild1TypeI64,
/* 16592*/  OPC_CheckTypeI64,
/* 16593*/  OPC_CheckTypeRes, 1, /*MVT::i64*/8, 
/* 16596*/  OPC_MorphNodeTo2None, TARGET_VAL(WebAssembly::I64_MUL_WIDE_U),
                /*MVT::i64*/8, /*MVT::i64*/8, 2/*#Ops*/, 0, 1, 
            // Src: (wasm_mul_wide_u:{ *:[i64] }:{ *:[i64] } I64:{ *:[i64] }:$x, I64:{ *:[i64] }:$y) - Complexity = 3
            // Dst: (I64_MUL_WIDE_U:{ *:[i64] }:{ *:[i64] } ?:{ *:[i64] }:$x, ?:{ *:[i64] }:$y)
/* 16604*/ /*SwitchOpcode*/ 7, TARGET_VAL(ISD::TRUNCATE),// ->16614
/* 16607*/  OPC_RecordChild0, // #0 = $src
/* 16608*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_WRAP_I64),
                /*MVT::i32*/7, 1/*#Ops*/, 0, 
            // Src: (trunc:{ *:[i32] } I64:{ *:[i64] }:$src) - Complexity = 3
            // Dst: (I32_WRAP_I64:{ *:[i32] } I64:{ *:[i64] }:$src)
/* 16614*/ /*SwitchOpcode*/ 7, TARGET_VAL(ISD::SIGN_EXTEND),// ->16624
/* 16617*/  OPC_RecordChild0, // #0 = $src
/* 16618*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_EXTEND_S_I32),
                /*MVT::i64*/8, 1/*#Ops*/, 0, 
            // Src: (sext:{ *:[i64] } I32:{ *:[i32] }:$src) - Complexity = 3
            // Dst: (I64_EXTEND_S_I32:{ *:[i64] } I32:{ *:[i32] }:$src)
/* 16624*/ /*SwitchOpcode*/ 121, TARGET_VAL(ISD::FP_TO_SINT),// ->16748
/* 16627*/  OPC_RecordChild0, // #0 = $src
/* 16628*/  OPC_Scope, 48, /*->16678*/ // 4 children in Scope
/* 16630*/   OPC_CheckChild0Type, /*MVT::f32*/12, 
/* 16632*/   OPC_SwitchType /*2 cases */, 20, /*MVT::i32*/7, // ->16655
/* 16635*/    OPC_Scope, 8, /*->16645*/ // 2 children in Scope
/* 16637*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16639*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_SAT_F32),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (I32_TRUNC_S_SAT_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 16645*/    /*Scope*/ 8, /*->16654*/
/* 16646*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16648*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_SINT_I32_F32),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (FP_TO_SINT_I32_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 16654*/    0, /*End of Scope*/
/* 16655*/   /*SwitchType*/ 20, /*MVT::i64*/8, // ->16677
/* 16657*/    OPC_Scope, 8, /*->16667*/ // 2 children in Scope
/* 16659*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16661*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_SAT_F32),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i64] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (I64_TRUNC_S_SAT_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 16667*/    /*Scope*/ 8, /*->16676*/
/* 16668*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16670*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_SINT_I64_F32),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i64] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (FP_TO_SINT_I64_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 16676*/    0, /*End of Scope*/
/* 16677*/   0, // EndSwitchType
/* 16678*/  /*Scope*/ 48, /*->16727*/
/* 16679*/   OPC_CheckChild0Type, /*MVT::f64*/13, 
/* 16681*/   OPC_SwitchType /*2 cases */, 20, /*MVT::i32*/7, // ->16704
/* 16684*/    OPC_Scope, 8, /*->16694*/ // 2 children in Scope
/* 16686*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16688*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_SAT_F64),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i32] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (I32_TRUNC_S_SAT_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 16694*/    /*Scope*/ 8, /*->16703*/
/* 16695*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16697*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_SINT_I32_F64),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i32] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (FP_TO_SINT_I32_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 16703*/    0, /*End of Scope*/
/* 16704*/   /*SwitchType*/ 20, /*MVT::i64*/8, // ->16726
/* 16706*/    OPC_Scope, 8, /*->16716*/ // 2 children in Scope
/* 16708*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16710*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_SAT_F64),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (I64_TRUNC_S_SAT_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 16716*/    /*Scope*/ 8, /*->16725*/
/* 16717*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16719*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_SINT_I64_F64),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (fp_to_sint:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (FP_TO_SINT_I64_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 16725*/    0, /*End of Scope*/
/* 16726*/   0, // EndSwitchType
/* 16727*/  /*Scope*/ 9, /*->16737*/
/* 16728*/   OPC_CheckType, /*MVT::v4i32*/60, 
/* 16730*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 16731*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_sint_I32x4),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
             // Src: (fp_to_sint:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec) - Complexity = 3
             // Dst: (fp_to_sint_I32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec)
/* 16737*/  /*Scope*/ 9, /*->16747*/
/* 16738*/   OPC_CheckType, /*MVT::v8i16*/50, 
/* 16740*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 16741*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_sint_I16x8),
                 /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
             // Src: (fp_to_sint:{ *:[v8i16] } V128:{ *:[v8f16] }:$vec) - Complexity = 3
             // Dst: (fp_to_sint_I16x8:{ *:[v8i16] } V128:{ *:[v8f16] }:$vec)
/* 16747*/  0, /*End of Scope*/
/* 16748*/ /*SwitchOpcode*/ 121, TARGET_VAL(ISD::FP_TO_UINT),// ->16872
/* 16751*/  OPC_RecordChild0, // #0 = $src
/* 16752*/  OPC_Scope, 48, /*->16802*/ // 4 children in Scope
/* 16754*/   OPC_CheckChild0Type, /*MVT::f32*/12, 
/* 16756*/   OPC_SwitchType /*2 cases */, 20, /*MVT::i32*/7, // ->16779
/* 16759*/    OPC_Scope, 8, /*->16769*/ // 2 children in Scope
/* 16761*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16763*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_SAT_F32),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (I32_TRUNC_U_SAT_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 16769*/    /*Scope*/ 8, /*->16778*/
/* 16770*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16772*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_UINT_I32_F32),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (FP_TO_UINT_I32_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 16778*/    0, /*End of Scope*/
/* 16779*/   /*SwitchType*/ 20, /*MVT::i64*/8, // ->16801
/* 16781*/    OPC_Scope, 8, /*->16791*/ // 2 children in Scope
/* 16783*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16785*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_SAT_F32),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i64] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (I64_TRUNC_U_SAT_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 16791*/    /*Scope*/ 8, /*->16800*/
/* 16792*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16794*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_UINT_I64_F32),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i64] } F32:{ *:[f32] }:$src) - Complexity = 3
               // Dst: (FP_TO_UINT_I64_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 16800*/    0, /*End of Scope*/
/* 16801*/   0, // EndSwitchType
/* 16802*/  /*Scope*/ 48, /*->16851*/
/* 16803*/   OPC_CheckChild0Type, /*MVT::f64*/13, 
/* 16805*/   OPC_SwitchType /*2 cases */, 20, /*MVT::i32*/7, // ->16828
/* 16808*/    OPC_Scope, 8, /*->16818*/ // 2 children in Scope
/* 16810*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16812*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_SAT_F64),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i32] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (I32_TRUNC_U_SAT_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 16818*/    /*Scope*/ 8, /*->16827*/
/* 16819*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16821*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_UINT_I32_F64),
                   /*MVT::i32*/7, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i32] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (FP_TO_UINT_I32_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 16827*/    0, /*End of Scope*/
/* 16828*/   /*SwitchType*/ 20, /*MVT::i64*/8, // ->16850
/* 16830*/    OPC_Scope, 8, /*->16840*/ // 2 children in Scope
/* 16832*/     OPC_CheckPatternPredicate, 9, // (Subtarget->hasNontrappingFPToInt())
/* 16834*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_SAT_F64),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (I64_TRUNC_U_SAT_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 16840*/    /*Scope*/ 8, /*->16849*/
/* 16841*/     OPC_CheckPatternPredicate, 10, // (!Subtarget->hasNontrappingFPToInt())
/* 16843*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FP_TO_UINT_I64_F64),
                   /*MVT::i64*/8, 1/*#Ops*/, 0, 
               // Src: (fp_to_uint:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
               // Dst: (FP_TO_UINT_I64_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 16849*/    0, /*End of Scope*/
/* 16850*/   0, // EndSwitchType
/* 16851*/  /*Scope*/ 9, /*->16861*/
/* 16852*/   OPC_CheckType, /*MVT::v4i32*/60, 
/* 16854*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 16855*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_uint_I32x4),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
             // Src: (fp_to_uint:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec) - Complexity = 3
             // Dst: (fp_to_uint_I32x4:{ *:[v4i32] } V128:{ *:[v4f32] }:$vec)
/* 16861*/  /*Scope*/ 9, /*->16871*/
/* 16862*/   OPC_CheckType, /*MVT::v8i16*/50, 
/* 16864*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 16865*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_uint_I16x8),
                 /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
             // Src: (fp_to_uint:{ *:[v8i16] } V128:{ *:[v8f16] }:$vec) - Complexity = 3
             // Dst: (fp_to_uint_I16x8:{ *:[v8i16] } V128:{ *:[v8f16] }:$vec)
/* 16871*/  0, /*End of Scope*/
/* 16872*/ /*SwitchOpcode*/ 87, TARGET_VAL(ISD::FP_TO_SINT_SAT),// ->16962
/* 16875*/  OPC_RecordChild0, // #0 = $src
/* 16876*/  OPC_Scope, 27, /*->16905*/ // 3 children in Scope
/* 16878*/   OPC_CheckChild0Type, /*MVT::f32*/12, 
/* 16880*/   OPC_MoveChild1,
/* 16881*/   OPC_Scope, 10, /*->16893*/ // 2 children in Scope
/* 16883*/    OPC_CheckValueType, /*MVT::i32*/7, 
/* 16885*/    OPC_MoveParent,
/* 16886*/    OPC_CheckTypeI32,
/* 16887*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_SAT_F32),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[i32] } F32:{ *:[f32] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I32_TRUNC_S_SAT_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 16893*/   /*Scope*/ 10, /*->16904*/
/* 16894*/    OPC_CheckValueType, /*MVT::i64*/8, 
/* 16896*/    OPC_MoveParent,
/* 16897*/    OPC_CheckTypeI64,
/* 16898*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_SAT_F32),
                  /*MVT::i64*/8, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[i64] } F32:{ *:[f32] }:$src, i64:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_TRUNC_S_SAT_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 16904*/   0, /*End of Scope*/
/* 16905*/  /*Scope*/ 27, /*->16933*/
/* 16906*/   OPC_CheckChild0Type, /*MVT::f64*/13, 
/* 16908*/   OPC_MoveChild1,
/* 16909*/   OPC_Scope, 10, /*->16921*/ // 2 children in Scope
/* 16911*/    OPC_CheckValueType, /*MVT::i32*/7, 
/* 16913*/    OPC_MoveParent,
/* 16914*/    OPC_CheckTypeI32,
/* 16915*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_S_SAT_F64),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[i32] } F64:{ *:[f64] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I32_TRUNC_S_SAT_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 16921*/   /*Scope*/ 10, /*->16932*/
/* 16922*/    OPC_CheckValueType, /*MVT::i64*/8, 
/* 16924*/    OPC_MoveParent,
/* 16925*/    OPC_CheckTypeI64,
/* 16926*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_S_SAT_F64),
                  /*MVT::i64*/8, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[i64] } F64:{ *:[f64] }:$src, i64:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_TRUNC_S_SAT_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 16932*/   0, /*End of Scope*/
/* 16933*/  /*Scope*/ 27, /*->16961*/
/* 16934*/   OPC_MoveChild1,
/* 16935*/   OPC_Scope, 11, /*->16948*/ // 2 children in Scope
/* 16937*/    OPC_CheckValueType, /*MVT::i32*/7, 
/* 16939*/    OPC_MoveParent,
/* 16940*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 16942*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_sint_I32x4),
                  /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[v4i32] } V128:{ *:[v4f32] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (fp_to_sint_I32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$src)
/* 16948*/   /*Scope*/ 11, /*->16960*/
/* 16949*/    OPC_CheckValueType, /*MVT::i16*/6, 
/* 16951*/    OPC_MoveParent,
/* 16952*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 16954*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_sint_I16x8),
                  /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
              // Src: (fp_to_sint_sat:{ *:[v8i16] } V128:{ *:[v8f16] }:$src, i16:{ *:[Other] }) - Complexity = 3
              // Dst: (fp_to_sint_I16x8:{ *:[v8i16] } ?:{ *:[v8f16] }:$src)
/* 16960*/   0, /*End of Scope*/
/* 16961*/  0, /*End of Scope*/
/* 16962*/ /*SwitchOpcode*/ 87, TARGET_VAL(ISD::FP_TO_UINT_SAT),// ->17052
/* 16965*/  OPC_RecordChild0, // #0 = $src
/* 16966*/  OPC_Scope, 27, /*->16995*/ // 3 children in Scope
/* 16968*/   OPC_CheckChild0Type, /*MVT::f32*/12, 
/* 16970*/   OPC_MoveChild1,
/* 16971*/   OPC_Scope, 10, /*->16983*/ // 2 children in Scope
/* 16973*/    OPC_CheckValueType, /*MVT::i32*/7, 
/* 16975*/    OPC_MoveParent,
/* 16976*/    OPC_CheckTypeI32,
/* 16977*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_SAT_F32),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[i32] } F32:{ *:[f32] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I32_TRUNC_U_SAT_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 16983*/   /*Scope*/ 10, /*->16994*/
/* 16984*/    OPC_CheckValueType, /*MVT::i64*/8, 
/* 16986*/    OPC_MoveParent,
/* 16987*/    OPC_CheckTypeI64,
/* 16988*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_SAT_F32),
                  /*MVT::i64*/8, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[i64] } F32:{ *:[f32] }:$src, i64:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_TRUNC_U_SAT_F32:{ *:[i64] } F32:{ *:[f32] }:$src)
/* 16994*/   0, /*End of Scope*/
/* 16995*/  /*Scope*/ 27, /*->17023*/
/* 16996*/   OPC_CheckChild0Type, /*MVT::f64*/13, 
/* 16998*/   OPC_MoveChild1,
/* 16999*/   OPC_Scope, 10, /*->17011*/ // 2 children in Scope
/* 17001*/    OPC_CheckValueType, /*MVT::i32*/7, 
/* 17003*/    OPC_MoveParent,
/* 17004*/    OPC_CheckTypeI32,
/* 17005*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_TRUNC_U_SAT_F64),
                  /*MVT::i32*/7, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[i32] } F64:{ *:[f64] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (I32_TRUNC_U_SAT_F64:{ *:[i32] } F64:{ *:[f64] }:$src)
/* 17011*/   /*Scope*/ 10, /*->17022*/
/* 17012*/    OPC_CheckValueType, /*MVT::i64*/8, 
/* 17014*/    OPC_MoveParent,
/* 17015*/    OPC_CheckTypeI64,
/* 17016*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_TRUNC_U_SAT_F64),
                  /*MVT::i64*/8, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[i64] } F64:{ *:[f64] }:$src, i64:{ *:[Other] }) - Complexity = 3
              // Dst: (I64_TRUNC_U_SAT_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 17022*/   0, /*End of Scope*/
/* 17023*/  /*Scope*/ 27, /*->17051*/
/* 17024*/   OPC_MoveChild1,
/* 17025*/   OPC_Scope, 11, /*->17038*/ // 2 children in Scope
/* 17027*/    OPC_CheckValueType, /*MVT::i32*/7, 
/* 17029*/    OPC_MoveParent,
/* 17030*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 17032*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_uint_I32x4),
                  /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[v4i32] } V128:{ *:[v4f32] }:$src, i32:{ *:[Other] }) - Complexity = 3
              // Dst: (fp_to_uint_I32x4:{ *:[v4i32] } ?:{ *:[v4f32] }:$src)
/* 17038*/   /*Scope*/ 11, /*->17050*/
/* 17039*/    OPC_CheckValueType, /*MVT::i16*/6, 
/* 17041*/    OPC_MoveParent,
/* 17042*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 17044*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::fp_to_uint_I16x8),
                  /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
              // Src: (fp_to_uint_sat:{ *:[v8i16] } V128:{ *:[v8f16] }:$src, i16:{ *:[Other] }) - Complexity = 3
              // Dst: (fp_to_uint_I16x8:{ *:[v8i16] } ?:{ *:[v8f16] }:$src)
/* 17050*/   0, /*End of Scope*/
/* 17051*/  0, /*End of Scope*/
/* 17052*/ /*SwitchOpcode*/ 39|128,2/*295*/, TARGET_VAL(ISD::BITCAST),// ->17351
/* 17056*/  OPC_RecordChild0, // #0 = $src
/* 17057*/  OPC_Scope, 9, /*->17068*/ // 11 children in Scope
/* 17059*/   OPC_CheckChild0Type, /*MVT::f32*/12, 
/* 17061*/   OPC_CheckTypeI32,
/* 17062*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I32_REINTERPRET_F32),
                 /*MVT::i32*/7, 1/*#Ops*/, 0, 
             // Src: (bitconvert:{ *:[i32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (I32_REINTERPRET_F32:{ *:[i32] } F32:{ *:[f32] }:$src)
/* 17068*/  /*Scope*/ 9, /*->17078*/
/* 17069*/   OPC_CheckChild0Type, /*MVT::f64*/13, 
/* 17071*/   OPC_CheckTypeI64,
/* 17072*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::I64_REINTERPRET_F64),
                 /*MVT::i64*/8, 1/*#Ops*/, 0, 
             // Src: (bitconvert:{ *:[i64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (I64_REINTERPRET_F64:{ *:[i64] } F64:{ *:[f64] }:$src)
/* 17078*/  /*Scope*/ 9, /*->17088*/
/* 17079*/   OPC_CheckChild0TypeI32,
/* 17080*/   OPC_CheckType, /*MVT::f32*/12, 
/* 17082*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_REINTERPRET_I32),
                 /*MVT::f32*/12, 1/*#Ops*/, 0, 
             // Src: (bitconvert:{ *:[f32] } I32:{ *:[i32] }:$src) - Complexity = 3
             // Dst: (F32_REINTERPRET_I32:{ *:[f32] } I32:{ *:[i32] }:$src)
/* 17088*/  /*Scope*/ 9, /*->17098*/
/* 17089*/   OPC_CheckChild0TypeI64,
/* 17090*/   OPC_CheckType, /*MVT::f64*/13, 
/* 17092*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_REINTERPRET_I64),
                 /*MVT::f64*/13, 1/*#Ops*/, 0, 
             // Src: (bitconvert:{ *:[f64] } I64:{ *:[i64] }:$src) - Complexity = 3
             // Dst: (F64_REINTERPRET_I64:{ *:[f64] } I64:{ *:[i64] }:$src)
/* 17098*/  /*Scope*/ 35, /*->17134*/
/* 17099*/   OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 17101*/   OPC_SwitchType /*6 cases */, 3, /*MVT::v16i8*/39, // ->17107
/* 17104*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 17107*/   /*SwitchType*/ 3, /*MVT::v4i32*/60, // ->17112
/* 17109*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 17112*/   /*SwitchType*/ 3, /*MVT::v2i64*/78, // ->17117
/* 17114*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 17117*/   /*SwitchType*/ 3, /*MVT::v4f32*/111, // ->17122
/* 17119*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 17122*/   /*SwitchType*/ 3, /*MVT::v2f64*/1|128,1/*129*/, // ->17128
/* 17125*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 17128*/   /*SwitchType*/ 3, /*MVT::v8f16*/92, // ->17133
/* 17130*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8f16] } V128:{ *:[v8i16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8f16] }:$v
/* 17133*/   0, // EndSwitchType
/* 17134*/  /*Scope*/ 35, /*->17170*/
/* 17135*/   OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 17137*/   OPC_SwitchType /*6 cases */, 3, /*MVT::v16i8*/39, // ->17143
/* 17140*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 17143*/   /*SwitchType*/ 3, /*MVT::v8i16*/50, // ->17148
/* 17145*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 17148*/   /*SwitchType*/ 3, /*MVT::v2i64*/78, // ->17153
/* 17150*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 17153*/   /*SwitchType*/ 3, /*MVT::v4f32*/111, // ->17158
/* 17155*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 17158*/   /*SwitchType*/ 3, /*MVT::v2f64*/1|128,1/*129*/, // ->17164
/* 17161*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 17164*/   /*SwitchType*/ 3, /*MVT::v8f16*/92, // ->17169
/* 17166*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8f16] } V128:{ *:[v4i32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8f16] }:$v
/* 17169*/   0, // EndSwitchType
/* 17170*/  /*Scope*/ 35, /*->17206*/
/* 17171*/   OPC_CheckChild0Type, /*MVT::v2i64*/78, 
/* 17173*/   OPC_SwitchType /*6 cases */, 3, /*MVT::v16i8*/39, // ->17179
/* 17176*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 17179*/   /*SwitchType*/ 3, /*MVT::v8i16*/50, // ->17184
/* 17181*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 17184*/   /*SwitchType*/ 3, /*MVT::v4i32*/60, // ->17189
/* 17186*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 17189*/   /*SwitchType*/ 3, /*MVT::v4f32*/111, // ->17194
/* 17191*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 17194*/   /*SwitchType*/ 3, /*MVT::v2f64*/1|128,1/*129*/, // ->17200
/* 17197*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 17200*/   /*SwitchType*/ 3, /*MVT::v8f16*/92, // ->17205
/* 17202*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8f16] } V128:{ *:[v2i64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8f16] }:$v
/* 17205*/   0, // EndSwitchType
/* 17206*/  /*Scope*/ 35, /*->17242*/
/* 17207*/   OPC_CheckChild0Type, /*MVT::v4f32*/111, 
/* 17209*/   OPC_SwitchType /*6 cases */, 3, /*MVT::v16i8*/39, // ->17215
/* 17212*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 17215*/   /*SwitchType*/ 3, /*MVT::v8i16*/50, // ->17220
/* 17217*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 17220*/   /*SwitchType*/ 3, /*MVT::v4i32*/60, // ->17225
/* 17222*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 17225*/   /*SwitchType*/ 3, /*MVT::v2i64*/78, // ->17230
/* 17227*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 17230*/   /*SwitchType*/ 3, /*MVT::v2f64*/1|128,1/*129*/, // ->17236
/* 17233*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 17236*/   /*SwitchType*/ 3, /*MVT::v8f16*/92, // ->17241
/* 17238*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8f16] } V128:{ *:[v4f32] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8f16] }:$v
/* 17241*/   0, // EndSwitchType
/* 17242*/  /*Scope*/ 35, /*->17278*/
/* 17243*/   OPC_CheckChild0Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 17246*/   OPC_SwitchType /*6 cases */, 3, /*MVT::v16i8*/39, // ->17252
/* 17249*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 17252*/   /*SwitchType*/ 3, /*MVT::v8i16*/50, // ->17257
/* 17254*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 17257*/   /*SwitchType*/ 3, /*MVT::v4i32*/60, // ->17262
/* 17259*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 17262*/   /*SwitchType*/ 3, /*MVT::v2i64*/78, // ->17267
/* 17264*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 17267*/   /*SwitchType*/ 3, /*MVT::v4f32*/111, // ->17272
/* 17269*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 17272*/   /*SwitchType*/ 3, /*MVT::v8f16*/92, // ->17277
/* 17274*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8f16] } V128:{ *:[v2f64] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8f16] }:$v
/* 17277*/   0, // EndSwitchType
/* 17278*/  /*Scope*/ 35, /*->17314*/
/* 17279*/   OPC_CheckChild0Type, /*MVT::v8f16*/92, 
/* 17281*/   OPC_SwitchType /*6 cases */, 3, /*MVT::v16i8*/39, // ->17287
/* 17284*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v16i8] } V128:{ *:[v8f16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v16i8] }:$v
/* 17287*/   /*SwitchType*/ 3, /*MVT::v8i16*/50, // ->17292
/* 17289*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v8f16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 17292*/   /*SwitchType*/ 3, /*MVT::v4i32*/60, // ->17297
/* 17294*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v8f16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 17297*/   /*SwitchType*/ 3, /*MVT::v2i64*/78, // ->17302
/* 17299*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v8f16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 17302*/   /*SwitchType*/ 3, /*MVT::v4f32*/111, // ->17307
/* 17304*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v8f16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 17307*/   /*SwitchType*/ 3, /*MVT::v2f64*/1|128,1/*129*/, // ->17313
/* 17310*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v8f16] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 17313*/   0, // EndSwitchType
/* 17314*/  /*Scope*/ 35, /*->17350*/
/* 17315*/   OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 17317*/   OPC_SwitchType /*6 cases */, 3, /*MVT::v8i16*/50, // ->17323
/* 17320*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8i16] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8i16] }:$v
/* 17323*/   /*SwitchType*/ 3, /*MVT::v4i32*/60, // ->17328
/* 17325*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4i32] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4i32] }:$v
/* 17328*/   /*SwitchType*/ 3, /*MVT::v2i64*/78, // ->17333
/* 17330*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2i64] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2i64] }:$v
/* 17333*/   /*SwitchType*/ 3, /*MVT::v4f32*/111, // ->17338
/* 17335*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v4f32] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v4f32] }:$v
/* 17338*/   /*SwitchType*/ 3, /*MVT::v2f64*/1|128,1/*129*/, // ->17344
/* 17341*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v2f64] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v2f64] }:$v
/* 17344*/   /*SwitchType*/ 3, /*MVT::v8f16*/92, // ->17349
/* 17346*/    OPC_CompleteMatch, 1, 0, 
               // Src: (bitconvert:{ *:[v8f16] } V128:{ *:[v16i8] }:$v) - Complexity = 3
               // Dst: V128:{ *:[v8f16] }:$v
/* 17349*/   0, // EndSwitchType
/* 17350*/  0, /*End of Scope*/
/* 17351*/ /*SwitchOpcode*/ 21, TARGET_VAL(ISD::ConstantFP),// ->17375
/* 17354*/  OPC_RecordNode, // #0 = $imm
/* 17355*/  OPC_SwitchType /*2 cases */, 7, /*MVT::f32*/12, // ->17365
/* 17358*/   OPC_EmitConvertToTarget0,
/* 17359*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_F32),
                 /*MVT::f32*/12, 1/*#Ops*/, 1, 
             // Src: (fpimm:{ *:[f32] }):$imm - Complexity = 3
             // Dst: (CONST_F32:{ *:[f32] } (fpimm:{ *:[f32] }):$imm)
/* 17365*/  /*SwitchType*/ 7, /*MVT::f64*/13, // ->17374
/* 17367*/   OPC_EmitConvertToTarget0,
/* 17368*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_F64),
                 /*MVT::f64*/13, 1/*#Ops*/, 1, 
             // Src: (fpimm:{ *:[f64] }):$imm - Complexity = 3
             // Dst: (CONST_F64:{ *:[f64] } (fpimm:{ *:[f64] }):$imm)
/* 17374*/  0, // EndSwitchType
/* 17375*/ /*SwitchOpcode*/ 63, TARGET_VAL(ISD::SINT_TO_FP),// ->17441
/* 17378*/  OPC_RecordChild0, // #0 = $src
/* 17379*/  OPC_Scope, 19, /*->17400*/ // 4 children in Scope
/* 17381*/   OPC_CheckChild0TypeI32,
/* 17382*/   OPC_SwitchType /*2 cases */, 6, /*MVT::f32*/12, // ->17391
/* 17385*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_CONVERT_S_I32),
                  /*MVT::f32*/12, 1/*#Ops*/, 0, 
              // Src: (sint_to_fp:{ *:[f32] } I32:{ *:[i32] }:$src) - Complexity = 3
              // Dst: (F32_CONVERT_S_I32:{ *:[f32] } I32:{ *:[i32] }:$src)
/* 17391*/   /*SwitchType*/ 6, /*MVT::f64*/13, // ->17399
/* 17393*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_CONVERT_S_I32),
                  /*MVT::f64*/13, 1/*#Ops*/, 0, 
              // Src: (sint_to_fp:{ *:[f64] } I32:{ *:[i32] }:$src) - Complexity = 3
              // Dst: (F64_CONVERT_S_I32:{ *:[f64] } I32:{ *:[i32] }:$src)
/* 17399*/   0, // EndSwitchType
/* 17400*/  /*Scope*/ 19, /*->17420*/
/* 17401*/   OPC_CheckChild0TypeI64,
/* 17402*/   OPC_SwitchType /*2 cases */, 6, /*MVT::f32*/12, // ->17411
/* 17405*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_CONVERT_S_I64),
                  /*MVT::f32*/12, 1/*#Ops*/, 0, 
              // Src: (sint_to_fp:{ *:[f32] } I64:{ *:[i64] }:$src) - Complexity = 3
              // Dst: (F32_CONVERT_S_I64:{ *:[f32] } I64:{ *:[i64] }:$src)
/* 17411*/   /*SwitchType*/ 6, /*MVT::f64*/13, // ->17419
/* 17413*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_CONVERT_S_I64),
                  /*MVT::f64*/13, 1/*#Ops*/, 0, 
              // Src: (sint_to_fp:{ *:[f64] } I64:{ *:[i64] }:$src) - Complexity = 3
              // Dst: (F64_CONVERT_S_I64:{ *:[f64] } I64:{ *:[i64] }:$src)
/* 17419*/   0, // EndSwitchType
/* 17420*/  /*Scope*/ 9, /*->17430*/
/* 17421*/   OPC_CheckType, /*MVT::v4f32*/111, 
/* 17423*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17424*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::sint_to_fp_F32x4),
                 /*MVT::v4f32*/111, 1/*#Ops*/, 0, 
             // Src: (sint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (sint_to_fp_F32x4:{ *:[v4f32] } V128:{ *:[v4i32] }:$vec)
/* 17430*/  /*Scope*/ 9, /*->17440*/
/* 17431*/   OPC_CheckType, /*MVT::v8f16*/92, 
/* 17433*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 17434*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::sint_to_fp_F16x8),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (sint_to_fp:{ *:[v8f16] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (sint_to_fp_F16x8:{ *:[v8f16] } V128:{ *:[v8i16] }:$vec)
/* 17440*/  0, /*End of Scope*/
/* 17441*/ /*SwitchOpcode*/ 63, TARGET_VAL(ISD::UINT_TO_FP),// ->17507
/* 17444*/  OPC_RecordChild0, // #0 = $src
/* 17445*/  OPC_Scope, 19, /*->17466*/ // 4 children in Scope
/* 17447*/   OPC_CheckChild0TypeI32,
/* 17448*/   OPC_SwitchType /*2 cases */, 6, /*MVT::f32*/12, // ->17457
/* 17451*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_CONVERT_U_I32),
                  /*MVT::f32*/12, 1/*#Ops*/, 0, 
              // Src: (uint_to_fp:{ *:[f32] } I32:{ *:[i32] }:$src) - Complexity = 3
              // Dst: (F32_CONVERT_U_I32:{ *:[f32] } I32:{ *:[i32] }:$src)
/* 17457*/   /*SwitchType*/ 6, /*MVT::f64*/13, // ->17465
/* 17459*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_CONVERT_U_I32),
                  /*MVT::f64*/13, 1/*#Ops*/, 0, 
              // Src: (uint_to_fp:{ *:[f64] } I32:{ *:[i32] }:$src) - Complexity = 3
              // Dst: (F64_CONVERT_U_I32:{ *:[f64] } I32:{ *:[i32] }:$src)
/* 17465*/   0, // EndSwitchType
/* 17466*/  /*Scope*/ 19, /*->17486*/
/* 17467*/   OPC_CheckChild0TypeI64,
/* 17468*/   OPC_SwitchType /*2 cases */, 6, /*MVT::f32*/12, // ->17477
/* 17471*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_CONVERT_U_I64),
                  /*MVT::f32*/12, 1/*#Ops*/, 0, 
              // Src: (uint_to_fp:{ *:[f32] } I64:{ *:[i64] }:$src) - Complexity = 3
              // Dst: (F32_CONVERT_U_I64:{ *:[f32] } I64:{ *:[i64] }:$src)
/* 17477*/   /*SwitchType*/ 6, /*MVT::f64*/13, // ->17485
/* 17479*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_CONVERT_U_I64),
                  /*MVT::f64*/13, 1/*#Ops*/, 0, 
              // Src: (uint_to_fp:{ *:[f64] } I64:{ *:[i64] }:$src) - Complexity = 3
              // Dst: (F64_CONVERT_U_I64:{ *:[f64] } I64:{ *:[i64] }:$src)
/* 17485*/   0, // EndSwitchType
/* 17486*/  /*Scope*/ 9, /*->17496*/
/* 17487*/   OPC_CheckType, /*MVT::v4f32*/111, 
/* 17489*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17490*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::uint_to_fp_F32x4),
                 /*MVT::v4f32*/111, 1/*#Ops*/, 0, 
             // Src: (uint_to_fp:{ *:[v4f32] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (uint_to_fp_F32x4:{ *:[v4f32] } V128:{ *:[v4i32] }:$vec)
/* 17496*/  /*Scope*/ 9, /*->17506*/
/* 17497*/   OPC_CheckType, /*MVT::v8f16*/92, 
/* 17499*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 17500*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::uint_to_fp_F16x8),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (uint_to_fp:{ *:[v8f16] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (uint_to_fp_F16x8:{ *:[v8f16] } V128:{ *:[v8i16] }:$vec)
/* 17506*/  0, /*End of Scope*/
/* 17507*/ /*SwitchOpcode*/ 7, TARGET_VAL(ISD::FP_EXTEND),// ->17517
/* 17510*/  OPC_RecordChild0, // #0 = $src
/* 17511*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F64_PROMOTE_F32),
                /*MVT::f64*/13, 1/*#Ops*/, 0, 
            // Src: (fpextend:{ *:[f64] } F32:{ *:[f32] }:$src) - Complexity = 3
            // Dst: (F64_PROMOTE_F32:{ *:[f64] } F32:{ *:[f32] }:$src)
/* 17517*/ /*SwitchOpcode*/ 7, TARGET_VAL(ISD::FP_ROUND),// ->17527
/* 17520*/  OPC_RecordChild0, // #0 = $src
/* 17521*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::F32_DEMOTE_F64),
                /*MVT::f32*/12, 1/*#Ops*/, 0, 
            // Src: (fpround:{ *:[f32] } F64:{ *:[f64] }:$src) - Complexity = 3
            // Dst: (F32_DEMOTE_F64:{ *:[f32] } F64:{ *:[f64] }:$src)
/* 17527*/ /*SwitchOpcode*/ 54, TARGET_VAL(ISD::FADD),// ->17584
/* 17530*/  OPC_RecordChild0, // #0 = $lhs
/* 17531*/  OPC_RecordChild1, // #1 = $rhs
/* 17532*/  OPC_SwitchType /*5 cases */, 7, /*MVT::f32*/12, // ->17542
/* 17535*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_F32),
                 /*MVT::f32*/12, 2/*#Ops*/, 0, 1, 
             // Src: (fadd:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (ADD_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 17542*/  /*SwitchType*/ 7, /*MVT::f64*/13, // ->17551
/* 17544*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_F64),
                 /*MVT::f64*/13, 2/*#Ops*/, 0, 1, 
             // Src: (fadd:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (ADD_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 17551*/  /*SwitchType*/ 8, /*MVT::v4f32*/111, // ->17561
/* 17553*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17554*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_F32x4),
                 /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
             // Src: (fadd:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (ADD_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 17561*/  /*SwitchType*/ 9, /*MVT::v2f64*/1|128,1/*129*/, // ->17573
/* 17564*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17565*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_F64x2),
                 /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
             // Src: (fadd:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (ADD_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 17573*/  /*SwitchType*/ 8, /*MVT::v8f16*/92, // ->17583
/* 17575*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 17576*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_F16x8),
                 /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
             // Src: (fadd:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 3
             // Dst: (ADD_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 17583*/  0, // EndSwitchType
/* 17584*/ /*SwitchOpcode*/ 54, TARGET_VAL(ISD::FSUB),// ->17641
/* 17587*/  OPC_RecordChild0, // #0 = $lhs
/* 17588*/  OPC_RecordChild1, // #1 = $rhs
/* 17589*/  OPC_SwitchType /*5 cases */, 7, /*MVT::f32*/12, // ->17599
/* 17592*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_F32),
                 /*MVT::f32*/12, 2/*#Ops*/, 0, 1, 
             // Src: (fsub:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (SUB_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 17599*/  /*SwitchType*/ 7, /*MVT::f64*/13, // ->17608
/* 17601*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_F64),
                 /*MVT::f64*/13, 2/*#Ops*/, 0, 1, 
             // Src: (fsub:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (SUB_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 17608*/  /*SwitchType*/ 8, /*MVT::v4f32*/111, // ->17618
/* 17610*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17611*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_F32x4),
                 /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
             // Src: (fsub:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (SUB_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 17618*/  /*SwitchType*/ 9, /*MVT::v2f64*/1|128,1/*129*/, // ->17630
/* 17621*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17622*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_F64x2),
                 /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
             // Src: (fsub:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (SUB_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 17630*/  /*SwitchType*/ 8, /*MVT::v8f16*/92, // ->17640
/* 17632*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 17633*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_F16x8),
                 /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
             // Src: (fsub:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 3
             // Dst: (SUB_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 17640*/  0, // EndSwitchType
/* 17641*/ /*SwitchOpcode*/ 54, TARGET_VAL(ISD::FMUL),// ->17698
/* 17644*/  OPC_RecordChild0, // #0 = $lhs
/* 17645*/  OPC_RecordChild1, // #1 = $rhs
/* 17646*/  OPC_SwitchType /*5 cases */, 7, /*MVT::f32*/12, // ->17656
/* 17649*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_F32),
                 /*MVT::f32*/12, 2/*#Ops*/, 0, 1, 
             // Src: (fmul:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (MUL_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 17656*/  /*SwitchType*/ 7, /*MVT::f64*/13, // ->17665
/* 17658*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_F64),
                 /*MVT::f64*/13, 2/*#Ops*/, 0, 1, 
             // Src: (fmul:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (MUL_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 17665*/  /*SwitchType*/ 8, /*MVT::v4f32*/111, // ->17675
/* 17667*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17668*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_F32x4),
                 /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
             // Src: (fmul:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (MUL_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 17675*/  /*SwitchType*/ 9, /*MVT::v2f64*/1|128,1/*129*/, // ->17687
/* 17678*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17679*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_F64x2),
                 /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
             // Src: (fmul:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (MUL_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 17687*/  /*SwitchType*/ 8, /*MVT::v8f16*/92, // ->17697
/* 17689*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 17690*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MUL_F16x8),
                 /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
             // Src: (fmul:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 3
             // Dst: (MUL_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 17697*/  0, // EndSwitchType
/* 17698*/ /*SwitchOpcode*/ 54, TARGET_VAL(ISD::FDIV),// ->17755
/* 17701*/  OPC_RecordChild0, // #0 = $lhs
/* 17702*/  OPC_RecordChild1, // #1 = $rhs
/* 17703*/  OPC_SwitchType /*5 cases */, 7, /*MVT::f32*/12, // ->17713
/* 17706*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_F32),
                 /*MVT::f32*/12, 2/*#Ops*/, 0, 1, 
             // Src: (fdiv:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (DIV_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 17713*/  /*SwitchType*/ 7, /*MVT::f64*/13, // ->17722
/* 17715*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_F64),
                 /*MVT::f64*/13, 2/*#Ops*/, 0, 1, 
             // Src: (fdiv:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (DIV_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 17722*/  /*SwitchType*/ 8, /*MVT::v4f32*/111, // ->17732
/* 17724*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17725*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_F32x4),
                 /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
             // Src: (fdiv:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (DIV_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 17732*/  /*SwitchType*/ 9, /*MVT::v2f64*/1|128,1/*129*/, // ->17744
/* 17735*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17736*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_F64x2),
                 /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
             // Src: (fdiv:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (DIV_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 17744*/  /*SwitchType*/ 8, /*MVT::v8f16*/92, // ->17754
/* 17746*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 17747*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::DIV_F16x8),
                 /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
             // Src: (fdiv:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 3
             // Dst: (DIV_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 17754*/  0, // EndSwitchType
/* 17755*/ /*SwitchOpcode*/ 48, TARGET_VAL(ISD::FSQRT),// ->17806
/* 17758*/  OPC_RecordChild0, // #0 = $src
/* 17759*/  OPC_SwitchType /*5 cases */, 6, /*MVT::f32*/12, // ->17768
/* 17762*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SQRT_F32),
                 /*MVT::f32*/12, 1/*#Ops*/, 0, 
             // Src: (fsqrt:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (SQRT_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 17768*/  /*SwitchType*/ 6, /*MVT::f64*/13, // ->17776
/* 17770*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SQRT_F64),
                 /*MVT::f64*/13, 1/*#Ops*/, 0, 
             // Src: (fsqrt:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (SQRT_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 17776*/  /*SwitchType*/ 7, /*MVT::v4f32*/111, // ->17785
/* 17778*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17779*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SQRT_F32x4),
                 /*MVT::v4f32*/111, 1/*#Ops*/, 0, 
             // Src: (fsqrt:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (SQRT_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 17785*/  /*SwitchType*/ 8, /*MVT::v2f64*/1|128,1/*129*/, // ->17796
/* 17788*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17789*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SQRT_F64x2),
                 /*MVT::v2f64*/1|128,1/*129*/, 1/*#Ops*/, 0, 
             // Src: (fsqrt:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (SQRT_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 17796*/  /*SwitchType*/ 7, /*MVT::v8f16*/92, // ->17805
/* 17798*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 17799*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SQRT_F16x8),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (fsqrt:{ *:[v8f16] } V128:{ *:[v8f16] }:$v) - Complexity = 3
             // Dst: (SQRT_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$v)
/* 17805*/  0, // EndSwitchType
/* 17806*/ /*SwitchOpcode*/ 48, TARGET_VAL(ISD::FABS),// ->17857
/* 17809*/  OPC_RecordChild0, // #0 = $src
/* 17810*/  OPC_SwitchType /*5 cases */, 6, /*MVT::f32*/12, // ->17819
/* 17813*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_F32),
                 /*MVT::f32*/12, 1/*#Ops*/, 0, 
             // Src: (fabs:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (ABS_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 17819*/  /*SwitchType*/ 6, /*MVT::f64*/13, // ->17827
/* 17821*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_F64),
                 /*MVT::f64*/13, 1/*#Ops*/, 0, 
             // Src: (fabs:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (ABS_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 17827*/  /*SwitchType*/ 7, /*MVT::v4f32*/111, // ->17836
/* 17829*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17830*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_F32x4),
                 /*MVT::v4f32*/111, 1/*#Ops*/, 0, 
             // Src: (fabs:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (ABS_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 17836*/  /*SwitchType*/ 8, /*MVT::v2f64*/1|128,1/*129*/, // ->17847
/* 17839*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17840*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_F64x2),
                 /*MVT::v2f64*/1|128,1/*129*/, 1/*#Ops*/, 0, 
             // Src: (fabs:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (ABS_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 17847*/  /*SwitchType*/ 7, /*MVT::v8f16*/92, // ->17856
/* 17849*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 17850*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_F16x8),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (fabs:{ *:[v8f16] } V128:{ *:[v8f16] }:$v) - Complexity = 3
             // Dst: (ABS_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$v)
/* 17856*/  0, // EndSwitchType
/* 17857*/ /*SwitchOpcode*/ 48, TARGET_VAL(ISD::FNEG),// ->17908
/* 17860*/  OPC_RecordChild0, // #0 = $src
/* 17861*/  OPC_SwitchType /*5 cases */, 6, /*MVT::f32*/12, // ->17870
/* 17864*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_F32),
                 /*MVT::f32*/12, 1/*#Ops*/, 0, 
             // Src: (fneg:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (NEG_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 17870*/  /*SwitchType*/ 6, /*MVT::f64*/13, // ->17878
/* 17872*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_F64),
                 /*MVT::f64*/13, 1/*#Ops*/, 0, 
             // Src: (fneg:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (NEG_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 17878*/  /*SwitchType*/ 7, /*MVT::v4f32*/111, // ->17887
/* 17880*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17881*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_F32x4),
                 /*MVT::v4f32*/111, 1/*#Ops*/, 0, 
             // Src: (fneg:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (NEG_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 17887*/  /*SwitchType*/ 8, /*MVT::v2f64*/1|128,1/*129*/, // ->17898
/* 17890*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 17891*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_F64x2),
                 /*MVT::v2f64*/1|128,1/*129*/, 1/*#Ops*/, 0, 
             // Src: (fneg:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (NEG_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 17898*/  /*SwitchType*/ 7, /*MVT::v8f16*/92, // ->17907
/* 17900*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 17901*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEG_F16x8),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (fneg:{ *:[v8f16] } V128:{ *:[v8f16] }:$v) - Complexity = 3
             // Dst: (NEG_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$v)
/* 17907*/  0, // EndSwitchType
/* 17908*/ /*SwitchOpcode*/ 62, TARGET_VAL(ISD::FCOPYSIGN),// ->17973
/* 17911*/  OPC_RecordChild0, // #0 = $lhs
/* 17912*/  OPC_RecordChild1, // #1 = $rhs
/* 17913*/  OPC_Scope, 28, /*->17943*/ // 2 children in Scope
/* 17915*/   OPC_CheckChild1Type, /*MVT::f32*/12, 
/* 17917*/   OPC_SwitchType /*2 cases */, 7, /*MVT::f32*/12, // ->17927
/* 17920*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::COPYSIGN_F32),
                  /*MVT::f32*/12, 2/*#Ops*/, 0, 1, 
              // Src: (fcopysign:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
              // Dst: (COPYSIGN_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 17927*/   /*SwitchType*/ 13, /*MVT::f64*/13, // ->17942
/* 17929*/    OPC_EmitNode1None, TARGET_VAL(WebAssembly::F64_PROMOTE_F32),
                  /*MVT::f64*/13, 1/*#Ops*/, 1,  // Results = #2
/* 17935*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::COPYSIGN_F64),
                  /*MVT::f64*/13, 2/*#Ops*/, 0, 2, 
              // Src: (fcopysign:{ *:[f64] } F64:{ *:[f64] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
              // Dst: (COPYSIGN_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, (F64_PROMOTE_F32:{ *:[f64] } F32:{ *:[f32] }:$rhs))
/* 17942*/   0, // EndSwitchType
/* 17943*/  /*Scope*/ 28, /*->17972*/
/* 17944*/   OPC_CheckChild1Type, /*MVT::f64*/13, 
/* 17946*/   OPC_SwitchType /*2 cases */, 7, /*MVT::f64*/13, // ->17956
/* 17949*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::COPYSIGN_F64),
                  /*MVT::f64*/13, 2/*#Ops*/, 0, 1, 
              // Src: (fcopysign:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
              // Dst: (COPYSIGN_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 17956*/   /*SwitchType*/ 13, /*MVT::f32*/12, // ->17971
/* 17958*/    OPC_EmitNode1None, TARGET_VAL(WebAssembly::F32_DEMOTE_F64),
                  /*MVT::f32*/12, 1/*#Ops*/, 1,  // Results = #2
/* 17964*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::COPYSIGN_F32),
                  /*MVT::f32*/12, 2/*#Ops*/, 0, 2, 
              // Src: (fcopysign:{ *:[f32] } F32:{ *:[f32] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
              // Dst: (COPYSIGN_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, (F32_DEMOTE_F64:{ *:[f32] } F64:{ *:[f64] }:$rhs))
/* 17971*/   0, // EndSwitchType
/* 17972*/  0, /*End of Scope*/
/* 17973*/ /*SwitchOpcode*/ 54, TARGET_VAL(ISD::FMINIMUM),// ->18030
/* 17976*/  OPC_RecordChild0, // #0 = $lhs
/* 17977*/  OPC_RecordChild1, // #1 = $rhs
/* 17978*/  OPC_SwitchType /*5 cases */, 7, /*MVT::f32*/12, // ->17988
/* 17981*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_F32),
                 /*MVT::f32*/12, 2/*#Ops*/, 0, 1, 
             // Src: (fminimum:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (MIN_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 17988*/  /*SwitchType*/ 7, /*MVT::f64*/13, // ->17997
/* 17990*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_F64),
                 /*MVT::f64*/13, 2/*#Ops*/, 0, 1, 
             // Src: (fminimum:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (MIN_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 17997*/  /*SwitchType*/ 8, /*MVT::v4f32*/111, // ->18007
/* 17999*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18000*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_F32x4),
                 /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
             // Src: (fminimum:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (MIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 18007*/  /*SwitchType*/ 9, /*MVT::v2f64*/1|128,1/*129*/, // ->18019
/* 18010*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18011*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_F64x2),
                 /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
             // Src: (fminimum:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (MIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 18019*/  /*SwitchType*/ 8, /*MVT::v8f16*/92, // ->18029
/* 18021*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 18022*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_F16x8),
                 /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
             // Src: (fminimum:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 3
             // Dst: (MIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 18029*/  0, // EndSwitchType
/* 18030*/ /*SwitchOpcode*/ 54, TARGET_VAL(ISD::FMAXIMUM),// ->18087
/* 18033*/  OPC_RecordChild0, // #0 = $lhs
/* 18034*/  OPC_RecordChild1, // #1 = $rhs
/* 18035*/  OPC_SwitchType /*5 cases */, 7, /*MVT::f32*/12, // ->18045
/* 18038*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_F32),
                 /*MVT::f32*/12, 2/*#Ops*/, 0, 1, 
             // Src: (fmaximum:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs) - Complexity = 3
             // Dst: (MAX_F32:{ *:[f32] } F32:{ *:[f32] }:$lhs, F32:{ *:[f32] }:$rhs)
/* 18045*/  /*SwitchType*/ 7, /*MVT::f64*/13, // ->18054
/* 18047*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_F64),
                 /*MVT::f64*/13, 2/*#Ops*/, 0, 1, 
             // Src: (fmaximum:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs) - Complexity = 3
             // Dst: (MAX_F64:{ *:[f64] } F64:{ *:[f64] }:$lhs, F64:{ *:[f64] }:$rhs)
/* 18054*/  /*SwitchType*/ 8, /*MVT::v4f32*/111, // ->18064
/* 18056*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18057*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_F32x4),
                 /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
             // Src: (fmaximum:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 3
             // Dst: (MAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 18064*/  /*SwitchType*/ 9, /*MVT::v2f64*/1|128,1/*129*/, // ->18076
/* 18067*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18068*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_F64x2),
                 /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
             // Src: (fmaximum:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 3
             // Dst: (MAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 18076*/  /*SwitchType*/ 8, /*MVT::v8f16*/92, // ->18086
/* 18078*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 18079*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_F16x8),
                 /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
             // Src: (fmaximum:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 3
             // Dst: (MAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 18086*/  0, // EndSwitchType
/* 18087*/ /*SwitchOpcode*/ 48, TARGET_VAL(ISD::FCEIL),// ->18138
/* 18090*/  OPC_RecordChild0, // #0 = $src
/* 18091*/  OPC_SwitchType /*5 cases */, 6, /*MVT::f32*/12, // ->18100
/* 18094*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CEIL_F32),
                 /*MVT::f32*/12, 1/*#Ops*/, 0, 
             // Src: (fceil:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (CEIL_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 18100*/  /*SwitchType*/ 6, /*MVT::f64*/13, // ->18108
/* 18102*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CEIL_F64),
                 /*MVT::f64*/13, 1/*#Ops*/, 0, 
             // Src: (fceil:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (CEIL_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 18108*/  /*SwitchType*/ 7, /*MVT::v4f32*/111, // ->18117
/* 18110*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18111*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CEIL_F32x4),
                 /*MVT::v4f32*/111, 1/*#Ops*/, 0, 
             // Src: (fceil:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (CEIL_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 18117*/  /*SwitchType*/ 8, /*MVT::v2f64*/1|128,1/*129*/, // ->18128
/* 18120*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18121*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CEIL_F64x2),
                 /*MVT::v2f64*/1|128,1/*129*/, 1/*#Ops*/, 0, 
             // Src: (fceil:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (CEIL_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 18128*/  /*SwitchType*/ 7, /*MVT::v8f16*/92, // ->18137
/* 18130*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 18131*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CEIL_F16x8),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (fceil:{ *:[v8f16] } V128:{ *:[v8f16] }:$v) - Complexity = 3
             // Dst: (CEIL_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$v)
/* 18137*/  0, // EndSwitchType
/* 18138*/ /*SwitchOpcode*/ 48, TARGET_VAL(ISD::FFLOOR),// ->18189
/* 18141*/  OPC_RecordChild0, // #0 = $src
/* 18142*/  OPC_SwitchType /*5 cases */, 6, /*MVT::f32*/12, // ->18151
/* 18145*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FLOOR_F32),
                 /*MVT::f32*/12, 1/*#Ops*/, 0, 
             // Src: (ffloor:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (FLOOR_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 18151*/  /*SwitchType*/ 6, /*MVT::f64*/13, // ->18159
/* 18153*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FLOOR_F64),
                 /*MVT::f64*/13, 1/*#Ops*/, 0, 
             // Src: (ffloor:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (FLOOR_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 18159*/  /*SwitchType*/ 7, /*MVT::v4f32*/111, // ->18168
/* 18161*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18162*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FLOOR_F32x4),
                 /*MVT::v4f32*/111, 1/*#Ops*/, 0, 
             // Src: (ffloor:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (FLOOR_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 18168*/  /*SwitchType*/ 8, /*MVT::v2f64*/1|128,1/*129*/, // ->18179
/* 18171*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18172*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FLOOR_F64x2),
                 /*MVT::v2f64*/1|128,1/*129*/, 1/*#Ops*/, 0, 
             // Src: (ffloor:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (FLOOR_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 18179*/  /*SwitchType*/ 7, /*MVT::v8f16*/92, // ->18188
/* 18181*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 18182*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::FLOOR_F16x8),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (ffloor:{ *:[v8f16] } V128:{ *:[v8f16] }:$v) - Complexity = 3
             // Dst: (FLOOR_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$v)
/* 18188*/  0, // EndSwitchType
/* 18189*/ /*SwitchOpcode*/ 48, TARGET_VAL(ISD::FTRUNC),// ->18240
/* 18192*/  OPC_RecordChild0, // #0 = $src
/* 18193*/  OPC_SwitchType /*5 cases */, 6, /*MVT::f32*/12, // ->18202
/* 18196*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::TRUNC_F32),
                 /*MVT::f32*/12, 1/*#Ops*/, 0, 
             // Src: (ftrunc:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (TRUNC_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 18202*/  /*SwitchType*/ 6, /*MVT::f64*/13, // ->18210
/* 18204*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::TRUNC_F64),
                 /*MVT::f64*/13, 1/*#Ops*/, 0, 
             // Src: (ftrunc:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (TRUNC_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 18210*/  /*SwitchType*/ 7, /*MVT::v4f32*/111, // ->18219
/* 18212*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18213*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::TRUNC_F32x4),
                 /*MVT::v4f32*/111, 1/*#Ops*/, 0, 
             // Src: (ftrunc:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (TRUNC_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 18219*/  /*SwitchType*/ 8, /*MVT::v2f64*/1|128,1/*129*/, // ->18230
/* 18222*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18223*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::TRUNC_F64x2),
                 /*MVT::v2f64*/1|128,1/*129*/, 1/*#Ops*/, 0, 
             // Src: (ftrunc:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (TRUNC_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 18230*/  /*SwitchType*/ 7, /*MVT::v8f16*/92, // ->18239
/* 18232*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 18233*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::TRUNC_F16x8),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (ftrunc:{ *:[v8f16] } V128:{ *:[v8f16] }:$v) - Complexity = 3
             // Dst: (TRUNC_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$v)
/* 18239*/  0, // EndSwitchType
/* 18240*/ /*SwitchOpcode*/ 48, TARGET_VAL(ISD::FNEARBYINT),// ->18291
/* 18243*/  OPC_RecordChild0, // #0 = $src
/* 18244*/  OPC_SwitchType /*5 cases */, 6, /*MVT::f32*/12, // ->18253
/* 18247*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32),
                 /*MVT::f32*/12, 1/*#Ops*/, 0, 
             // Src: (fnearbyint:{ *:[f32] } F32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (NEAREST_F32:{ *:[f32] } F32:{ *:[f32] }:$src)
/* 18253*/  /*SwitchType*/ 6, /*MVT::f64*/13, // ->18261
/* 18255*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64),
                 /*MVT::f64*/13, 1/*#Ops*/, 0, 
             // Src: (fnearbyint:{ *:[f64] } F64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (NEAREST_F64:{ *:[f64] } F64:{ *:[f64] }:$src)
/* 18261*/  /*SwitchType*/ 7, /*MVT::v4f32*/111, // ->18270
/* 18263*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18264*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32x4),
                 /*MVT::v4f32*/111, 1/*#Ops*/, 0, 
             // Src: (fnearbyint:{ *:[v4f32] } V128:{ *:[v4f32] }:$v) - Complexity = 3
             // Dst: (NEAREST_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$v)
/* 18270*/  /*SwitchType*/ 8, /*MVT::v2f64*/1|128,1/*129*/, // ->18281
/* 18273*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18274*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64x2),
                 /*MVT::v2f64*/1|128,1/*129*/, 1/*#Ops*/, 0, 
             // Src: (fnearbyint:{ *:[v2f64] } V128:{ *:[v2f64] }:$v) - Complexity = 3
             // Dst: (NEAREST_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$v)
/* 18281*/  /*SwitchType*/ 7, /*MVT::v8f16*/92, // ->18290
/* 18283*/   OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 18284*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F16x8),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (fnearbyint:{ *:[v8f16] } V128:{ *:[v8f16] }:$v) - Complexity = 3
             // Dst: (NEAREST_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$v)
/* 18290*/  0, // EndSwitchType
/* 18291*/ /*SwitchOpcode*/ 45, TARGET_VAL(ISD::FRINT),// ->18339
/* 18294*/  OPC_RecordChild0, // #0 = $src
/* 18295*/  OPC_SwitchType /*5 cases */, 6, /*MVT::f32*/12, // ->18304
/* 18298*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32),
                 /*MVT::f32*/12, 1/*#Ops*/, 0, 
             // Src: (frint:{ *:[f32] } f32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (NEAREST_F32:{ *:[f32] } f32:{ *:[f32] }:$src)
/* 18304*/  /*SwitchType*/ 6, /*MVT::f64*/13, // ->18312
/* 18306*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64),
                 /*MVT::f64*/13, 1/*#Ops*/, 0, 
             // Src: (frint:{ *:[f64] } f64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (NEAREST_F64:{ *:[f64] } f64:{ *:[f64] }:$src)
/* 18312*/  /*SwitchType*/ 6, /*MVT::v4f32*/111, // ->18320
/* 18314*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32x4),
                 /*MVT::v4f32*/111, 1/*#Ops*/, 0, 
             // Src: (frint:{ *:[v4f32] } V128:{ *:[v4f32] }:$src) - Complexity = 3
             // Dst: (NEAREST_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$src)
/* 18320*/  /*SwitchType*/ 7, /*MVT::v2f64*/1|128,1/*129*/, // ->18330
/* 18323*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64x2),
                 /*MVT::v2f64*/1|128,1/*129*/, 1/*#Ops*/, 0, 
             // Src: (frint:{ *:[v2f64] } V128:{ *:[v2f64] }:$src) - Complexity = 3
             // Dst: (NEAREST_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$src)
/* 18330*/  /*SwitchType*/ 6, /*MVT::v8f16*/92, // ->18338
/* 18332*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F16x8),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (frint:{ *:[v8f16] } V128:{ *:[v8f16] }:$src) - Complexity = 3
             // Dst: (NEAREST_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$src)
/* 18338*/  0, // EndSwitchType
/* 18339*/ /*SwitchOpcode*/ 45, TARGET_VAL(ISD::FROUNDEVEN),// ->18387
/* 18342*/  OPC_RecordChild0, // #0 = $src
/* 18343*/  OPC_SwitchType /*5 cases */, 6, /*MVT::f32*/12, // ->18352
/* 18346*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32),
                 /*MVT::f32*/12, 1/*#Ops*/, 0, 
             // Src: (froundeven:{ *:[f32] } f32:{ *:[f32] }:$src) - Complexity = 3
             // Dst: (NEAREST_F32:{ *:[f32] } f32:{ *:[f32] }:$src)
/* 18352*/  /*SwitchType*/ 6, /*MVT::f64*/13, // ->18360
/* 18354*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64),
                 /*MVT::f64*/13, 1/*#Ops*/, 0, 
             // Src: (froundeven:{ *:[f64] } f64:{ *:[f64] }:$src) - Complexity = 3
             // Dst: (NEAREST_F64:{ *:[f64] } f64:{ *:[f64] }:$src)
/* 18360*/  /*SwitchType*/ 6, /*MVT::v4f32*/111, // ->18368
/* 18362*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F32x4),
                 /*MVT::v4f32*/111, 1/*#Ops*/, 0, 
             // Src: (froundeven:{ *:[v4f32] } V128:{ *:[v4f32] }:$src) - Complexity = 3
             // Dst: (NEAREST_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$src)
/* 18368*/  /*SwitchType*/ 7, /*MVT::v2f64*/1|128,1/*129*/, // ->18378
/* 18371*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F64x2),
                 /*MVT::v2f64*/1|128,1/*129*/, 1/*#Ops*/, 0, 
             // Src: (froundeven:{ *:[v2f64] } V128:{ *:[v2f64] }:$src) - Complexity = 3
             // Dst: (NEAREST_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$src)
/* 18378*/  /*SwitchType*/ 6, /*MVT::v8f16*/92, // ->18386
/* 18380*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NEAREST_F16x8),
                 /*MVT::v8f16*/92, 1/*#Ops*/, 0, 
             // Src: (froundeven:{ *:[v8f16] } V128:{ *:[v8f16] }:$src) - Complexity = 3
             // Dst: (NEAREST_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$src)
/* 18386*/  0, // EndSwitchType
/* 18387*/ /*SwitchOpcode*/ 22|128,3/*406*/, TARGET_VAL(ISD::BUILD_VECTOR),// ->18797
/* 18391*/  OPC_RecordChild0, // #0 = $i0
/* 18392*/  OPC_MoveChild0,
/* 18393*/  OPC_SwitchOpcode /*2 cases */, 73|128,2/*329*/, TARGET_VAL(ISD::Constant),// ->18727
/* 18398*/   OPC_SwitchType /*2 cases */, 47|128,2/*303*/, /*MVT::i32*/7, // ->18705
/* 18402*/    OPC_Scope, 51|128,1/*179*/, /*->18584*/ // 3 children in Scope
/* 18405*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18407*/     OPC_MoveSibling1,
/* 18408*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18411*/     OPC_RecordNode, // #1 = $i1
/* 18412*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18414*/     OPC_CheckTypeI32,
/* 18415*/     OPC_MoveSibling2,
/* 18416*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18419*/     OPC_RecordNode, // #2 = $i2
/* 18420*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18422*/     OPC_CheckTypeI32,
/* 18423*/     OPC_MoveSibling3,
/* 18424*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18427*/     OPC_RecordNode, // #3 = $i3
/* 18428*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18430*/     OPC_CheckTypeI32,
/* 18431*/     OPC_MoveSibling4,
/* 18432*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18435*/     OPC_RecordNode, // #4 = $i4
/* 18436*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18438*/     OPC_CheckTypeI32,
/* 18439*/     OPC_MoveSibling5,
/* 18440*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18443*/     OPC_RecordNode, // #5 = $i5
/* 18444*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18446*/     OPC_CheckTypeI32,
/* 18447*/     OPC_MoveSibling6,
/* 18448*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18451*/     OPC_RecordNode, // #6 = $i6
/* 18452*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18454*/     OPC_CheckTypeI32,
/* 18455*/     OPC_MoveSibling7,
/* 18456*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18459*/     OPC_RecordNode, // #7 = $i7
/* 18460*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18462*/     OPC_CheckTypeI32,
/* 18463*/     OPC_MoveSibling, 8,
/* 18465*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18468*/     OPC_RecordNode, // #8 = $i8
/* 18469*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18471*/     OPC_CheckTypeI32,
/* 18472*/     OPC_MoveSibling, 9,
/* 18474*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18477*/     OPC_RecordNode, // #9 = $i9
/* 18478*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18480*/     OPC_CheckTypeI32,
/* 18481*/     OPC_MoveSibling, 10,
/* 18483*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18486*/     OPC_RecordNode, // #10 = $iA
/* 18487*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18489*/     OPC_CheckTypeI32,
/* 18490*/     OPC_MoveSibling, 11,
/* 18492*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18495*/     OPC_RecordNode, // #11 = $iB
/* 18496*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18498*/     OPC_CheckTypeI32,
/* 18499*/     OPC_MoveSibling, 12,
/* 18501*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18504*/     OPC_RecordNode, // #12 = $iC
/* 18505*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18507*/     OPC_CheckTypeI32,
/* 18508*/     OPC_MoveSibling, 13,
/* 18510*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18513*/     OPC_RecordNode, // #13 = $iD
/* 18514*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18516*/     OPC_CheckTypeI32,
/* 18517*/     OPC_MoveSibling, 14,
/* 18519*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18522*/     OPC_RecordNode, // #14 = $iE
/* 18523*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18525*/     OPC_CheckTypeI32,
/* 18526*/     OPC_MoveSibling, 15,
/* 18528*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18531*/     OPC_RecordNode, // #15 = $iF
/* 18532*/     OPC_CheckPredicate, 9, // Predicate_ImmI8
/* 18534*/     OPC_CheckTypeI32,
/* 18535*/     OPC_MoveParent,
/* 18536*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 18538*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18539*/     OPC_EmitConvertToTarget0,
/* 18540*/     OPC_EmitConvertToTarget1,
/* 18541*/     OPC_EmitConvertToTarget2,
/* 18542*/     OPC_EmitConvertToTarget3,
/* 18543*/     OPC_EmitConvertToTarget4,
/* 18544*/     OPC_EmitConvertToTarget5,
/* 18545*/     OPC_EmitConvertToTarget6,
/* 18546*/     OPC_EmitConvertToTarget7,
/* 18547*/     OPC_EmitConvertToTarget, 8,
/* 18549*/     OPC_EmitConvertToTarget, 9,
/* 18551*/     OPC_EmitConvertToTarget, 10,
/* 18553*/     OPC_EmitConvertToTarget, 11,
/* 18555*/     OPC_EmitConvertToTarget, 12,
/* 18557*/     OPC_EmitConvertToTarget, 13,
/* 18559*/     OPC_EmitConvertToTarget, 14,
/* 18561*/     OPC_EmitConvertToTarget, 15,
/* 18563*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I8x16),
                   /*MVT::v16i8*/39, 16/*#Ops*/, 16, 17, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 
               // Src: (build_vector:{ *:[v16i8] } (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i0, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i1, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i2, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i3, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i4, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i5, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i6, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i7, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i8, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$i9, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iA, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iB, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iC, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iD, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iE, (imm:{ *:[i32] })<<P:Predicate_ImmI8>>:$iF) - Complexity = 67
               // Dst: (CONST_V128_I8x16:{ *:[v16i8] } (imm:{ *:[i32] }):$i0, (imm:{ *:[i32] }):$i1, (imm:{ *:[i32] }):$i2, (imm:{ *:[i32] }):$i3, (imm:{ *:[i32] }):$i4, (imm:{ *:[i32] }):$i5, (imm:{ *:[i32] }):$i6, (imm:{ *:[i32] }):$i7, (imm:{ *:[i32] }):$i8, (imm:{ *:[i32] }):$i9, (imm:{ *:[i32] }):$iA, (imm:{ *:[i32] }):$iB, (imm:{ *:[i32] }):$iC, (imm:{ *:[i32] }):$iD, (imm:{ *:[i32] }):$iE, (imm:{ *:[i32] }):$iF)
/* 18584*/    /*Scope*/ 83, /*->18668*/
/* 18585*/     OPC_CheckPredicate, 17, // Predicate_ImmI16
/* 18587*/     OPC_MoveSibling1,
/* 18588*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18591*/     OPC_RecordNode, // #1 = $i1
/* 18592*/     OPC_CheckPredicate, 17, // Predicate_ImmI16
/* 18594*/     OPC_CheckTypeI32,
/* 18595*/     OPC_MoveSibling2,
/* 18596*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18599*/     OPC_RecordNode, // #2 = $i2
/* 18600*/     OPC_CheckPredicate, 17, // Predicate_ImmI16
/* 18602*/     OPC_CheckTypeI32,
/* 18603*/     OPC_MoveSibling3,
/* 18604*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18607*/     OPC_RecordNode, // #3 = $i3
/* 18608*/     OPC_CheckPredicate, 17, // Predicate_ImmI16
/* 18610*/     OPC_CheckTypeI32,
/* 18611*/     OPC_MoveSibling4,
/* 18612*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18615*/     OPC_RecordNode, // #4 = $i4
/* 18616*/     OPC_CheckPredicate, 17, // Predicate_ImmI16
/* 18618*/     OPC_CheckTypeI32,
/* 18619*/     OPC_MoveSibling5,
/* 18620*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18623*/     OPC_RecordNode, // #5 = $i5
/* 18624*/     OPC_CheckPredicate, 17, // Predicate_ImmI16
/* 18626*/     OPC_CheckTypeI32,
/* 18627*/     OPC_MoveSibling6,
/* 18628*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18631*/     OPC_RecordNode, // #6 = $i6
/* 18632*/     OPC_CheckPredicate, 17, // Predicate_ImmI16
/* 18634*/     OPC_CheckTypeI32,
/* 18635*/     OPC_MoveSibling7,
/* 18636*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18639*/     OPC_RecordNode, // #7 = $i7
/* 18640*/     OPC_CheckPredicate, 17, // Predicate_ImmI16
/* 18642*/     OPC_CheckTypeI32,
/* 18643*/     OPC_MoveParent,
/* 18644*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 18646*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18647*/     OPC_EmitConvertToTarget0,
/* 18648*/     OPC_EmitConvertToTarget1,
/* 18649*/     OPC_EmitConvertToTarget2,
/* 18650*/     OPC_EmitConvertToTarget3,
/* 18651*/     OPC_EmitConvertToTarget4,
/* 18652*/     OPC_EmitConvertToTarget5,
/* 18653*/     OPC_EmitConvertToTarget6,
/* 18654*/     OPC_EmitConvertToTarget7,
/* 18655*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I16x8),
                   /*MVT::v8i16*/50, 8/*#Ops*/, 8, 9, 10, 11, 12, 13, 14, 15, 
               // Src: (build_vector:{ *:[v8i16] } (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i0, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i1, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i2, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i3, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i4, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i5, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i6, (imm:{ *:[i32] })<<P:Predicate_ImmI16>>:$i7) - Complexity = 35
               // Dst: (CONST_V128_I16x8:{ *:[v8i16] } (imm:{ *:[i32] }):$i0, (imm:{ *:[i32] }):$i1, (imm:{ *:[i32] }):$i2, (imm:{ *:[i32] }):$i3, (imm:{ *:[i32] }):$i4, (imm:{ *:[i32] }):$i5, (imm:{ *:[i32] }):$i6, (imm:{ *:[i32] }):$i7)
/* 18668*/    /*Scope*/ 35, /*->18704*/
/* 18669*/     OPC_MoveSibling1,
/* 18670*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18673*/     OPC_RecordNode, // #1 = $i1
/* 18674*/     OPC_CheckTypeI32,
/* 18675*/     OPC_MoveSibling2,
/* 18676*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18679*/     OPC_RecordNode, // #2 = $i2
/* 18680*/     OPC_CheckTypeI32,
/* 18681*/     OPC_MoveSibling3,
/* 18682*/     OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18685*/     OPC_RecordNode, // #3 = $i3
/* 18686*/     OPC_CheckTypeI32,
/* 18687*/     OPC_MoveParent,
/* 18688*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 18690*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18691*/     OPC_EmitConvertToTarget0,
/* 18692*/     OPC_EmitConvertToTarget1,
/* 18693*/     OPC_EmitConvertToTarget2,
/* 18694*/     OPC_EmitConvertToTarget3,
/* 18695*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I32x4),
                   /*MVT::v4i32*/60, 4/*#Ops*/, 4, 5, 6, 7, 
               // Src: (build_vector:{ *:[v4i32] } (imm:{ *:[i32] }):$i0, (imm:{ *:[i32] }):$i1, (imm:{ *:[i32] }):$i2, (imm:{ *:[i32] }):$i3) - Complexity = 15
               // Dst: (CONST_V128_I32x4:{ *:[v4i32] } (imm:{ *:[i32] }):$i0, (imm:{ *:[i32] }):$i1, (imm:{ *:[i32] }):$i2, (imm:{ *:[i32] }):$i3)
/* 18704*/    0, /*End of Scope*/
/* 18705*/   /*SwitchType*/ 19, /*MVT::i64*/8, // ->18726
/* 18707*/    OPC_MoveSibling1,
/* 18708*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18711*/    OPC_RecordNode, // #1 = $i1
/* 18712*/    OPC_CheckTypeI64,
/* 18713*/    OPC_MoveParent,
/* 18714*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 18716*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18717*/    OPC_EmitConvertToTarget0,
/* 18718*/    OPC_EmitConvertToTarget1,
/* 18719*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I64x2),
                  /*MVT::v2i64*/78, 2/*#Ops*/, 2, 3, 
              // Src: (build_vector:{ *:[v2i64] } (imm:{ *:[i64] }):$i0, (imm:{ *:[i64] }):$i1) - Complexity = 9
              // Dst: (CONST_V128_I64x2:{ *:[v2i64] } (imm:{ *:[i64] }):$i0, (imm:{ *:[i64] }):$i1)
/* 18726*/   0, // EndSwitchType
/* 18727*/  /*SwitchOpcode*/ 66, TARGET_VAL(ISD::ConstantFP),// ->18796
/* 18730*/   OPC_SwitchType /*2 cases */, 38, /*MVT::f32*/12, // ->18771
/* 18733*/    OPC_MoveSibling1,
/* 18734*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 18737*/    OPC_RecordNode, // #1 = $i1
/* 18738*/    OPC_CheckType, /*MVT::f32*/12, 
/* 18740*/    OPC_MoveSibling2,
/* 18741*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 18744*/    OPC_RecordNode, // #2 = $i2
/* 18745*/    OPC_CheckType, /*MVT::f32*/12, 
/* 18747*/    OPC_MoveSibling3,
/* 18748*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 18751*/    OPC_RecordNode, // #3 = $i3
/* 18752*/    OPC_CheckType, /*MVT::f32*/12, 
/* 18754*/    OPC_MoveParent,
/* 18755*/    OPC_CheckType, /*MVT::v4f32*/111, 
/* 18757*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18758*/    OPC_EmitConvertToTarget0,
/* 18759*/    OPC_EmitConvertToTarget1,
/* 18760*/    OPC_EmitConvertToTarget2,
/* 18761*/    OPC_EmitConvertToTarget3,
/* 18762*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_F32x4),
                  /*MVT::v4f32*/111, 4/*#Ops*/, 4, 5, 6, 7, 
              // Src: (build_vector:{ *:[v4f32] } (fpimm:{ *:[f32] }):$i0, (fpimm:{ *:[f32] }):$i1, (fpimm:{ *:[f32] }):$i2, (fpimm:{ *:[f32] }):$i3) - Complexity = 15
              // Dst: (CONST_V128_F32x4:{ *:[v4f32] } (fpimm:{ *:[f32] }):$i0, (fpimm:{ *:[f32] }):$i1, (fpimm:{ *:[f32] }):$i2, (fpimm:{ *:[f32] }):$i3)
/* 18771*/   /*SwitchType*/ 22, /*MVT::f64*/13, // ->18795
/* 18773*/    OPC_MoveSibling1,
/* 18774*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 18777*/    OPC_RecordNode, // #1 = $i1
/* 18778*/    OPC_CheckType, /*MVT::f64*/13, 
/* 18780*/    OPC_MoveParent,
/* 18781*/    OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 18784*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 18785*/    OPC_EmitConvertToTarget0,
/* 18786*/    OPC_EmitConvertToTarget1,
/* 18787*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_F64x2),
                  /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 2, 3, 
              // Src: (build_vector:{ *:[v2f64] } (fpimm:{ *:[f64] }):$i0, (fpimm:{ *:[f64] }):$i1) - Complexity = 9
              // Dst: (CONST_V128_F64x2:{ *:[v2f64] } (fpimm:{ *:[f64] }):$i0, (fpimm:{ *:[f64] }):$i1)
/* 18795*/   0, // EndSwitchType
/* 18796*/  0, // EndSwitchOpcode
/* 18797*/ /*SwitchOpcode*/ 7|128,16/*2055*/, TARGET_VAL(WebAssemblyISD::SHUFFLE),// ->20856
/* 18801*/  OPC_RecordChild0, // #0 = $x
/* 18802*/  OPC_Scope, 83|128,2/*339*/, /*->19144*/ // 6 children in Scope
/* 18805*/   OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 18807*/   OPC_RecordChild1, // #1 = $y
/* 18808*/   OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/* 18810*/   OPC_RecordChild2, // #2 = $m0
/* 18811*/   OPC_MoveChild2,
/* 18812*/   OPC_SwitchOpcode /*2 cases */, 41|128,1/*169*/, TARGET_VAL(ISD::Constant),// ->18986
/* 18817*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18818*/    OPC_CheckTypeI32,
/* 18819*/    OPC_MoveSibling3,
/* 18820*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18823*/    OPC_RecordNode, // #3 = $m1
/* 18824*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18825*/    OPC_CheckTypeI32,
/* 18826*/    OPC_MoveSibling4,
/* 18827*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18830*/    OPC_RecordNode, // #4 = $m2
/* 18831*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18832*/    OPC_CheckTypeI32,
/* 18833*/    OPC_MoveSibling5,
/* 18834*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18837*/    OPC_RecordNode, // #5 = $m3
/* 18838*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18839*/    OPC_CheckTypeI32,
/* 18840*/    OPC_MoveSibling6,
/* 18841*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18844*/    OPC_RecordNode, // #6 = $m4
/* 18845*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18846*/    OPC_CheckTypeI32,
/* 18847*/    OPC_MoveSibling7,
/* 18848*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18851*/    OPC_RecordNode, // #7 = $m5
/* 18852*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18853*/    OPC_CheckTypeI32,
/* 18854*/    OPC_MoveSibling, 8,
/* 18856*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18859*/    OPC_RecordNode, // #8 = $m6
/* 18860*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18861*/    OPC_CheckTypeI32,
/* 18862*/    OPC_MoveSibling, 9,
/* 18864*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18867*/    OPC_RecordNode, // #9 = $m7
/* 18868*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18869*/    OPC_CheckTypeI32,
/* 18870*/    OPC_MoveSibling, 10,
/* 18872*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18875*/    OPC_RecordNode, // #10 = $m8
/* 18876*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18877*/    OPC_CheckTypeI32,
/* 18878*/    OPC_MoveSibling, 11,
/* 18880*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18883*/    OPC_RecordNode, // #11 = $m9
/* 18884*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18885*/    OPC_CheckTypeI32,
/* 18886*/    OPC_MoveSibling, 12,
/* 18888*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18891*/    OPC_RecordNode, // #12 = $mA
/* 18892*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18893*/    OPC_CheckTypeI32,
/* 18894*/    OPC_MoveSibling, 13,
/* 18896*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18899*/    OPC_RecordNode, // #13 = $mB
/* 18900*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18901*/    OPC_CheckTypeI32,
/* 18902*/    OPC_MoveSibling, 14,
/* 18904*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18907*/    OPC_RecordNode, // #14 = $mC
/* 18908*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18909*/    OPC_CheckTypeI32,
/* 18910*/    OPC_MoveSibling, 15,
/* 18912*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18915*/    OPC_RecordNode, // #15 = $mD
/* 18916*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18917*/    OPC_CheckTypeI32,
/* 18918*/    OPC_MoveSibling, 16,
/* 18920*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18923*/    OPC_RecordNode, // #16 = $mE
/* 18924*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18925*/    OPC_CheckTypeI32,
/* 18926*/    OPC_MoveSibling, 17,
/* 18928*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 18931*/    OPC_RecordNode, // #17 = $mF
/* 18932*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 18933*/    OPC_CheckTypeI32,
/* 18934*/    OPC_MoveParent,
/* 18935*/    OPC_CheckType, /*MVT::v16i8*/39, 
/* 18937*/    OPC_EmitConvertToTarget2,
/* 18938*/    OPC_EmitConvertToTarget3,
/* 18939*/    OPC_EmitConvertToTarget4,
/* 18940*/    OPC_EmitConvertToTarget5,
/* 18941*/    OPC_EmitConvertToTarget6,
/* 18942*/    OPC_EmitConvertToTarget7,
/* 18943*/    OPC_EmitConvertToTarget, 8,
/* 18945*/    OPC_EmitConvertToTarget, 9,
/* 18947*/    OPC_EmitConvertToTarget, 10,
/* 18949*/    OPC_EmitConvertToTarget, 11,
/* 18951*/    OPC_EmitConvertToTarget, 12,
/* 18953*/    OPC_EmitConvertToTarget, 13,
/* 18955*/    OPC_EmitConvertToTarget, 14,
/* 18957*/    OPC_EmitConvertToTarget, 15,
/* 18959*/    OPC_EmitConvertToTarget, 16,
/* 18961*/    OPC_EmitConvertToTarget, 17,
/* 18963*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v16i8*/39, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v16i8] } V128:{ *:[v16i8] }:$x, V128:{ *:[v16i8] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v16i8] } ?:{ *:[v16i8] }:$x, ?:{ *:[v16i8] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 18986*/   /*SwitchOpcode*/ 25|128,1/*153*/, TARGET_VAL(ISD::TargetConstant),// ->19143
/* 18990*/    OPC_CheckTypeI32,
/* 18991*/    OPC_MoveSibling3,
/* 18992*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 18995*/    OPC_RecordNode, // #3 = $m1
/* 18996*/    OPC_CheckTypeI32,
/* 18997*/    OPC_MoveSibling4,
/* 18998*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19001*/    OPC_RecordNode, // #4 = $m2
/* 19002*/    OPC_CheckTypeI32,
/* 19003*/    OPC_MoveSibling5,
/* 19004*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19007*/    OPC_RecordNode, // #5 = $m3
/* 19008*/    OPC_CheckTypeI32,
/* 19009*/    OPC_MoveSibling6,
/* 19010*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19013*/    OPC_RecordNode, // #6 = $m4
/* 19014*/    OPC_CheckTypeI32,
/* 19015*/    OPC_MoveSibling7,
/* 19016*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19019*/    OPC_RecordNode, // #7 = $m5
/* 19020*/    OPC_CheckTypeI32,
/* 19021*/    OPC_MoveSibling, 8,
/* 19023*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19026*/    OPC_RecordNode, // #8 = $m6
/* 19027*/    OPC_CheckTypeI32,
/* 19028*/    OPC_MoveSibling, 9,
/* 19030*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19033*/    OPC_RecordNode, // #9 = $m7
/* 19034*/    OPC_CheckTypeI32,
/* 19035*/    OPC_MoveSibling, 10,
/* 19037*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19040*/    OPC_RecordNode, // #10 = $m8
/* 19041*/    OPC_CheckTypeI32,
/* 19042*/    OPC_MoveSibling, 11,
/* 19044*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19047*/    OPC_RecordNode, // #11 = $m9
/* 19048*/    OPC_CheckTypeI32,
/* 19049*/    OPC_MoveSibling, 12,
/* 19051*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19054*/    OPC_RecordNode, // #12 = $mA
/* 19055*/    OPC_CheckTypeI32,
/* 19056*/    OPC_MoveSibling, 13,
/* 19058*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19061*/    OPC_RecordNode, // #13 = $mB
/* 19062*/    OPC_CheckTypeI32,
/* 19063*/    OPC_MoveSibling, 14,
/* 19065*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19068*/    OPC_RecordNode, // #14 = $mC
/* 19069*/    OPC_CheckTypeI32,
/* 19070*/    OPC_MoveSibling, 15,
/* 19072*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19075*/    OPC_RecordNode, // #15 = $mD
/* 19076*/    OPC_CheckTypeI32,
/* 19077*/    OPC_MoveSibling, 16,
/* 19079*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19082*/    OPC_RecordNode, // #16 = $mE
/* 19083*/    OPC_CheckTypeI32,
/* 19084*/    OPC_MoveSibling, 17,
/* 19086*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19089*/    OPC_RecordNode, // #17 = $mF
/* 19090*/    OPC_CheckTypeI32,
/* 19091*/    OPC_MoveParent,
/* 19092*/    OPC_CheckType, /*MVT::v16i8*/39, 
/* 19094*/    OPC_EmitConvertToTarget2,
/* 19095*/    OPC_EmitConvertToTarget3,
/* 19096*/    OPC_EmitConvertToTarget4,
/* 19097*/    OPC_EmitConvertToTarget5,
/* 19098*/    OPC_EmitConvertToTarget6,
/* 19099*/    OPC_EmitConvertToTarget7,
/* 19100*/    OPC_EmitConvertToTarget, 8,
/* 19102*/    OPC_EmitConvertToTarget, 9,
/* 19104*/    OPC_EmitConvertToTarget, 10,
/* 19106*/    OPC_EmitConvertToTarget, 11,
/* 19108*/    OPC_EmitConvertToTarget, 12,
/* 19110*/    OPC_EmitConvertToTarget, 13,
/* 19112*/    OPC_EmitConvertToTarget, 14,
/* 19114*/    OPC_EmitConvertToTarget, 15,
/* 19116*/    OPC_EmitConvertToTarget, 16,
/* 19118*/    OPC_EmitConvertToTarget, 17,
/* 19120*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v16i8*/39, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v16i8] } V128:{ *:[v16i8] }:$x, V128:{ *:[v16i8] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v16i8] } ?:{ *:[v16i8] }:$x, ?:{ *:[v16i8] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 19143*/   0, // EndSwitchOpcode
/* 19144*/  /*Scope*/ 83|128,2/*339*/, /*->19485*/
/* 19146*/   OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 19148*/   OPC_RecordChild1, // #1 = $y
/* 19149*/   OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 19151*/   OPC_RecordChild2, // #2 = $m0
/* 19152*/   OPC_MoveChild2,
/* 19153*/   OPC_SwitchOpcode /*2 cases */, 41|128,1/*169*/, TARGET_VAL(ISD::Constant),// ->19327
/* 19158*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19159*/    OPC_CheckTypeI32,
/* 19160*/    OPC_MoveSibling3,
/* 19161*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19164*/    OPC_RecordNode, // #3 = $m1
/* 19165*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19166*/    OPC_CheckTypeI32,
/* 19167*/    OPC_MoveSibling4,
/* 19168*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19171*/    OPC_RecordNode, // #4 = $m2
/* 19172*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19173*/    OPC_CheckTypeI32,
/* 19174*/    OPC_MoveSibling5,
/* 19175*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19178*/    OPC_RecordNode, // #5 = $m3
/* 19179*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19180*/    OPC_CheckTypeI32,
/* 19181*/    OPC_MoveSibling6,
/* 19182*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19185*/    OPC_RecordNode, // #6 = $m4
/* 19186*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19187*/    OPC_CheckTypeI32,
/* 19188*/    OPC_MoveSibling7,
/* 19189*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19192*/    OPC_RecordNode, // #7 = $m5
/* 19193*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19194*/    OPC_CheckTypeI32,
/* 19195*/    OPC_MoveSibling, 8,
/* 19197*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19200*/    OPC_RecordNode, // #8 = $m6
/* 19201*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19202*/    OPC_CheckTypeI32,
/* 19203*/    OPC_MoveSibling, 9,
/* 19205*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19208*/    OPC_RecordNode, // #9 = $m7
/* 19209*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19210*/    OPC_CheckTypeI32,
/* 19211*/    OPC_MoveSibling, 10,
/* 19213*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19216*/    OPC_RecordNode, // #10 = $m8
/* 19217*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19218*/    OPC_CheckTypeI32,
/* 19219*/    OPC_MoveSibling, 11,
/* 19221*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19224*/    OPC_RecordNode, // #11 = $m9
/* 19225*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19226*/    OPC_CheckTypeI32,
/* 19227*/    OPC_MoveSibling, 12,
/* 19229*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19232*/    OPC_RecordNode, // #12 = $mA
/* 19233*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19234*/    OPC_CheckTypeI32,
/* 19235*/    OPC_MoveSibling, 13,
/* 19237*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19240*/    OPC_RecordNode, // #13 = $mB
/* 19241*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19242*/    OPC_CheckTypeI32,
/* 19243*/    OPC_MoveSibling, 14,
/* 19245*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19248*/    OPC_RecordNode, // #14 = $mC
/* 19249*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19250*/    OPC_CheckTypeI32,
/* 19251*/    OPC_MoveSibling, 15,
/* 19253*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19256*/    OPC_RecordNode, // #15 = $mD
/* 19257*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19258*/    OPC_CheckTypeI32,
/* 19259*/    OPC_MoveSibling, 16,
/* 19261*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19264*/    OPC_RecordNode, // #16 = $mE
/* 19265*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19266*/    OPC_CheckTypeI32,
/* 19267*/    OPC_MoveSibling, 17,
/* 19269*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19272*/    OPC_RecordNode, // #17 = $mF
/* 19273*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19274*/    OPC_CheckTypeI32,
/* 19275*/    OPC_MoveParent,
/* 19276*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 19278*/    OPC_EmitConvertToTarget2,
/* 19279*/    OPC_EmitConvertToTarget3,
/* 19280*/    OPC_EmitConvertToTarget4,
/* 19281*/    OPC_EmitConvertToTarget5,
/* 19282*/    OPC_EmitConvertToTarget6,
/* 19283*/    OPC_EmitConvertToTarget7,
/* 19284*/    OPC_EmitConvertToTarget, 8,
/* 19286*/    OPC_EmitConvertToTarget, 9,
/* 19288*/    OPC_EmitConvertToTarget, 10,
/* 19290*/    OPC_EmitConvertToTarget, 11,
/* 19292*/    OPC_EmitConvertToTarget, 12,
/* 19294*/    OPC_EmitConvertToTarget, 13,
/* 19296*/    OPC_EmitConvertToTarget, 14,
/* 19298*/    OPC_EmitConvertToTarget, 15,
/* 19300*/    OPC_EmitConvertToTarget, 16,
/* 19302*/    OPC_EmitConvertToTarget, 17,
/* 19304*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v8i16*/50, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v8i16] } V128:{ *:[v8i16] }:$x, V128:{ *:[v8i16] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v8i16] } ?:{ *:[v8i16] }:$x, ?:{ *:[v8i16] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 19327*/   /*SwitchOpcode*/ 25|128,1/*153*/, TARGET_VAL(ISD::TargetConstant),// ->19484
/* 19331*/    OPC_CheckTypeI32,
/* 19332*/    OPC_MoveSibling3,
/* 19333*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19336*/    OPC_RecordNode, // #3 = $m1
/* 19337*/    OPC_CheckTypeI32,
/* 19338*/    OPC_MoveSibling4,
/* 19339*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19342*/    OPC_RecordNode, // #4 = $m2
/* 19343*/    OPC_CheckTypeI32,
/* 19344*/    OPC_MoveSibling5,
/* 19345*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19348*/    OPC_RecordNode, // #5 = $m3
/* 19349*/    OPC_CheckTypeI32,
/* 19350*/    OPC_MoveSibling6,
/* 19351*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19354*/    OPC_RecordNode, // #6 = $m4
/* 19355*/    OPC_CheckTypeI32,
/* 19356*/    OPC_MoveSibling7,
/* 19357*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19360*/    OPC_RecordNode, // #7 = $m5
/* 19361*/    OPC_CheckTypeI32,
/* 19362*/    OPC_MoveSibling, 8,
/* 19364*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19367*/    OPC_RecordNode, // #8 = $m6
/* 19368*/    OPC_CheckTypeI32,
/* 19369*/    OPC_MoveSibling, 9,
/* 19371*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19374*/    OPC_RecordNode, // #9 = $m7
/* 19375*/    OPC_CheckTypeI32,
/* 19376*/    OPC_MoveSibling, 10,
/* 19378*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19381*/    OPC_RecordNode, // #10 = $m8
/* 19382*/    OPC_CheckTypeI32,
/* 19383*/    OPC_MoveSibling, 11,
/* 19385*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19388*/    OPC_RecordNode, // #11 = $m9
/* 19389*/    OPC_CheckTypeI32,
/* 19390*/    OPC_MoveSibling, 12,
/* 19392*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19395*/    OPC_RecordNode, // #12 = $mA
/* 19396*/    OPC_CheckTypeI32,
/* 19397*/    OPC_MoveSibling, 13,
/* 19399*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19402*/    OPC_RecordNode, // #13 = $mB
/* 19403*/    OPC_CheckTypeI32,
/* 19404*/    OPC_MoveSibling, 14,
/* 19406*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19409*/    OPC_RecordNode, // #14 = $mC
/* 19410*/    OPC_CheckTypeI32,
/* 19411*/    OPC_MoveSibling, 15,
/* 19413*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19416*/    OPC_RecordNode, // #15 = $mD
/* 19417*/    OPC_CheckTypeI32,
/* 19418*/    OPC_MoveSibling, 16,
/* 19420*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19423*/    OPC_RecordNode, // #16 = $mE
/* 19424*/    OPC_CheckTypeI32,
/* 19425*/    OPC_MoveSibling, 17,
/* 19427*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19430*/    OPC_RecordNode, // #17 = $mF
/* 19431*/    OPC_CheckTypeI32,
/* 19432*/    OPC_MoveParent,
/* 19433*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 19435*/    OPC_EmitConvertToTarget2,
/* 19436*/    OPC_EmitConvertToTarget3,
/* 19437*/    OPC_EmitConvertToTarget4,
/* 19438*/    OPC_EmitConvertToTarget5,
/* 19439*/    OPC_EmitConvertToTarget6,
/* 19440*/    OPC_EmitConvertToTarget7,
/* 19441*/    OPC_EmitConvertToTarget, 8,
/* 19443*/    OPC_EmitConvertToTarget, 9,
/* 19445*/    OPC_EmitConvertToTarget, 10,
/* 19447*/    OPC_EmitConvertToTarget, 11,
/* 19449*/    OPC_EmitConvertToTarget, 12,
/* 19451*/    OPC_EmitConvertToTarget, 13,
/* 19453*/    OPC_EmitConvertToTarget, 14,
/* 19455*/    OPC_EmitConvertToTarget, 15,
/* 19457*/    OPC_EmitConvertToTarget, 16,
/* 19459*/    OPC_EmitConvertToTarget, 17,
/* 19461*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v8i16*/50, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v8i16] } V128:{ *:[v8i16] }:$x, V128:{ *:[v8i16] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v8i16] } ?:{ *:[v8i16] }:$x, ?:{ *:[v8i16] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 19484*/   0, // EndSwitchOpcode
/* 19485*/  /*Scope*/ 83|128,2/*339*/, /*->19826*/
/* 19487*/   OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 19489*/   OPC_RecordChild1, // #1 = $y
/* 19490*/   OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/* 19492*/   OPC_RecordChild2, // #2 = $m0
/* 19493*/   OPC_MoveChild2,
/* 19494*/   OPC_SwitchOpcode /*2 cases */, 41|128,1/*169*/, TARGET_VAL(ISD::Constant),// ->19668
/* 19499*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19500*/    OPC_CheckTypeI32,
/* 19501*/    OPC_MoveSibling3,
/* 19502*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19505*/    OPC_RecordNode, // #3 = $m1
/* 19506*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19507*/    OPC_CheckTypeI32,
/* 19508*/    OPC_MoveSibling4,
/* 19509*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19512*/    OPC_RecordNode, // #4 = $m2
/* 19513*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19514*/    OPC_CheckTypeI32,
/* 19515*/    OPC_MoveSibling5,
/* 19516*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19519*/    OPC_RecordNode, // #5 = $m3
/* 19520*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19521*/    OPC_CheckTypeI32,
/* 19522*/    OPC_MoveSibling6,
/* 19523*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19526*/    OPC_RecordNode, // #6 = $m4
/* 19527*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19528*/    OPC_CheckTypeI32,
/* 19529*/    OPC_MoveSibling7,
/* 19530*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19533*/    OPC_RecordNode, // #7 = $m5
/* 19534*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19535*/    OPC_CheckTypeI32,
/* 19536*/    OPC_MoveSibling, 8,
/* 19538*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19541*/    OPC_RecordNode, // #8 = $m6
/* 19542*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19543*/    OPC_CheckTypeI32,
/* 19544*/    OPC_MoveSibling, 9,
/* 19546*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19549*/    OPC_RecordNode, // #9 = $m7
/* 19550*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19551*/    OPC_CheckTypeI32,
/* 19552*/    OPC_MoveSibling, 10,
/* 19554*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19557*/    OPC_RecordNode, // #10 = $m8
/* 19558*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19559*/    OPC_CheckTypeI32,
/* 19560*/    OPC_MoveSibling, 11,
/* 19562*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19565*/    OPC_RecordNode, // #11 = $m9
/* 19566*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19567*/    OPC_CheckTypeI32,
/* 19568*/    OPC_MoveSibling, 12,
/* 19570*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19573*/    OPC_RecordNode, // #12 = $mA
/* 19574*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19575*/    OPC_CheckTypeI32,
/* 19576*/    OPC_MoveSibling, 13,
/* 19578*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19581*/    OPC_RecordNode, // #13 = $mB
/* 19582*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19583*/    OPC_CheckTypeI32,
/* 19584*/    OPC_MoveSibling, 14,
/* 19586*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19589*/    OPC_RecordNode, // #14 = $mC
/* 19590*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19591*/    OPC_CheckTypeI32,
/* 19592*/    OPC_MoveSibling, 15,
/* 19594*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19597*/    OPC_RecordNode, // #15 = $mD
/* 19598*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19599*/    OPC_CheckTypeI32,
/* 19600*/    OPC_MoveSibling, 16,
/* 19602*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19605*/    OPC_RecordNode, // #16 = $mE
/* 19606*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19607*/    OPC_CheckTypeI32,
/* 19608*/    OPC_MoveSibling, 17,
/* 19610*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19613*/    OPC_RecordNode, // #17 = $mF
/* 19614*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19615*/    OPC_CheckTypeI32,
/* 19616*/    OPC_MoveParent,
/* 19617*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 19619*/    OPC_EmitConvertToTarget2,
/* 19620*/    OPC_EmitConvertToTarget3,
/* 19621*/    OPC_EmitConvertToTarget4,
/* 19622*/    OPC_EmitConvertToTarget5,
/* 19623*/    OPC_EmitConvertToTarget6,
/* 19624*/    OPC_EmitConvertToTarget7,
/* 19625*/    OPC_EmitConvertToTarget, 8,
/* 19627*/    OPC_EmitConvertToTarget, 9,
/* 19629*/    OPC_EmitConvertToTarget, 10,
/* 19631*/    OPC_EmitConvertToTarget, 11,
/* 19633*/    OPC_EmitConvertToTarget, 12,
/* 19635*/    OPC_EmitConvertToTarget, 13,
/* 19637*/    OPC_EmitConvertToTarget, 14,
/* 19639*/    OPC_EmitConvertToTarget, 15,
/* 19641*/    OPC_EmitConvertToTarget, 16,
/* 19643*/    OPC_EmitConvertToTarget, 17,
/* 19645*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v4i32*/60, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v4i32] } V128:{ *:[v4i32] }:$x, V128:{ *:[v4i32] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v4i32] } ?:{ *:[v4i32] }:$x, ?:{ *:[v4i32] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 19668*/   /*SwitchOpcode*/ 25|128,1/*153*/, TARGET_VAL(ISD::TargetConstant),// ->19825
/* 19672*/    OPC_CheckTypeI32,
/* 19673*/    OPC_MoveSibling3,
/* 19674*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19677*/    OPC_RecordNode, // #3 = $m1
/* 19678*/    OPC_CheckTypeI32,
/* 19679*/    OPC_MoveSibling4,
/* 19680*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19683*/    OPC_RecordNode, // #4 = $m2
/* 19684*/    OPC_CheckTypeI32,
/* 19685*/    OPC_MoveSibling5,
/* 19686*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19689*/    OPC_RecordNode, // #5 = $m3
/* 19690*/    OPC_CheckTypeI32,
/* 19691*/    OPC_MoveSibling6,
/* 19692*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19695*/    OPC_RecordNode, // #6 = $m4
/* 19696*/    OPC_CheckTypeI32,
/* 19697*/    OPC_MoveSibling7,
/* 19698*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19701*/    OPC_RecordNode, // #7 = $m5
/* 19702*/    OPC_CheckTypeI32,
/* 19703*/    OPC_MoveSibling, 8,
/* 19705*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19708*/    OPC_RecordNode, // #8 = $m6
/* 19709*/    OPC_CheckTypeI32,
/* 19710*/    OPC_MoveSibling, 9,
/* 19712*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19715*/    OPC_RecordNode, // #9 = $m7
/* 19716*/    OPC_CheckTypeI32,
/* 19717*/    OPC_MoveSibling, 10,
/* 19719*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19722*/    OPC_RecordNode, // #10 = $m8
/* 19723*/    OPC_CheckTypeI32,
/* 19724*/    OPC_MoveSibling, 11,
/* 19726*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19729*/    OPC_RecordNode, // #11 = $m9
/* 19730*/    OPC_CheckTypeI32,
/* 19731*/    OPC_MoveSibling, 12,
/* 19733*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19736*/    OPC_RecordNode, // #12 = $mA
/* 19737*/    OPC_CheckTypeI32,
/* 19738*/    OPC_MoveSibling, 13,
/* 19740*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19743*/    OPC_RecordNode, // #13 = $mB
/* 19744*/    OPC_CheckTypeI32,
/* 19745*/    OPC_MoveSibling, 14,
/* 19747*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19750*/    OPC_RecordNode, // #14 = $mC
/* 19751*/    OPC_CheckTypeI32,
/* 19752*/    OPC_MoveSibling, 15,
/* 19754*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19757*/    OPC_RecordNode, // #15 = $mD
/* 19758*/    OPC_CheckTypeI32,
/* 19759*/    OPC_MoveSibling, 16,
/* 19761*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19764*/    OPC_RecordNode, // #16 = $mE
/* 19765*/    OPC_CheckTypeI32,
/* 19766*/    OPC_MoveSibling, 17,
/* 19768*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 19771*/    OPC_RecordNode, // #17 = $mF
/* 19772*/    OPC_CheckTypeI32,
/* 19773*/    OPC_MoveParent,
/* 19774*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 19776*/    OPC_EmitConvertToTarget2,
/* 19777*/    OPC_EmitConvertToTarget3,
/* 19778*/    OPC_EmitConvertToTarget4,
/* 19779*/    OPC_EmitConvertToTarget5,
/* 19780*/    OPC_EmitConvertToTarget6,
/* 19781*/    OPC_EmitConvertToTarget7,
/* 19782*/    OPC_EmitConvertToTarget, 8,
/* 19784*/    OPC_EmitConvertToTarget, 9,
/* 19786*/    OPC_EmitConvertToTarget, 10,
/* 19788*/    OPC_EmitConvertToTarget, 11,
/* 19790*/    OPC_EmitConvertToTarget, 12,
/* 19792*/    OPC_EmitConvertToTarget, 13,
/* 19794*/    OPC_EmitConvertToTarget, 14,
/* 19796*/    OPC_EmitConvertToTarget, 15,
/* 19798*/    OPC_EmitConvertToTarget, 16,
/* 19800*/    OPC_EmitConvertToTarget, 17,
/* 19802*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v4i32*/60, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v4i32] } V128:{ *:[v4i32] }:$x, V128:{ *:[v4i32] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v4i32] } ?:{ *:[v4i32] }:$x, ?:{ *:[v4i32] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 19825*/   0, // EndSwitchOpcode
/* 19826*/  /*Scope*/ 83|128,2/*339*/, /*->20167*/
/* 19828*/   OPC_CheckChild0Type, /*MVT::v2i64*/78, 
/* 19830*/   OPC_RecordChild1, // #1 = $y
/* 19831*/   OPC_CheckChild1Type, /*MVT::v2i64*/78, 
/* 19833*/   OPC_RecordChild2, // #2 = $m0
/* 19834*/   OPC_MoveChild2,
/* 19835*/   OPC_SwitchOpcode /*2 cases */, 41|128,1/*169*/, TARGET_VAL(ISD::Constant),// ->20009
/* 19840*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19841*/    OPC_CheckTypeI32,
/* 19842*/    OPC_MoveSibling3,
/* 19843*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19846*/    OPC_RecordNode, // #3 = $m1
/* 19847*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19848*/    OPC_CheckTypeI32,
/* 19849*/    OPC_MoveSibling4,
/* 19850*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19853*/    OPC_RecordNode, // #4 = $m2
/* 19854*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19855*/    OPC_CheckTypeI32,
/* 19856*/    OPC_MoveSibling5,
/* 19857*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19860*/    OPC_RecordNode, // #5 = $m3
/* 19861*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19862*/    OPC_CheckTypeI32,
/* 19863*/    OPC_MoveSibling6,
/* 19864*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19867*/    OPC_RecordNode, // #6 = $m4
/* 19868*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19869*/    OPC_CheckTypeI32,
/* 19870*/    OPC_MoveSibling7,
/* 19871*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19874*/    OPC_RecordNode, // #7 = $m5
/* 19875*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19876*/    OPC_CheckTypeI32,
/* 19877*/    OPC_MoveSibling, 8,
/* 19879*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19882*/    OPC_RecordNode, // #8 = $m6
/* 19883*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19884*/    OPC_CheckTypeI32,
/* 19885*/    OPC_MoveSibling, 9,
/* 19887*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19890*/    OPC_RecordNode, // #9 = $m7
/* 19891*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19892*/    OPC_CheckTypeI32,
/* 19893*/    OPC_MoveSibling, 10,
/* 19895*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19898*/    OPC_RecordNode, // #10 = $m8
/* 19899*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19900*/    OPC_CheckTypeI32,
/* 19901*/    OPC_MoveSibling, 11,
/* 19903*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19906*/    OPC_RecordNode, // #11 = $m9
/* 19907*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19908*/    OPC_CheckTypeI32,
/* 19909*/    OPC_MoveSibling, 12,
/* 19911*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19914*/    OPC_RecordNode, // #12 = $mA
/* 19915*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19916*/    OPC_CheckTypeI32,
/* 19917*/    OPC_MoveSibling, 13,
/* 19919*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19922*/    OPC_RecordNode, // #13 = $mB
/* 19923*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19924*/    OPC_CheckTypeI32,
/* 19925*/    OPC_MoveSibling, 14,
/* 19927*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19930*/    OPC_RecordNode, // #14 = $mC
/* 19931*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19932*/    OPC_CheckTypeI32,
/* 19933*/    OPC_MoveSibling, 15,
/* 19935*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19938*/    OPC_RecordNode, // #15 = $mD
/* 19939*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19940*/    OPC_CheckTypeI32,
/* 19941*/    OPC_MoveSibling, 16,
/* 19943*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19946*/    OPC_RecordNode, // #16 = $mE
/* 19947*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19948*/    OPC_CheckTypeI32,
/* 19949*/    OPC_MoveSibling, 17,
/* 19951*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 19954*/    OPC_RecordNode, // #17 = $mF
/* 19955*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 19956*/    OPC_CheckTypeI32,
/* 19957*/    OPC_MoveParent,
/* 19958*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 19960*/    OPC_EmitConvertToTarget2,
/* 19961*/    OPC_EmitConvertToTarget3,
/* 19962*/    OPC_EmitConvertToTarget4,
/* 19963*/    OPC_EmitConvertToTarget5,
/* 19964*/    OPC_EmitConvertToTarget6,
/* 19965*/    OPC_EmitConvertToTarget7,
/* 19966*/    OPC_EmitConvertToTarget, 8,
/* 19968*/    OPC_EmitConvertToTarget, 9,
/* 19970*/    OPC_EmitConvertToTarget, 10,
/* 19972*/    OPC_EmitConvertToTarget, 11,
/* 19974*/    OPC_EmitConvertToTarget, 12,
/* 19976*/    OPC_EmitConvertToTarget, 13,
/* 19978*/    OPC_EmitConvertToTarget, 14,
/* 19980*/    OPC_EmitConvertToTarget, 15,
/* 19982*/    OPC_EmitConvertToTarget, 16,
/* 19984*/    OPC_EmitConvertToTarget, 17,
/* 19986*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v2i64*/78, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v2i64] } V128:{ *:[v2i64] }:$x, V128:{ *:[v2i64] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v2i64] } ?:{ *:[v2i64] }:$x, ?:{ *:[v2i64] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 20009*/   /*SwitchOpcode*/ 25|128,1/*153*/, TARGET_VAL(ISD::TargetConstant),// ->20166
/* 20013*/    OPC_CheckTypeI32,
/* 20014*/    OPC_MoveSibling3,
/* 20015*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20018*/    OPC_RecordNode, // #3 = $m1
/* 20019*/    OPC_CheckTypeI32,
/* 20020*/    OPC_MoveSibling4,
/* 20021*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20024*/    OPC_RecordNode, // #4 = $m2
/* 20025*/    OPC_CheckTypeI32,
/* 20026*/    OPC_MoveSibling5,
/* 20027*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20030*/    OPC_RecordNode, // #5 = $m3
/* 20031*/    OPC_CheckTypeI32,
/* 20032*/    OPC_MoveSibling6,
/* 20033*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20036*/    OPC_RecordNode, // #6 = $m4
/* 20037*/    OPC_CheckTypeI32,
/* 20038*/    OPC_MoveSibling7,
/* 20039*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20042*/    OPC_RecordNode, // #7 = $m5
/* 20043*/    OPC_CheckTypeI32,
/* 20044*/    OPC_MoveSibling, 8,
/* 20046*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20049*/    OPC_RecordNode, // #8 = $m6
/* 20050*/    OPC_CheckTypeI32,
/* 20051*/    OPC_MoveSibling, 9,
/* 20053*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20056*/    OPC_RecordNode, // #9 = $m7
/* 20057*/    OPC_CheckTypeI32,
/* 20058*/    OPC_MoveSibling, 10,
/* 20060*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20063*/    OPC_RecordNode, // #10 = $m8
/* 20064*/    OPC_CheckTypeI32,
/* 20065*/    OPC_MoveSibling, 11,
/* 20067*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20070*/    OPC_RecordNode, // #11 = $m9
/* 20071*/    OPC_CheckTypeI32,
/* 20072*/    OPC_MoveSibling, 12,
/* 20074*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20077*/    OPC_RecordNode, // #12 = $mA
/* 20078*/    OPC_CheckTypeI32,
/* 20079*/    OPC_MoveSibling, 13,
/* 20081*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20084*/    OPC_RecordNode, // #13 = $mB
/* 20085*/    OPC_CheckTypeI32,
/* 20086*/    OPC_MoveSibling, 14,
/* 20088*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20091*/    OPC_RecordNode, // #14 = $mC
/* 20092*/    OPC_CheckTypeI32,
/* 20093*/    OPC_MoveSibling, 15,
/* 20095*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20098*/    OPC_RecordNode, // #15 = $mD
/* 20099*/    OPC_CheckTypeI32,
/* 20100*/    OPC_MoveSibling, 16,
/* 20102*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20105*/    OPC_RecordNode, // #16 = $mE
/* 20106*/    OPC_CheckTypeI32,
/* 20107*/    OPC_MoveSibling, 17,
/* 20109*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20112*/    OPC_RecordNode, // #17 = $mF
/* 20113*/    OPC_CheckTypeI32,
/* 20114*/    OPC_MoveParent,
/* 20115*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 20117*/    OPC_EmitConvertToTarget2,
/* 20118*/    OPC_EmitConvertToTarget3,
/* 20119*/    OPC_EmitConvertToTarget4,
/* 20120*/    OPC_EmitConvertToTarget5,
/* 20121*/    OPC_EmitConvertToTarget6,
/* 20122*/    OPC_EmitConvertToTarget7,
/* 20123*/    OPC_EmitConvertToTarget, 8,
/* 20125*/    OPC_EmitConvertToTarget, 9,
/* 20127*/    OPC_EmitConvertToTarget, 10,
/* 20129*/    OPC_EmitConvertToTarget, 11,
/* 20131*/    OPC_EmitConvertToTarget, 12,
/* 20133*/    OPC_EmitConvertToTarget, 13,
/* 20135*/    OPC_EmitConvertToTarget, 14,
/* 20137*/    OPC_EmitConvertToTarget, 15,
/* 20139*/    OPC_EmitConvertToTarget, 16,
/* 20141*/    OPC_EmitConvertToTarget, 17,
/* 20143*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v2i64*/78, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v2i64] } V128:{ *:[v2i64] }:$x, V128:{ *:[v2i64] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v2i64] } ?:{ *:[v2i64] }:$x, ?:{ *:[v2i64] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 20166*/   0, // EndSwitchOpcode
/* 20167*/  /*Scope*/ 83|128,2/*339*/, /*->20508*/
/* 20169*/   OPC_CheckChild0Type, /*MVT::v4f32*/111, 
/* 20171*/   OPC_RecordChild1, // #1 = $y
/* 20172*/   OPC_CheckChild1Type, /*MVT::v4f32*/111, 
/* 20174*/   OPC_RecordChild2, // #2 = $m0
/* 20175*/   OPC_MoveChild2,
/* 20176*/   OPC_SwitchOpcode /*2 cases */, 41|128,1/*169*/, TARGET_VAL(ISD::Constant),// ->20350
/* 20181*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20182*/    OPC_CheckTypeI32,
/* 20183*/    OPC_MoveSibling3,
/* 20184*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20187*/    OPC_RecordNode, // #3 = $m1
/* 20188*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20189*/    OPC_CheckTypeI32,
/* 20190*/    OPC_MoveSibling4,
/* 20191*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20194*/    OPC_RecordNode, // #4 = $m2
/* 20195*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20196*/    OPC_CheckTypeI32,
/* 20197*/    OPC_MoveSibling5,
/* 20198*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20201*/    OPC_RecordNode, // #5 = $m3
/* 20202*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20203*/    OPC_CheckTypeI32,
/* 20204*/    OPC_MoveSibling6,
/* 20205*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20208*/    OPC_RecordNode, // #6 = $m4
/* 20209*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20210*/    OPC_CheckTypeI32,
/* 20211*/    OPC_MoveSibling7,
/* 20212*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20215*/    OPC_RecordNode, // #7 = $m5
/* 20216*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20217*/    OPC_CheckTypeI32,
/* 20218*/    OPC_MoveSibling, 8,
/* 20220*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20223*/    OPC_RecordNode, // #8 = $m6
/* 20224*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20225*/    OPC_CheckTypeI32,
/* 20226*/    OPC_MoveSibling, 9,
/* 20228*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20231*/    OPC_RecordNode, // #9 = $m7
/* 20232*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20233*/    OPC_CheckTypeI32,
/* 20234*/    OPC_MoveSibling, 10,
/* 20236*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20239*/    OPC_RecordNode, // #10 = $m8
/* 20240*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20241*/    OPC_CheckTypeI32,
/* 20242*/    OPC_MoveSibling, 11,
/* 20244*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20247*/    OPC_RecordNode, // #11 = $m9
/* 20248*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20249*/    OPC_CheckTypeI32,
/* 20250*/    OPC_MoveSibling, 12,
/* 20252*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20255*/    OPC_RecordNode, // #12 = $mA
/* 20256*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20257*/    OPC_CheckTypeI32,
/* 20258*/    OPC_MoveSibling, 13,
/* 20260*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20263*/    OPC_RecordNode, // #13 = $mB
/* 20264*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20265*/    OPC_CheckTypeI32,
/* 20266*/    OPC_MoveSibling, 14,
/* 20268*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20271*/    OPC_RecordNode, // #14 = $mC
/* 20272*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20273*/    OPC_CheckTypeI32,
/* 20274*/    OPC_MoveSibling, 15,
/* 20276*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20279*/    OPC_RecordNode, // #15 = $mD
/* 20280*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20281*/    OPC_CheckTypeI32,
/* 20282*/    OPC_MoveSibling, 16,
/* 20284*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20287*/    OPC_RecordNode, // #16 = $mE
/* 20288*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20289*/    OPC_CheckTypeI32,
/* 20290*/    OPC_MoveSibling, 17,
/* 20292*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20295*/    OPC_RecordNode, // #17 = $mF
/* 20296*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20297*/    OPC_CheckTypeI32,
/* 20298*/    OPC_MoveParent,
/* 20299*/    OPC_CheckType, /*MVT::v4f32*/111, 
/* 20301*/    OPC_EmitConvertToTarget2,
/* 20302*/    OPC_EmitConvertToTarget3,
/* 20303*/    OPC_EmitConvertToTarget4,
/* 20304*/    OPC_EmitConvertToTarget5,
/* 20305*/    OPC_EmitConvertToTarget6,
/* 20306*/    OPC_EmitConvertToTarget7,
/* 20307*/    OPC_EmitConvertToTarget, 8,
/* 20309*/    OPC_EmitConvertToTarget, 9,
/* 20311*/    OPC_EmitConvertToTarget, 10,
/* 20313*/    OPC_EmitConvertToTarget, 11,
/* 20315*/    OPC_EmitConvertToTarget, 12,
/* 20317*/    OPC_EmitConvertToTarget, 13,
/* 20319*/    OPC_EmitConvertToTarget, 14,
/* 20321*/    OPC_EmitConvertToTarget, 15,
/* 20323*/    OPC_EmitConvertToTarget, 16,
/* 20325*/    OPC_EmitConvertToTarget, 17,
/* 20327*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v4f32*/111, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v4f32] } V128:{ *:[v4f32] }:$x, V128:{ *:[v4f32] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v4f32] } ?:{ *:[v4f32] }:$x, ?:{ *:[v4f32] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 20350*/   /*SwitchOpcode*/ 25|128,1/*153*/, TARGET_VAL(ISD::TargetConstant),// ->20507
/* 20354*/    OPC_CheckTypeI32,
/* 20355*/    OPC_MoveSibling3,
/* 20356*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20359*/    OPC_RecordNode, // #3 = $m1
/* 20360*/    OPC_CheckTypeI32,
/* 20361*/    OPC_MoveSibling4,
/* 20362*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20365*/    OPC_RecordNode, // #4 = $m2
/* 20366*/    OPC_CheckTypeI32,
/* 20367*/    OPC_MoveSibling5,
/* 20368*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20371*/    OPC_RecordNode, // #5 = $m3
/* 20372*/    OPC_CheckTypeI32,
/* 20373*/    OPC_MoveSibling6,
/* 20374*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20377*/    OPC_RecordNode, // #6 = $m4
/* 20378*/    OPC_CheckTypeI32,
/* 20379*/    OPC_MoveSibling7,
/* 20380*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20383*/    OPC_RecordNode, // #7 = $m5
/* 20384*/    OPC_CheckTypeI32,
/* 20385*/    OPC_MoveSibling, 8,
/* 20387*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20390*/    OPC_RecordNode, // #8 = $m6
/* 20391*/    OPC_CheckTypeI32,
/* 20392*/    OPC_MoveSibling, 9,
/* 20394*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20397*/    OPC_RecordNode, // #9 = $m7
/* 20398*/    OPC_CheckTypeI32,
/* 20399*/    OPC_MoveSibling, 10,
/* 20401*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20404*/    OPC_RecordNode, // #10 = $m8
/* 20405*/    OPC_CheckTypeI32,
/* 20406*/    OPC_MoveSibling, 11,
/* 20408*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20411*/    OPC_RecordNode, // #11 = $m9
/* 20412*/    OPC_CheckTypeI32,
/* 20413*/    OPC_MoveSibling, 12,
/* 20415*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20418*/    OPC_RecordNode, // #12 = $mA
/* 20419*/    OPC_CheckTypeI32,
/* 20420*/    OPC_MoveSibling, 13,
/* 20422*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20425*/    OPC_RecordNode, // #13 = $mB
/* 20426*/    OPC_CheckTypeI32,
/* 20427*/    OPC_MoveSibling, 14,
/* 20429*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20432*/    OPC_RecordNode, // #14 = $mC
/* 20433*/    OPC_CheckTypeI32,
/* 20434*/    OPC_MoveSibling, 15,
/* 20436*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20439*/    OPC_RecordNode, // #15 = $mD
/* 20440*/    OPC_CheckTypeI32,
/* 20441*/    OPC_MoveSibling, 16,
/* 20443*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20446*/    OPC_RecordNode, // #16 = $mE
/* 20447*/    OPC_CheckTypeI32,
/* 20448*/    OPC_MoveSibling, 17,
/* 20450*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20453*/    OPC_RecordNode, // #17 = $mF
/* 20454*/    OPC_CheckTypeI32,
/* 20455*/    OPC_MoveParent,
/* 20456*/    OPC_CheckType, /*MVT::v4f32*/111, 
/* 20458*/    OPC_EmitConvertToTarget2,
/* 20459*/    OPC_EmitConvertToTarget3,
/* 20460*/    OPC_EmitConvertToTarget4,
/* 20461*/    OPC_EmitConvertToTarget5,
/* 20462*/    OPC_EmitConvertToTarget6,
/* 20463*/    OPC_EmitConvertToTarget7,
/* 20464*/    OPC_EmitConvertToTarget, 8,
/* 20466*/    OPC_EmitConvertToTarget, 9,
/* 20468*/    OPC_EmitConvertToTarget, 10,
/* 20470*/    OPC_EmitConvertToTarget, 11,
/* 20472*/    OPC_EmitConvertToTarget, 12,
/* 20474*/    OPC_EmitConvertToTarget, 13,
/* 20476*/    OPC_EmitConvertToTarget, 14,
/* 20478*/    OPC_EmitConvertToTarget, 15,
/* 20480*/    OPC_EmitConvertToTarget, 16,
/* 20482*/    OPC_EmitConvertToTarget, 17,
/* 20484*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v4f32*/111, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v4f32] } V128:{ *:[v4f32] }:$x, V128:{ *:[v4f32] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v4f32] } ?:{ *:[v4f32] }:$x, ?:{ *:[v4f32] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 20507*/   0, // EndSwitchOpcode
/* 20508*/  /*Scope*/ 89|128,2/*345*/, /*->20855*/
/* 20510*/   OPC_CheckChild0Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 20513*/   OPC_RecordChild1, // #1 = $y
/* 20514*/   OPC_CheckChild1Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 20517*/   OPC_RecordChild2, // #2 = $m0
/* 20518*/   OPC_MoveChild2,
/* 20519*/   OPC_SwitchOpcode /*2 cases */, 43|128,1/*171*/, TARGET_VAL(ISD::Constant),// ->20695
/* 20524*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20525*/    OPC_CheckTypeI32,
/* 20526*/    OPC_MoveSibling3,
/* 20527*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20530*/    OPC_RecordNode, // #3 = $m1
/* 20531*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20532*/    OPC_CheckTypeI32,
/* 20533*/    OPC_MoveSibling4,
/* 20534*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20537*/    OPC_RecordNode, // #4 = $m2
/* 20538*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20539*/    OPC_CheckTypeI32,
/* 20540*/    OPC_MoveSibling5,
/* 20541*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20544*/    OPC_RecordNode, // #5 = $m3
/* 20545*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20546*/    OPC_CheckTypeI32,
/* 20547*/    OPC_MoveSibling6,
/* 20548*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20551*/    OPC_RecordNode, // #6 = $m4
/* 20552*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20553*/    OPC_CheckTypeI32,
/* 20554*/    OPC_MoveSibling7,
/* 20555*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20558*/    OPC_RecordNode, // #7 = $m5
/* 20559*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20560*/    OPC_CheckTypeI32,
/* 20561*/    OPC_MoveSibling, 8,
/* 20563*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20566*/    OPC_RecordNode, // #8 = $m6
/* 20567*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20568*/    OPC_CheckTypeI32,
/* 20569*/    OPC_MoveSibling, 9,
/* 20571*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20574*/    OPC_RecordNode, // #9 = $m7
/* 20575*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20576*/    OPC_CheckTypeI32,
/* 20577*/    OPC_MoveSibling, 10,
/* 20579*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20582*/    OPC_RecordNode, // #10 = $m8
/* 20583*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20584*/    OPC_CheckTypeI32,
/* 20585*/    OPC_MoveSibling, 11,
/* 20587*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20590*/    OPC_RecordNode, // #11 = $m9
/* 20591*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20592*/    OPC_CheckTypeI32,
/* 20593*/    OPC_MoveSibling, 12,
/* 20595*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20598*/    OPC_RecordNode, // #12 = $mA
/* 20599*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20600*/    OPC_CheckTypeI32,
/* 20601*/    OPC_MoveSibling, 13,
/* 20603*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20606*/    OPC_RecordNode, // #13 = $mB
/* 20607*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20608*/    OPC_CheckTypeI32,
/* 20609*/    OPC_MoveSibling, 14,
/* 20611*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20614*/    OPC_RecordNode, // #14 = $mC
/* 20615*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20616*/    OPC_CheckTypeI32,
/* 20617*/    OPC_MoveSibling, 15,
/* 20619*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20622*/    OPC_RecordNode, // #15 = $mD
/* 20623*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20624*/    OPC_CheckTypeI32,
/* 20625*/    OPC_MoveSibling, 16,
/* 20627*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20630*/    OPC_RecordNode, // #16 = $mE
/* 20631*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20632*/    OPC_CheckTypeI32,
/* 20633*/    OPC_MoveSibling, 17,
/* 20635*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 20638*/    OPC_RecordNode, // #17 = $mF
/* 20639*/    OPC_CheckPredicate0,  // Predicate_LaneIdx32
/* 20640*/    OPC_CheckTypeI32,
/* 20641*/    OPC_MoveParent,
/* 20642*/    OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 20645*/    OPC_EmitConvertToTarget2,
/* 20646*/    OPC_EmitConvertToTarget3,
/* 20647*/    OPC_EmitConvertToTarget4,
/* 20648*/    OPC_EmitConvertToTarget5,
/* 20649*/    OPC_EmitConvertToTarget6,
/* 20650*/    OPC_EmitConvertToTarget7,
/* 20651*/    OPC_EmitConvertToTarget, 8,
/* 20653*/    OPC_EmitConvertToTarget, 9,
/* 20655*/    OPC_EmitConvertToTarget, 10,
/* 20657*/    OPC_EmitConvertToTarget, 11,
/* 20659*/    OPC_EmitConvertToTarget, 12,
/* 20661*/    OPC_EmitConvertToTarget, 13,
/* 20663*/    OPC_EmitConvertToTarget, 14,
/* 20665*/    OPC_EmitConvertToTarget, 15,
/* 20667*/    OPC_EmitConvertToTarget, 16,
/* 20669*/    OPC_EmitConvertToTarget, 17,
/* 20671*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v2f64*/1|128,1/*129*/, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v2f64] } V128:{ *:[v2f64] }:$x, V128:{ *:[v2f64] }:$y, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m0, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m1, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m2, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m3, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m4, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m5, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m6, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m7, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m8, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$m9, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mA, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mB, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mC, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mD, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mE, (imm:{ *:[i32] })<<P:Predicate_LaneIdx32>>:$mF) - Complexity = 67
              // Dst: (SHUFFLE:{ *:[v2f64] } ?:{ *:[v2f64] }:$x, ?:{ *:[v2f64] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 20695*/   /*SwitchOpcode*/ 27|128,1/*155*/, TARGET_VAL(ISD::TargetConstant),// ->20854
/* 20699*/    OPC_CheckTypeI32,
/* 20700*/    OPC_MoveSibling3,
/* 20701*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20704*/    OPC_RecordNode, // #3 = $m1
/* 20705*/    OPC_CheckTypeI32,
/* 20706*/    OPC_MoveSibling4,
/* 20707*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20710*/    OPC_RecordNode, // #4 = $m2
/* 20711*/    OPC_CheckTypeI32,
/* 20712*/    OPC_MoveSibling5,
/* 20713*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20716*/    OPC_RecordNode, // #5 = $m3
/* 20717*/    OPC_CheckTypeI32,
/* 20718*/    OPC_MoveSibling6,
/* 20719*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20722*/    OPC_RecordNode, // #6 = $m4
/* 20723*/    OPC_CheckTypeI32,
/* 20724*/    OPC_MoveSibling7,
/* 20725*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20728*/    OPC_RecordNode, // #7 = $m5
/* 20729*/    OPC_CheckTypeI32,
/* 20730*/    OPC_MoveSibling, 8,
/* 20732*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20735*/    OPC_RecordNode, // #8 = $m6
/* 20736*/    OPC_CheckTypeI32,
/* 20737*/    OPC_MoveSibling, 9,
/* 20739*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20742*/    OPC_RecordNode, // #9 = $m7
/* 20743*/    OPC_CheckTypeI32,
/* 20744*/    OPC_MoveSibling, 10,
/* 20746*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20749*/    OPC_RecordNode, // #10 = $m8
/* 20750*/    OPC_CheckTypeI32,
/* 20751*/    OPC_MoveSibling, 11,
/* 20753*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20756*/    OPC_RecordNode, // #11 = $m9
/* 20757*/    OPC_CheckTypeI32,
/* 20758*/    OPC_MoveSibling, 12,
/* 20760*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20763*/    OPC_RecordNode, // #12 = $mA
/* 20764*/    OPC_CheckTypeI32,
/* 20765*/    OPC_MoveSibling, 13,
/* 20767*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20770*/    OPC_RecordNode, // #13 = $mB
/* 20771*/    OPC_CheckTypeI32,
/* 20772*/    OPC_MoveSibling, 14,
/* 20774*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20777*/    OPC_RecordNode, // #14 = $mC
/* 20778*/    OPC_CheckTypeI32,
/* 20779*/    OPC_MoveSibling, 15,
/* 20781*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20784*/    OPC_RecordNode, // #15 = $mD
/* 20785*/    OPC_CheckTypeI32,
/* 20786*/    OPC_MoveSibling, 16,
/* 20788*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20791*/    OPC_RecordNode, // #16 = $mE
/* 20792*/    OPC_CheckTypeI32,
/* 20793*/    OPC_MoveSibling, 17,
/* 20795*/    OPC_CheckOpcode, TARGET_VAL(ISD::TargetConstant),
/* 20798*/    OPC_RecordNode, // #17 = $mF
/* 20799*/    OPC_CheckTypeI32,
/* 20800*/    OPC_MoveParent,
/* 20801*/    OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 20804*/    OPC_EmitConvertToTarget2,
/* 20805*/    OPC_EmitConvertToTarget3,
/* 20806*/    OPC_EmitConvertToTarget4,
/* 20807*/    OPC_EmitConvertToTarget5,
/* 20808*/    OPC_EmitConvertToTarget6,
/* 20809*/    OPC_EmitConvertToTarget7,
/* 20810*/    OPC_EmitConvertToTarget, 8,
/* 20812*/    OPC_EmitConvertToTarget, 9,
/* 20814*/    OPC_EmitConvertToTarget, 10,
/* 20816*/    OPC_EmitConvertToTarget, 11,
/* 20818*/    OPC_EmitConvertToTarget, 12,
/* 20820*/    OPC_EmitConvertToTarget, 13,
/* 20822*/    OPC_EmitConvertToTarget, 14,
/* 20824*/    OPC_EmitConvertToTarget, 15,
/* 20826*/    OPC_EmitConvertToTarget, 16,
/* 20828*/    OPC_EmitConvertToTarget, 17,
/* 20830*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHUFFLE),
                  /*MVT::v2f64*/1|128,1/*129*/, 18/*#Ops*/, 0, 1, 18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 
              // Src: (wasm_shuffle:{ *:[v2f64] } V128:{ *:[v2f64] }:$x, V128:{ *:[v2f64] }:$y, (timm:{ *:[i32] }):$m0, (timm:{ *:[i32] }):$m1, (timm:{ *:[i32] }):$m2, (timm:{ *:[i32] }):$m3, (timm:{ *:[i32] }):$m4, (timm:{ *:[i32] }):$m5, (timm:{ *:[i32] }):$m6, (timm:{ *:[i32] }):$m7, (timm:{ *:[i32] }):$m8, (timm:{ *:[i32] }):$m9, (timm:{ *:[i32] }):$mA, (timm:{ *:[i32] }):$mB, (timm:{ *:[i32] }):$mC, (timm:{ *:[i32] }):$mD, (timm:{ *:[i32] }):$mE, (timm:{ *:[i32] }):$mF) - Complexity = 51
              // Dst: (SHUFFLE:{ *:[v2f64] } ?:{ *:[v2f64] }:$x, ?:{ *:[v2f64] }:$y, (imm:{ *:[i32] }):$m0, (imm:{ *:[i32] }):$m1, (imm:{ *:[i32] }):$m2, (imm:{ *:[i32] }):$m3, (imm:{ *:[i32] }):$m4, (imm:{ *:[i32] }):$m5, (imm:{ *:[i32] }):$m6, (imm:{ *:[i32] }):$m7, (imm:{ *:[i32] }):$m8, (imm:{ *:[i32] }):$m9, (imm:{ *:[i32] }):$mA, (imm:{ *:[i32] }):$mB, (imm:{ *:[i32] }):$mC, (imm:{ *:[i32] }):$mD, (imm:{ *:[i32] }):$mE, (imm:{ *:[i32] }):$mF)
/* 20854*/   0, // EndSwitchOpcode
/* 20855*/  0, /*End of Scope*/
/* 20856*/ /*SwitchOpcode*/ 73|128,8/*1097*/, TARGET_VAL(ISD::INSERT_VECTOR_ELT),// ->21957
/* 20860*/  OPC_Scope, 6|128,1/*134*/, /*->20997*/ // 2 children in Scope
/* 20863*/   OPC_MoveChild0,
/* 20864*/   OPC_CheckOpcode, TARGET_VAL(ISD::SPLAT_VECTOR),
/* 20867*/   OPC_CheckChild0Integer, 0, 
/* 20869*/   OPC_Scope, 62, /*->20933*/ // 2 children in Scope
/* 20871*/    OPC_CheckChild0TypeI32,
/* 20872*/    OPC_MoveSibling1,
/* 20873*/    OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 20876*/    OPC_RecordMemRef,
/* 20877*/    OPC_RecordNode, // #0 = 'ld' chained node
/* 20878*/    OPC_CheckFoldableChainNode,
/* 20879*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 20880*/    OPC_CheckTypeI32,
/* 20881*/    OPC_Scope, 24, /*->20907*/ // 2 children in Scope
/* 20883*/     OPC_CheckChild1TypeI32,
/* 20884*/     OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 20886*/     OPC_CheckPredicate6,  // Predicate_load
/* 20887*/     OPC_MoveParent,
/* 20888*/     OPC_CheckChild2Integer, 0, 
/* 20890*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 20892*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 20893*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 20895*/     OPC_EmitMergeInputChains1_0,
/* 20896*/     OPC_EmitInteger32, 0, 
/* 20898*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
               // Src: (vector_insert:{ *:[v4i32] } (splat_vector:{ *:[v4i32] } 0:{ *:[i32] }), (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 29
               // Dst: (LOAD_ZERO_32_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 20907*/    /*Scope*/ 24, /*->20932*/
/* 20908*/     OPC_CheckChild1TypeI64,
/* 20909*/     OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 20911*/     OPC_CheckPredicate6,  // Predicate_load
/* 20912*/     OPC_MoveParent,
/* 20913*/     OPC_CheckChild2Integer, 0, 
/* 20915*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 20917*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 20918*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 20920*/     OPC_EmitMergeInputChains1_0,
/* 20921*/     OPC_EmitInteger32, 0, 
/* 20923*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
               // Src: (vector_insert:{ *:[v4i32] } (splat_vector:{ *:[v4i32] } 0:{ *:[i32] }), (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 29
               // Dst: (LOAD_ZERO_32_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 20932*/    0, /*End of Scope*/
/* 20933*/   /*Scope*/ 62, /*->20996*/
/* 20934*/    OPC_CheckChild0TypeI64,
/* 20935*/    OPC_MoveSibling1,
/* 20936*/    OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 20939*/    OPC_RecordMemRef,
/* 20940*/    OPC_RecordNode, // #0 = 'ld' chained node
/* 20941*/    OPC_CheckFoldableChainNode,
/* 20942*/    OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 20943*/    OPC_CheckTypeI64,
/* 20944*/    OPC_Scope, 24, /*->20970*/ // 2 children in Scope
/* 20946*/     OPC_CheckChild1TypeI32,
/* 20947*/     OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 20949*/     OPC_CheckPredicate6,  // Predicate_load
/* 20950*/     OPC_MoveParent,
/* 20951*/     OPC_CheckChild2Integer, 0, 
/* 20953*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 20955*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 20956*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 20958*/     OPC_EmitMergeInputChains1_0,
/* 20959*/     OPC_EmitInteger32, 0, 
/* 20961*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
               // Src: (vector_insert:{ *:[v2i64] } (splat_vector:{ *:[v2i64] } 0:{ *:[i64] }), (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 29
               // Dst: (LOAD_ZERO_64_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 20970*/    /*Scope*/ 24, /*->20995*/
/* 20971*/     OPC_CheckChild1TypeI64,
/* 20972*/     OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 20974*/     OPC_CheckPredicate6,  // Predicate_load
/* 20975*/     OPC_MoveParent,
/* 20976*/     OPC_CheckChild2Integer, 0, 
/* 20978*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 20980*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 20981*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 20983*/     OPC_EmitMergeInputChains1_0,
/* 20984*/     OPC_EmitInteger32, 0, 
/* 20986*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
               // Src: (vector_insert:{ *:[v2i64] } (splat_vector:{ *:[v2i64] } 0:{ *:[i64] }), (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>, 0:{ *:[iPTR] }) - Complexity = 29
               // Dst: (LOAD_ZERO_64_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 20995*/    0, /*End of Scope*/
/* 20996*/   0, /*End of Scope*/
/* 20997*/  /*Scope*/ 61|128,7/*957*/, /*->21956*/
/* 20999*/   OPC_RecordChild0, // #0 = $vec
/* 21000*/   OPC_Scope, 32|128,3/*416*/, /*->21419*/ // 4 children in Scope
/* 21003*/    OPC_MoveChild1,
/* 21004*/    OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 21007*/    OPC_RecordMemRef,
/* 21008*/    OPC_RecordNode, // #1 = 'ld' chained node
/* 21009*/    OPC_CheckFoldableChainNode,
/* 21010*/    OPC_RecordChild1, // #2 = $addr
/* 21011*/    OPC_Scope, 73|128,1/*201*/, /*->21215*/ // 2 children in Scope
/* 21014*/     OPC_CheckChild1TypeI32,
/* 21015*/     OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 21017*/     OPC_Scope, 67, /*->21086*/ // 2 children in Scope
/* 21019*/      OPC_CheckPredicate, 10, // Predicate_extload
/* 21021*/      OPC_CheckTypeI32,
/* 21022*/      OPC_Scope, 30, /*->21054*/ // 2 children in Scope
/* 21024*/       OPC_CheckPredicate1,  // Predicate_extloadi8
/* 21025*/       OPC_MoveSibling2,
/* 21026*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21029*/       OPC_RecordNode, // #3 = $idx
/* 21030*/       OPC_CheckPredicate, 18, // Predicate_LaneIdx16
/* 21032*/       OPC_CheckTypeI32,
/* 21033*/       OPC_MoveParent,
/* 21034*/       OPC_CheckType, /*MVT::v16i8*/39, 
/* 21036*/       OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 21037*/       OPC_EmitMergeInputChains1_1,
/* 21038*/       OPC_EmitInteger32, 0, 
/* 21040*/       OPC_EmitInteger32, 0, 
/* 21042*/       OPC_EmitConvertToTarget3,
/* 21043*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_8_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     /*MVT::v16i8*/39, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, (ld:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_8_A32:{ *:[v16i8] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v16i8] }:$vec)
/* 21054*/      /*Scope*/ 30, /*->21085*/
/* 21055*/       OPC_CheckPredicate2,  // Predicate_extloadi16
/* 21056*/       OPC_MoveSibling2,
/* 21057*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21060*/       OPC_RecordNode, // #3 = $idx
/* 21061*/       OPC_CheckPredicate, 13, // Predicate_LaneIdx8
/* 21063*/       OPC_CheckTypeI32,
/* 21064*/       OPC_MoveParent,
/* 21065*/       OPC_CheckType, /*MVT::v8i16*/50, 
/* 21067*/       OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 21068*/       OPC_EmitMergeInputChains1_1,
/* 21069*/       OPC_EmitInteger32, 0, 
/* 21071*/       OPC_EmitInteger32, 0, 
/* 21073*/       OPC_EmitConvertToTarget3,
/* 21074*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_16_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     /*MVT::v8i16*/50, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, (ld:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_16_A32:{ *:[v8i16] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v8i16] }:$vec)
/* 21085*/      0, /*End of Scope*/
/* 21086*/     /*Scope*/ 127, /*->21214*/
/* 21087*/      OPC_CheckPredicate6,  // Predicate_load
/* 21088*/      OPC_SwitchType /*4 cases */, 29, /*MVT::i32*/7, // ->21120
/* 21091*/       OPC_MoveSibling2,
/* 21092*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21095*/       OPC_RecordNode, // #3 = $idx
/* 21096*/       OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/* 21098*/       OPC_CheckTypeI32,
/* 21099*/       OPC_MoveParent,
/* 21100*/       OPC_CheckType, /*MVT::v4i32*/60, 
/* 21102*/       OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 21103*/       OPC_EmitMergeInputChains1_1,
/* 21104*/       OPC_EmitInteger32, 0, 
/* 21106*/       OPC_EmitInteger32, 0, 
/* 21108*/       OPC_EmitConvertToTarget3,
/* 21109*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     /*MVT::v4i32*/60, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, (ld:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_32_A32:{ *:[v4i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v4i32] }:$vec)
/* 21120*/      /*SwitchType*/ 29, /*MVT::f32*/12, // ->21151
/* 21122*/       OPC_MoveSibling2,
/* 21123*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21126*/       OPC_RecordNode, // #3 = $idx
/* 21127*/       OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/* 21129*/       OPC_CheckTypeI32,
/* 21130*/       OPC_MoveParent,
/* 21131*/       OPC_CheckType, /*MVT::v4i32*/60, 
/* 21133*/       OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 21134*/       OPC_EmitMergeInputChains1_1,
/* 21135*/       OPC_EmitInteger32, 0, 
/* 21137*/       OPC_EmitInteger32, 0, 
/* 21139*/       OPC_EmitConvertToTarget3,
/* 21140*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     /*MVT::v4i32*/60, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, (ld:{ *:[f32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_32_A32:{ *:[v4i32] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v4i32] }:$vec)
/* 21151*/      /*SwitchType*/ 29, /*MVT::i64*/8, // ->21182
/* 21153*/       OPC_MoveSibling2,
/* 21154*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21157*/       OPC_RecordNode, // #3 = $idx
/* 21158*/       OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/* 21160*/       OPC_CheckTypeI32,
/* 21161*/       OPC_MoveParent,
/* 21162*/       OPC_CheckType, /*MVT::v2i64*/78, 
/* 21164*/       OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 21165*/       OPC_EmitMergeInputChains1_1,
/* 21166*/       OPC_EmitInteger32, 0, 
/* 21168*/       OPC_EmitInteger32, 0, 
/* 21170*/       OPC_EmitConvertToTarget3,
/* 21171*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     /*MVT::v2i64*/78, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, (ld:{ *:[i64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_64_A32:{ *:[v2i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v2i64] }:$vec)
/* 21182*/      /*SwitchType*/ 29, /*MVT::f64*/13, // ->21213
/* 21184*/       OPC_MoveSibling2,
/* 21185*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21188*/       OPC_RecordNode, // #3 = $idx
/* 21189*/       OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/* 21191*/       OPC_CheckTypeI32,
/* 21192*/       OPC_MoveParent,
/* 21193*/       OPC_CheckType, /*MVT::v2i64*/78, 
/* 21195*/       OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 21196*/       OPC_EmitMergeInputChains1_1,
/* 21197*/       OPC_EmitInteger32, 0, 
/* 21199*/       OPC_EmitInteger32, 0, 
/* 21201*/       OPC_EmitConvertToTarget3,
/* 21202*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                     /*MVT::v2i64*/78, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, (ld:{ *:[f64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_64_A32:{ *:[v2i64] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v2i64] }:$vec)
/* 21213*/      0, // EndSwitchType
/* 21214*/     0, /*End of Scope*/
/* 21215*/    /*Scope*/ 73|128,1/*201*/, /*->21418*/
/* 21217*/     OPC_CheckChild1TypeI64,
/* 21218*/     OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 21220*/     OPC_Scope, 67, /*->21289*/ // 2 children in Scope
/* 21222*/      OPC_CheckPredicate, 10, // Predicate_extload
/* 21224*/      OPC_CheckTypeI32,
/* 21225*/      OPC_Scope, 30, /*->21257*/ // 2 children in Scope
/* 21227*/       OPC_CheckPredicate1,  // Predicate_extloadi8
/* 21228*/       OPC_MoveSibling2,
/* 21229*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21232*/       OPC_RecordNode, // #3 = $idx
/* 21233*/       OPC_CheckPredicate, 18, // Predicate_LaneIdx16
/* 21235*/       OPC_CheckTypeI32,
/* 21236*/       OPC_MoveParent,
/* 21237*/       OPC_CheckType, /*MVT::v16i8*/39, 
/* 21239*/       OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 21240*/       OPC_EmitMergeInputChains1_1,
/* 21241*/       OPC_EmitInteger32, 0, 
/* 21243*/       OPC_EmitInteger64, 0, 
/* 21245*/       OPC_EmitConvertToTarget3,
/* 21246*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_8_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     /*MVT::v16i8*/39, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, (ld:{ *:[i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_8_A64:{ *:[v16i8] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v16i8] }:$vec)
/* 21257*/      /*Scope*/ 30, /*->21288*/
/* 21258*/       OPC_CheckPredicate2,  // Predicate_extloadi16
/* 21259*/       OPC_MoveSibling2,
/* 21260*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21263*/       OPC_RecordNode, // #3 = $idx
/* 21264*/       OPC_CheckPredicate, 13, // Predicate_LaneIdx8
/* 21266*/       OPC_CheckTypeI32,
/* 21267*/       OPC_MoveParent,
/* 21268*/       OPC_CheckType, /*MVT::v8i16*/50, 
/* 21270*/       OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 21271*/       OPC_EmitMergeInputChains1_1,
/* 21272*/       OPC_EmitInteger32, 0, 
/* 21274*/       OPC_EmitInteger64, 0, 
/* 21276*/       OPC_EmitConvertToTarget3,
/* 21277*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_16_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     /*MVT::v8i16*/50, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, (ld:{ *:[i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_16_A64:{ *:[v8i16] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v8i16] }:$vec)
/* 21288*/      0, /*End of Scope*/
/* 21289*/     /*Scope*/ 127, /*->21417*/
/* 21290*/      OPC_CheckPredicate6,  // Predicate_load
/* 21291*/      OPC_SwitchType /*4 cases */, 29, /*MVT::i32*/7, // ->21323
/* 21294*/       OPC_MoveSibling2,
/* 21295*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21298*/       OPC_RecordNode, // #3 = $idx
/* 21299*/       OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/* 21301*/       OPC_CheckTypeI32,
/* 21302*/       OPC_MoveParent,
/* 21303*/       OPC_CheckType, /*MVT::v4i32*/60, 
/* 21305*/       OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 21306*/       OPC_EmitMergeInputChains1_1,
/* 21307*/       OPC_EmitInteger32, 0, 
/* 21309*/       OPC_EmitInteger64, 0, 
/* 21311*/       OPC_EmitConvertToTarget3,
/* 21312*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     /*MVT::v4i32*/60, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, (ld:{ *:[i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_32_A64:{ *:[v4i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v4i32] }:$vec)
/* 21323*/      /*SwitchType*/ 29, /*MVT::f32*/12, // ->21354
/* 21325*/       OPC_MoveSibling2,
/* 21326*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21329*/       OPC_RecordNode, // #3 = $idx
/* 21330*/       OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/* 21332*/       OPC_CheckTypeI32,
/* 21333*/       OPC_MoveParent,
/* 21334*/       OPC_CheckType, /*MVT::v4i32*/60, 
/* 21336*/       OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 21337*/       OPC_EmitMergeInputChains1_1,
/* 21338*/       OPC_EmitInteger32, 0, 
/* 21340*/       OPC_EmitInteger64, 0, 
/* 21342*/       OPC_EmitConvertToTarget3,
/* 21343*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     /*MVT::v4i32*/60, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, (ld:{ *:[f32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_32_A64:{ *:[v4i32] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v4i32] }:$vec)
/* 21354*/      /*SwitchType*/ 29, /*MVT::i64*/8, // ->21385
/* 21356*/       OPC_MoveSibling2,
/* 21357*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21360*/       OPC_RecordNode, // #3 = $idx
/* 21361*/       OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/* 21363*/       OPC_CheckTypeI32,
/* 21364*/       OPC_MoveParent,
/* 21365*/       OPC_CheckType, /*MVT::v2i64*/78, 
/* 21367*/       OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 21368*/       OPC_EmitMergeInputChains1_1,
/* 21369*/       OPC_EmitInteger32, 0, 
/* 21371*/       OPC_EmitInteger64, 0, 
/* 21373*/       OPC_EmitConvertToTarget3,
/* 21374*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     /*MVT::v2i64*/78, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, (ld:{ *:[i64] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_64_A64:{ *:[v2i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v2i64] }:$vec)
/* 21385*/      /*SwitchType*/ 29, /*MVT::f64*/13, // ->21416
/* 21387*/       OPC_MoveSibling2,
/* 21388*/       OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21391*/       OPC_RecordNode, // #3 = $idx
/* 21392*/       OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/* 21394*/       OPC_CheckTypeI32,
/* 21395*/       OPC_MoveParent,
/* 21396*/       OPC_CheckType, /*MVT::v2i64*/78, 
/* 21398*/       OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 21399*/       OPC_EmitMergeInputChains1_1,
/* 21400*/       OPC_EmitInteger32, 0, 
/* 21402*/       OPC_EmitInteger64, 0, 
/* 21404*/       OPC_EmitConvertToTarget3,
/* 21405*/       OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                     /*MVT::v2i64*/78, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                 // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, (ld:{ *:[f64] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 11
                 // Dst: (LOAD_LANE_64_A64:{ *:[v2i64] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v2i64] }:$vec)
/* 21416*/      0, // EndSwitchType
/* 21417*/     0, /*End of Scope*/
/* 21418*/    0, /*End of Scope*/
/* 21419*/   /*Scope*/ 24|128,1/*152*/, /*->21573*/
/* 21421*/    OPC_RecordChild1, // #1 = $x
/* 21422*/    OPC_Scope, 104, /*->21528*/ // 2 children in Scope
/* 21424*/     OPC_CheckChild1TypeI32,
/* 21425*/     OPC_Scope, 56, /*->21483*/ // 2 children in Scope
/* 21427*/      OPC_RecordChild2, // #2 = $idx
/* 21428*/      OPC_MoveChild2,
/* 21429*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21432*/      OPC_CheckTypeI32,
/* 21433*/      OPC_Scope, 15, /*->21450*/ // 3 children in Scope
/* 21435*/       OPC_CheckPredicate, 18, // Predicate_LaneIdx16
/* 21437*/       OPC_MoveParent,
/* 21438*/       OPC_CheckType, /*MVT::v16i8*/39, 
/* 21440*/       OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21441*/       OPC_EmitConvertToTarget2,
/* 21442*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I8x16),
                     /*MVT::v16i8*/39, 3/*#Ops*/, 0, 3, 1, 
                 // Src: (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx16>>:$idx) - Complexity = 7
                 // Dst: (REPLACE_LANE_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$x)
/* 21450*/      /*Scope*/ 15, /*->21466*/
/* 21451*/       OPC_CheckPredicate, 13, // Predicate_LaneIdx8
/* 21453*/       OPC_MoveParent,
/* 21454*/       OPC_CheckType, /*MVT::v8i16*/50, 
/* 21456*/       OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21457*/       OPC_EmitConvertToTarget2,
/* 21458*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I16x8),
                     /*MVT::v8i16*/50, 3/*#Ops*/, 0, 3, 1, 
                 // Src: (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx8>>:$idx) - Complexity = 7
                 // Dst: (REPLACE_LANE_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$x)
/* 21466*/      /*Scope*/ 15, /*->21482*/
/* 21467*/       OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/* 21469*/       OPC_MoveParent,
/* 21470*/       OPC_CheckType, /*MVT::v4i32*/60, 
/* 21472*/       OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21473*/       OPC_EmitConvertToTarget2,
/* 21474*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I32x4),
                     /*MVT::v4i32*/60, 3/*#Ops*/, 0, 3, 1, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 7
                 // Dst: (REPLACE_LANE_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, (imm:{ *:[i32] }):$idx, I32:{ *:[i32] }:$x)
/* 21482*/      0, /*End of Scope*/
/* 21483*/     /*Scope*/ 43, /*->21527*/
/* 21484*/      OPC_MoveChild2,
/* 21485*/      OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 21488*/      OPC_MoveParent,
/* 21489*/      OPC_SwitchType /*3 cases */, 10, /*MVT::v16i8*/39, // ->21502
/* 21492*/       OPC_EmitInteger32, 0, 
/* 21494*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I8x16),
                     /*MVT::v16i8*/39, 3/*#Ops*/, 0, 2, 1, 
                 // Src: (vector_insert:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                 // Dst: (REPLACE_LANE_I8x16:{ *:[v16i8] } ?:{ *:[v16i8] }:$vec, 0:{ *:[i32] }, ?:{ *:[i32] }:$x)
/* 21502*/      /*SwitchType*/ 10, /*MVT::v8i16*/50, // ->21514
/* 21504*/       OPC_EmitInteger32, 0, 
/* 21506*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I16x8),
                     /*MVT::v8i16*/50, 3/*#Ops*/, 0, 2, 1, 
                 // Src: (vector_insert:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                 // Dst: (REPLACE_LANE_I16x8:{ *:[v8i16] } ?:{ *:[v8i16] }:$vec, 0:{ *:[i32] }, ?:{ *:[i32] }:$x)
/* 21514*/      /*SwitchType*/ 10, /*MVT::v4i32*/60, // ->21526
/* 21516*/       OPC_EmitInteger32, 0, 
/* 21518*/       OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I32x4),
                     /*MVT::v4i32*/60, 3/*#Ops*/, 0, 2, 1, 
                 // Src: (vector_insert:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                 // Dst: (REPLACE_LANE_I32x4:{ *:[v4i32] } ?:{ *:[v4i32] }:$vec, 0:{ *:[i32] }, ?:{ *:[i32] }:$x)
/* 21526*/      0, // EndSwitchType
/* 21527*/     0, /*End of Scope*/
/* 21528*/    /*Scope*/ 43, /*->21572*/
/* 21529*/     OPC_CheckChild1TypeI64,
/* 21530*/     OPC_Scope, 21, /*->21553*/ // 2 children in Scope
/* 21532*/      OPC_RecordChild2, // #2 = $idx
/* 21533*/      OPC_MoveChild2,
/* 21534*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21537*/      OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/* 21539*/      OPC_CheckTypeI32,
/* 21540*/      OPC_MoveParent,
/* 21541*/      OPC_CheckType, /*MVT::v2i64*/78, 
/* 21543*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21544*/      OPC_EmitConvertToTarget2,
/* 21545*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I64x2),
                    /*MVT::v2i64*/78, 3/*#Ops*/, 0, 3, 1, 
                // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I64:{ *:[i64] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 7
                // Dst: (REPLACE_LANE_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, (imm:{ *:[i32] }):$idx, I64:{ *:[i64] }:$x)
/* 21553*/     /*Scope*/ 17, /*->21571*/
/* 21554*/      OPC_MoveChild2,
/* 21555*/      OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 21558*/      OPC_MoveParent,
/* 21559*/      OPC_CheckType, /*MVT::v2i64*/78, 
/* 21561*/      OPC_EmitInteger32, 0, 
/* 21563*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_I64x2),
                    /*MVT::v2i64*/78, 3/*#Ops*/, 0, 2, 1, 
                // Src: (vector_insert:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I64:{ *:[i64] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                // Dst: (REPLACE_LANE_I64x2:{ *:[v2i64] } ?:{ *:[v2i64] }:$vec, 0:{ *:[i32] }, ?:{ *:[i64] }:$x)
/* 21571*/     0, /*End of Scope*/
/* 21572*/    0, /*End of Scope*/
/* 21573*/   /*Scope*/ 26|128,2/*282*/, /*->21857*/
/* 21575*/    OPC_MoveChild1,
/* 21576*/    OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 21579*/    OPC_RecordMemRef,
/* 21580*/    OPC_RecordNode, // #1 = 'ld' chained node
/* 21581*/    OPC_CheckFoldableChainNode,
/* 21582*/    OPC_RecordChild1, // #2 = $addr
/* 21583*/    OPC_Scope, 6|128,1/*134*/, /*->21720*/ // 2 children in Scope
/* 21586*/     OPC_CheckChild1TypeI32,
/* 21587*/     OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 21589*/     OPC_CheckPredicate6,  // Predicate_load
/* 21590*/     OPC_SwitchType /*4 cases */, 29, /*MVT::i32*/7, // ->21622
/* 21593*/      OPC_MoveSibling2,
/* 21594*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21597*/      OPC_RecordNode, // #3 = $idx
/* 21598*/      OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/* 21600*/      OPC_CheckTypeI32,
/* 21601*/      OPC_MoveParent,
/* 21602*/      OPC_CheckType, /*MVT::v4f32*/111, 
/* 21604*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 21605*/      OPC_EmitMergeInputChains1_1,
/* 21606*/      OPC_EmitInteger32, 0, 
/* 21608*/      OPC_EmitInteger32, 0, 
/* 21610*/      OPC_EmitConvertToTarget3,
/* 21611*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v4f32*/111, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                // Src: (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, (ld:{ *:[i32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 11
                // Dst: (LOAD_LANE_32_A32:{ *:[v4f32] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v4f32] }:$vec)
/* 21622*/     /*SwitchType*/ 29, /*MVT::f32*/12, // ->21653
/* 21624*/      OPC_MoveSibling2,
/* 21625*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21628*/      OPC_RecordNode, // #3 = $idx
/* 21629*/      OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/* 21631*/      OPC_CheckTypeI32,
/* 21632*/      OPC_MoveParent,
/* 21633*/      OPC_CheckType, /*MVT::v4f32*/111, 
/* 21635*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 21636*/      OPC_EmitMergeInputChains1_1,
/* 21637*/      OPC_EmitInteger32, 0, 
/* 21639*/      OPC_EmitInteger32, 0, 
/* 21641*/      OPC_EmitConvertToTarget3,
/* 21642*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v4f32*/111, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                // Src: (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, (ld:{ *:[f32] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 11
                // Dst: (LOAD_LANE_32_A32:{ *:[v4f32] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v4f32] }:$vec)
/* 21653*/     /*SwitchType*/ 31, /*MVT::i64*/8, // ->21686
/* 21655*/      OPC_MoveSibling2,
/* 21656*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21659*/      OPC_RecordNode, // #3 = $idx
/* 21660*/      OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/* 21662*/      OPC_CheckTypeI32,
/* 21663*/      OPC_MoveParent,
/* 21664*/      OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 21667*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 21668*/      OPC_EmitMergeInputChains1_1,
/* 21669*/      OPC_EmitInteger32, 0, 
/* 21671*/      OPC_EmitInteger32, 0, 
/* 21673*/      OPC_EmitConvertToTarget3,
/* 21674*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v2f64*/1|128,1/*129*/, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                // Src: (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, (ld:{ *:[i64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 11
                // Dst: (LOAD_LANE_64_A32:{ *:[v2f64] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v2f64] }:$vec)
/* 21686*/     /*SwitchType*/ 31, /*MVT::f64*/13, // ->21719
/* 21688*/      OPC_MoveSibling2,
/* 21689*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21692*/      OPC_RecordNode, // #3 = $idx
/* 21693*/      OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/* 21695*/      OPC_CheckTypeI32,
/* 21696*/      OPC_MoveParent,
/* 21697*/      OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 21700*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 21701*/      OPC_EmitMergeInputChains1_1,
/* 21702*/      OPC_EmitInteger32, 0, 
/* 21704*/      OPC_EmitInteger32, 0, 
/* 21706*/      OPC_EmitConvertToTarget3,
/* 21707*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v2f64*/1|128,1/*129*/, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                // Src: (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, (ld:{ *:[f64] } I32:{ *:[i32] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 11
                // Dst: (LOAD_LANE_64_A32:{ *:[v2f64] } 0:{ *:[i32] }, 0:{ *:[i32] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i32] }:$addr, ?:{ *:[v2f64] }:$vec)
/* 21719*/     0, // EndSwitchType
/* 21720*/    /*Scope*/ 6|128,1/*134*/, /*->21856*/
/* 21722*/     OPC_CheckChild1TypeI64,
/* 21723*/     OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 21725*/     OPC_CheckPredicate6,  // Predicate_load
/* 21726*/     OPC_SwitchType /*4 cases */, 29, /*MVT::i32*/7, // ->21758
/* 21729*/      OPC_MoveSibling2,
/* 21730*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21733*/      OPC_RecordNode, // #3 = $idx
/* 21734*/      OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/* 21736*/      OPC_CheckTypeI32,
/* 21737*/      OPC_MoveParent,
/* 21738*/      OPC_CheckType, /*MVT::v4f32*/111, 
/* 21740*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 21741*/      OPC_EmitMergeInputChains1_1,
/* 21742*/      OPC_EmitInteger32, 0, 
/* 21744*/      OPC_EmitInteger64, 0, 
/* 21746*/      OPC_EmitConvertToTarget3,
/* 21747*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v4f32*/111, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                // Src: (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, (ld:{ *:[i32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 11
                // Dst: (LOAD_LANE_32_A64:{ *:[v4f32] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v4f32] }:$vec)
/* 21758*/     /*SwitchType*/ 29, /*MVT::f32*/12, // ->21789
/* 21760*/      OPC_MoveSibling2,
/* 21761*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21764*/      OPC_RecordNode, // #3 = $idx
/* 21765*/      OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/* 21767*/      OPC_CheckTypeI32,
/* 21768*/      OPC_MoveParent,
/* 21769*/      OPC_CheckType, /*MVT::v4f32*/111, 
/* 21771*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 21772*/      OPC_EmitMergeInputChains1_1,
/* 21773*/      OPC_EmitInteger32, 0, 
/* 21775*/      OPC_EmitInteger64, 0, 
/* 21777*/      OPC_EmitConvertToTarget3,
/* 21778*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v4f32*/111, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                // Src: (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, (ld:{ *:[f32] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 11
                // Dst: (LOAD_LANE_32_A64:{ *:[v4f32] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v4f32] }:$vec)
/* 21789*/     /*SwitchType*/ 31, /*MVT::i64*/8, // ->21822
/* 21791*/      OPC_MoveSibling2,
/* 21792*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21795*/      OPC_RecordNode, // #3 = $idx
/* 21796*/      OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/* 21798*/      OPC_CheckTypeI32,
/* 21799*/      OPC_MoveParent,
/* 21800*/      OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 21803*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 21804*/      OPC_EmitMergeInputChains1_1,
/* 21805*/      OPC_EmitInteger32, 0, 
/* 21807*/      OPC_EmitInteger64, 0, 
/* 21809*/      OPC_EmitConvertToTarget3,
/* 21810*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v2f64*/1|128,1/*129*/, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                // Src: (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, (ld:{ *:[i64] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 11
                // Dst: (LOAD_LANE_64_A64:{ *:[v2f64] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v2f64] }:$vec)
/* 21822*/     /*SwitchType*/ 31, /*MVT::f64*/13, // ->21855
/* 21824*/      OPC_MoveSibling2,
/* 21825*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21828*/      OPC_RecordNode, // #3 = $idx
/* 21829*/      OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/* 21831*/      OPC_CheckTypeI32,
/* 21832*/      OPC_MoveParent,
/* 21833*/      OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 21836*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 21837*/      OPC_EmitMergeInputChains1_1,
/* 21838*/      OPC_EmitInteger32, 0, 
/* 21840*/      OPC_EmitInteger64, 0, 
/* 21842*/      OPC_EmitConvertToTarget3,
/* 21843*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_LANE_64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v2f64*/1|128,1/*129*/, 5/*#Ops*/, 4, 5, 6, 2, 0, 
                // Src: (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, (ld:{ *:[f64] } I64:{ *:[i64] }:$addr)<<P:Predicate_unindexedload>><<P:Predicate_load>>, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 11
                // Dst: (LOAD_LANE_64_A64:{ *:[v2f64] } 0:{ *:[i32] }, 0:{ *:[i64] }, (imm:{ *:[i32] }):$idx, ?:{ *:[i64] }:$addr, ?:{ *:[v2f64] }:$vec)
/* 21855*/     0, // EndSwitchType
/* 21856*/    0, /*End of Scope*/
/* 21857*/   /*Scope*/ 97, /*->21955*/
/* 21858*/    OPC_RecordChild1, // #1 = $x
/* 21859*/    OPC_Scope, 44, /*->21905*/ // 2 children in Scope
/* 21861*/     OPC_CheckChild1Type, /*MVT::f32*/12, 
/* 21863*/     OPC_Scope, 21, /*->21886*/ // 2 children in Scope
/* 21865*/      OPC_RecordChild2, // #2 = $idx
/* 21866*/      OPC_MoveChild2,
/* 21867*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21870*/      OPC_CheckPredicate, 11, // Predicate_LaneIdx4
/* 21872*/      OPC_CheckTypeI32,
/* 21873*/      OPC_MoveParent,
/* 21874*/      OPC_CheckType, /*MVT::v4f32*/111, 
/* 21876*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21877*/      OPC_EmitConvertToTarget2,
/* 21878*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_F32x4),
                    /*MVT::v4f32*/111, 3/*#Ops*/, 0, 3, 1, 
                // Src: (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, F32:{ *:[f32] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx4>>:$idx) - Complexity = 7
                // Dst: (REPLACE_LANE_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, (imm:{ *:[i32] }):$idx, F32:{ *:[f32] }:$x)
/* 21886*/     /*Scope*/ 17, /*->21904*/
/* 21887*/      OPC_MoveChild2,
/* 21888*/      OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 21891*/      OPC_MoveParent,
/* 21892*/      OPC_CheckType, /*MVT::v4f32*/111, 
/* 21894*/      OPC_EmitInteger32, 0, 
/* 21896*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_F32x4),
                    /*MVT::v4f32*/111, 3/*#Ops*/, 0, 2, 1, 
                // Src: (vector_insert:{ *:[v4f32] } V128:{ *:[v4f32] }:$vec, F32:{ *:[f32] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                // Dst: (REPLACE_LANE_F32x4:{ *:[v4f32] } ?:{ *:[v4f32] }:$vec, 0:{ *:[i32] }, ?:{ *:[f32] }:$x)
/* 21904*/     0, /*End of Scope*/
/* 21905*/    /*Scope*/ 48, /*->21954*/
/* 21906*/     OPC_CheckChild1Type, /*MVT::f64*/13, 
/* 21908*/     OPC_Scope, 23, /*->21933*/ // 2 children in Scope
/* 21910*/      OPC_RecordChild2, // #2 = $idx
/* 21911*/      OPC_MoveChild2,
/* 21912*/      OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 21915*/      OPC_CheckPredicate, 12, // Predicate_LaneIdx2
/* 21917*/      OPC_CheckTypeI32,
/* 21918*/      OPC_MoveParent,
/* 21919*/      OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 21922*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 21923*/      OPC_EmitConvertToTarget2,
/* 21924*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_F64x2),
                    /*MVT::v2f64*/1|128,1/*129*/, 3/*#Ops*/, 0, 3, 1, 
                // Src: (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, F64:{ *:[f64] }:$x, (imm:{ *:[i32] })<<P:Predicate_LaneIdx2>>:$idx) - Complexity = 7
                // Dst: (REPLACE_LANE_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, (imm:{ *:[i32] }):$idx, F64:{ *:[f64] }:$x)
/* 21933*/     /*Scope*/ 19, /*->21953*/
/* 21934*/      OPC_MoveChild2,
/* 21935*/      OPC_CheckOpcode, TARGET_VAL(ISD::UNDEF),
/* 21938*/      OPC_MoveParent,
/* 21939*/      OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 21942*/      OPC_EmitInteger32, 0, 
/* 21944*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::REPLACE_LANE_F64x2),
                    /*MVT::v2f64*/1|128,1/*129*/, 3/*#Ops*/, 0, 2, 1, 
                // Src: (vector_insert:{ *:[v2f64] } V128:{ *:[v2f64] }:$vec, F64:{ *:[f64] }:$x, (undef:{ *:[iPTR] })) - Complexity = 6
                // Dst: (REPLACE_LANE_F64x2:{ *:[v2f64] } ?:{ *:[v2f64] }:$vec, 0:{ *:[i32] }, ?:{ *:[f64] }:$x)
/* 21953*/     0, /*End of Scope*/
/* 21954*/    0, /*End of Scope*/
/* 21955*/   0, /*End of Scope*/
/* 21956*/  0, /*End of Scope*/
/* 21957*/ /*SwitchOpcode*/ 96|128,1/*224*/, TARGET_VAL(WebAssemblyISD::VEC_SHR_U),// ->22185
/* 21961*/  OPC_Scope, 87, /*->22050*/ // 2 children in Scope
/* 21963*/   OPC_MoveChild0,
/* 21964*/   OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/* 21967*/   OPC_MoveChild0,
/* 21968*/   OPC_SwitchOpcode /*2 cases */, 37, TARGET_VAL(ISD::ADD),// ->22009
/* 21972*/    OPC_RecordChild0, // #0 = $lhs
/* 21973*/    OPC_RecordChild1, // #1 = $rhs
/* 21974*/    OPC_CheckPredicate, 24, // Predicate_add_nuw
/* 21976*/    OPC_MoveSibling1,
/* 21977*/    OPC_CheckOpcode, TARGET_VAL(ISD::SPLAT_VECTOR),
/* 21980*/    OPC_CheckChild0Integer, 2, 
/* 21982*/    OPC_CheckChild0TypeI32,
/* 21983*/    OPC_MoveParent,
/* 21984*/    OPC_CheckPredicate, 24, // Predicate_add_nuw
/* 21986*/    OPC_MoveParent,
/* 21987*/    OPC_CheckChild1Integer, 2, 
/* 21989*/    OPC_SwitchType /*2 cases */, 7, /*MVT::v16i8*/39, // ->21999
/* 21992*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v16i8] } (add:{ *:[v16i8] } (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)<<P:Predicate_add_nuw>>, (splat_vector:{ *:[v16i8] } 1:{ *:[i32] }))<<P:Predicate_add_nuw>>, 1:{ *:[i32] }) - Complexity = 24
               // Dst: (AVGR_U_I8x16:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/* 21999*/    /*SwitchType*/ 7, /*MVT::v8i16*/50, // ->22008
/* 22001*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I16x8),
                   /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v8i16] } (add:{ *:[v8i16] } (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)<<P:Predicate_add_nuw>>, (splat_vector:{ *:[v8i16] } 1:{ *:[i32] }))<<P:Predicate_add_nuw>>, 1:{ *:[i32] }) - Complexity = 24
               // Dst: (AVGR_U_I16x8:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 22008*/    0, // EndSwitchType
/* 22009*/   /*SwitchOpcode*/ 37, TARGET_VAL(ISD::SPLAT_VECTOR),// ->22049
/* 22012*/    OPC_CheckChild0Integer, 2, 
/* 22014*/    OPC_CheckChild0TypeI32,
/* 22015*/    OPC_MoveSibling1,
/* 22016*/    OPC_CheckOpcode, TARGET_VAL(ISD::ADD),
/* 22019*/    OPC_RecordChild0, // #0 = $lhs
/* 22020*/    OPC_RecordChild1, // #1 = $rhs
/* 22021*/    OPC_CheckPredicate, 24, // Predicate_add_nuw
/* 22023*/    OPC_MoveParent,
/* 22024*/    OPC_CheckPredicate, 24, // Predicate_add_nuw
/* 22026*/    OPC_MoveParent,
/* 22027*/    OPC_CheckChild1Integer, 2, 
/* 22029*/    OPC_SwitchType /*2 cases */, 7, /*MVT::v16i8*/39, // ->22039
/* 22032*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v16i8] } (add:{ *:[v16i8] } (splat_vector:{ *:[v16i8] } 1:{ *:[i32] }), (add:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)<<P:Predicate_add_nuw>>)<<P:Predicate_add_nuw>>, 1:{ *:[i32] }) - Complexity = 24
               // Dst: (AVGR_U_I8x16:{ *:[v16i8] } ?:{ *:[v16i8] }:$lhs, ?:{ *:[v16i8] }:$rhs)
/* 22039*/    /*SwitchType*/ 7, /*MVT::v8i16*/50, // ->22048
/* 22041*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::AVGR_U_I16x8),
                   /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v8i16] } (add:{ *:[v8i16] } (splat_vector:{ *:[v8i16] } 1:{ *:[i32] }), (add:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)<<P:Predicate_add_nuw>>)<<P:Predicate_add_nuw>>, 1:{ *:[i32] }) - Complexity = 24
               // Dst: (AVGR_U_I16x8:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 22048*/    0, // EndSwitchType
/* 22049*/   0, // EndSwitchOpcode
/* 22050*/  /*Scope*/ 4|128,1/*132*/, /*->22184*/
/* 22052*/   OPC_RecordChild0, // #0 = $lhs
/* 22053*/   OPC_Scope, 84, /*->22139*/ // 2 children in Scope
/* 22055*/    OPC_MoveChild1,
/* 22056*/    OPC_Scope, 24, /*->22082*/ // 5 children in Scope
/* 22058*/     OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 22061*/     OPC_MoveChild0,
/* 22062*/     OPC_CheckAndImm, 63, 
/* 22064*/     OPC_RecordChild0, // #1 = $rhs
/* 22065*/     OPC_MoveParent,
/* 22066*/     OPC_MoveParent,
/* 22067*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 22069*/     OPC_EmitNode1None, TARGET_VAL(WebAssembly::I32_WRAP_I64),
                   /*MVT::i32*/7, 1/*#Ops*/, 1,  // Results = #2
/* 22075*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I64x2),
                   /*MVT::v2i64*/78, 2/*#Ops*/, 0, 2, 
               // Src: (wasm_shr_u:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (trunc:{ *:[i32] } (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] }))) - Complexity = 14
               // Dst: (SHR_U_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (I32_WRAP_I64:{ *:[i32] } I64:{ *:[i64] }:$rhs))
/* 22082*/    /*Scope*/ 13, /*->22096*/
/* 22083*/     OPC_CheckAndImm, 7, 
/* 22085*/     OPC_RecordChild0, // #1 = $rhs
/* 22086*/     OPC_MoveParent,
/* 22087*/     OPC_CheckType, /*MVT::v16i8*/39, 
/* 22089*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 7:{ *:[i32] })) - Complexity = 11
               // Dst: (SHR_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 22096*/    /*Scope*/ 13, /*->22110*/
/* 22097*/     OPC_CheckAndImm, 15, 
/* 22099*/     OPC_RecordChild0, // #1 = $rhs
/* 22100*/     OPC_MoveParent,
/* 22101*/     OPC_CheckType, /*MVT::v8i16*/50, 
/* 22103*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I16x8),
                   /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 15:{ *:[i32] })) - Complexity = 11
               // Dst: (SHR_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 22110*/    /*Scope*/ 13, /*->22124*/
/* 22111*/     OPC_CheckAndImm, 31, 
/* 22113*/     OPC_RecordChild0, // #1 = $rhs
/* 22114*/     OPC_MoveParent,
/* 22115*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 22117*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I32x4),
                   /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
               // Dst: (SHR_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 22124*/    /*Scope*/ 13, /*->22138*/
/* 22125*/     OPC_CheckAndImm, 63, 
/* 22127*/     OPC_RecordChild0, // #1 = $rhs
/* 22128*/     OPC_MoveParent,
/* 22129*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 22131*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I64x2),
                   /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 63:{ *:[i32] })) - Complexity = 11
               // Dst: (SHR_U_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 22138*/    0, /*End of Scope*/
/* 22139*/   /*Scope*/ 43, /*->22183*/
/* 22140*/    OPC_RecordChild1, // #1 = $x
/* 22141*/    OPC_SwitchType /*4 cases */, 8, /*MVT::v16i8*/39, // ->22152
/* 22144*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22145*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I8x16),
                   /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SHR_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x)
/* 22152*/    /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->22162
/* 22154*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22155*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I16x8),
                   /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SHR_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x)
/* 22162*/    /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->22172
/* 22164*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22165*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I32x4),
                   /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SHR_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x)
/* 22172*/    /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->22182
/* 22174*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22175*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_U_I64x2),
                   /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
               // Src: (wasm_shr_u:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SHR_U_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x)
/* 22182*/    0, // EndSwitchType
/* 22183*/   0, /*End of Scope*/
/* 22184*/  0, /*End of Scope*/
/* 22185*/ /*SwitchOpcode*/ 22|128,4/*534*/, TARGET_VAL(ISD::SPLAT_VECTOR),// ->22723
/* 22189*/  OPC_Scope, 73|128,1/*201*/, /*->22393*/ // 4 children in Scope
/* 22192*/   OPC_MoveChild0,
/* 22193*/   OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 22196*/   OPC_RecordMemRef,
/* 22197*/   OPC_RecordNode, // #0 = 'ld' chained node
/* 22198*/   OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 22199*/   OPC_Scope, 95, /*->22296*/ // 2 children in Scope
/* 22201*/    OPC_CheckChild1TypeI32,
/* 22202*/    OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 22204*/    OPC_Scope, 45, /*->22251*/ // 2 children in Scope
/* 22206*/     OPC_CheckPredicate, 10, // Predicate_extload
/* 22208*/     OPC_CheckTypeI32,
/* 22209*/     OPC_Scope, 19, /*->22230*/ // 2 children in Scope
/* 22211*/      OPC_CheckPredicate1,  // Predicate_extloadi8
/* 22212*/      OPC_MoveParent,
/* 22213*/      OPC_CheckType, /*MVT::v16i8*/39, 
/* 22215*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 22216*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 22218*/      OPC_EmitMergeInputChains1_0,
/* 22219*/      OPC_EmitInteger32, 0, 
/* 22221*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v16i8*/39, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v16i8] } (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>) - Complexity = 16
                // Dst: (LOAD8_SPLAT_A32:{ *:[v16i8] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 22230*/     /*Scope*/ 19, /*->22250*/
/* 22231*/      OPC_CheckPredicate2,  // Predicate_extloadi16
/* 22232*/      OPC_MoveParent,
/* 22233*/      OPC_CheckType, /*MVT::v8i16*/50, 
/* 22235*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 22236*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 22238*/      OPC_EmitMergeInputChains1_0,
/* 22239*/      OPC_EmitInteger32, 0, 
/* 22241*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v8i16*/50, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v8i16] } (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>) - Complexity = 16
                // Dst: (LOAD16_SPLAT_A32:{ *:[v8i16] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 22250*/     0, /*End of Scope*/
/* 22251*/    /*Scope*/ 43, /*->22295*/
/* 22252*/     OPC_CheckPredicate6,  // Predicate_load
/* 22253*/     OPC_SwitchType /*2 cases */, 18, /*MVT::i32*/7, // ->22274
/* 22256*/      OPC_MoveParent,
/* 22257*/      OPC_CheckType, /*MVT::v4i32*/60, 
/* 22259*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 22260*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 22262*/      OPC_EmitMergeInputChains1_0,
/* 22263*/      OPC_EmitInteger32, 0, 
/* 22265*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v4i32] } (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
                // Dst: (LOAD32_SPLAT_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 22274*/     /*SwitchType*/ 18, /*MVT::i64*/8, // ->22294
/* 22276*/      OPC_MoveParent,
/* 22277*/      OPC_CheckType, /*MVT::v2i64*/78, 
/* 22279*/      OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 22280*/      OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 22282*/      OPC_EmitMergeInputChains1_0,
/* 22283*/      OPC_EmitInteger32, 0, 
/* 22285*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v2i64] } (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
                // Dst: (LOAD64_SPLAT_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 22294*/     0, // EndSwitchType
/* 22295*/    0, /*End of Scope*/
/* 22296*/   /*Scope*/ 95, /*->22392*/
/* 22297*/    OPC_CheckChild1TypeI64,
/* 22298*/    OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 22300*/    OPC_Scope, 45, /*->22347*/ // 2 children in Scope
/* 22302*/     OPC_CheckPredicate, 10, // Predicate_extload
/* 22304*/     OPC_CheckTypeI32,
/* 22305*/     OPC_Scope, 19, /*->22326*/ // 2 children in Scope
/* 22307*/      OPC_CheckPredicate1,  // Predicate_extloadi8
/* 22308*/      OPC_MoveParent,
/* 22309*/      OPC_CheckType, /*MVT::v16i8*/39, 
/* 22311*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 22312*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 22314*/      OPC_EmitMergeInputChains1_0,
/* 22315*/      OPC_EmitInteger32, 0, 
/* 22317*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD8_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v16i8*/39, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v16i8] } (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi8>>) - Complexity = 16
                // Dst: (LOAD8_SPLAT_A64:{ *:[v16i8] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 22326*/     /*Scope*/ 19, /*->22346*/
/* 22327*/      OPC_CheckPredicate2,  // Predicate_extloadi16
/* 22328*/      OPC_MoveParent,
/* 22329*/      OPC_CheckType, /*MVT::v8i16*/50, 
/* 22331*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 22332*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 22334*/      OPC_EmitMergeInputChains1_0,
/* 22335*/      OPC_EmitInteger32, 0, 
/* 22337*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD16_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v8i16*/50, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v8i16] } (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_extload>><<P:Predicate_extloadi16>>) - Complexity = 16
                // Dst: (LOAD16_SPLAT_A64:{ *:[v8i16] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 22346*/     0, /*End of Scope*/
/* 22347*/    /*Scope*/ 43, /*->22391*/
/* 22348*/     OPC_CheckPredicate6,  // Predicate_load
/* 22349*/     OPC_SwitchType /*2 cases */, 18, /*MVT::i32*/7, // ->22370
/* 22352*/      OPC_MoveParent,
/* 22353*/      OPC_CheckType, /*MVT::v4i32*/60, 
/* 22355*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 22356*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 22358*/      OPC_EmitMergeInputChains1_0,
/* 22359*/      OPC_EmitInteger32, 0, 
/* 22361*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v4i32] } (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
                // Dst: (LOAD32_SPLAT_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 22370*/     /*SwitchType*/ 18, /*MVT::i64*/8, // ->22390
/* 22372*/      OPC_MoveParent,
/* 22373*/      OPC_CheckType, /*MVT::v2i64*/78, 
/* 22375*/      OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 22376*/      OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 22378*/      OPC_EmitMergeInputChains1_0,
/* 22379*/      OPC_EmitInteger32, 0, 
/* 22381*/      OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                    /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
                // Src: (splat_vector:{ *:[v2i64] } (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
                // Dst: (LOAD64_SPLAT_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 22390*/     0, // EndSwitchType
/* 22391*/    0, /*End of Scope*/
/* 22392*/   0, /*End of Scope*/
/* 22393*/  /*Scope*/ 20|128,1/*148*/, /*->22543*/
/* 22395*/   OPC_RecordChild0, // #0 = $x
/* 22396*/   OPC_Scope, 102, /*->22500*/ // 3 children in Scope
/* 22398*/    OPC_MoveChild0,
/* 22399*/    OPC_CheckOpcode, TARGET_VAL(ISD::Constant),
/* 22402*/    OPC_SwitchType /*2 cases */, 80, /*MVT::i32*/7, // ->22485
/* 22405*/     OPC_MoveParent,
/* 22406*/     OPC_SwitchType /*3 cases */, 37, /*MVT::v16i8*/39, // ->22446
/* 22409*/      OPC_EmitConvertToTarget0,
/* 22410*/      OPC_EmitConvertToTarget0,
/* 22411*/      OPC_EmitConvertToTarget0,
/* 22412*/      OPC_EmitConvertToTarget0,
/* 22413*/      OPC_EmitConvertToTarget0,
/* 22414*/      OPC_EmitConvertToTarget0,
/* 22415*/      OPC_EmitConvertToTarget0,
/* 22416*/      OPC_EmitConvertToTarget0,
/* 22417*/      OPC_EmitConvertToTarget0,
/* 22418*/      OPC_EmitConvertToTarget0,
/* 22419*/      OPC_EmitConvertToTarget0,
/* 22420*/      OPC_EmitConvertToTarget0,
/* 22421*/      OPC_EmitConvertToTarget0,
/* 22422*/      OPC_EmitConvertToTarget0,
/* 22423*/      OPC_EmitConvertToTarget0,
/* 22424*/      OPC_EmitConvertToTarget0,
/* 22425*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I8x16),
                    /*MVT::v16i8*/39, 16/*#Ops*/, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 
                // Src: (splat_vector:{ *:[v16i8] } (imm:{ *:[i32] }):$x) - Complexity = 6
                // Dst: (CONST_V128_I8x16:{ *:[v16i8] } (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x)
/* 22446*/     /*SwitchType*/ 21, /*MVT::v8i16*/50, // ->22469
/* 22448*/      OPC_EmitConvertToTarget0,
/* 22449*/      OPC_EmitConvertToTarget0,
/* 22450*/      OPC_EmitConvertToTarget0,
/* 22451*/      OPC_EmitConvertToTarget0,
/* 22452*/      OPC_EmitConvertToTarget0,
/* 22453*/      OPC_EmitConvertToTarget0,
/* 22454*/      OPC_EmitConvertToTarget0,
/* 22455*/      OPC_EmitConvertToTarget0,
/* 22456*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I16x8),
                    /*MVT::v8i16*/50, 8/*#Ops*/, 1, 2, 3, 4, 5, 6, 7, 8, 
                // Src: (splat_vector:{ *:[v8i16] } (imm:{ *:[i32] }):$x) - Complexity = 6
                // Dst: (CONST_V128_I16x8:{ *:[v8i16] } (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x)
/* 22469*/     /*SwitchType*/ 13, /*MVT::v4i32*/60, // ->22484
/* 22471*/      OPC_EmitConvertToTarget0,
/* 22472*/      OPC_EmitConvertToTarget0,
/* 22473*/      OPC_EmitConvertToTarget0,
/* 22474*/      OPC_EmitConvertToTarget0,
/* 22475*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I32x4),
                    /*MVT::v4i32*/60, 4/*#Ops*/, 1, 2, 3, 4, 
                // Src: (splat_vector:{ *:[v4i32] } (imm:{ *:[i32] }):$x) - Complexity = 6
                // Dst: (CONST_V128_I32x4:{ *:[v4i32] } (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x, (imm:{ *:[i32] }):$x)
/* 22484*/     0, // EndSwitchType
/* 22485*/    /*SwitchType*/ 12, /*MVT::i64*/8, // ->22499
/* 22487*/     OPC_MoveParent,
/* 22488*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 22490*/     OPC_EmitConvertToTarget0,
/* 22491*/     OPC_EmitConvertToTarget0,
/* 22492*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_I64x2),
                   /*MVT::v2i64*/78, 2/*#Ops*/, 1, 2, 
               // Src: (splat_vector:{ *:[v2i64] } (imm:{ *:[i64] }):$x) - Complexity = 6
               // Dst: (CONST_V128_I64x2:{ *:[v2i64] } (imm:{ *:[i64] }):$x, (imm:{ *:[i64] }):$x)
/* 22499*/    0, // EndSwitchType
/* 22500*/   /*Scope*/ 30, /*->22531*/
/* 22501*/    OPC_CheckChild0TypeI32,
/* 22502*/    OPC_SwitchType /*3 cases */, 7, /*MVT::v16i8*/39, // ->22512
/* 22505*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22506*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I8x16),
                   /*MVT::v16i8*/39, 1/*#Ops*/, 0, 
               // Src: (splat_vector:{ *:[v16i8] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I8x16:{ *:[v16i8] } I32:{ *:[i32] }:$x)
/* 22512*/    /*SwitchType*/ 7, /*MVT::v8i16*/50, // ->22521
/* 22514*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22515*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I16x8),
                   /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
               // Src: (splat_vector:{ *:[v8i16] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I16x8:{ *:[v8i16] } I32:{ *:[i32] }:$x)
/* 22521*/    /*SwitchType*/ 7, /*MVT::v4i32*/60, // ->22530
/* 22523*/     OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22524*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I32x4),
                   /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
               // Src: (splat_vector:{ *:[v4i32] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I32x4:{ *:[v4i32] } I32:{ *:[i32] }:$x)
/* 22530*/    0, // EndSwitchType
/* 22531*/   /*Scope*/ 10, /*->22542*/
/* 22532*/    OPC_CheckChild0TypeI64,
/* 22533*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 22535*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22536*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I64x2),
                  /*MVT::v2i64*/78, 1/*#Ops*/, 0, 
              // Src: (splat_vector:{ *:[v2i64] } I64:{ *:[i64] }:$x) - Complexity = 3
              // Dst: (SPLAT_I64x2:{ *:[v2i64] } I64:{ *:[i64] }:$x)
/* 22542*/   0, /*End of Scope*/
/* 22543*/  /*Scope*/ 107, /*->22651*/
/* 22544*/   OPC_MoveChild0,
/* 22545*/   OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 22548*/   OPC_RecordMemRef,
/* 22549*/   OPC_RecordNode, // #0 = 'ld' chained node
/* 22550*/   OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 22551*/   OPC_Scope, 48, /*->22601*/ // 2 children in Scope
/* 22553*/    OPC_CheckChild1TypeI32,
/* 22554*/    OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 22556*/    OPC_CheckPredicate6,  // Predicate_load
/* 22557*/    OPC_SwitchType /*2 cases */, 18, /*MVT::f32*/12, // ->22578
/* 22560*/     OPC_MoveParent,
/* 22561*/     OPC_CheckType, /*MVT::v4f32*/111, 
/* 22563*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 22564*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 22566*/     OPC_EmitMergeInputChains1_0,
/* 22567*/     OPC_EmitInteger32, 0, 
/* 22569*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v4f32*/111, 3/*#Ops*/, 4, 2, 3, 
               // Src: (splat_vector:{ *:[v4f32] } (ld:{ *:[f32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD32_SPLAT_A32:{ *:[v4f32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 22578*/    /*SwitchType*/ 20, /*MVT::f64*/13, // ->22600
/* 22580*/     OPC_MoveParent,
/* 22581*/     OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 22584*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 22585*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 22587*/     OPC_EmitMergeInputChains1_0,
/* 22588*/     OPC_EmitInteger32, 0, 
/* 22590*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v2f64*/1|128,1/*129*/, 3/*#Ops*/, 4, 2, 3, 
               // Src: (splat_vector:{ *:[v2f64] } (ld:{ *:[f64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD64_SPLAT_A32:{ *:[v2f64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 22600*/    0, // EndSwitchType
/* 22601*/   /*Scope*/ 48, /*->22650*/
/* 22602*/    OPC_CheckChild1TypeI64,
/* 22603*/    OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 22605*/    OPC_CheckPredicate6,  // Predicate_load
/* 22606*/    OPC_SwitchType /*2 cases */, 18, /*MVT::f32*/12, // ->22627
/* 22609*/     OPC_MoveParent,
/* 22610*/     OPC_CheckType, /*MVT::v4f32*/111, 
/* 22612*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 22613*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 22615*/     OPC_EmitMergeInputChains1_0,
/* 22616*/     OPC_EmitInteger32, 0, 
/* 22618*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD32_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v4f32*/111, 3/*#Ops*/, 4, 2, 3, 
               // Src: (splat_vector:{ *:[v4f32] } (ld:{ *:[f32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD32_SPLAT_A64:{ *:[v4f32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 22627*/    /*SwitchType*/ 20, /*MVT::f64*/13, // ->22649
/* 22629*/     OPC_MoveParent,
/* 22630*/     OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 22633*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 22634*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 22636*/     OPC_EmitMergeInputChains1_0,
/* 22637*/     OPC_EmitInteger32, 0, 
/* 22639*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD64_SPLAT_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v2f64*/1|128,1/*129*/, 3/*#Ops*/, 4, 2, 3, 
               // Src: (splat_vector:{ *:[v2f64] } (ld:{ *:[f64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD64_SPLAT_A64:{ *:[v2f64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 22649*/    0, // EndSwitchType
/* 22650*/   0, /*End of Scope*/
/* 22651*/  /*Scope*/ 70, /*->22722*/
/* 22652*/   OPC_RecordChild0, // #0 = $x
/* 22653*/   OPC_Scope, 40, /*->22695*/ // 3 children in Scope
/* 22655*/    OPC_MoveChild0,
/* 22656*/    OPC_CheckOpcode, TARGET_VAL(ISD::ConstantFP),
/* 22659*/    OPC_SwitchType /*2 cases */, 16, /*MVT::f32*/12, // ->22678
/* 22662*/     OPC_MoveParent,
/* 22663*/     OPC_CheckType, /*MVT::v4f32*/111, 
/* 22665*/     OPC_EmitConvertToTarget0,
/* 22666*/     OPC_EmitConvertToTarget0,
/* 22667*/     OPC_EmitConvertToTarget0,
/* 22668*/     OPC_EmitConvertToTarget0,
/* 22669*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_F32x4),
                   /*MVT::v4f32*/111, 4/*#Ops*/, 1, 2, 3, 4, 
               // Src: (splat_vector:{ *:[v4f32] } (fpimm:{ *:[f32] }):$x) - Complexity = 6
               // Dst: (CONST_V128_F32x4:{ *:[v4f32] } (fpimm:{ *:[f32] }):$x, (fpimm:{ *:[f32] }):$x, (fpimm:{ *:[f32] }):$x, (fpimm:{ *:[f32] }):$x)
/* 22678*/    /*SwitchType*/ 14, /*MVT::f64*/13, // ->22694
/* 22680*/     OPC_MoveParent,
/* 22681*/     OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 22684*/     OPC_EmitConvertToTarget0,
/* 22685*/     OPC_EmitConvertToTarget0,
/* 22686*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::CONST_V128_F64x2),
                   /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 1, 2, 
               // Src: (splat_vector:{ *:[v2f64] } (fpimm:{ *:[f64] }):$x) - Complexity = 6
               // Dst: (CONST_V128_F64x2:{ *:[v2f64] } (fpimm:{ *:[f64] }):$x, (fpimm:{ *:[f64] }):$x)
/* 22694*/    0, // EndSwitchType
/* 22695*/   /*Scope*/ 11, /*->22707*/
/* 22696*/    OPC_CheckChild0Type, /*MVT::f32*/12, 
/* 22698*/    OPC_CheckType, /*MVT::v4f32*/111, 
/* 22700*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22701*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_F32x4),
                  /*MVT::v4f32*/111, 1/*#Ops*/, 0, 
              // Src: (splat_vector:{ *:[v4f32] } F32:{ *:[f32] }:$x) - Complexity = 3
              // Dst: (SPLAT_F32x4:{ *:[v4f32] } F32:{ *:[f32] }:$x)
/* 22707*/   /*Scope*/ 13, /*->22721*/
/* 22708*/    OPC_CheckChild0Type, /*MVT::f64*/13, 
/* 22710*/    OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 22713*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 22714*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_F64x2),
                  /*MVT::v2f64*/1|128,1/*129*/, 1/*#Ops*/, 0, 
              // Src: (splat_vector:{ *:[v2f64] } F64:{ *:[f64] }:$x) - Complexity = 3
              // Dst: (SPLAT_F64x2:{ *:[v2f64] } F64:{ *:[f64] }:$x)
/* 22721*/   0, /*End of Scope*/
/* 22722*/  0, /*End of Scope*/
/* 22723*/ /*SwitchOpcode*/ 26|128,2/*282*/, TARGET_VAL(ISD::SCALAR_TO_VECTOR),// ->23009
/* 22727*/  OPC_Scope, 103, /*->22832*/ // 4 children in Scope
/* 22729*/   OPC_MoveChild0,
/* 22730*/   OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 22733*/   OPC_RecordMemRef,
/* 22734*/   OPC_RecordNode, // #0 = 'ld' chained node
/* 22735*/   OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 22736*/   OPC_Scope, 46, /*->22784*/ // 2 children in Scope
/* 22738*/    OPC_CheckChild1TypeI32,
/* 22739*/    OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 22741*/    OPC_CheckPredicate6,  // Predicate_load
/* 22742*/    OPC_SwitchType /*2 cases */, 18, /*MVT::i32*/7, // ->22763
/* 22745*/     OPC_MoveParent,
/* 22746*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 22748*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 22749*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 22751*/     OPC_EmitMergeInputChains1_0,
/* 22752*/     OPC_EmitInteger32, 0, 
/* 22754*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v4i32] } (ld:{ *:[i32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_32_A32:{ *:[v4i32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 22763*/    /*SwitchType*/ 18, /*MVT::i64*/8, // ->22783
/* 22765*/     OPC_MoveParent,
/* 22766*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 22768*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 22769*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 22771*/     OPC_EmitMergeInputChains1_0,
/* 22772*/     OPC_EmitInteger32, 0, 
/* 22774*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v2i64] } (ld:{ *:[i64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_64_A32:{ *:[v2i64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 22783*/    0, // EndSwitchType
/* 22784*/   /*Scope*/ 46, /*->22831*/
/* 22785*/    OPC_CheckChild1TypeI64,
/* 22786*/    OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 22788*/    OPC_CheckPredicate6,  // Predicate_load
/* 22789*/    OPC_SwitchType /*2 cases */, 18, /*MVT::i32*/7, // ->22810
/* 22792*/     OPC_MoveParent,
/* 22793*/     OPC_CheckType, /*MVT::v4i32*/60, 
/* 22795*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 22796*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 22798*/     OPC_EmitMergeInputChains1_0,
/* 22799*/     OPC_EmitInteger32, 0, 
/* 22801*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v4i32*/60, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v4i32] } (ld:{ *:[i32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_32_A64:{ *:[v4i32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 22810*/    /*SwitchType*/ 18, /*MVT::i64*/8, // ->22830
/* 22812*/     OPC_MoveParent,
/* 22813*/     OPC_CheckType, /*MVT::v2i64*/78, 
/* 22815*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 22816*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 22818*/     OPC_EmitMergeInputChains1_0,
/* 22819*/     OPC_EmitInteger32, 0, 
/* 22821*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v2i64*/78, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v2i64] } (ld:{ *:[i64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_64_A64:{ *:[v2i64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 22830*/    0, // EndSwitchType
/* 22831*/   0, /*End of Scope*/
/* 22832*/  /*Scope*/ 41, /*->22874*/
/* 22833*/   OPC_RecordChild0, // #0 = $x
/* 22834*/   OPC_Scope, 27, /*->22863*/ // 2 children in Scope
/* 22836*/    OPC_CheckChild0TypeI32,
/* 22837*/    OPC_SwitchType /*3 cases */, 6, /*MVT::v16i8*/39, // ->22846
/* 22840*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I8x16),
                   /*MVT::v16i8*/39, 1/*#Ops*/, 0, 
               // Src: (scalar_to_vector:{ *:[v16i8] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I8x16:{ *:[v16i8] } ?:{ *:[i32] }:$x)
/* 22846*/    /*SwitchType*/ 6, /*MVT::v8i16*/50, // ->22854
/* 22848*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I16x8),
                   /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
               // Src: (scalar_to_vector:{ *:[v8i16] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I16x8:{ *:[v8i16] } ?:{ *:[i32] }:$x)
/* 22854*/    /*SwitchType*/ 6, /*MVT::v4i32*/60, // ->22862
/* 22856*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I32x4),
                   /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
               // Src: (scalar_to_vector:{ *:[v4i32] } I32:{ *:[i32] }:$x) - Complexity = 3
               // Dst: (SPLAT_I32x4:{ *:[v4i32] } ?:{ *:[i32] }:$x)
/* 22862*/    0, // EndSwitchType
/* 22863*/   /*Scope*/ 9, /*->22873*/
/* 22864*/    OPC_CheckChild0TypeI64,
/* 22865*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 22867*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_I64x2),
                  /*MVT::v2i64*/78, 1/*#Ops*/, 0, 
              // Src: (scalar_to_vector:{ *:[v2i64] } I64:{ *:[i64] }:$x) - Complexity = 3
              // Dst: (SPLAT_I64x2:{ *:[v2i64] } ?:{ *:[i64] }:$x)
/* 22873*/   0, /*End of Scope*/
/* 22874*/  /*Scope*/ 107, /*->22982*/
/* 22875*/   OPC_MoveChild0,
/* 22876*/   OPC_CheckOpcode, TARGET_VAL(ISD::LOAD),
/* 22879*/   OPC_RecordMemRef,
/* 22880*/   OPC_RecordNode, // #0 = 'ld' chained node
/* 22881*/   OPC_RecordChild1, // #1 = $AddrOps32:offset:addr
/* 22882*/   OPC_Scope, 48, /*->22932*/ // 2 children in Scope
/* 22884*/    OPC_CheckChild1TypeI32,
/* 22885*/    OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 22887*/    OPC_CheckPredicate6,  // Predicate_load
/* 22888*/    OPC_SwitchType /*2 cases */, 18, /*MVT::f32*/12, // ->22909
/* 22891*/     OPC_MoveParent,
/* 22892*/     OPC_CheckType, /*MVT::v4f32*/111, 
/* 22894*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 22895*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 22897*/     OPC_EmitMergeInputChains1_0,
/* 22898*/     OPC_EmitInteger32, 0, 
/* 22900*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_32_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v4f32*/111, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v4f32] } (ld:{ *:[f32] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_32_A32:{ *:[v4f32] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 22909*/    /*SwitchType*/ 20, /*MVT::f64*/13, // ->22931
/* 22911*/     OPC_MoveParent,
/* 22912*/     OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 22915*/     OPC_CheckPatternPredicate1, // (!Subtarget->hasAddr64())
/* 22916*/     OPC_CheckComplexPat0, /*#*/1, // SelectAddrOperands32:$ #2 #3
/* 22918*/     OPC_EmitMergeInputChains1_0,
/* 22919*/     OPC_EmitInteger32, 0, 
/* 22921*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_64_A32), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v2f64*/1|128,1/*129*/, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v2f64] } (ld:{ *:[f64] } (AddrOps32:{ *:[i32] } offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_64_A32:{ *:[v2f64] } 0:{ *:[i32] }, offset32_op:{ *:[i32] }:$offset, I32:{ *:[i32] }:$addr)
/* 22931*/    0, // EndSwitchType
/* 22932*/   /*Scope*/ 48, /*->22981*/
/* 22933*/    OPC_CheckChild1TypeI64,
/* 22934*/    OPC_CheckPredicate, 8, // Predicate_unindexedload
/* 22936*/    OPC_CheckPredicate6,  // Predicate_load
/* 22937*/    OPC_SwitchType /*2 cases */, 18, /*MVT::f32*/12, // ->22958
/* 22940*/     OPC_MoveParent,
/* 22941*/     OPC_CheckType, /*MVT::v4f32*/111, 
/* 22943*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 22944*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 22946*/     OPC_EmitMergeInputChains1_0,
/* 22947*/     OPC_EmitInteger32, 0, 
/* 22949*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_32_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v4f32*/111, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v4f32] } (ld:{ *:[f32] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_32_A64:{ *:[v4f32] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 22958*/    /*SwitchType*/ 20, /*MVT::f64*/13, // ->22980
/* 22960*/     OPC_MoveParent,
/* 22961*/     OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 22964*/     OPC_CheckPatternPredicate2, // (Subtarget->hasAddr64())
/* 22965*/     OPC_CheckComplexPat1, /*#*/1, // SelectAddrOperands64:$ #2 #3
/* 22967*/     OPC_EmitMergeInputChains1_0,
/* 22968*/     OPC_EmitInteger32, 0, 
/* 22970*/     OPC_MorphNodeTo1, TARGET_VAL(WebAssembly::LOAD_ZERO_64_A64), 0|OPFL_Chain|OPFL_MemRefs,
                   /*MVT::v2f64*/1|128,1/*129*/, 3/*#Ops*/, 4, 2, 3, 
               // Src: (scalar_to_vector:{ *:[v2f64] } (ld:{ *:[f64] } (AddrOps64:{ *:[i64] } offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr))<<P:Predicate_unindexedload>><<P:Predicate_load>>) - Complexity = 16
               // Dst: (LOAD_ZERO_64_A64:{ *:[v2f64] } 0:{ *:[i32] }, offset64_op:{ *:[i64] }:$offset, I64:{ *:[i64] }:$addr)
/* 22980*/    0, // EndSwitchType
/* 22981*/   0, /*End of Scope*/
/* 22982*/  /*Scope*/ 25, /*->23008*/
/* 22983*/   OPC_RecordChild0, // #0 = $x
/* 22984*/   OPC_SwitchType /*2 cases */, 8, /*MVT::v4f32*/111, // ->22995
/* 22987*/    OPC_CheckChild0Type, /*MVT::f32*/12, 
/* 22989*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_F32x4),
                  /*MVT::v4f32*/111, 1/*#Ops*/, 0, 
              // Src: (scalar_to_vector:{ *:[v4f32] } F32:{ *:[f32] }:$x) - Complexity = 3
              // Dst: (SPLAT_F32x4:{ *:[v4f32] } ?:{ *:[f32] }:$x)
/* 22995*/   /*SwitchType*/ 9, /*MVT::v2f64*/1|128,1/*129*/, // ->23007
/* 22998*/    OPC_CheckChild0Type, /*MVT::f64*/13, 
/* 23000*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SPLAT_F64x2),
                  /*MVT::v2f64*/1|128,1/*129*/, 1/*#Ops*/, 0, 
              // Src: (scalar_to_vector:{ *:[v2f64] } F64:{ *:[f64] }:$x) - Complexity = 3
              // Dst: (SPLAT_F64x2:{ *:[v2f64] } ?:{ *:[f64] }:$x)
/* 23007*/   0, // EndSwitchType
/* 23008*/  0, /*End of Scope*/
/* 23009*/ /*SwitchOpcode*/ 4|128,1/*132*/, TARGET_VAL(WebAssemblyISD::VEC_SHL),// ->23145
/* 23013*/  OPC_RecordChild0, // #0 = $lhs
/* 23014*/  OPC_Scope, 84, /*->23100*/ // 2 children in Scope
/* 23016*/   OPC_MoveChild1,
/* 23017*/   OPC_Scope, 24, /*->23043*/ // 5 children in Scope
/* 23019*/    OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 23022*/    OPC_MoveChild0,
/* 23023*/    OPC_CheckAndImm, 63, 
/* 23025*/    OPC_RecordChild0, // #1 = $rhs
/* 23026*/    OPC_MoveParent,
/* 23027*/    OPC_MoveParent,
/* 23028*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 23030*/    OPC_EmitNode1None, TARGET_VAL(WebAssembly::I32_WRAP_I64),
                  /*MVT::i32*/7, 1/*#Ops*/, 1,  // Results = #2
/* 23036*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I64x2),
                  /*MVT::v2i64*/78, 2/*#Ops*/, 0, 2, 
              // Src: (wasm_shl:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (trunc:{ *:[i32] } (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] }))) - Complexity = 14
              // Dst: (SHL_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (I32_WRAP_I64:{ *:[i32] } I64:{ *:[i64] }:$rhs))
/* 23043*/   /*Scope*/ 13, /*->23057*/
/* 23044*/    OPC_CheckAndImm, 7, 
/* 23046*/    OPC_RecordChild0, // #1 = $rhs
/* 23047*/    OPC_MoveParent,
/* 23048*/    OPC_CheckType, /*MVT::v16i8*/39, 
/* 23050*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I8x16),
                  /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 7:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 23057*/   /*Scope*/ 13, /*->23071*/
/* 23058*/    OPC_CheckAndImm, 15, 
/* 23060*/    OPC_RecordChild0, // #1 = $rhs
/* 23061*/    OPC_MoveParent,
/* 23062*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 23064*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I16x8),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 15:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 23071*/   /*Scope*/ 13, /*->23085*/
/* 23072*/    OPC_CheckAndImm, 31, 
/* 23074*/    OPC_RecordChild0, // #1 = $rhs
/* 23075*/    OPC_MoveParent,
/* 23076*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 23078*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I32x4),
                  /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 23085*/   /*Scope*/ 13, /*->23099*/
/* 23086*/    OPC_CheckAndImm, 63, 
/* 23088*/    OPC_RecordChild0, // #1 = $rhs
/* 23089*/    OPC_MoveParent,
/* 23090*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 23092*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I64x2),
                  /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 63:{ *:[i32] })) - Complexity = 11
              // Dst: (SHL_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 23099*/   0, /*End of Scope*/
/* 23100*/  /*Scope*/ 43, /*->23144*/
/* 23101*/   OPC_RecordChild1, // #1 = $x
/* 23102*/   OPC_SwitchType /*4 cases */, 8, /*MVT::v16i8*/39, // ->23113
/* 23105*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23106*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I8x16),
                  /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHL_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x)
/* 23113*/   /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->23123
/* 23115*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23116*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I16x8),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHL_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x)
/* 23123*/   /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->23133
/* 23125*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23126*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I32x4),
                  /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHL_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x)
/* 23133*/   /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->23143
/* 23135*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23136*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHL_I64x2),
                  /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shl:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHL_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x)
/* 23143*/   0, // EndSwitchType
/* 23144*/  0, /*End of Scope*/
/* 23145*/ /*SwitchOpcode*/ 4|128,1/*132*/, TARGET_VAL(WebAssemblyISD::VEC_SHR_S),// ->23281
/* 23149*/  OPC_RecordChild0, // #0 = $lhs
/* 23150*/  OPC_Scope, 84, /*->23236*/ // 2 children in Scope
/* 23152*/   OPC_MoveChild1,
/* 23153*/   OPC_Scope, 24, /*->23179*/ // 5 children in Scope
/* 23155*/    OPC_CheckOpcode, TARGET_VAL(ISD::TRUNCATE),
/* 23158*/    OPC_MoveChild0,
/* 23159*/    OPC_CheckAndImm, 63, 
/* 23161*/    OPC_RecordChild0, // #1 = $rhs
/* 23162*/    OPC_MoveParent,
/* 23163*/    OPC_MoveParent,
/* 23164*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 23166*/    OPC_EmitNode1None, TARGET_VAL(WebAssembly::I32_WRAP_I64),
                  /*MVT::i32*/7, 1/*#Ops*/, 1,  // Results = #2
/* 23172*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I64x2),
                  /*MVT::v2i64*/78, 2/*#Ops*/, 0, 2, 
              // Src: (wasm_shr_s:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (trunc:{ *:[i32] } (and:{ *:[i64] } I64:{ *:[i64] }:$rhs, 63:{ *:[i64] }))) - Complexity = 14
              // Dst: (SHR_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (I32_WRAP_I64:{ *:[i32] } I64:{ *:[i64] }:$rhs))
/* 23179*/   /*Scope*/ 13, /*->23193*/
/* 23180*/    OPC_CheckAndImm, 7, 
/* 23182*/    OPC_RecordChild0, // #1 = $rhs
/* 23183*/    OPC_MoveParent,
/* 23184*/    OPC_CheckType, /*MVT::v16i8*/39, 
/* 23186*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I8x16),
                  /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 7:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 23193*/   /*Scope*/ 13, /*->23207*/
/* 23194*/    OPC_CheckAndImm, 15, 
/* 23196*/    OPC_RecordChild0, // #1 = $rhs
/* 23197*/    OPC_MoveParent,
/* 23198*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 23200*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I16x8),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 15:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 23207*/   /*Scope*/ 13, /*->23221*/
/* 23208*/    OPC_CheckAndImm, 31, 
/* 23210*/    OPC_RecordChild0, // #1 = $rhs
/* 23211*/    OPC_MoveParent,
/* 23212*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 23214*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I32x4),
                  /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 31:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 23221*/   /*Scope*/ 13, /*->23235*/
/* 23222*/    OPC_CheckAndImm, 63, 
/* 23224*/    OPC_RecordChild0, // #1 = $rhs
/* 23225*/    OPC_MoveParent,
/* 23226*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 23228*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I64x2),
                  /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, (and:{ *:[i32] } I32:{ *:[i32] }:$rhs, 63:{ *:[i32] })) - Complexity = 11
              // Dst: (SHR_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$lhs, I32:{ *:[i32] }:$rhs)
/* 23235*/   0, /*End of Scope*/
/* 23236*/  /*Scope*/ 43, /*->23280*/
/* 23237*/   OPC_RecordChild1, // #1 = $x
/* 23238*/   OPC_SwitchType /*4 cases */, 8, /*MVT::v16i8*/39, // ->23249
/* 23241*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23242*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I8x16),
                  /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHR_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$vec, I32:{ *:[i32] }:$x)
/* 23249*/   /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->23259
/* 23251*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23252*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I16x8),
                  /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHR_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$vec, I32:{ *:[i32] }:$x)
/* 23259*/   /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->23269
/* 23261*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23262*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I32x4),
                  /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHR_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$vec, I32:{ *:[i32] }:$x)
/* 23269*/   /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->23279
/* 23271*/    OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23272*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SHR_S_I64x2),
                  /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
              // Src: (wasm_shr_s:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x) - Complexity = 3
              // Dst: (SHR_S_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$vec, I32:{ *:[i32] }:$x)
/* 23279*/   0, // EndSwitchType
/* 23280*/  0, /*End of Scope*/
/* 23281*/ /*SwitchOpcode*/ 66|128,8/*1090*/, TARGET_VAL(ISD::VSELECT),// ->24375
/* 23285*/  OPC_Scope, 13|128,1/*141*/, /*->23429*/ // 4 children in Scope
/* 23288*/   OPC_MoveChild0,
/* 23289*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/* 23292*/   OPC_MoveChild0,
/* 23293*/   OPC_CheckOpcode, TARGET_VAL(ISD::BITCAST),
/* 23296*/   OPC_RecordChild0, // #0 = $rhs
/* 23297*/   OPC_SwitchType /*3 cases */, 41, /*MVT::v4f32*/111, // ->23341
/* 23300*/    OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 23302*/    OPC_MoveSibling1,
/* 23303*/    OPC_CheckOpcode, TARGET_VAL(ISD::BITCAST),
/* 23306*/    OPC_RecordChild0, // #1 = $lhs
/* 23307*/    OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 23309*/    OPC_MoveParent,
/* 23310*/    OPC_CheckChild2CondCode, ISD::SETOLT,
/* 23312*/    OPC_MoveParent,
/* 23313*/    OPC_CheckType, /*MVT::v4i32*/60, 
/* 23315*/    OPC_Scope, 11, /*->23328*/ // 2 children in Scope
/* 23317*/     OPC_CheckChild1Same, 0,
/* 23319*/     OPC_CheckChild2Same, 1,
/* 23321*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                   /*MVT::v4i32*/60, 2/*#Ops*/, 1, 0, 
               // Src: (vselect:{ *:[v4i32] } (setcc:{ *:[v4i32] } (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$rhs), (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$lhs), SETOLT:{ *:[Other] }), V128:{ *:[v4i32] }:$rhs, V128:{ *:[v4i32] }:$lhs) - Complexity = 12
               // Dst: (PMIN_F32x4:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/* 23328*/    /*Scope*/ 11, /*->23340*/
/* 23329*/     OPC_CheckChild1Same, 1,
/* 23331*/     OPC_CheckChild2Same, 0,
/* 23333*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                   /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
               // Src: (vselect:{ *:[v4i32] } (setcc:{ *:[v4i32] } (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$lhs), (bitconvert:{ *:[v4f32] } V128:{ *:[v4i32] }:$rhs), SETOLT:{ *:[Other] }), V128:{ *:[v4i32] }:$rhs, V128:{ *:[v4i32] }:$lhs) - Complexity = 12
               // Dst: (PMAX_F32x4:{ *:[v4i32] } ?:{ *:[v4i32] }:$lhs, ?:{ *:[v4i32] }:$rhs)
/* 23340*/    0, /*End of Scope*/
/* 23341*/   /*SwitchType*/ 41, /*MVT::v2f64*/1|128,1/*129*/, // ->23385
/* 23344*/    OPC_CheckChild0Type, /*MVT::v2i64*/78, 
/* 23346*/    OPC_MoveSibling1,
/* 23347*/    OPC_CheckOpcode, TARGET_VAL(ISD::BITCAST),
/* 23350*/    OPC_RecordChild0, // #1 = $lhs
/* 23351*/    OPC_CheckChild0Type, /*MVT::v2i64*/78, 
/* 23353*/    OPC_MoveParent,
/* 23354*/    OPC_CheckChild2CondCode, ISD::SETOLT,
/* 23356*/    OPC_MoveParent,
/* 23357*/    OPC_CheckType, /*MVT::v2i64*/78, 
/* 23359*/    OPC_Scope, 11, /*->23372*/ // 2 children in Scope
/* 23361*/     OPC_CheckChild1Same, 0,
/* 23363*/     OPC_CheckChild2Same, 1,
/* 23365*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                   /*MVT::v2i64*/78, 2/*#Ops*/, 1, 0, 
               // Src: (vselect:{ *:[v2i64] } (setcc:{ *:[v2i64] } (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$rhs), (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$lhs), SETOLT:{ *:[Other] }), V128:{ *:[v2i64] }:$rhs, V128:{ *:[v2i64] }:$lhs) - Complexity = 12
               // Dst: (PMIN_F64x2:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/* 23372*/    /*Scope*/ 11, /*->23384*/
/* 23373*/     OPC_CheckChild1Same, 1,
/* 23375*/     OPC_CheckChild2Same, 0,
/* 23377*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                   /*MVT::v2i64*/78, 2/*#Ops*/, 0, 1, 
               // Src: (vselect:{ *:[v2i64] } (setcc:{ *:[v2i64] } (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$lhs), (bitconvert:{ *:[v2f64] } V128:{ *:[v2i64] }:$rhs), SETOLT:{ *:[Other] }), V128:{ *:[v2i64] }:$rhs, V128:{ *:[v2i64] }:$lhs) - Complexity = 12
               // Dst: (PMAX_F64x2:{ *:[v2i64] } ?:{ *:[v2i64] }:$lhs, ?:{ *:[v2i64] }:$rhs)
/* 23384*/    0, /*End of Scope*/
/* 23385*/   /*SwitchType*/ 41, /*MVT::v8f16*/92, // ->23428
/* 23387*/    OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 23389*/    OPC_MoveSibling1,
/* 23390*/    OPC_CheckOpcode, TARGET_VAL(ISD::BITCAST),
/* 23393*/    OPC_RecordChild0, // #1 = $lhs
/* 23394*/    OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 23396*/    OPC_MoveParent,
/* 23397*/    OPC_CheckChild2CondCode, ISD::SETOLT,
/* 23399*/    OPC_MoveParent,
/* 23400*/    OPC_CheckType, /*MVT::v8i16*/50, 
/* 23402*/    OPC_Scope, 11, /*->23415*/ // 2 children in Scope
/* 23404*/     OPC_CheckChild1Same, 0,
/* 23406*/     OPC_CheckChild2Same, 1,
/* 23408*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                   /*MVT::v8i16*/50, 2/*#Ops*/, 1, 0, 
               // Src: (vselect:{ *:[v8i16] } (setcc:{ *:[v8i16] } (bitconvert:{ *:[v8f16] } V128:{ *:[v8i16] }:$rhs), (bitconvert:{ *:[v8f16] } V128:{ *:[v8i16] }:$lhs), SETOLT:{ *:[Other] }), V128:{ *:[v8i16] }:$rhs, V128:{ *:[v8i16] }:$lhs) - Complexity = 12
               // Dst: (PMIN_F16x8:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 23415*/    /*Scope*/ 11, /*->23427*/
/* 23416*/     OPC_CheckChild1Same, 1,
/* 23418*/     OPC_CheckChild2Same, 0,
/* 23420*/     OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                   /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
               // Src: (vselect:{ *:[v8i16] } (setcc:{ *:[v8i16] } (bitconvert:{ *:[v8f16] } V128:{ *:[v8i16] }:$lhs), (bitconvert:{ *:[v8f16] } V128:{ *:[v8i16] }:$rhs), SETOLT:{ *:[Other] }), V128:{ *:[v8i16] }:$rhs, V128:{ *:[v8i16] }:$lhs) - Complexity = 12
               // Dst: (PMAX_F16x8:{ *:[v8i16] } ?:{ *:[v8i16] }:$lhs, ?:{ *:[v8i16] }:$rhs)
/* 23427*/    0, /*End of Scope*/
/* 23428*/   0, // EndSwitchType
/* 23429*/  /*Scope*/ 45, /*->23475*/
/* 23430*/   OPC_RecordChild0, // #0 = $c
/* 23431*/   OPC_RecordChild1, // #1 = $v1
/* 23432*/   OPC_RecordChild2, // #2 = $v2
/* 23433*/   OPC_SwitchType /*4 cases */, 8, /*MVT::v16i8*/39, // ->23444
/* 23436*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v16i8*/39, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v16i8] } V128:{ *:[v16i8] }:$c, V128:{ *:[v16i8] }:$v1, V128:{ *:[v16i8] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v16i8] } ?:{ *:[v16i8] }:$v1, ?:{ *:[v16i8] }:$v2, ?:{ *:[v16i8] }:$c)
/* 23444*/   /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->23454
/* 23446*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v8i16*/50, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v8i16] } V128:{ *:[v8i16] }:$c, V128:{ *:[v8i16] }:$v1, V128:{ *:[v8i16] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v8i16] } ?:{ *:[v8i16] }:$v1, ?:{ *:[v8i16] }:$v2, ?:{ *:[v8i16] }:$c)
/* 23454*/   /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->23464
/* 23456*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v4i32*/60, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v4i32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4i32] }:$v1, V128:{ *:[v4i32] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v4i32] } ?:{ *:[v4i32] }:$v1, ?:{ *:[v4i32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 23464*/   /*SwitchType*/ 8, /*MVT::v2i64*/78, // ->23474
/* 23466*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v2i64*/78, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v2i64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2i64] }:$v1, V128:{ *:[v2i64] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v2i64] } ?:{ *:[v2i64] }:$v1, ?:{ *:[v2i64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 23474*/   0, // EndSwitchType
/* 23475*/  /*Scope*/ 101|128,6/*869*/, /*->24346*/
/* 23477*/   OPC_MoveChild0,
/* 23478*/   OPC_CheckOpcode, TARGET_VAL(ISD::SETCC),
/* 23481*/   OPC_RecordChild0, // #0 = $rhs
/* 23482*/   OPC_Scope, 21|128,2/*277*/, /*->23762*/ // 3 children in Scope
/* 23485*/    OPC_CheckChild0Type, /*MVT::v4f32*/111, 
/* 23487*/    OPC_RecordChild1, // #1 = $lhs
/* 23488*/    OPC_Scope, 33, /*->23523*/ // 8 children in Scope
/* 23490*/     OPC_CheckChild2CondCode, ISD::SETOLT,
/* 23492*/     OPC_MoveParent,
/* 23493*/     OPC_CheckType, /*MVT::v4f32*/111, 
/* 23495*/     OPC_Scope, 12, /*->23509*/ // 2 children in Scope
/* 23497*/      OPC_CheckChild1Same, 0,
/* 23499*/      OPC_CheckChild2Same, 1,
/* 23501*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23502*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    /*MVT::v4f32*/111, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs, SETOLT:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23509*/     /*Scope*/ 12, /*->23522*/
/* 23510*/      OPC_CheckChild1Same, 1,
/* 23512*/      OPC_CheckChild2Same, 0,
/* 23514*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23515*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOLT:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23522*/     0, /*End of Scope*/
/* 23523*/    /*Scope*/ 33, /*->23557*/
/* 23524*/     OPC_CheckChild2CondCode, ISD::SETOLE,
/* 23526*/     OPC_MoveParent,
/* 23527*/     OPC_CheckType, /*MVT::v4f32*/111, 
/* 23529*/     OPC_Scope, 12, /*->23543*/ // 2 children in Scope
/* 23531*/      OPC_CheckChild1Same, 0,
/* 23533*/      OPC_CheckChild2Same, 1,
/* 23535*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23536*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    /*MVT::v4f32*/111, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs, SETOLE:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23543*/     /*Scope*/ 12, /*->23556*/
/* 23544*/      OPC_CheckChild1Same, 1,
/* 23546*/      OPC_CheckChild2Same, 0,
/* 23548*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23549*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOLE:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23556*/     0, /*End of Scope*/
/* 23557*/    /*Scope*/ 33, /*->23591*/
/* 23558*/     OPC_CheckChild2CondCode, ISD::SETOGT,
/* 23560*/     OPC_MoveParent,
/* 23561*/     OPC_CheckType, /*MVT::v4f32*/111, 
/* 23563*/     OPC_Scope, 12, /*->23577*/ // 2 children in Scope
/* 23565*/      OPC_CheckChild1Same, 1,
/* 23567*/      OPC_CheckChild2Same, 0,
/* 23569*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23570*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOGT:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23577*/     /*Scope*/ 12, /*->23590*/
/* 23578*/      OPC_CheckChild1Same, 0,
/* 23580*/      OPC_CheckChild2Same, 1,
/* 23582*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23583*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    /*MVT::v4f32*/111, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs, SETOGT:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23590*/     0, /*End of Scope*/
/* 23591*/    /*Scope*/ 33, /*->23625*/
/* 23592*/     OPC_CheckChild2CondCode, ISD::SETOGE,
/* 23594*/     OPC_MoveParent,
/* 23595*/     OPC_CheckType, /*MVT::v4f32*/111, 
/* 23597*/     OPC_Scope, 12, /*->23611*/ // 2 children in Scope
/* 23599*/      OPC_CheckChild1Same, 1,
/* 23601*/      OPC_CheckChild2Same, 0,
/* 23603*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23604*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETOGE:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23611*/     /*Scope*/ 12, /*->23624*/
/* 23612*/      OPC_CheckChild1Same, 0,
/* 23614*/      OPC_CheckChild2Same, 1,
/* 23616*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23617*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    /*MVT::v4f32*/111, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs, SETOGE:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23624*/     0, /*End of Scope*/
/* 23625*/    /*Scope*/ 33, /*->23659*/
/* 23626*/     OPC_CheckChild2CondCode, ISD::SETLT,
/* 23628*/     OPC_MoveParent,
/* 23629*/     OPC_CheckType, /*MVT::v4f32*/111, 
/* 23631*/     OPC_Scope, 12, /*->23645*/ // 2 children in Scope
/* 23633*/      OPC_CheckChild1Same, 0,
/* 23635*/      OPC_CheckChild2Same, 1,
/* 23637*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23638*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETLT:{ *:[Other] }), V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23645*/     /*Scope*/ 12, /*->23658*/
/* 23646*/      OPC_CheckChild1Same, 1,
/* 23648*/      OPC_CheckChild2Same, 0,
/* 23650*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23651*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETLT:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23658*/     0, /*End of Scope*/
/* 23659*/    /*Scope*/ 33, /*->23693*/
/* 23660*/     OPC_CheckChild2CondCode, ISD::SETLE,
/* 23662*/     OPC_MoveParent,
/* 23663*/     OPC_CheckType, /*MVT::v4f32*/111, 
/* 23665*/     OPC_Scope, 12, /*->23679*/ // 2 children in Scope
/* 23667*/      OPC_CheckChild1Same, 0,
/* 23669*/      OPC_CheckChild2Same, 1,
/* 23671*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23672*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETLE:{ *:[Other] }), V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23679*/     /*Scope*/ 12, /*->23692*/
/* 23680*/      OPC_CheckChild1Same, 1,
/* 23682*/      OPC_CheckChild2Same, 0,
/* 23684*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23685*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETLE:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23692*/     0, /*End of Scope*/
/* 23693*/    /*Scope*/ 33, /*->23727*/
/* 23694*/     OPC_CheckChild2CondCode, ISD::SETGT,
/* 23696*/     OPC_MoveParent,
/* 23697*/     OPC_CheckType, /*MVT::v4f32*/111, 
/* 23699*/     OPC_Scope, 12, /*->23713*/ // 2 children in Scope
/* 23701*/      OPC_CheckChild1Same, 1,
/* 23703*/      OPC_CheckChild2Same, 0,
/* 23705*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23706*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETGT:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23713*/     /*Scope*/ 12, /*->23726*/
/* 23714*/      OPC_CheckChild1Same, 0,
/* 23716*/      OPC_CheckChild2Same, 1,
/* 23718*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23719*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETGT:{ *:[Other] }), V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23726*/     0, /*End of Scope*/
/* 23727*/    /*Scope*/ 33, /*->23761*/
/* 23728*/     OPC_CheckChild2CondCode, ISD::SETGE,
/* 23730*/     OPC_MoveParent,
/* 23731*/     OPC_CheckType, /*MVT::v4f32*/111, 
/* 23733*/     OPC_Scope, 12, /*->23747*/ // 2 children in Scope
/* 23735*/      OPC_CheckChild1Same, 1,
/* 23737*/      OPC_CheckChild2Same, 0,
/* 23739*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23740*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F32x4),
                    /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETGE:{ *:[Other] }), V128:{ *:[v4f32] }:$rhs, V128:{ *:[v4f32] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23747*/     /*Scope*/ 12, /*->23760*/
/* 23748*/      OPC_CheckChild1Same, 0,
/* 23750*/      OPC_CheckChild2Same, 1,
/* 23752*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23753*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F32x4),
                    /*MVT::v4f32*/111, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v4f32] } (setcc:{ *:[v4i32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs, SETGE:{ *:[Other] }), V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs) - Complexity = 6
                // Dst: (PMAX_F32x4:{ *:[v4f32] } V128:{ *:[v4f32] }:$lhs, V128:{ *:[v4f32] }:$rhs)
/* 23760*/     0, /*End of Scope*/
/* 23761*/    0, /*End of Scope*/
/* 23762*/   /*Scope*/ 46|128,2/*302*/, /*->24066*/
/* 23764*/    OPC_CheckChild0Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 23767*/    OPC_RecordChild1, // #1 = $lhs
/* 23768*/    OPC_Scope, 36, /*->23806*/ // 8 children in Scope
/* 23770*/     OPC_CheckChild2CondCode, ISD::SETOLT,
/* 23772*/     OPC_MoveParent,
/* 23773*/     OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 23776*/     OPC_Scope, 13, /*->23791*/ // 2 children in Scope
/* 23778*/      OPC_CheckChild1Same, 0,
/* 23780*/      OPC_CheckChild2Same, 1,
/* 23782*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23783*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs, SETOLT:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 23791*/     /*Scope*/ 13, /*->23805*/
/* 23792*/      OPC_CheckChild1Same, 1,
/* 23794*/      OPC_CheckChild2Same, 0,
/* 23796*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23797*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOLT:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 23805*/     0, /*End of Scope*/
/* 23806*/    /*Scope*/ 36, /*->23843*/
/* 23807*/     OPC_CheckChild2CondCode, ISD::SETOLE,
/* 23809*/     OPC_MoveParent,
/* 23810*/     OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 23813*/     OPC_Scope, 13, /*->23828*/ // 2 children in Scope
/* 23815*/      OPC_CheckChild1Same, 0,
/* 23817*/      OPC_CheckChild2Same, 1,
/* 23819*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23820*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs, SETOLE:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 23828*/     /*Scope*/ 13, /*->23842*/
/* 23829*/      OPC_CheckChild1Same, 1,
/* 23831*/      OPC_CheckChild2Same, 0,
/* 23833*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23834*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOLE:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 23842*/     0, /*End of Scope*/
/* 23843*/    /*Scope*/ 36, /*->23880*/
/* 23844*/     OPC_CheckChild2CondCode, ISD::SETOGT,
/* 23846*/     OPC_MoveParent,
/* 23847*/     OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 23850*/     OPC_Scope, 13, /*->23865*/ // 2 children in Scope
/* 23852*/      OPC_CheckChild1Same, 1,
/* 23854*/      OPC_CheckChild2Same, 0,
/* 23856*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23857*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOGT:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 23865*/     /*Scope*/ 13, /*->23879*/
/* 23866*/      OPC_CheckChild1Same, 0,
/* 23868*/      OPC_CheckChild2Same, 1,
/* 23870*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23871*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs, SETOGT:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 23879*/     0, /*End of Scope*/
/* 23880*/    /*Scope*/ 36, /*->23917*/
/* 23881*/     OPC_CheckChild2CondCode, ISD::SETOGE,
/* 23883*/     OPC_MoveParent,
/* 23884*/     OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 23887*/     OPC_Scope, 13, /*->23902*/ // 2 children in Scope
/* 23889*/      OPC_CheckChild1Same, 1,
/* 23891*/      OPC_CheckChild2Same, 0,
/* 23893*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23894*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETOGE:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 23902*/     /*Scope*/ 13, /*->23916*/
/* 23903*/      OPC_CheckChild1Same, 0,
/* 23905*/      OPC_CheckChild2Same, 1,
/* 23907*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23908*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs, SETOGE:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 23916*/     0, /*End of Scope*/
/* 23917*/    /*Scope*/ 36, /*->23954*/
/* 23918*/     OPC_CheckChild2CondCode, ISD::SETLT,
/* 23920*/     OPC_MoveParent,
/* 23921*/     OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 23924*/     OPC_Scope, 13, /*->23939*/ // 2 children in Scope
/* 23926*/      OPC_CheckChild1Same, 0,
/* 23928*/      OPC_CheckChild2Same, 1,
/* 23930*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23931*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETLT:{ *:[Other] }), V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 23939*/     /*Scope*/ 13, /*->23953*/
/* 23940*/      OPC_CheckChild1Same, 1,
/* 23942*/      OPC_CheckChild2Same, 0,
/* 23944*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23945*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETLT:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 23953*/     0, /*End of Scope*/
/* 23954*/    /*Scope*/ 36, /*->23991*/
/* 23955*/     OPC_CheckChild2CondCode, ISD::SETLE,
/* 23957*/     OPC_MoveParent,
/* 23958*/     OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 23961*/     OPC_Scope, 13, /*->23976*/ // 2 children in Scope
/* 23963*/      OPC_CheckChild1Same, 0,
/* 23965*/      OPC_CheckChild2Same, 1,
/* 23967*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23968*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETLE:{ *:[Other] }), V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 23976*/     /*Scope*/ 13, /*->23990*/
/* 23977*/      OPC_CheckChild1Same, 1,
/* 23979*/      OPC_CheckChild2Same, 0,
/* 23981*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 23982*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETLE:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 23990*/     0, /*End of Scope*/
/* 23991*/    /*Scope*/ 36, /*->24028*/
/* 23992*/     OPC_CheckChild2CondCode, ISD::SETGT,
/* 23994*/     OPC_MoveParent,
/* 23995*/     OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 23998*/     OPC_Scope, 13, /*->24013*/ // 2 children in Scope
/* 24000*/      OPC_CheckChild1Same, 1,
/* 24002*/      OPC_CheckChild2Same, 0,
/* 24004*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24005*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETGT:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 24013*/     /*Scope*/ 13, /*->24027*/
/* 24014*/      OPC_CheckChild1Same, 0,
/* 24016*/      OPC_CheckChild2Same, 1,
/* 24018*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24019*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETGT:{ *:[Other] }), V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 24027*/     0, /*End of Scope*/
/* 24028*/    /*Scope*/ 36, /*->24065*/
/* 24029*/     OPC_CheckChild2CondCode, ISD::SETGE,
/* 24031*/     OPC_MoveParent,
/* 24032*/     OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 24035*/     OPC_Scope, 13, /*->24050*/ // 2 children in Scope
/* 24037*/      OPC_CheckChild1Same, 1,
/* 24039*/      OPC_CheckChild2Same, 0,
/* 24041*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24042*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F64x2),
                    /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETGE:{ *:[Other] }), V128:{ *:[v2f64] }:$rhs, V128:{ *:[v2f64] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 24050*/     /*Scope*/ 13, /*->24064*/
/* 24051*/      OPC_CheckChild1Same, 0,
/* 24053*/      OPC_CheckChild2Same, 1,
/* 24055*/      OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24056*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F64x2),
                    /*MVT::v2f64*/1|128,1/*129*/, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v2f64] } (setcc:{ *:[v2i64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs, SETGE:{ *:[Other] }), V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs) - Complexity = 6
                // Dst: (PMAX_F64x2:{ *:[v2f64] } V128:{ *:[v2f64] }:$lhs, V128:{ *:[v2f64] }:$rhs)
/* 24064*/     0, /*End of Scope*/
/* 24065*/    0, /*End of Scope*/
/* 24066*/   /*Scope*/ 21|128,2/*277*/, /*->24345*/
/* 24068*/    OPC_CheckChild0Type, /*MVT::v8f16*/92, 
/* 24070*/    OPC_RecordChild1, // #1 = $lhs
/* 24071*/    OPC_Scope, 33, /*->24106*/ // 8 children in Scope
/* 24073*/     OPC_CheckChild2CondCode, ISD::SETOLT,
/* 24075*/     OPC_MoveParent,
/* 24076*/     OPC_CheckType, /*MVT::v8f16*/92, 
/* 24078*/     OPC_Scope, 12, /*->24092*/ // 2 children in Scope
/* 24080*/      OPC_CheckChild1Same, 0,
/* 24082*/      OPC_CheckChild2Same, 1,
/* 24084*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24085*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs, SETOLT:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24092*/     /*Scope*/ 12, /*->24105*/
/* 24093*/      OPC_CheckChild1Same, 1,
/* 24095*/      OPC_CheckChild2Same, 0,
/* 24097*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24098*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOLT:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24105*/     0, /*End of Scope*/
/* 24106*/    /*Scope*/ 33, /*->24140*/
/* 24107*/     OPC_CheckChild2CondCode, ISD::SETOLE,
/* 24109*/     OPC_MoveParent,
/* 24110*/     OPC_CheckType, /*MVT::v8f16*/92, 
/* 24112*/     OPC_Scope, 12, /*->24126*/ // 2 children in Scope
/* 24114*/      OPC_CheckChild1Same, 0,
/* 24116*/      OPC_CheckChild2Same, 1,
/* 24118*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24119*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs, SETOLE:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24126*/     /*Scope*/ 12, /*->24139*/
/* 24127*/      OPC_CheckChild1Same, 1,
/* 24129*/      OPC_CheckChild2Same, 0,
/* 24131*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24132*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOLE:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24139*/     0, /*End of Scope*/
/* 24140*/    /*Scope*/ 33, /*->24174*/
/* 24141*/     OPC_CheckChild2CondCode, ISD::SETOGT,
/* 24143*/     OPC_MoveParent,
/* 24144*/     OPC_CheckType, /*MVT::v8f16*/92, 
/* 24146*/     OPC_Scope, 12, /*->24160*/ // 2 children in Scope
/* 24148*/      OPC_CheckChild1Same, 1,
/* 24150*/      OPC_CheckChild2Same, 0,
/* 24152*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24153*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOGT:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24160*/     /*Scope*/ 12, /*->24173*/
/* 24161*/      OPC_CheckChild1Same, 0,
/* 24163*/      OPC_CheckChild2Same, 1,
/* 24165*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24166*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs, SETOGT:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24173*/     0, /*End of Scope*/
/* 24174*/    /*Scope*/ 33, /*->24208*/
/* 24175*/     OPC_CheckChild2CondCode, ISD::SETOGE,
/* 24177*/     OPC_MoveParent,
/* 24178*/     OPC_CheckType, /*MVT::v8f16*/92, 
/* 24180*/     OPC_Scope, 12, /*->24194*/ // 2 children in Scope
/* 24182*/      OPC_CheckChild1Same, 1,
/* 24184*/      OPC_CheckChild2Same, 0,
/* 24186*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24187*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETOGE:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24194*/     /*Scope*/ 12, /*->24207*/
/* 24195*/      OPC_CheckChild1Same, 0,
/* 24197*/      OPC_CheckChild2Same, 1,
/* 24199*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24200*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 1, 0, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs, SETOGE:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24207*/     0, /*End of Scope*/
/* 24208*/    /*Scope*/ 33, /*->24242*/
/* 24209*/     OPC_CheckChild2CondCode, ISD::SETLT,
/* 24211*/     OPC_MoveParent,
/* 24212*/     OPC_CheckType, /*MVT::v8f16*/92, 
/* 24214*/     OPC_Scope, 12, /*->24228*/ // 2 children in Scope
/* 24216*/      OPC_CheckChild1Same, 0,
/* 24218*/      OPC_CheckChild2Same, 1,
/* 24220*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24221*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETLT:{ *:[Other] }), V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 6
                // Dst: (PMIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24228*/     /*Scope*/ 12, /*->24241*/
/* 24229*/      OPC_CheckChild1Same, 1,
/* 24231*/      OPC_CheckChild2Same, 0,
/* 24233*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24234*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETLT:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24241*/     0, /*End of Scope*/
/* 24242*/    /*Scope*/ 33, /*->24276*/
/* 24243*/     OPC_CheckChild2CondCode, ISD::SETLE,
/* 24245*/     OPC_MoveParent,
/* 24246*/     OPC_CheckType, /*MVT::v8f16*/92, 
/* 24248*/     OPC_Scope, 12, /*->24262*/ // 2 children in Scope
/* 24250*/      OPC_CheckChild1Same, 0,
/* 24252*/      OPC_CheckChild2Same, 1,
/* 24254*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24255*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETLE:{ *:[Other] }), V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 6
                // Dst: (PMIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24262*/     /*Scope*/ 12, /*->24275*/
/* 24263*/      OPC_CheckChild1Same, 1,
/* 24265*/      OPC_CheckChild2Same, 0,
/* 24267*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24268*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETLE:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24275*/     0, /*End of Scope*/
/* 24276*/    /*Scope*/ 33, /*->24310*/
/* 24277*/     OPC_CheckChild2CondCode, ISD::SETGT,
/* 24279*/     OPC_MoveParent,
/* 24280*/     OPC_CheckType, /*MVT::v8f16*/92, 
/* 24282*/     OPC_Scope, 12, /*->24296*/ // 2 children in Scope
/* 24284*/      OPC_CheckChild1Same, 1,
/* 24286*/      OPC_CheckChild2Same, 0,
/* 24288*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24289*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETGT:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24296*/     /*Scope*/ 12, /*->24309*/
/* 24297*/      OPC_CheckChild1Same, 0,
/* 24299*/      OPC_CheckChild2Same, 1,
/* 24301*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24302*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETGT:{ *:[Other] }), V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 6
                // Dst: (PMAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24309*/     0, /*End of Scope*/
/* 24310*/    /*Scope*/ 33, /*->24344*/
/* 24311*/     OPC_CheckChild2CondCode, ISD::SETGE,
/* 24313*/     OPC_MoveParent,
/* 24314*/     OPC_CheckType, /*MVT::v8f16*/92, 
/* 24316*/     OPC_Scope, 12, /*->24330*/ // 2 children in Scope
/* 24318*/      OPC_CheckChild1Same, 1,
/* 24320*/      OPC_CheckChild2Same, 0,
/* 24322*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24323*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMIN_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETGE:{ *:[Other] }), V128:{ *:[v8f16] }:$rhs, V128:{ *:[v8f16] }:$lhs) - Complexity = 6
                // Dst: (PMIN_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24330*/     /*Scope*/ 12, /*->24343*/
/* 24331*/      OPC_CheckChild1Same, 0,
/* 24333*/      OPC_CheckChild2Same, 1,
/* 24335*/      OPC_CheckPatternPredicate5, // (Subtarget->hasFP16()) && (Subtarget->hasSIMD128())
/* 24336*/      OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::PMAX_F16x8),
                    /*MVT::v8f16*/92, 2/*#Ops*/, 0, 1, 
                // Src: (vselect:{ *:[v8f16] } (setcc:{ *:[v8i16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs, SETGE:{ *:[Other] }), V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs) - Complexity = 6
                // Dst: (PMAX_F16x8:{ *:[v8f16] } V128:{ *:[v8f16] }:$lhs, V128:{ *:[v8f16] }:$rhs)
/* 24343*/     0, /*End of Scope*/
/* 24344*/    0, /*End of Scope*/
/* 24345*/   0, /*End of Scope*/
/* 24346*/  /*Scope*/ 27, /*->24374*/
/* 24347*/   OPC_RecordChild0, // #0 = $c
/* 24348*/   OPC_RecordChild1, // #1 = $v1
/* 24349*/   OPC_RecordChild2, // #2 = $v2
/* 24350*/   OPC_SwitchType /*2 cases */, 8, /*MVT::v4f32*/111, // ->24361
/* 24353*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v4f32*/111, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v4f32] } V128:{ *:[v4i32] }:$c, V128:{ *:[v4f32] }:$v1, V128:{ *:[v4f32] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v4f32] } ?:{ *:[v4f32] }:$v1, ?:{ *:[v4f32] }:$v2, ?:{ *:[v4i32] }:$c)
/* 24361*/   /*SwitchType*/ 9, /*MVT::v2f64*/1|128,1/*129*/, // ->24373
/* 24364*/    OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::BITSELECT),
                  /*MVT::v2f64*/1|128,1/*129*/, 3/*#Ops*/, 1, 2, 0, 
              // Src: (vselect:{ *:[v2f64] } V128:{ *:[v2i64] }:$c, V128:{ *:[v2f64] }:$v1, V128:{ *:[v2f64] }:$v2) - Complexity = 3
              // Dst: (BITSELECT:{ *:[v2f64] } ?:{ *:[v2f64] }:$v1, ?:{ *:[v2f64] }:$v2, ?:{ *:[v2i64] }:$c)
/* 24373*/   0, // EndSwitchType
/* 24374*/  0, /*End of Scope*/
/* 24375*/ /*SwitchOpcode*/ 16, TARGET_VAL(WebAssemblyISD::SWIZZLE),// ->24394
/* 24378*/  OPC_RecordChild0, // #0 = $src
/* 24379*/  OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 24381*/  OPC_RecordChild1, // #1 = $mask
/* 24382*/  OPC_CheckChild1Type, /*MVT::v16i8*/39, 
/* 24384*/  OPC_CheckType, /*MVT::v16i8*/39, 
/* 24386*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24387*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SWIZZLE),
                /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
            // Src: (wasm_swizzle:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask) - Complexity = 3
            // Dst: (SWIZZLE:{ *:[v16i8] } V128:{ *:[v16i8] }:$src, V128:{ *:[v16i8] }:$mask)
/* 24394*/ /*SwitchOpcode*/ 39, TARGET_VAL(ISD::ABS),// ->24436
/* 24397*/  OPC_RecordChild0, // #0 = $v
/* 24398*/  OPC_SwitchType /*4 cases */, 7, /*MVT::v16i8*/39, // ->24408
/* 24401*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24402*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_I8x16),
                 /*MVT::v16i8*/39, 1/*#Ops*/, 0, 
             // Src: (abs:{ *:[v16i8] } V128:{ *:[v16i8] }:$v) - Complexity = 3
             // Dst: (ABS_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$v)
/* 24408*/  /*SwitchType*/ 7, /*MVT::v8i16*/50, // ->24417
/* 24410*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24411*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_I16x8),
                 /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
             // Src: (abs:{ *:[v8i16] } V128:{ *:[v8i16] }:$v) - Complexity = 3
             // Dst: (ABS_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$v)
/* 24417*/  /*SwitchType*/ 7, /*MVT::v4i32*/60, // ->24426
/* 24419*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24420*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_I32x4),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
             // Src: (abs:{ *:[v4i32] } V128:{ *:[v4i32] }:$v) - Complexity = 3
             // Dst: (ABS_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$v)
/* 24426*/  /*SwitchType*/ 7, /*MVT::v2i64*/78, // ->24435
/* 24428*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24429*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ABS_I64x2),
                 /*MVT::v2i64*/78, 1/*#Ops*/, 0, 
             // Src: (abs:{ *:[v2i64] } V128:{ *:[v2i64] }:$v) - Complexity = 3
             // Dst: (ABS_I64x2:{ *:[v2i64] } V128:{ *:[v2i64] }:$v)
/* 24435*/  0, // EndSwitchType
/* 24436*/ /*SwitchOpcode*/ 24, TARGET_VAL(ISD::SADDSAT),// ->24463
/* 24439*/  OPC_RecordChild0, // #0 = $lhs
/* 24440*/  OPC_RecordChild1, // #1 = $rhs
/* 24441*/  OPC_SwitchType /*2 cases */, 8, /*MVT::v16i8*/39, // ->24452
/* 24444*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24445*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_SAT_S_I8x16),
                 /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
             // Src: (saddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (ADD_SAT_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 24452*/  /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->24462
/* 24454*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24455*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_SAT_S_I16x8),
                 /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
             // Src: (saddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (ADD_SAT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 24462*/  0, // EndSwitchType
/* 24463*/ /*SwitchOpcode*/ 24, TARGET_VAL(ISD::UADDSAT),// ->24490
/* 24466*/  OPC_RecordChild0, // #0 = $lhs
/* 24467*/  OPC_RecordChild1, // #1 = $rhs
/* 24468*/  OPC_SwitchType /*2 cases */, 8, /*MVT::v16i8*/39, // ->24479
/* 24471*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24472*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_SAT_U_I8x16),
                 /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
             // Src: (uaddsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (ADD_SAT_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 24479*/  /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->24489
/* 24481*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24482*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::ADD_SAT_U_I16x8),
                 /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
             // Src: (uaddsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (ADD_SAT_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 24489*/  0, // EndSwitchType
/* 24490*/ /*SwitchOpcode*/ 24, TARGET_VAL(ISD::SSUBSAT),// ->24517
/* 24493*/  OPC_RecordChild0, // #0 = $lhs
/* 24494*/  OPC_RecordChild1, // #1 = $rhs
/* 24495*/  OPC_SwitchType /*2 cases */, 8, /*MVT::v16i8*/39, // ->24506
/* 24498*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24499*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_SAT_S_I8x16),
                 /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
             // Src: (ssubsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (SUB_SAT_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 24506*/  /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->24516
/* 24508*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24509*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_SAT_S_I16x8),
                 /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
             // Src: (ssubsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (SUB_SAT_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 24516*/  0, // EndSwitchType
/* 24517*/ /*SwitchOpcode*/ 24, TARGET_VAL(ISD::USUBSAT),// ->24544
/* 24520*/  OPC_RecordChild0, // #0 = $lhs
/* 24521*/  OPC_RecordChild1, // #1 = $rhs
/* 24522*/  OPC_SwitchType /*2 cases */, 8, /*MVT::v16i8*/39, // ->24533
/* 24525*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24526*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_SAT_U_I8x16),
                 /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
             // Src: (usubsat:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (SUB_SAT_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 24533*/  /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->24543
/* 24535*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24536*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::SUB_SAT_U_I16x8),
                 /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
             // Src: (usubsat:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (SUB_SAT_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 24543*/  0, // EndSwitchType
/* 24544*/ /*SwitchOpcode*/ 34, TARGET_VAL(ISD::SMIN),// ->24581
/* 24547*/  OPC_RecordChild0, // #0 = $lhs
/* 24548*/  OPC_RecordChild1, // #1 = $rhs
/* 24549*/  OPC_SwitchType /*3 cases */, 8, /*MVT::v16i8*/39, // ->24560
/* 24552*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24553*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_S_I8x16),
                 /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
             // Src: (smin:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (MIN_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 24560*/  /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->24570
/* 24562*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24563*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_S_I16x8),
                 /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
             // Src: (smin:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (MIN_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 24570*/  /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->24580
/* 24572*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24573*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_S_I32x4),
                 /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
             // Src: (smin:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (MIN_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 24580*/  0, // EndSwitchType
/* 24581*/ /*SwitchOpcode*/ 34, TARGET_VAL(ISD::UMIN),// ->24618
/* 24584*/  OPC_RecordChild0, // #0 = $lhs
/* 24585*/  OPC_RecordChild1, // #1 = $rhs
/* 24586*/  OPC_SwitchType /*3 cases */, 8, /*MVT::v16i8*/39, // ->24597
/* 24589*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24590*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_U_I8x16),
                 /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
             // Src: (umin:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (MIN_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 24597*/  /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->24607
/* 24599*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24600*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_U_I16x8),
                 /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
             // Src: (umin:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (MIN_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 24607*/  /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->24617
/* 24609*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24610*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MIN_U_I32x4),
                 /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
             // Src: (umin:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (MIN_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 24617*/  0, // EndSwitchType
/* 24618*/ /*SwitchOpcode*/ 34, TARGET_VAL(ISD::SMAX),// ->24655
/* 24621*/  OPC_RecordChild0, // #0 = $lhs
/* 24622*/  OPC_RecordChild1, // #1 = $rhs
/* 24623*/  OPC_SwitchType /*3 cases */, 8, /*MVT::v16i8*/39, // ->24634
/* 24626*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24627*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_S_I8x16),
                 /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
             // Src: (smax:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (MAX_S_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 24634*/  /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->24644
/* 24636*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24637*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_S_I16x8),
                 /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
             // Src: (smax:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (MAX_S_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 24644*/  /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->24654
/* 24646*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24647*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_S_I32x4),
                 /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
             // Src: (smax:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (MAX_S_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 24654*/  0, // EndSwitchType
/* 24655*/ /*SwitchOpcode*/ 34, TARGET_VAL(ISD::UMAX),// ->24692
/* 24658*/  OPC_RecordChild0, // #0 = $lhs
/* 24659*/  OPC_RecordChild1, // #1 = $rhs
/* 24660*/  OPC_SwitchType /*3 cases */, 8, /*MVT::v16i8*/39, // ->24671
/* 24663*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24664*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_U_I8x16),
                 /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
             // Src: (umax:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs) - Complexity = 3
             // Dst: (MAX_U_I8x16:{ *:[v16i8] } V128:{ *:[v16i8] }:$lhs, V128:{ *:[v16i8] }:$rhs)
/* 24671*/  /*SwitchType*/ 8, /*MVT::v8i16*/50, // ->24681
/* 24673*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24674*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_U_I16x8),
                 /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
             // Src: (umax:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs) - Complexity = 3
             // Dst: (MAX_U_I16x8:{ *:[v8i16] } V128:{ *:[v8i16] }:$lhs, V128:{ *:[v8i16] }:$rhs)
/* 24681*/  /*SwitchType*/ 8, /*MVT::v4i32*/60, // ->24691
/* 24683*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24684*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::MAX_U_I32x4),
                 /*MVT::v4i32*/60, 2/*#Ops*/, 0, 1, 
             // Src: (umax:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs) - Complexity = 3
             // Dst: (MAX_U_I32x4:{ *:[v4i32] } V128:{ *:[v4i32] }:$lhs, V128:{ *:[v4i32] }:$rhs)
/* 24691*/  0, // EndSwitchType
/* 24692*/ /*SwitchOpcode*/ 13, TARGET_VAL(WebAssemblyISD::TRUNC_SAT_ZERO_S),// ->24708
/* 24695*/  OPC_RecordChild0, // #0 = $vec
/* 24696*/  OPC_CheckChild0Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 24699*/  OPC_CheckType, /*MVT::v4i32*/60, 
/* 24701*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24702*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::trunc_sat_zero_s_I32x4),
                /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
            // Src: (trunc_sat_zero_s:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec) - Complexity = 3
            // Dst: (trunc_sat_zero_s_I32x4:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec)
/* 24708*/ /*SwitchOpcode*/ 13, TARGET_VAL(WebAssemblyISD::TRUNC_SAT_ZERO_U),// ->24724
/* 24711*/  OPC_RecordChild0, // #0 = $vec
/* 24712*/  OPC_CheckChild0Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 24715*/  OPC_CheckType, /*MVT::v4i32*/60, 
/* 24717*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24718*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::trunc_sat_zero_u_I32x4),
                /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
            // Src: (trunc_sat_zero_u:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec) - Complexity = 3
            // Dst: (trunc_sat_zero_u_I32x4:{ *:[v4i32] } V128:{ *:[v2f64] }:$vec)
/* 24724*/ /*SwitchOpcode*/ 36, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_S),// ->24763
/* 24727*/  OPC_RecordChild0, // #0 = $vec
/* 24728*/  OPC_SwitchType /*3 cases */, 9, /*MVT::v8i16*/50, // ->24740
/* 24731*/   OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 24733*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24734*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_s_I16x8),
                 /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
             // Src: (extend_low_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec) - Complexity = 3
             // Dst: (extend_low_s_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 24740*/  /*SwitchType*/ 9, /*MVT::v4i32*/60, // ->24751
/* 24742*/   OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 24744*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24745*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_s_I32x4),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
             // Src: (extend_low_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (extend_low_s_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 24751*/  /*SwitchType*/ 9, /*MVT::v2i64*/78, // ->24762
/* 24753*/   OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 24755*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24756*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_s_I64x2),
                 /*MVT::v2i64*/78, 1/*#Ops*/, 0, 
             // Src: (extend_low_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (extend_low_s_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec)
/* 24762*/  0, // EndSwitchType
/* 24763*/ /*SwitchOpcode*/ 36, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_S),// ->24802
/* 24766*/  OPC_RecordChild0, // #0 = $vec
/* 24767*/  OPC_SwitchType /*3 cases */, 9, /*MVT::v8i16*/50, // ->24779
/* 24770*/   OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 24772*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24773*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_s_I16x8),
                 /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
             // Src: (extend_high_s:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec) - Complexity = 3
             // Dst: (extend_high_s_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 24779*/  /*SwitchType*/ 9, /*MVT::v4i32*/60, // ->24790
/* 24781*/   OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 24783*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24784*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_s_I32x4),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
             // Src: (extend_high_s:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (extend_high_s_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 24790*/  /*SwitchType*/ 9, /*MVT::v2i64*/78, // ->24801
/* 24792*/   OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 24794*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24795*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_s_I64x2),
                 /*MVT::v2i64*/78, 1/*#Ops*/, 0, 
             // Src: (extend_high_s:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (extend_high_s_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec)
/* 24801*/  0, // EndSwitchType
/* 24802*/ /*SwitchOpcode*/ 36, TARGET_VAL(WebAssemblyISD::EXTEND_LOW_U),// ->24841
/* 24805*/  OPC_RecordChild0, // #0 = $vec
/* 24806*/  OPC_SwitchType /*3 cases */, 9, /*MVT::v8i16*/50, // ->24818
/* 24809*/   OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 24811*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24812*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_u_I16x8),
                 /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
             // Src: (extend_low_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec) - Complexity = 3
             // Dst: (extend_low_u_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 24818*/  /*SwitchType*/ 9, /*MVT::v4i32*/60, // ->24829
/* 24820*/   OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 24822*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24823*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_u_I32x4),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
             // Src: (extend_low_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (extend_low_u_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 24829*/  /*SwitchType*/ 9, /*MVT::v2i64*/78, // ->24840
/* 24831*/   OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 24833*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24834*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_low_u_I64x2),
                 /*MVT::v2i64*/78, 1/*#Ops*/, 0, 
             // Src: (extend_low_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (extend_low_u_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec)
/* 24840*/  0, // EndSwitchType
/* 24841*/ /*SwitchOpcode*/ 36, TARGET_VAL(WebAssemblyISD::EXTEND_HIGH_U),// ->24880
/* 24844*/  OPC_RecordChild0, // #0 = $vec
/* 24845*/  OPC_SwitchType /*3 cases */, 9, /*MVT::v8i16*/50, // ->24857
/* 24848*/   OPC_CheckChild0Type, /*MVT::v16i8*/39, 
/* 24850*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24851*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_u_I16x8),
                 /*MVT::v8i16*/50, 1/*#Ops*/, 0, 
             // Src: (extend_high_u:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec) - Complexity = 3
             // Dst: (extend_high_u_I16x8:{ *:[v8i16] } V128:{ *:[v16i8] }:$vec)
/* 24857*/  /*SwitchType*/ 9, /*MVT::v4i32*/60, // ->24868
/* 24859*/   OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 24861*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24862*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_u_I32x4),
                 /*MVT::v4i32*/60, 1/*#Ops*/, 0, 
             // Src: (extend_high_u:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec) - Complexity = 3
             // Dst: (extend_high_u_I32x4:{ *:[v4i32] } V128:{ *:[v8i16] }:$vec)
/* 24868*/  /*SwitchType*/ 9, /*MVT::v2i64*/78, // ->24879
/* 24870*/   OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 24872*/   OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24873*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::extend_high_u_I64x2),
                 /*MVT::v2i64*/78, 1/*#Ops*/, 0, 
             // Src: (extend_high_u:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
             // Dst: (extend_high_u_I64x2:{ *:[v2i64] } V128:{ *:[v4i32] }:$vec)
/* 24879*/  0, // EndSwitchType
/* 24880*/ /*SwitchOpcode*/ 31, TARGET_VAL(WebAssemblyISD::NARROW_U),// ->24914
/* 24883*/  OPC_RecordChild0, // #0 = $left
/* 24884*/  OPC_SwitchType /*2 cases */, 12, /*MVT::v16i8*/39, // ->24899
/* 24887*/   OPC_CheckChild0Type, /*MVT::v8i16*/50, 
/* 24889*/   OPC_RecordChild1, // #1 = $right
/* 24890*/   OPC_CheckChild1Type, /*MVT::v8i16*/50, 
/* 24892*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_U_I8x16),
                 /*MVT::v16i8*/39, 2/*#Ops*/, 0, 1, 
             // Src: (wasm_narrow_u:{ *:[v16i8] } V128:{ *:[v8i16] }:$left, V128:{ *:[v8i16] }:$right) - Complexity = 3
             // Dst: (NARROW_U_I8x16:{ *:[v16i8] } ?:{ *:[v8i16] }:$left, ?:{ *:[v8i16] }:$right)
/* 24899*/  /*SwitchType*/ 12, /*MVT::v8i16*/50, // ->24913
/* 24901*/   OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 24903*/   OPC_RecordChild1, // #1 = $right
/* 24904*/   OPC_CheckChild1Type, /*MVT::v4i32*/60, 
/* 24906*/   OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::NARROW_U_I16x8),
                 /*MVT::v8i16*/50, 2/*#Ops*/, 0, 1, 
             // Src: (wasm_narrow_u:{ *:[v8i16] } V128:{ *:[v4i32] }:$left, V128:{ *:[v4i32] }:$right) - Complexity = 3
             // Dst: (NARROW_U_I16x8:{ *:[v8i16] } ?:{ *:[v4i32] }:$left, ?:{ *:[v4i32] }:$right)
/* 24913*/  0, // EndSwitchType
/* 24914*/ /*SwitchOpcode*/ 14, TARGET_VAL(WebAssemblyISD::CONVERT_LOW_S),// ->24931
/* 24917*/  OPC_RecordChild0, // #0 = $vec
/* 24918*/  OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 24920*/  OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 24923*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24924*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::convert_low_s_F64x2),
                /*MVT::v2f64*/1|128,1/*129*/, 1/*#Ops*/, 0, 
            // Src: (convert_low_s:{ *:[v2f64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
            // Dst: (convert_low_s_F64x2:{ *:[v2f64] } V128:{ *:[v4i32] }:$vec)
/* 24931*/ /*SwitchOpcode*/ 14, TARGET_VAL(WebAssemblyISD::CONVERT_LOW_U),// ->24948
/* 24934*/  OPC_RecordChild0, // #0 = $vec
/* 24935*/  OPC_CheckChild0Type, /*MVT::v4i32*/60, 
/* 24937*/  OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 24940*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24941*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::convert_low_u_F64x2),
                /*MVT::v2f64*/1|128,1/*129*/, 1/*#Ops*/, 0, 
            // Src: (convert_low_u:{ *:[v2f64] } V128:{ *:[v4i32] }:$vec) - Complexity = 3
            // Dst: (convert_low_u_F64x2:{ *:[v2f64] } V128:{ *:[v4i32] }:$vec)
/* 24948*/ /*SwitchOpcode*/ 13, TARGET_VAL(WebAssemblyISD::DEMOTE_ZERO),// ->24964
/* 24951*/  OPC_RecordChild0, // #0 = $vec
/* 24952*/  OPC_CheckChild0Type, /*MVT::v2f64*/1|128,1/*129*/, 
/* 24955*/  OPC_CheckType, /*MVT::v4f32*/111, 
/* 24957*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24958*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::demote_zero_F32x4),
                /*MVT::v4f32*/111, 1/*#Ops*/, 0, 
            // Src: (demote_zero:{ *:[v4f32] } V128:{ *:[v2f64] }:$vec) - Complexity = 3
            // Dst: (demote_zero_F32x4:{ *:[v4f32] } V128:{ *:[v2f64] }:$vec)
/* 24964*/ /*SwitchOpcode*/ 14, TARGET_VAL(WebAssemblyISD::PROMOTE_LOW),// ->24981
/* 24967*/  OPC_RecordChild0, // #0 = $vec
/* 24968*/  OPC_CheckChild0Type, /*MVT::v4f32*/111, 
/* 24970*/  OPC_CheckType, /*MVT::v2f64*/1|128,1/*129*/, 
/* 24973*/  OPC_CheckPatternPredicate0, // (Subtarget->hasSIMD128())
/* 24974*/  OPC_MorphNodeTo1None, TARGET_VAL(WebAssembly::promote_low_F64x2),
                /*MVT::v2f64*/1|128,1/*129*/, 1/*#Ops*/, 0, 
            // Src: (promote_low:{ *:[v2f64] } V128:{ *:[v4f32] }:$vec) - Complexity = 3
            // Dst: (promote_low_F64x2:{ *:[v2f64] } V128:{ *:[v4f32] }:$vec)
/* 24981*/ 0, // EndSwitchOpcode
    0
  }; // Total Array size is 24983 bytes

  // Opcode Histogram:
  // #OPC_Scope                                = 360
  // #OPC_RecordNode                           = 299
  // #OPC_RecordChild                          = 758
  // #OPC_RecordMemRef                         = 43
  // #OPC_CaptureGlueInput                     = 1
  // #OPC_MoveChild                            = 297
  // #OPC_MoveSibling                          = 297
  // #OPC_MoveParent                           = 611
  // #OPC_CheckSame                            = 0
  // #OPC_CheckChildSame                       = 195
  // #OPC_CheckPatternPredicate                = 762
  // #OPC_CheckPredicate                       = 557
  // #OPC_CheckOpcode                          = 518
  // #OPC_SwitchOpcode                         = 15
  // #OPC_CheckType                            = 574
  // #OPC_SwitchType                           = 184
  // #OPC_CheckChildType                       = 468
  // #OPC_CheckInteger                         = 0
  // #OPC_CheckChildInteger                    = 106
  // #OPC_CheckCondCode                        = 0
  // #OPC_CheckChild2CondCode                  = 165
  // #OPC_CheckValueType                       = 17
  // #OPC_CheckComplexPat                      = 330
  // #OPC_CheckAndImm                          = 27
  // #OPC_CheckOrImm                           = 0
  // #OPC_CheckImmAllOnesV                     = 44
  // #OPC_CheckImmAllZerosV                    = 1
  // #OPC_CheckFoldableChainNode               = 6
  // #OPC_EmitInteger                          = 381
  // #OPC_EmitStringInteger                    = 0
  // #OPC_EmitRegister                         = 0
  // #OPC_EmitConvertToTarget                  = 324
  // #OPC_EmitMergeInputChains                 = 452
  // #OPC_EmitCopyToReg                        = 0
  // #OPC_EmitNode                             = 9
  // #OPC_EmitNodeXForm                        = 0
  // #OPC_CompleteMatch                        = 44
  // #OPC_MorphNodeTo                          = 1266

  #undef TARGET_VAL
  SelectCodeCommon(N, MatcherTable, sizeof(MatcherTable));
}
#endif // GET_DAGISEL_BODY

#ifdef GET_DAGISEL_DECL
bool CheckPatternPredicate(unsigned PredNo) const override;
#endif
#if defined(GET_DAGISEL_BODY) || DAGISEL_INLINE
bool DAGISEL_CLASS_COLONCOLON CheckPatternPredicate(unsigned PredNo) const
#if DAGISEL_INLINE
  override
#endif
{
  switch (PredNo) {
  default: llvm_unreachable("Invalid predicate in table?");
  case 0: return (Subtarget->hasSIMD128());
  case 1: return (!Subtarget->hasAddr64());
  case 2: return (Subtarget->hasAddr64());
  case 3: return (!Subtarget->hasAddr64()) && (Subtarget->hasAtomics());
  case 4: return (Subtarget->hasAddr64()) && (Subtarget->hasAtomics());
  case 5: return (Subtarget->hasFP16()) && (Subtarget->hasSIMD128());
  case 6: return (Subtarget->hasReferenceTypes());
  case 7: return (Subtarget->hasRelaxedSIMD());
  case 8: return (Subtarget->hasExceptionHandling()) && (Subtarget->hasReferenceTypes());
  case 9: return (Subtarget->hasNontrappingFPToInt());
  case 10: return (!Subtarget->hasNontrappingFPToInt());
  case 11: return (Subtarget->hasSignExt());
  case 12: return (Subtarget->hasBulkMemory());
  case 13: return (Subtarget->hasRelaxedSIMD()) && (Subtarget->hasSIMD128());
  case 14: return (!Subtarget->hasAddr64()) && (TM.isPositionIndependent());
  case 15: return (Subtarget->hasAddr64()) && (TM.isPositionIndependent());
  case 16: return (Subtarget->hasExceptionHandling());
  case 17: return (Subtarget->hasFP16());
  case 18: return (!Subtarget->hasAddr64()) && (!TM.isPositionIndependent());
  case 19: return (Subtarget->hasAddr64()) && (!TM.isPositionIndependent());
  }
}
#endif // GET_DAGISEL_BODY

#ifdef GET_DAGISEL_DECL
bool CheckNodePredicate(SDNode *Node, unsigned PredNo) const override;
#endif
#if defined(GET_DAGISEL_BODY) || DAGISEL_INLINE
bool DAGISEL_CLASS_COLONCOLON CheckNodePredicate(SDNode *Node, unsigned PredNo) const
#if DAGISEL_INLINE
  override
#endif
{
  switch (PredNo) {
  default: llvm_unreachable("Invalid predicate in table?");
  case 0: {
    // Predicate_LaneIdx32
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 32;
  }
  case 1: {
    // Predicate_atomic_cmp_swap_i8
    // Predicate_atomic_load_8
    // Predicate_atomic_load_add_i8
    // Predicate_atomic_load_and_i8
    // Predicate_atomic_load_or_i8
    // Predicate_atomic_load_sub_i8
    // Predicate_atomic_load_xor_i8
    // Predicate_atomic_store_8
    // Predicate_atomic_swap_i8
    // Predicate_extloadi8
    // Predicate_sextloadi8
    // Predicate_zextloadi8
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i8) return false;
return true;

  }
  case 2: {
    // Predicate_atomic_cmp_swap_i16
    // Predicate_atomic_load_16
    // Predicate_atomic_load_add_i16
    // Predicate_atomic_load_and_i16
    // Predicate_atomic_load_or_i16
    // Predicate_atomic_load_sub_i16
    // Predicate_atomic_load_xor_i16
    // Predicate_atomic_store_16
    // Predicate_atomic_swap_i16
    // Predicate_extloadi16
    // Predicate_sextloadi16
    // Predicate_zextloadi16
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i16) return false;
return true;

  }
  case 3: {
    // Predicate_atomic_cmp_swap_i32
    // Predicate_atomic_load_32
    // Predicate_atomic_load_add_i32
    // Predicate_atomic_load_and_i32
    // Predicate_atomic_load_or_i32
    // Predicate_atomic_load_sub_i32
    // Predicate_atomic_load_xor_i32
    // Predicate_atomic_store_32
    // Predicate_atomic_swap_i32
    // Predicate_extloadi32
    // Predicate_sextloadi32
    // Predicate_zextloadi32
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i32) return false;
return true;

  }
  case 4: {
    // Predicate_unindexedstore
    SDNode *N = Node;
    (void)N;
if (cast<StoreSDNode>(N)->getAddressingMode() != ISD::UNINDEXED) return false;
return true;

  }
  case 5: {
    // Predicate_store
    SDNode *N = Node;
    (void)N;
 if (cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 6: {
    // Predicate_load
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getExtensionType() != ISD::NON_EXTLOAD) return false;
return true;

  }
  case 7: {
    // Predicate_atomic_cmp_swap_i64
    // Predicate_atomic_load_64
    // Predicate_atomic_load_add_i64
    // Predicate_atomic_load_and_i64
    // Predicate_atomic_load_or_i64
    // Predicate_atomic_load_sub_i64
    // Predicate_atomic_load_xor_i64
    // Predicate_atomic_store_64
    // Predicate_atomic_swap_i64
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i64) return false;
return true;

  }
  case 8: {
    // Predicate_unindexedload
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getAddressingMode() != ISD::UNINDEXED) return false;
return true;

  }
  case 9: {
    // Predicate_ImmI8
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return -(1 << (8 - 1)) <= Imm && Imm < (1 << 8);
  }
  case 10: {
    // Predicate_extload
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getExtensionType() != ISD::EXTLOAD) return false;
return true;

  }
  case 11: {
    // Predicate_LaneIdx4
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 4;
  }
  case 12: {
    // Predicate_LaneIdx2
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 2;
  }
  case 13: {
    // Predicate_LaneIdx8
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 8;
  }
  case 14: {
    // Predicate_truncstore
    SDNode *N = Node;
    (void)N;
 if (!cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 15: {
    // Predicate_sextload
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getExtensionType() != ISD::SEXTLOAD) return false;
return true;

  }
  case 16: {
    // Predicate_zextload
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getExtensionType() != ISD::ZEXTLOAD) return false;
return true;

  }
  case 17: {
    // Predicate_ImmI16
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return -(1 << (16 - 1)) <= Imm && Imm < (1 << 16);
  }
  case 18: {
    // Predicate_LaneIdx16
    int64_t Imm = cast<ConstantSDNode>(Node)->getSExtValue();
return 0 <= Imm && Imm < 16;
  }
  case 19: {
    // Predicate_truncstorei8
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i8) return false;
 if (!cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 20: {
    // Predicate_truncstorei16
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i16) return false;
 if (!cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 21: {
    // Predicate_extloadvi8
    // Predicate_sextloadvi8
    // Predicate_zextloadvi8
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getMemoryVT().getScalarType() != MVT::i8) return false;
return true;

  }
  case 22: {
    // Predicate_extloadvi16
    // Predicate_sextloadvi16
    // Predicate_zextloadvi16
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getMemoryVT().getScalarType() != MVT::i16) return false;
return true;

  }
  case 23: {
    // Predicate_extloadvi32
    // Predicate_sextloadvi32
    // Predicate_zextloadvi32
    SDNode *N = Node;
    (void)N;
if (cast<LoadSDNode>(N)->getMemoryVT().getScalarType() != MVT::i32) return false;
return true;

  }
  case 24: {
    // Predicate_add_nuw
    SDNode *N = Node;
    (void)N;
return N->getFlags().hasNoUnsignedWrap();
  }
  case 25: {
    // Predicate_truncstorei32
    SDNode *N = Node;
    (void)N;
if (cast<MemSDNode>(N)->getMemoryVT() != MVT::i32) return false;
 if (!cast<StoreSDNode>(N)->isTruncatingStore()) return false;
return true;

  }
  case 26: {
    // Predicate_bool_node
    SDNode *N = Node;
    (void)N;

  return CurDAG->computeKnownBits(SDValue(N, 0)).countMinLeadingZeros() == 31;

  }
  }
}
#endif // GET_DAGISEL_BODY

#ifdef GET_DAGISEL_DECL
bool CheckComplexPattern(SDNode *Root, SDNode *Parent,
      SDValue N, unsigned PatternNo,
      SmallVectorImpl<std::pair<SDValue, SDNode *>> &Result) override;
#endif
#if defined(GET_DAGISEL_BODY) || DAGISEL_INLINE
bool DAGISEL_CLASS_COLONCOLON CheckComplexPattern(SDNode *Root, SDNode *Parent,
      SDValue N, unsigned PatternNo,
      SmallVectorImpl<std::pair<SDValue, SDNode *>> &Result)
#if DAGISEL_INLINE
  override
#endif
{
  unsigned NextRes = Result.size();
  switch (PatternNo) {
  default: llvm_unreachable("Invalid pattern # in table?");
  case 0:
    Result.resize(NextRes+2);
  return SelectAddrOperands32(N, Result[NextRes+0].first, Result[NextRes+1].first);
  case 1:
    Result.resize(NextRes+2);
  return SelectAddrOperands64(N, Result[NextRes+0].first, Result[NextRes+1].first);
  }
}
#endif // GET_DAGISEL_BODY


#ifdef DAGISEL_INLINE
#undef DAGISEL_INLINE
#endif
#ifdef DAGISEL_CLASS_COLONCOLON
#undef DAGISEL_CLASS_COLONCOLON
#endif
#ifdef GET_DAGISEL_DECL
#undef GET_DAGISEL_DECL
#endif
#ifdef GET_DAGISEL_BODY
#undef GET_DAGISEL_BODY
#endif
